!      DOUBLE PRECISION FUNCTION DNRM2(N,X,INCX)
      SUBROUTINE DDNRM2(N,Xh,Xl,INCX,DDNRM2h,DDNRM2l)
*     .. Scalar Arguments ..
      INTEGER INCX,N
*     ..
*     .. Array Arguments ..
!      DOUBLE PRECISION X(*)
       DOUBLE PRECISION Xh(*),Xl(*)
      double precision DDNRM2h, DDNRM2l
*     ..
*
*  Purpose
*  =======
*
*  DNRM2 returns the euclidean norm of a vector via the function
*  name, so that
*
*     DNRM2 := sqrt( x'*x )
*
*  Further Details
*  ===============
*
*  -- This version written on 25-October-1982.
*     Modified on 14-October-1993 to inline the call to DLASSQ.
*     Sven Hammarling, Nag Ltd.
*
*  =====================================================================
*
*     .. Parameters ..
!      DOUBLE PRECISION ONE,ZERO
!      PARAMETER (ONE=1.0D+0,ZERO=0.0D+0)
      double precision ONEh, ONEl
      double precision ZEROh, ZEROl
*     ..
*     .. Local Scalars ..
!      DOUBLE PRECISION ABSXI,NORM,SCALE,SSQ
      double precision ABSXIh, ABSXIl
      double precision NORMh, NORMl
      double precision SCALEh, SCALEl
      double precision SSQh, SSQl
      INTEGER IX
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC ABS,SQRT

      double precision tmp1h, tmp1l
      double precision tmp2h, tmp2l
      double precision tmp3h, tmp3l
      double precision tmp4h, tmp4l
!     tmp vars
      double precision T_ch, T_cl
      double precision T_p1, T_p2
      double precision T_q1, T_q2
      double precision T_r1, T_r2
      double precision T_s1, T_s2
      double precision T_t1, T_t2
      double precision T_u1, T_u2
      double precision T_x1, T_x2
      double precision T_y1, T_y2
      double precision T_z1, T_z2
      double precision T_x, T_ax
      double precision T_t1h, T_t1l
      double precision T_t2h, T_t2l
*     ..
      ONEh = 1.0d+0
      ONEl = 0.0d+0
      ZEROh = 0.0d+0
      ZEROl = 0.0d+0

      IF (N.LT.1 .OR. INCX.LT.1) THEN
!          NORM = ZERO
      NORMh = ZEROh
      NORMl = ZEROl
      ELSE IF (N.EQ.1) THEN
!<<<  tmp1 = abs(X(1))
      if (Xh(1) .lt. 0.0d+0) then
        tmp1h = -Xh(1)
        tmp1l = -Xl(1)
      elseif (
     +  (Xh(1) .eq. 0.0d+0).and.
     +  (Xl(1) .lt. 0.0d+0)) then
        tmp1h = Xh(1)
        tmp1l = -Xl(1)
      else
        tmp1h = Xh(1)
        tmp1l = Xl(1)
      endif
!>>>  tmp1 = abs(X(1))
!          NORM = ABS(X(1))
      NORMh = tmp1h
      NORMl = tmp1l
      ELSE
!          SCALE = ZERO
      SCALEh = ZEROh
      SCALEl = ZEROl
!          SSQ = ONE
      SSQh = ONEh
      SSQl = ONEl
*        The following loop is equivalent to this call to the LAPACK
*        auxiliary routine:
*        CALL DLASSQ( N, X, INCX, SCALE, SSQ )
*
          DO 10 IX = 1,1 + (N-1)*INCX,INCX
              IF (
!                  X(IX).NE.ZERO
!       (X(IX) .ne. ZERO)
     + ((Xh(IX) .ne. ZEROh) .or.
     +  (Xl(IX) .ne. ZEROl))
     &            ) THEN
!                  ABSXI = ABS(X(IX))
!<<<  ABSXI = abs(X(IX))
      if (Xh(IX) .lt. 0.0d+0) then
        ABSXIh = -Xh(IX)
        ABSXIl = -Xl(IX)
      elseif (
     +  (Xh(IX) .eq. 0.0d+0).and.
     +  (Xl(IX) .lt. 0.0d+0)) then
        ABSXIh = Xh(IX)
        ABSXIl = -Xl(IX)
      else
        ABSXIh = Xh(IX)
        ABSXIl = Xl(IX)
      endif
!>>>  ABSXI = abs(X(IX))
                  IF (
!                      SCALE.LT.ABSXI
!       (SCALE .lt. ABSXI)
     + ((SCALEh .lt. ABSXIh) .or.
     +  ((SCALEh .eq. ABSXIh) .and.
     +   (SCALEl .lt. ABSXIl)))
     &            ) THEN
!                      SSQ = ONE + SSQ* (SCALE/ABSXI)**2
!<<<  tmp1 = SCALE / ABSXI
      T_q1 = SCALEh / ABSXIh
      tmp1h = ABSXIh * T_q1
      T_u1 = 134217729.0 * ABSXIh
      T_p1 = T_u1
     +         - (T_u1 - ABSXIh)
      T_p2 = ABSXIh - T_p1
      T_u1 = 134217729.0 * T_q1
      T_r1 = T_u1
     +         - (T_u1 - T_q1)
      T_r2 = T_q1 - T_r1
      tmp1l = ((T_p1*T_r1
     +       - tmp1h)
     +       + T_p1*T_r2
     +       + T_p2*T_r1)
     +       + T_p2*T_r2
      tmp1l = tmp1l + (ABSXIl*T_q1)
      T_s1 = tmp1h + tmp1l
      tmp1l = tmp1l - (T_s1 - tmp1h)
      tmp1h = T_s1
      T_s1 = SCALEh - tmp1h
      T_r1 = T_s1 - SCALEh
      T_s2 = (SCALEh 
     +         - (T_s1 - T_r1))
     +         - (tmp1h + T_r1)
      T_s2 = T_s2 - tmp1l
      T_s2 = T_s2 + SCALEl
      T_q2 = (T_s1 + T_s2)
     +         / ABSXIh
      tmp1h = T_q1 + T_q2
      tmp1l = T_q2
     +      - (tmp1h - T_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>  tmp1 = SCALE / ABSXI
!<<<  tmp2 = tmp1 * tmp1
      tmp2h = tmp1h * tmp1h
      T_u1 = 134217729.0 * tmp1h
      T_p1 = T_u1
     +         - (T_u1 - tmp1h)
      T_p2 = tmp1h - T_p1
      T_u1 = 134217729.0 * tmp1h
      T_r1 = T_u1
     +         - (T_u1 - tmp1h)
      T_r2 = tmp1h - T_r1
      tmp2l = ((T_p1*T_r1
     +        - tmp2h)
     +        + T_p1 * T_r2
     +        + T_p2 * T_r1)
     +        + T_p2 * T_r2
      tmp2l = tmp2l
     +      + (tmp1h*tmp1l
     +      + tmp1l*tmp1h)
      T_s1 = tmp2h + tmp2l
      tmp2l = tmp2l - (T_s1 - tmp2h)
      tmp2h = T_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>  tmp2 = tmp1 * tmp1
!<<<  tmp3 = SSQ * tmp2
      tmp3h = SSQh * tmp2h
      T_u1 = 134217729.0 * SSQh
      T_p1 = T_u1
     +         - (T_u1 - SSQh)
      T_p2 = SSQh - T_p1
      T_u1 = 134217729.0 * tmp2h
      T_r1 = T_u1
     +         - (T_u1 - tmp2h)
      T_r2 = tmp2h - T_r1
      tmp3l = ((T_p1*T_r1
     +        - tmp3h)
     +        + T_p1 * T_r2
     +        + T_p2 * T_r1)
     +        + T_p2 * T_r2
      tmp3l = tmp3l
     +      + (SSQh*tmp2l
     +      + SSQl*tmp2h)
      T_s1 = tmp3h + tmp3l
      tmp3l = tmp3l - (T_s1 - tmp3h)
      tmp3h = T_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>  tmp3 = SSQ * tmp2
!<<<  SSQ = ONE + tmp3
      T_p1 = ONEh + tmp3h
      T_p2 = T_p1 - ONEh
      SSQh = T_p1
      SSQl = (ONEh - (T_p1 - T_p2))
     +      + (tmp3h - T_p2)
      SSQl = SSQl + ONEl + tmp3l
      T_s1 = SSQh + SSQl
      SSQl = SSQl - (T_s1 - SSQh)
      SSQh = T_s1
#ifdef FPCOUNTER
#include "fadd.h"
#endif
!>>>  SSQ = ONE + tmp3
!                      SCALE = ABSXI
      SCALEh = ABSXIh
      SCALEl = ABSXIl
                  ELSE
!                      SSQ = SSQ + (ABSXI/SCALE)**2
!<<<  tmp1 = ABSXI / SCALE
      T_q1 = ABSXIh / SCALEh
      tmp1h = SCALEh * T_q1
      T_u1 = 134217729.0 * SCALEh
      T_p1 = T_u1
     +         - (T_u1 - SCALEh)
      T_p2 = SCALEh - T_p1
      T_u1 = 134217729.0 * T_q1
      T_r1 = T_u1
     +         - (T_u1 - T_q1)
      T_r2 = T_q1 - T_r1
      tmp1l = ((T_p1*T_r1
     +       - tmp1h)
     +       + T_p1*T_r2
     +       + T_p2*T_r1)
     +       + T_p2*T_r2
      tmp1l = tmp1l + (SCALEl*T_q1)
      T_s1 = tmp1h + tmp1l
      tmp1l = tmp1l - (T_s1 - tmp1h)
      tmp1h = T_s1
      T_s1 = ABSXIh - tmp1h
      T_r1 = T_s1 - ABSXIh
      T_s2 = (ABSXIh 
     +         - (T_s1 - T_r1))
     +         - (tmp1h + T_r1)
      T_s2 = T_s2 - tmp1l
      T_s2 = T_s2 + ABSXIl
      T_q2 = (T_s1 + T_s2)
     +         / SCALEh
      tmp1h = T_q1 + T_q2
      tmp1l = T_q2
     +      - (tmp1h - T_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>  tmp1 = ABSXI / SCALE
!<<<  tmp2 = tmp1 * tmp1
      tmp2h = tmp1h * tmp1h
      T_u1 = 134217729.0 * tmp1h
      T_p1 = T_u1
     +         - (T_u1 - tmp1h)
      T_p2 = tmp1h - T_p1
      T_u1 = 134217729.0 * tmp1h
      T_r1 = T_u1
     +         - (T_u1 - tmp1h)
      T_r2 = tmp1h - T_r1
      tmp2l = ((T_p1*T_r1
     +        - tmp2h)
     +        + T_p1 * T_r2
     +        + T_p2 * T_r1)
     +        + T_p2 * T_r2
      tmp2l = tmp2l
     +      + (tmp1h*tmp1l
     +      + tmp1l*tmp1h)
      T_s1 = tmp2h + tmp2l
      tmp2l = tmp2l - (T_s1 - tmp2h)
      tmp2h = T_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>  tmp2 = tmp1 * tmp1
!<<<  SSQ = SSQ + tmp2
      T_p1 = SSQh + tmp2h
      T_p2 = T_p1 - SSQh
      T_q1 = T_p1
      T_q2 = (SSQh - (T_p1 - T_p2))
     +         + (tmp2h - T_p2)
      T_q2 = T_q2 + SSQl + tmp2l
      SSQh = T_q1 + T_q2
      SSQl = T_q2 - (SSQh - T_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>  SSQ = SSQ + tmp2
                  END IF
              END IF
   10     CONTINUE
!          NORM = SCALE*SQRT(SSQ)
!<<<  tmp1 = sqrt(SSQ)
      if (SSQh.eq.0.0D+0.and.SSQl.eq.0.0D+0) then
        tmp1h = 0.0d+0
        tmp1l = 0.0d+0
      endif
      if (SSQh.lt.0.0d+0.or.
     +   (SSQh.eq.0.0d+0.and.SSQl.lt.0.0d+0)) then
        write(6,'(a)')
     +     'SQRT CALLED WITH NEGATIVE ARGUMENT'
        tmp1h = 0.0d+0
        tmp1l = 0.0d+0
        return
      endif
      T_x = 1.0D+0/sqrt(SSQh)
      T_ax = SSQh * T_x
!         call dd_mul(T_y1,T_y2,T_x,
!                     0.0,0.5,0.0)
          T_y1 = T_x * 0.5d+0
          T_u1 = 134217729.0 * T_x
          T_p1 = T_u1
     +             - (T_u1 - T_x)
          T_p2 = T_x - T_p1
          T_u1 = 134217729.0 * 0.5d+0
          T_r1 = T_u1
     +             - (T_u1 - 0.5d+0)
          T_r2 = 0.5d+0 - T_r1
          T_y2 = ((T_p1*T_r1
     +             - T_y1)
     +             + T_p1*T_r2
     +             + T_p2 * T_r1)
     +             + T_p2 * T_r2
          T_s1 = T_y1 + T_y2
          T_y2 = T_y2
     +             - (T_s1 - T_y1)
          T_y1 = T_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!         call dd_mul(T_z1,T_z2,T_ax,
!                     0.0,T_ax,0.0)
          T_z1 = T_ax * T_ax
          T_u1 = 134217729.0 * T_ax
          T_p1 = T_u1
     +             - (T_u1 - T_ax)
          T_p2 = T_ax - T_p1
          T_u1 = 134217729.0 * T_ax
          T_r1 = T_u1
     +             - (T_u1 - T_ax)
          T_r2 = T_ax - T_r1
          T_z2 = ((T_p1 * T_r1
     +             - T_z1)
     +             + T_p1 * T_r2
     +             + T_p2 * T_r1)
     +             + T_p2*T_r2
          T_s1 = T_z1 + T_z2
          T_z2 = T_z2
     +             - (T_s1 - T_z1)
          T_z1 = T_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!         call dd_sub(T_t2h,T_t2l,
!                           SSQh,SSQl,T_z1,T_z2)
          T_p1 = SSQh - T_z1
          T_p2 = T_p1 - SSQh
          T_t2l = (SSQh
     +             -(T_p1 - T_p2))
     +             -(T_z1 + T_p2)
          T_t2h = T_p1
          T_t2l = T_t2l
     +             + SSQl - T_z2
          T_s1 = T_t2h + T_t2l
          T_t2l = T_t2l
     +             - (T_s1 - T_t2h)
          T_t2h = T_s1
#ifdef FPCOUNTER
#include "fsub.h"
#endif
!         call dd_mul(T_t1h,T_t1l,
!                     T_t2h,T_t2l,
!                     T_y1,T_y2)
          T_t1h = T_t2h * T_y1
          T_u1 = 134217729.0 * T_t2h
          T_p1 = T_u1
     +             - (T_u1 - T_t2h)
          T_p2 = T_t2h - T_p1
          T_u1 = 134217729.0 * T_y1
          T_r1 = T_u1
     +             - (T_u1 - T_y1)
          T_r2 = T_y1 - T_r1
          T_t1l = ((T_p1*T_r1
     +             - T_t1h)
     +             + T_p1*T_r2
     +             + T_p2*T_r1)
     +             + T_p2*T_r2
          T_t1l = T_t1l
     +             + (T_t2h * T_y2
     +             +  T_t2l * T_y1)
          T_s1 = T_t1h + T_t1l
          T_t1l = T_t1l - (T_s1
     +              - T_t1h)
          T_t1h = T_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!         call dd_selfadd(T_t1h,T_t1l,
!                     T_ax,0.0)
          T_p1 = T_t1h + T_ax
          T_p2 = T_p1 - T_t1h
          T_q2 = (T_t1h
     +             - (T_p1 - T_p2))
     +             + (T_ax - T_p2)
          T_q1 = T_p1
          T_q2 = T_q2 + T_t1l
          T_t1h = T_q1 + T_q2
          T_t1l = T_q2
     +              - (T_t1h - T_q1)
          tmp1h = T_t1h
          tmp1l = T_t1l
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>  tmp1 = sqrt(SSQ)
!<<<  NORM = SCALE * tmp1
      NORMh = SCALEh * tmp1h
      T_u1 = 134217729.0 * SCALEh
      T_p1 = T_u1
     +         - (T_u1 - SCALEh)
      T_p2 = SCALEh - T_p1
      T_u1 = 134217729.0 * tmp1h
      T_r1 = T_u1
     +         - (T_u1 - tmp1h)
      T_r2 = tmp1h - T_r1
      NORMl = ((T_p1*T_r1
     +        - NORMh)
     +        + T_p1 * T_r2
     +        + T_p2 * T_r1)
     +        + T_p2 * T_r2
      NORMl = NORMl
     +      + (SCALEh*tmp1l
     +      + SCALEl*tmp1h)
      T_s1 = NORMh + NORMl
      NORMl = NORMl - (T_s1 - NORMh)
      NORMh = T_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>  NORM = SCALE * tmp1
      END IF
*
!      DNRM2 = NORM
      DDNRM2h = NORMh
      DDNRM2l = NORMl
      RETURN
*
*     End of DNRM2.
*
      END
