!     SUBROUTINE DROTG(DA,DB,C,S)
      subroutine ddrotg(dah,dal,dbh,dbl,ch,cl,sh,sl)
      implicit none
*     .. Scalar Arguments ..
!     DOUBLE PRECISION C,DA,DB,S
      double precision ch, cl
      double precision dah, dal
      double precision dbh, dbl
      double precision sh, sl
*     ..
*
*  Purpose
*  =======
*
*     construct givens plane rotation.
*     jack dongarra, linpack, 3/11/78.
*
*
*     .. Local Scalars ..
!     DOUBLE PRECISION R,ROE,SCALE,Z
      double precision rh, rl
      double precision roeh, roel
      double precision scaleh, scalel
      double precision zh, zl
      double precision oneh, onel
      double precision absdah, absdal
      double precision absdbh, absdbl
#ifdef FPCOUNTER
#include "fpcounter.h"
#endif
      double precision ddtah, ddtal
      double precision ddta2h, ddta2l
      double precision ddtbh, ddtbl
      double precision ddtb2h, ddtb2l
      double precision ddtxh, ddtxl
      double precision ddtx2h, ddtx2l
!     tmp vars
      double precision t_ch, t_cl
      double precision t_p1, t_p2
      double precision t_q1, t_q2
      double precision t_r1, t_r2
      double precision t_s1, t_s2
      double precision t_t1, t_t2
      double precision t_u1, t_u2
      double precision t_x1, t_x2
      double precision t_y1, t_y2
      double precision t_z1, t_z2
      double precision t_x, t_ax
      double precision t_t1h, t_t1l
      double precision t_t2h, t_t2l
#ifdef FPCOUNTER
!     Dummy var
      integer incx, n
#endif
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC DABS,DSIGN,DSQRT
*     ..
      oneh = 1.0d+0
      onel = 0.0d+0
#ifdef FPCOUNTER
#include "finit.h"
      SUBNAME = "ddrotg"
#endif
!     ROE = DB
      roeh = dbh
      roel = dbl
!<<<  absda = abs(da)
      if (dah .lt. 0.0d+0) then
        absdah = -dah
        absdal = -dal
      elseif (
     +  (dah .eq. 0.0d+0).and.
     +  (dal .lt. 0.0d+0)) then
        absdah = dah
        absdal = -dal
      else
        absdah = dah
        absdal = dal
      endif
!>>>  absda = abs(da)
!<<<  absdb = abs(db)
      if (dbh .lt. 0.0d+0) then
        absdbh = -dbh
        absdbl = -dbl
      elseif (
     +  (dbh .eq. 0.0d+0).and.
     +  (dbl .lt. 0.0d+0)) then
        absdbh = dbh
        absdbl = -dbl
      else
        absdbh = dbh
        absdbl = dbl
      endif
!>>>  absdb = abs(db)
!     IF (DABS(DA).GT.DABS(DB)) ROE = DA
      if(
!       (absda .gt. absdb)
     + ((absdah .gt. absdbh) .or.
     +  ((absdah .eq. absdbh) .and.
     +   (absdal .gt. absdbl)))
     +)then
!     #roe = da
      roeh = dah
      roel = dal
      endif
!     SCALE = DABS(DA) + DABS(DB)
!<<<  scale = absda + absdb
      t_p1 = absdah + absdbh
      t_p2 = t_p1 - absdah
      scaleh = t_p1
      scalel = (absdah - (t_p1 - t_p2))
     +      + (absdbh - t_p2)
      scalel = scalel + absdal + absdbl
      t_s1 = scaleh + scalel
      scalel = scalel - (t_s1 - scaleh)
      scaleh = t_s1
#ifdef FPCOUNTER
#include "fadd.h"
#endif
!>>>  scale = absda + absdb
!     IF (SCALE.NE.0.0d0) GO TO 10
      if(
!       (scale .ne. 0.0)
     + ((scaleh .ne. 0.0d+0) .or.
     +  (scalel .ne. 0.0d+0))
     +) goto 10
!     C = 1.0d0
      ch = 1.0d+0
      cl = 0.0d+0
!     S = 0.0d0
      sh = 0.0d+0
      sl = 0.0d+0
!     R = 0.0d0
      rh = 0.0d+0
      rl = 0.0d+0
!     Z = 0.0d0
      zh = 0.0d+0
      zl = 0.0d+0
      GO TO 20
!  10 R = SCALE*DSQRT((DA/SCALE)**2+ (DB/SCALE)**2)
   10 continue
!<<<  ddta = da / scale
      t_q1 = dah / scaleh
      ddtah = scaleh * t_q1
      t_u1 = 134217729.0 * scaleh
      t_p1 = t_u1
     +         - (t_u1 - scaleh)
      t_p2 = scaleh - t_p1
      t_u1 = 134217729.0 * t_q1
      t_r1 = t_u1
     +         - (t_u1 - t_q1)
      t_r2 = t_q1 - t_r1
      ddtal = ((t_p1*t_r1
     +       - ddtah)
     +       + t_p1*t_r2
     +       + t_p2*t_r1)
     +       + t_p2*t_r2
      ddtal = ddtal + (scalel*t_q1)
      t_s1 = ddtah + ddtal
      ddtal = ddtal - (t_s1 - ddtah)
      ddtah = t_s1
      t_s1 = dah - ddtah
      t_r1 = t_s1 - dah
      t_s2 = (dah 
     +         - (t_s1 - t_r1))
     +         - (ddtah + t_r1)
      t_s2 = t_s2 - ddtal
      t_s2 = t_s2 + dal
      t_q2 = (t_s1 + t_s2)
     +         / scaleh
      ddtah = t_q1 + t_q2
      ddtal = t_q2
     +      - (ddtah - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>  ddta = da / scale
!<<<  ddta2 = ddta * ddta
      ddta2h = ddtah * ddtah
      t_u1 = 134217729.0 * ddtah
      t_p1 = t_u1
     +         - (t_u1 - ddtah)
      t_p2 = ddtah - t_p1
      t_u1 = 134217729.0 * ddtah
      t_r1 = t_u1
     +         - (t_u1 - ddtah)
      t_r2 = ddtah - t_r1
      ddta2l = ((t_p1*t_r1
     +        - ddta2h)
     +        + t_p1 * t_r2
     +        + t_p2 * t_r1)
     +        + t_p2 * t_r2
      ddta2l = ddta2l
     +      + (ddtah*ddtal
     +      + ddtal*ddtah)
      t_s1 = ddta2h + ddta2l
      ddta2l = ddta2l - (t_s1 - ddta2h)
      ddta2h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>  ddta2 = ddta * ddta
!<<<  ddtb = db / scale
      t_q1 = dbh / scaleh
      ddtbh = scaleh * t_q1
      t_u1 = 134217729.0 * scaleh
      t_p1 = t_u1
     +         - (t_u1 - scaleh)
      t_p2 = scaleh - t_p1
      t_u1 = 134217729.0 * t_q1
      t_r1 = t_u1
     +         - (t_u1 - t_q1)
      t_r2 = t_q1 - t_r1
      ddtbl = ((t_p1*t_r1
     +       - ddtbh)
     +       + t_p1*t_r2
     +       + t_p2*t_r1)
     +       + t_p2*t_r2
      ddtbl = ddtbl + (scalel*t_q1)
      t_s1 = ddtbh + ddtbl
      ddtbl = ddtbl - (t_s1 - ddtbh)
      ddtbh = t_s1
      t_s1 = dbh - ddtbh
      t_r1 = t_s1 - dbh
      t_s2 = (dbh 
     +         - (t_s1 - t_r1))
     +         - (ddtbh + t_r1)
      t_s2 = t_s2 - ddtbl
      t_s2 = t_s2 + dbl
      t_q2 = (t_s1 + t_s2)
     +         / scaleh
      ddtbh = t_q1 + t_q2
      ddtbl = t_q2
     +      - (ddtbh - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>  ddtb = db / scale
!<<<  ddtb2 = ddtb * ddtb
      ddtb2h = ddtbh * ddtbh
      t_u1 = 134217729.0 * ddtbh
      t_p1 = t_u1
     +         - (t_u1 - ddtbh)
      t_p2 = ddtbh - t_p1
      t_u1 = 134217729.0 * ddtbh
      t_r1 = t_u1
     +         - (t_u1 - ddtbh)
      t_r2 = ddtbh - t_r1
      ddtb2l = ((t_p1*t_r1
     +        - ddtb2h)
     +        + t_p1 * t_r2
     +        + t_p2 * t_r1)
     +        + t_p2 * t_r2
      ddtb2l = ddtb2l
     +      + (ddtbh*ddtbl
     +      + ddtbl*ddtbh)
      t_s1 = ddtb2h + ddtb2l
      ddtb2l = ddtb2l - (t_s1 - ddtb2h)
      ddtb2h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>  ddtb2 = ddtb * ddtb
!<<<  ddtx = ddta2 + ddtb2
      t_p1 = ddta2h + ddtb2h
      t_p2 = t_p1 - ddta2h
      ddtxh = t_p1
      ddtxl = (ddta2h - (t_p1 - t_p2))
     +      + (ddtb2h - t_p2)
      ddtxl = ddtxl + ddta2l + ddtb2l
      t_s1 = ddtxh + ddtxl
      ddtxl = ddtxl - (t_s1 - ddtxh)
      ddtxh = t_s1
#ifdef FPCOUNTER
#include "fadd.h"
#endif
!>>>  ddtx = ddta2 + ddtb2
!<<<  ddtx2 = sqrt(ddtx)
      if (ddtxh.eq.0.0D+0.and.ddtxl.eq.0.0D+0) then
        ddtx2h = 0.0d+0
        ddtx2l = 0.0d+0
      endif
      if (ddtxh.lt.0.0d+0.or.
     +   (ddtxh.eq.0.0d+0.and.ddtxl.lt.0.0d+0)) then
        write(6,'(a)')
     +     'SQRT CALLED WITH NEGATIVE ARGUMENT'
        ddtx2h = 0.0d+0
        ddtx2l = 0.0d+0
        return
      endif
      t_x = 1.0D+0/sqrt(ddtxh)
      t_ax = ddtxh * t_x
!         call dd_mul(t_y1,t_y2,t_x,
!                     0.0,0.5,0.0)
          t_y1 = t_x * 0.5d+0
          t_u1 = 134217729.0 * t_x
          t_p1 = t_u1
     +             - (t_u1 - t_x)
          t_p2 = t_x - t_p1
          t_u1 = 134217729.0 * 0.5d+0
          t_r1 = t_u1
     +             - (t_u1 - 0.5d+0)
          t_r2 = 0.5d+0 - t_r1
          t_y2 = ((t_p1*t_r1
     +             - t_y1)
     +             + t_p1*t_r2
     +             + t_p2 * t_r1)
     +             + t_p2 * t_r2
          t_s1 = t_y1 + t_y2
          t_y2 = t_y2
     +             - (t_s1 - t_y1)
          t_y1 = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!         call dd_mul(t_z1,t_z2,t_ax,
!                     0.0,t_ax,0.0)
          t_z1 = t_ax * t_ax
          t_u1 = 134217729.0 * t_ax
          t_p1 = t_u1
     +             - (t_u1 - t_ax)
          t_p2 = t_ax - t_p1
          t_u1 = 134217729.0 * t_ax
          t_r1 = t_u1
     +             - (t_u1 - t_ax)
          t_r2 = t_ax - t_r1
          t_z2 = ((t_p1 * t_r1
     +             - t_z1)
     +             + t_p1 * t_r2
     +             + t_p2 * t_r1)
     +             + t_p2*t_r2
          t_s1 = t_z1 + t_z2
          t_z2 = t_z2
     +             - (t_s1 - t_z1)
          t_z1 = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!         call dd_sub(t_t2h,t_t2l,
!                           ddtxh,ddtxl,t_z1,t_z2)
          t_p1 = ddtxh - t_z1
          t_p2 = t_p1 - ddtxh
          t_t2l = (ddtxh
     +             -(t_p1 - t_p2))
     +             -(t_z1 + t_p2)
          t_t2h = t_p1
          t_t2l = t_t2l
     +             + ddtxl - t_z2
          t_s1 = t_t2h + t_t2l
          t_t2l = t_t2l
     +             - (t_s1 - t_t2h)
          t_t2h = t_s1
#ifdef FPCOUNTER
#include "fsub.h"
#endif
!         call dd_mul(t_t1h,t_t1l,
!                     t_t2h,t_t2l,
!                     t_y1,t_y2)
          t_t1h = t_t2h * t_y1
          t_u1 = 134217729.0 * t_t2h
          t_p1 = t_u1
     +             - (t_u1 - t_t2h)
          t_p2 = t_t2h - t_p1
          t_u1 = 134217729.0 * t_y1
          t_r1 = t_u1
     +             - (t_u1 - t_y1)
          t_r2 = t_y1 - t_r1
          t_t1l = ((t_p1*t_r1
     +             - t_t1h)
     +             + t_p1*t_r2
     +             + t_p2*t_r1)
     +             + t_p2*t_r2
          t_t1l = t_t1l
     +             + (t_t2h * t_y2
     +             +  t_t2l * t_y1)
          t_s1 = t_t1h + t_t1l
          t_t1l = t_t1l - (t_s1
     +              - t_t1h)
          t_t1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!         call dd_selfadd(t_t1h,t_t1l,
!                     t_ax,0.0)
          t_p1 = t_t1h + t_ax
          t_p2 = t_p1 - t_t1h
          t_q2 = (t_t1h
     +             - (t_p1 - t_p2))
     +             + (t_ax - t_p2)
          t_q1 = t_p1
          t_q2 = t_q2 + t_t1l
          t_t1h = t_q1 + t_q2
          t_t1l = t_q2
     +              - (t_t1h - t_q1)
          ddtx2h = t_t1h
          ddtx2l = t_t1l
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>  ddtx2 = sqrt(ddtx)
!<<<  r = scale * ddtx2
      rh = scaleh * ddtx2h
      t_u1 = 134217729.0 * scaleh
      t_p1 = t_u1
     +         - (t_u1 - scaleh)
      t_p2 = scaleh - t_p1
      t_u1 = 134217729.0 * ddtx2h
      t_r1 = t_u1
     +         - (t_u1 - ddtx2h)
      t_r2 = ddtx2h - t_r1
      rl = ((t_p1*t_r1
     +        - rh)
     +        + t_p1 * t_r2
     +        + t_p2 * t_r1)
     +        + t_p2 * t_r2
      rl = rl
     +      + (scaleh*ddtx2l
     +      + scalel*ddtx2h)
      t_s1 = rh + rl
      rl = rl - (t_s1 - rh)
      rh = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>  r = scale * ddtx2
!     R = DSIGN(1.0d0,ROE)*R
!     if(roeh < 0.0d0)then
      if(
!       (roe .lt. 0.0)
     + ((roeh .lt. 0.0d+0) .or.
     +  ((roeh .eq. 0.0d+0) .and.
     +   (roel .lt. 0.0d+0)))
     +) then
!<<<  r = -r
      rh = -rh
      rl = -rl
!>>>  r = -r
      endif
!     C = DA/R
!<<<  c = da / r
      t_q1 = dah / rh
      ch = rh * t_q1
      t_u1 = 134217729.0 * rh
      t_p1 = t_u1
     +         - (t_u1 - rh)
      t_p2 = rh - t_p1
      t_u1 = 134217729.0 * t_q1
      t_r1 = t_u1
     +         - (t_u1 - t_q1)
      t_r2 = t_q1 - t_r1
      cl = ((t_p1*t_r1
     +       - ch)
     +       + t_p1*t_r2
     +       + t_p2*t_r1)
     +       + t_p2*t_r2
      cl = cl + (rl*t_q1)
      t_s1 = ch + cl
      cl = cl - (t_s1 - ch)
      ch = t_s1
      t_s1 = dah - ch
      t_r1 = t_s1 - dah
      t_s2 = (dah 
     +         - (t_s1 - t_r1))
     +         - (ch + t_r1)
      t_s2 = t_s2 - cl
      t_s2 = t_s2 + dal
      t_q2 = (t_s1 + t_s2)
     +         / rh
      ch = t_q1 + t_q2
      cl = t_q2
     +      - (ch - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>  c = da / r
!     S = DB/R
!<<<  s = db / r
      t_q1 = dbh / rh
      sh = rh * t_q1
      t_u1 = 134217729.0 * rh
      t_p1 = t_u1
     +         - (t_u1 - rh)
      t_p2 = rh - t_p1
      t_u1 = 134217729.0 * t_q1
      t_r1 = t_u1
     +         - (t_u1 - t_q1)
      t_r2 = t_q1 - t_r1
      sl = ((t_p1*t_r1
     +       - sh)
     +       + t_p1*t_r2
     +       + t_p2*t_r1)
     +       + t_p2*t_r2
      sl = sl + (rl*t_q1)
      t_s1 = sh + sl
      sl = sl - (t_s1 - sh)
      sh = t_s1
      t_s1 = dbh - sh
      t_r1 = t_s1 - dbh
      t_s2 = (dbh 
     +         - (t_s1 - t_r1))
     +         - (sh + t_r1)
      t_s2 = t_s2 - sl
      t_s2 = t_s2 + dbl
      t_q2 = (t_s1 + t_s2)
     +         / rh
      sh = t_q1 + t_q2
      sl = t_q2
     +      - (sh - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>  s = db / r
!     Z = 1.0d0
      zh = 1.0d+0
      zl = 0.0d+0
!<<<  absda = abs(da)
      if (dah .lt. 0.0d+0) then
        absdah = -dah
        absdal = -dal
      elseif (
     +  (dah .eq. 0.0d+0).and.
     +  (dal .lt. 0.0d+0)) then
        absdah = dah
        absdal = -dal
      else
        absdah = dah
        absdal = dal
      endif
!>>>  absda = abs(da)
!<<<  absdb = abs(db)
      if (dbh .lt. 0.0d+0) then
        absdbh = -dbh
        absdbl = -dbl
      elseif (
     +  (dbh .eq. 0.0d+0).and.
     +  (dbl .lt. 0.0d+0)) then
        absdbh = dbh
        absdbl = -dbl
      else
        absdbh = dbh
        absdbl = dbl
      endif
!>>>  absdb = abs(db)
!     IF (DABS(DA).GT.DABS(DB)) Z = S
      if(
!       (absda .gt. absdb)
     + ((absdah .gt. absdbh) .or.
     +  ((absdah .eq. absdbh) .and.
     +   (absdal .gt. absdbl)))
     +) then
!     #z = s
      zh = sh
      zl = sl
      endif
!     IF (DABS(DB).GE.DABS(DA) .AND. C.NE.0.0d0) Z = 1.0d0/C
      if(
!       (absdb .ge. absda)
     + ((absdbh .gt. absdah) .or.
     +  ((absdbh .eq. absdah) .and.
     +   (absdbl .ge. absdal)))
     +  .and.
!       (c .ne. 0.0)
     + ((ch .ne. 0.0d+0) .or.
     +  (cl .ne. 0.0d+0))
     +)then
!<<<  z = one / c
      t_q1 = oneh / ch
      zh = ch * t_q1
      t_u1 = 134217729.0 * ch
      t_p1 = t_u1
     +         - (t_u1 - ch)
      t_p2 = ch - t_p1
      t_u1 = 134217729.0 * t_q1
      t_r1 = t_u1
     +         - (t_u1 - t_q1)
      t_r2 = t_q1 - t_r1
      zl = ((t_p1*t_r1
     +       - zh)
     +       + t_p1*t_r2
     +       + t_p2*t_r1)
     +       + t_p2*t_r2
      zl = zl + (cl*t_q1)
      t_s1 = zh + zl
      zl = zl - (t_s1 - zh)
      zh = t_s1
      t_s1 = oneh - zh
      t_r1 = t_s1 - oneh
      t_s2 = (oneh 
     +         - (t_s1 - t_r1))
     +         - (zh + t_r1)
      t_s2 = t_s2 - zl
      t_s2 = t_s2 + onel
      t_q2 = (t_s1 + t_s2)
     +         / ch
      zh = t_q1 + t_q2
      zl = t_q2
     +      - (zh - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>  z = one / c
      endif
   20 continue
!  20 DA = R
      dah = rh
      dal = rl
!     DB = Z
      dbh = zh
      dbl = zl
 9999 continue
#ifdef FPCOUNTER
      WRITE(6,1000) "MODULE    = ddrotg"
#include "fout.h"
#include "fformat.h"
#endif
      RETURN
      END
