      SUBROUTINE DDSWAP(N,DXH,DXL,INCX,DYH,DYL,INCY)
*     .. Scalar Arguments ..
      INTEGER INCX,INCY,N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION DXH(*),DXL(*),DYH(*),DYL(*)
*     ..
*
*  Purpose
*  =======
*
*     interchanges two vectors.
*     uses unrolled loops for increments equal one.
*
*  Further Details
*  ===============
*
*     quad precision by Osamu Hino 01/04/2010
*
*  =====================================================================
*
*     .. Local Scalars ..
      DOUBLE PRECISION DTEMP
      INTEGER I,IX,IY,M,MP1
      integer IXG,IYG
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC MOD
*     ..
      IF (N.LE.0) RETURN
      IF (INCX.EQ.1 .AND. INCY.EQ.1) GO TO 20
*
*       code for unequal increments or equal increments not equal
*         to 1
*
      IX = 1
      IY = 1
      IF (INCX.LT.0) IX = (-N+1)*INCX + 1
      IF (INCY.LT.0) IY = (-N+1)*INCY + 1
      IXG = IX
      IYG = IY
!$omp parallel
!$omp do
!$omp& private(I,IX,IY,DTEMP)
      DO 10 I = 1,N
          IX = IXG + INCX*(I-1)
          IY = IYG + INCY*(I-1)
          DTEMP = DXH(IX)
          DXH(IX) = DYH(IY)
          DYH(IY) = DTEMP
*
          DTEMP = DXL(IX)
          DXL(IX) = DYL(IY)
          DYL(IY) = DTEMP
*
!          IX = IX + INCX
!          IY = IY + INCY
   10 CONTINUE
!$omp end parallel
      RETURN
*
*       code for both increments equal to 1
*
*
*       clean-up loop
*
   20 M = MOD(N,3)
      IF (M.EQ.0) GO TO 40
      DO 30 I = 1,M
          DTEMP = DXH(I)
          DXH(I) = DYH(I)
          DYH(I) = DTEMP
*
          DTEMP = DXL(I)
          DXL(I) = DYL(I)
          DYL(I) = DTEMP
   30 CONTINUE
      IF (N.LT.3) RETURN
   40 MP1 = M + 1
!$omp parallel private(I,DTEMP)
!$omp do
!$omp& private(I,DTEMP)
      DO 50 I = MP1,N,3
          DTEMP = DXH(I)
          DXH(I) = DYH(I)
          DYH(I) = DTEMP
          DTEMP = DXH(I+1)
          DXH(I+1) = DYH(I+1)
          DYH(I+1) = DTEMP
          DTEMP = DXH(I+2)
          DXH(I+2) = DYH(I+2)
          DYH(I+2) = DTEMP
*
          DTEMP = DXL(I)
          DXL(I) = DYL(I)
          DYL(I) = DTEMP
          DTEMP = DXL(I+1)
          DXL(I+1) = DYL(I+1)
          DYL(I+1) = DTEMP
          DTEMP = DXL(I+2)
          DXL(I+2) = DYL(I+2)
          DYL(I+2) = DTEMP
   50 CONTINUE
!$omp end parallel
      RETURN
      END
