!     SUBROUTINE DTRMM(SIDE,UPLO,TRANSA,DIAG,M,N,ALPHA,A,LDA,B,LDB)
      subroutine ddtrmm(side, uplo, transa, diag, m, n,
     +                  alphah, alphal ,ah, al, lda, bh, bl, ldb)
      implicit none
*     .. Scalar Arguments ..
!     DOUBLE PRECISION ALPHA
      double precision alphah, alphal
      INTEGER LDA,LDB,M,N
      CHARACTER DIAG,SIDE,TRANSA,UPLO
*     ..
*     .. Array Arguments ..
!     DOUBLE PRECISION A(LDA,*),B(LDB,*)
      double precision ah(lda,*), al(lda,*)
      double precision bh(ldb,*), bl(ldb,*)
!     tmp vars
      double precision t_ch, t_cl
      double precision t_p1, t_p2
      double precision t_q1, t_q2
      double precision t_r1, t_r2
      double precision t_s1, t_s2
      double precision t_t1, t_t2
      double precision t_u1, t_u2
      double precision t_x1, t_x2
      double precision t_y1, t_y2
      double precision t_z1, t_z2
      double precision t_x, t_ax
      double precision t_t1h, t_t1l
      double precision t_t2h, t_t2l
*     ..
*
*  Purpose
*  =======
*
*  DTRMM  performs one of the matrix-matrix operations
*
*     B := alpha*op( A )*B,   or   B := alpha*B*op( A ),
*
*  where  alpha  is a scalar,  B  is an m by n matrix,  A  is a unit, or
*  non-unit,  upper or lower triangular matrix  and  op( A )  is one  of
*
*     op( A ) = A   or   op( A ) = A'.
*
*  Arguments
*  ==========
*
*  SIDE   - CHARACTER*1.
*           On entry,  SIDE specifies whether  op( A ) multiplies B from
*           the left or right as follows:
*
*              SIDE = 'L' or 'l'   B := alpha*op( A )*B.
*
*              SIDE = 'R' or 'r'   B := alpha*B*op( A ).
*
*           Unchanged on exit.
*
*  UPLO   - CHARACTER*1.
*           On entry, UPLO specifies whether the matrix A is an upper or
*           lower triangular matrix as follows:
*
*              UPLO = 'U' or 'u'   A is an upper triangular matrix.
*
*              UPLO = 'L' or 'l'   A is a lower triangular matrix.
*
*           Unchanged on exit.
*
*  TRANSA - CHARACTER*1.
*           On entry, TRANSA specifies the form of op( A ) to be used in
*           the matrix multiplication as follows:
*
*              TRANSA = 'N' or 'n'   op( A ) = A.
*
*              TRANSA = 'T' or 't'   op( A ) = A'.
*
*              TRANSA = 'C' or 'c'   op( A ) = A'.
*
*           Unchanged on exit.
*
*  DIAG   - CHARACTER*1.
*           On entry, DIAG specifies whether or not A is unit triangular
*           as follows:
*
*              DIAG = 'U' or 'u'   A is assumed to be unit triangular.
*
*              DIAG = 'N' or 'n'   A is not assumed to be unit
*                                  triangular.
*
*           Unchanged on exit.
*
*  M      - INTEGER.
*           On entry, M specifies the number of rows of B. M must be at
*           least zero.
*           Unchanged on exit.
*
*  N      - INTEGER.
*           On entry, N specifies the number of columns of B.  N must be
*           at least zero.
*           Unchanged on exit.
*
*  ALPHA  - DOUBLE PRECISION.
*           On entry,  ALPHA specifies the scalar  alpha. When  alpha is
*           zero then  A is not referenced and  B need not be set before
*           entry.
*           Unchanged on exit.
*
*  A      - DOUBLE PRECISION array of DIMENSION ( LDA, k ), where k is m
*           when  SIDE = 'L' or 'l'  and is  n  when  SIDE = 'R' or 'r'.
*           Before entry  with  UPLO = 'U' or 'u',  the  leading  k by k
*           upper triangular part of the array  A must contain the upper
*           triangular matrix  and the strictly lower triangular part of
*           A is not referenced.
*           Before entry  with  UPLO = 'L' or 'l',  the  leading  k by k
*           lower triangular part of the array  A must contain the lower
*           triangular matrix  and the strictly upper triangular part of
*           A is not referenced.
*           Note that when  DIAG = 'U' or 'u',  the diagonal elements of
*           A  are not referenced either,  but are assumed to be  unity.
*           Unchanged on exit.
*
*  LDA    - INTEGER.
*           On entry, LDA specifies the first dimension of A as declared
*           in the calling (sub) program.  When  SIDE = 'L' or 'l'  then
*           LDA  must be at least  max( 1, m ),  when  SIDE = 'R' or 'r'
*           then LDA must be at least max( 1, n ).
*           Unchanged on exit.
*
*  B      - DOUBLE PRECISION array of DIMENSION ( LDB, n ).
*           Before entry,  the leading  m by n part of the array  B must
*           contain the matrix  B,  and  on exit  is overwritten  by the
*           transformed matrix.
*
*  LDB    - INTEGER.
*           On entry, LDB specifies the first dimension of B as declared
*           in  the  calling  (sub)  program.   LDB  must  be  at  least
*           max( 1, m ).
*           Unchanged on exit.
*
*
*  Level 3 Blas routine.
*
*  -- Written on 8-February-1989.
*     Jack Dongarra, Argonne National Laboratory.
*     Iain Duff, AERE Harwell.
*     Jeremy Du Croz, Numerical Algorithms Group Ltd.
*     Sven Hammarling, Numerical Algorithms Group Ltd.
*
*
! double double modefication (f.y.)
*     .. External Functions ..
      LOGICAL LSAME
      EXTERNAL LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC MAX
*     ..
*     .. Local Scalars ..
!     DOUBLE PRECISION TEMP
      double precision temph, templ
      INTEGER I,INFO,J,K,NROWA
      LOGICAL LSIDE,NOUNIT,UPPER
*     ..
*     .. Parameters ..
!     DOUBLE PRECISION ONE,ZERO
!     PARAMETER (ONE=1.0D+0,ZERO=0.0D+0)
      double precision oneh, onel
      double precision zeroh, zerol
      double precision ddmh, ddml
      double precision ddah, ddal
#ifdef FPCOUNTER
#include "fpcounter.h"
#endif
#ifdef FPCOUNTER
#include "finit.h"
      SUBNAME = "ddtrmm"
#endif
*     ..
*
*     Test the input parameters.
*
      zeroh = 0.0d+0
      zerol = 0.0d+0
      oneh = 1.0d+0
      onel = 0.0d+0
      LSIDE = LSAME(SIDE,'L')
      IF (LSIDE) THEN
          NROWA = M
      ELSE
          NROWA = N
      END IF
      NOUNIT = LSAME(DIAG,'N')
      UPPER = LSAME(UPLO,'U')
*
      INFO = 0
      IF ((.NOT.LSIDE) .AND. (.NOT.LSAME(SIDE,'R'))) THEN
          INFO = 1
      ELSE IF ((.NOT.UPPER) .AND. (.NOT.LSAME(UPLO,'L'))) THEN
          INFO = 2
      ELSE IF ((.NOT.LSAME(TRANSA,'N')) .AND.
     +         (.NOT.LSAME(TRANSA,'T')) .AND.
     +         (.NOT.LSAME(TRANSA,'C'))) THEN
          INFO = 3
      ELSE IF ((.NOT.LSAME(DIAG,'U')) .AND. (.NOT.LSAME(DIAG,'N'))) THEN
          INFO = 4
      ELSE IF (M.LT.0) THEN
          INFO = 5
      ELSE IF (N.LT.0) THEN
          INFO = 6
      ELSE IF (LDA.LT.MAX(1,NROWA)) THEN
          INFO = 9
      ELSE IF (LDB.LT.MAX(1,M)) THEN
          INFO = 11
      END IF
      IF (INFO.NE.0) THEN
          CALL XERBLA('DTRMM ',INFO)
          goto 9999
!         RETURN
      END IF
*
*     Quick return if possible.
*
!     IF (M.EQ.0 .OR. N.EQ.0) RETURN
      IF (M.EQ.0 .OR. N.EQ.0) goto 9999
*
*     And when  alpha.eq.zero.
*
!     IF (ALPHA.EQ.ZERO) THEN
      if(
!       (alpha .eq. zero)
     + ((alphah .eq. zeroh) .and.
     +  (alphal .eq. zerol))
     +) then
          DO 20 J = 1,N
!$omp parallel
!$omp do
!$omp+ private(I)
              DO 10 I = 1,M
!                 B(I,J) = ZERO
                  bh(i,j) = zeroh
                  bl(i,j) = zerol
   10         CONTINUE
!$omp end do
!$omp end parallel
   20     CONTINUE
          RETURN
      END IF
*
*     Start the operations.
*
      IF (LSIDE) THEN
          IF (LSAME(TRANSA,'N')) THEN
*
*           Form  B := alpha*A*B.
*
              IF (UPPER) THEN
                  DO 50 J = 1,N
                      DO 40 K = 1,M
!                         IF (B(K,J).NE.ZERO) THEN
                          if(
!                           (b(k,j) .ne. zero)
     +                     ((bh(k,j) .ne. zeroh) .or.
     +                      (bl(k,j) .ne. zerol))
     +                    ) then
!                             TEMP = ALPHA*B(K,J)
!<<<                        temp = alpha * b(k,j)
                            temph = alphah * bh(k,j)
                            t_u1 = 134217729.0 * alphah
                            t_p1 = t_u1
     +                               - (t_u1 - alphah)
                            t_p2 = alphah - t_p1
                            t_u1 = 134217729.0 * bh(k,j)
                            t_r1 = t_u1
     +                               - (t_u1 - bh(k,j))
                            t_r2 = bh(k,j) - t_r1
                            templ = ((t_p1*t_r1
     +                              - temph)
     +                              + t_p1 * t_r2
     +                              + t_p2 * t_r1)
     +                              + t_p2 * t_r2
                            templ = templ
     +                            + (alphah*bl(k,j)
     +                            + alphal*bh(k,j))
                            t_s1 = temph + templ
                            templ = templ - (t_s1 - temph)
                            temph = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>                        temp = alpha * b(k,j)
!$omp parallel
!$omp do
!$omp+ private(I)
!     tmp vars -> private
!$omp+ private(t_ch, t_cl)
!$omp+ private(t_p1, t_p2)
!$omp+ private(t_q1, t_q2)
!$omp+ private(t_r1, t_r2)
!$omp+ private(t_s1, t_s2)
!$omp+ private(t_t1, t_t2)
!$omp+ private(t_u1, t_u2)
!$omp+ private(t_x1, t_x2)
!$omp+ private(t_y1, t_y2)
!$omp+ private(t_z1, t_z2)
!$omp+ private(t_x, t_ax)
!$omp+ private(t_t1h, t_t1l)
!$omp+ private(t_t2h, t_t2l)
!$omp+ private(ddmh, ddml)
                              DO 30 I = 1,K - 1
!                                 B(I,J) = B(I,J) + TEMP*A(I,K)
!<<<                          ddm = temp * a(i,k)
                              ddmh = temph * ah(i,k)
                              t_u1 = 134217729.0 * temph
                              t_p1 = t_u1
     +                                 - (t_u1 - temph)
                              t_p2 = temph - t_p1
                              t_u1 = 134217729.0 * ah(i,k)
                              t_r1 = t_u1
     +                                 - (t_u1 - ah(i,k))
                              t_r2 = ah(i,k) - t_r1
                              ddml = ((t_p1*t_r1
     +                                - ddmh)
     +                                + t_p1 * t_r2
     +                                + t_p2 * t_r1)
     +                                + t_p2 * t_r2
                              ddml = ddml
     +                              + (temph*al(i,k)
     +                              + templ*ah(i,k))
                              t_s1 = ddmh + ddml
                              ddml = ddml - (t_s1 - ddmh)
                              ddmh = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>                          ddm = temp * a(i,k)
!<<<                          b(i,j) = b(i,j) + ddm
                              t_p1 = bh(i,j) + ddmh
                              t_p2 = t_p1 - bh(i,j)
                              t_q1 = t_p1
                              t_q2 = (bh(i,j) - (t_p1 - t_p2))
     +                                 + (ddmh - t_p2)
                              t_q2 = t_q2 + bl(i,j) + ddml
                              bh(i,j) = t_q1 + t_q2
                              bl(i,j) = t_q2 - (bh(i,j) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>                          b(i,j) = b(i,j) + ddm
   30                         CONTINUE
!$omp end do
!$omp end parallel
!                             IF (NOUNIT) TEMP = TEMP*A(K,K)
                              if(NOUNIT) then
!<<<                          temp = temp * a(k,k)
                              t_ch = temph * ah(k,k)
                              t_u1 = 134217729.0 * temph
                              t_p1 = t_u1
     +                                 - (t_u1 - temph)
                              t_p2 = temph - t_p1
                              t_u1 = 134217729.0 * ah(k,k)
                              t_r1 = t_u1
     +                                 - (t_u1 - ah(k,k))
                              t_r2 = ah(k,k) - t_r1
                              t_cl = ((t_p1*t_r1
     +                                 - t_ch)
     +                                + t_p1 * t_r2
     +                                + t_p2 * t_r1)
     +                                + t_p2 * t_r2
                              t_cl = t_cl
     +                                 + (temph*al(k,k)
     +                                 +  templ*ah(k,k))
                              t_s1 = t_ch + t_cl
                              templ = t_cl - (t_s1 - t_ch)
                              temph = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>                          temp = temp * a(k,k)
                              endif
!                             B(K,J) = TEMP
                            bh(k,j) = temph
                            bl(k,j) = templ
                          END IF
   40                 CONTINUE
   50             CONTINUE
              ELSE
                  DO 80 J = 1,N
                      DO 70 K = M,1,-1
!                         IF (B(K,J).NE.ZERO) THEN
                          if(
!                           (b(k,j) .ne. zero)
     +                     ((bh(k,j) .ne. zeroh) .or.
     +                      (bl(k,j) .ne. zerol))
     +                    ) then
!                             TEMP = ALPHA*B(K,J)
!<<<                        temp = alpha * b(k,j)
                            temph = alphah * bh(k,j)
                            t_u1 = 134217729.0 * alphah
                            t_p1 = t_u1
     +                               - (t_u1 - alphah)
                            t_p2 = alphah - t_p1
                            t_u1 = 134217729.0 * bh(k,j)
                            t_r1 = t_u1
     +                               - (t_u1 - bh(k,j))
                            t_r2 = bh(k,j) - t_r1
                            templ = ((t_p1*t_r1
     +                              - temph)
     +                              + t_p1 * t_r2
     +                              + t_p2 * t_r1)
     +                              + t_p2 * t_r2
                            templ = templ
     +                            + (alphah*bl(k,j)
     +                            + alphal*bh(k,j))
                            t_s1 = temph + templ
                            templ = templ - (t_s1 - temph)
                            temph = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>                        temp = alpha * b(k,j)
!                             B(K,J) = TEMP
                            bh(k,j) = temph
                            bl(k,j) = templ
!                             IF (NOUNIT) B(K,J) = B(K,J)*A(K,K)
                              if(nounit) then
!<<<                          b(k,j) = b(k,j) * a(k,k)
                              t_ch = bh(k,j) * ah(k,k)
                              t_u1 = 134217729.0 * bh(k,j)
                              t_p1 = t_u1
     +                                 - (t_u1 - bh(k,j))
                              t_p2 = bh(k,j) - t_p1
                              t_u1 = 134217729.0 * ah(k,k)
                              t_r1 = t_u1
     +                                 - (t_u1 - ah(k,k))
                              t_r2 = ah(k,k) - t_r1
                              t_cl = ((t_p1*t_r1
     +                                 - t_ch)
     +                                + t_p1 * t_r2
     +                                + t_p2 * t_r1)
     +                                + t_p2 * t_r2
                              t_cl = t_cl
     +                                 + (bh(k,j)*al(k,k)
     +                                 +  bl(k,j)*ah(k,k))
                              t_s1 = t_ch + t_cl
                              bl(k,j) = t_cl - (t_s1 - t_ch)
                              bh(k,j) = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>                          b(k,j) = b(k,j) * a(k,k)
                              endif
!$omp parallel
!$omp do
!$omp+ private(I)
!     tmp vars -> private
!$omp+ private(t_ch, t_cl)
!$omp+ private(t_p1, t_p2)
!$omp+ private(t_q1, t_q2)
!$omp+ private(t_r1, t_r2)
!$omp+ private(t_s1, t_s2)
!$omp+ private(t_t1, t_t2)
!$omp+ private(t_u1, t_u2)
!$omp+ private(t_x1, t_x2)
!$omp+ private(t_y1, t_y2)
!$omp+ private(t_z1, t_z2)
!$omp+ private(t_x, t_ax)
!$omp+ private(t_t1h, t_t1l)
!$omp+ private(t_t2h, t_t2l)
!$omp+ private(ddmh, ddml)
                              DO 60 I = K + 1,M
!                                 B(I,J) = B(I,J) + TEMP*A(I,K)
!<<<                          ddm = temp * a(i,k)
                              ddmh = temph * ah(i,k)
                              t_u1 = 134217729.0 * temph
                              t_p1 = t_u1
     +                                 - (t_u1 - temph)
                              t_p2 = temph - t_p1
                              t_u1 = 134217729.0 * ah(i,k)
                              t_r1 = t_u1
     +                                 - (t_u1 - ah(i,k))
                              t_r2 = ah(i,k) - t_r1
                              ddml = ((t_p1*t_r1
     +                                - ddmh)
     +                                + t_p1 * t_r2
     +                                + t_p2 * t_r1)
     +                                + t_p2 * t_r2
                              ddml = ddml
     +                              + (temph*al(i,k)
     +                              + templ*ah(i,k))
                              t_s1 = ddmh + ddml
                              ddml = ddml - (t_s1 - ddmh)
                              ddmh = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>                          ddm = temp * a(i,k)
!<<<                          b(i,j) = b(i,j) + ddm
                              t_p1 = bh(i,j) + ddmh
                              t_p2 = t_p1 - bh(i,j)
                              t_q1 = t_p1
                              t_q2 = (bh(i,j) - (t_p1 - t_p2))
     +                                 + (ddmh - t_p2)
                              t_q2 = t_q2 + bl(i,j) + ddml
                              bh(i,j) = t_q1 + t_q2
                              bl(i,j) = t_q2 - (bh(i,j) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>                          b(i,j) = b(i,j) + ddm
   60                         CONTINUE
!$omp end do
!$omp end parallel
                          END IF
   70                 CONTINUE
   80             CONTINUE
              END IF
          ELSE
*
*           Form  B := alpha*A'*B.
*
              IF (UPPER) THEN
                  DO 110 J = 1,N
                      DO 100 I = M,1,-1
!                         TEMP = B(I,J)
                          temph = bh(i,j)
                          templ = bl(i,j)
!                         IF (NOUNIT) TEMP = TEMP*A(I,I)
                          if(nounit) then
!<<<                        temp = temp * a(i,i)
                            t_ch = temph * ah(i,i)
                            t_u1 = 134217729.0 * temph
                            t_p1 = t_u1
     +                               - (t_u1 - temph)
                            t_p2 = temph - t_p1
                            t_u1 = 134217729.0 * ah(i,i)
                            t_r1 = t_u1
     +                               - (t_u1 - ah(i,i))
                            t_r2 = ah(i,i) - t_r1
                            t_cl = ((t_p1*t_r1
     +                               - t_ch)
     +                              + t_p1 * t_r2
     +                              + t_p2 * t_r1)
     +                              + t_p2 * t_r2
                            t_cl = t_cl
     +                               + (temph*al(i,i)
     +                               +  templ*ah(i,i))
                            t_s1 = t_ch + t_cl
                            templ = t_cl - (t_s1 - t_ch)
                            temph = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>                        temp = temp * a(i,i)
                          endif
!$omp parallel
!$omp do
!$omp+ private(K)
!     tmp vars -> private
!$omp+ private(t_ch, t_cl)
!$omp+ private(t_p1, t_p2)
!$omp+ private(t_q1, t_q2)
!$omp+ private(t_r1, t_r2)
!$omp+ private(t_s1, t_s2)
!$omp+ private(t_t1, t_t2)
!$omp+ private(t_u1, t_u2)
!$omp+ private(t_x1, t_x2)
!$omp+ private(t_y1, t_y2)
!$omp+ private(t_z1, t_z2)
!$omp+ private(t_x, t_ax)
!$omp+ private(t_t1h, t_t1l)
!$omp+ private(t_t2h, t_t2l)
!$omp+ private(ddmh, ddml)
                          DO 90 K = 1,I - 1
!                             TEMP = TEMP + A(K,I)*B(K,J)
!<<<                          ddm = a(k,i) * b(k,j)
                              ddmh = ah(k,i) * bh(k,j)
                              t_u1 = 134217729.0 * ah(k,i)
                              t_p1 = t_u1
     +                                 - (t_u1 - ah(k,i))
                              t_p2 = ah(k,i) - t_p1
                              t_u1 = 134217729.0 * bh(k,j)
                              t_r1 = t_u1
     +                                 - (t_u1 - bh(k,j))
                              t_r2 = bh(k,j) - t_r1
                              ddml = ((t_p1*t_r1
     +                                - ddmh)
     +                                + t_p1 * t_r2
     +                                + t_p2 * t_r1)
     +                                + t_p2 * t_r2
                              ddml = ddml
     +                              + (ah(k,i)*bl(k,j)
     +                              + al(k,i)*bh(k,j))
                              t_s1 = ddmh + ddml
                              ddml = ddml - (t_s1 - ddmh)
                              ddmh = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>                          ddm = a(k,i) * b(k,j)
!$omp critical
!<<<                          temp = temp + ddm
                              t_p1 = temph + ddmh
                              t_p2 = t_p1 - temph
                              t_q1 = t_p1
                              t_q2 = (temph - (t_p1 - t_p2))
     +                                 + (ddmh - t_p2)
                              t_q2 = t_q2 + templ + ddml
                              temph = t_q1 + t_q2
                              templ = t_q2 - (temph - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>                          temp = temp + ddm
!$omp end critical
   90                     CONTINUE
!$omp end do
!$omp end parallel
!                         B(I,J) = ALPHA*TEMP
!<<<                      b(i,j) = alpha * temp
                          bh(i,j) = alphah * temph
                          t_u1 = 134217729.0 * alphah
                          t_p1 = t_u1
     +                             - (t_u1 - alphah)
                          t_p2 = alphah - t_p1
                          t_u1 = 134217729.0 * temph
                          t_r1 = t_u1
     +                             - (t_u1 - temph)
                          t_r2 = temph - t_r1
                          bl(i,j) = ((t_p1*t_r1
     +                            - bh(i,j))
     +                            + t_p1 * t_r2
     +                            + t_p2 * t_r1)
     +                            + t_p2 * t_r2
                          bl(i,j) = bl(i,j)
     +                          + (alphah*templ
     +                          + alphal*temph)
                          t_s1 = bh(i,j) + bl(i,j)
                          bl(i,j) = bl(i,j) - (t_s1 - bh(i,j))
                          bh(i,j) = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>                      b(i,j) = alpha * temp
  100                 CONTINUE
  110             CONTINUE
              ELSE
                  DO 140 J = 1,N
                      DO 130 I = 1,M
!                         TEMP = B(I,J)
                          temph = bh(i,j)
                          templ = bl(i,j)
!                         IF (NOUNIT) TEMP = TEMP*A(I,I)
                          if(nounit) then
!<<<                        temp = temp * a(i,i)
                            t_ch = temph * ah(i,i)
                            t_u1 = 134217729.0 * temph
                            t_p1 = t_u1
     +                               - (t_u1 - temph)
                            t_p2 = temph - t_p1
                            t_u1 = 134217729.0 * ah(i,i)
                            t_r1 = t_u1
     +                               - (t_u1 - ah(i,i))
                            t_r2 = ah(i,i) - t_r1
                            t_cl = ((t_p1*t_r1
     +                               - t_ch)
     +                              + t_p1 * t_r2
     +                              + t_p2 * t_r1)
     +                              + t_p2 * t_r2
                            t_cl = t_cl
     +                               + (temph*al(i,i)
     +                               +  templ*ah(i,i))
                            t_s1 = t_ch + t_cl
                            templ = t_cl - (t_s1 - t_ch)
                            temph = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>                        temp = temp * a(i,i)
                          endif
!$omp parallel
!$omp do
!$omp+ private(K)
!     tmp vars -> private
!$omp+ private(t_ch, t_cl)
!$omp+ private(t_p1, t_p2)
!$omp+ private(t_q1, t_q2)
!$omp+ private(t_r1, t_r2)
!$omp+ private(t_s1, t_s2)
!$omp+ private(t_t1, t_t2)
!$omp+ private(t_u1, t_u2)
!$omp+ private(t_x1, t_x2)
!$omp+ private(t_y1, t_y2)
!$omp+ private(t_z1, t_z2)
!$omp+ private(t_x, t_ax)
!$omp+ private(t_t1h, t_t1l)
!$omp+ private(t_t2h, t_t2l)
!$omp+ private(ddmh, ddml)
                          DO 120 K = I + 1,M
!                             TEMP = TEMP + A(K,I)*B(K,J)
!<<<                          ddm = a(k,i) * b(k,j)
                              ddmh = ah(k,i) * bh(k,j)
                              t_u1 = 134217729.0 * ah(k,i)
                              t_p1 = t_u1
     +                                 - (t_u1 - ah(k,i))
                              t_p2 = ah(k,i) - t_p1
                              t_u1 = 134217729.0 * bh(k,j)
                              t_r1 = t_u1
     +                                 - (t_u1 - bh(k,j))
                              t_r2 = bh(k,j) - t_r1
                              ddml = ((t_p1*t_r1
     +                                - ddmh)
     +                                + t_p1 * t_r2
     +                                + t_p2 * t_r1)
     +                                + t_p2 * t_r2
                              ddml = ddml
     +                              + (ah(k,i)*bl(k,j)
     +                              + al(k,i)*bh(k,j))
                              t_s1 = ddmh + ddml
                              ddml = ddml - (t_s1 - ddmh)
                              ddmh = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>                          ddm = a(k,i) * b(k,j)
!$omp critical
!<<<                          temp = temp + ddm
                              t_p1 = temph + ddmh
                              t_p2 = t_p1 - temph
                              t_q1 = t_p1
                              t_q2 = (temph - (t_p1 - t_p2))
     +                                 + (ddmh - t_p2)
                              t_q2 = t_q2 + templ + ddml
                              temph = t_q1 + t_q2
                              templ = t_q2 - (temph - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>                          temp = temp + ddm
!$omp end critical
  120                     CONTINUE
!$omp end do
!$omp end parallel
!                         B(I,J) = ALPHA*TEMP
!<<<                      b(i,j) = alpha * temp
                          bh(i,j) = alphah * temph
                          t_u1 = 134217729.0 * alphah
                          t_p1 = t_u1
     +                             - (t_u1 - alphah)
                          t_p2 = alphah - t_p1
                          t_u1 = 134217729.0 * temph
                          t_r1 = t_u1
     +                             - (t_u1 - temph)
                          t_r2 = temph - t_r1
                          bl(i,j) = ((t_p1*t_r1
     +                            - bh(i,j))
     +                            + t_p1 * t_r2
     +                            + t_p2 * t_r1)
     +                            + t_p2 * t_r2
                          bl(i,j) = bl(i,j)
     +                          + (alphah*templ
     +                          + alphal*temph)
                          t_s1 = bh(i,j) + bl(i,j)
                          bl(i,j) = bl(i,j) - (t_s1 - bh(i,j))
                          bh(i,j) = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>                      b(i,j) = alpha * temp
  130                 CONTINUE
  140             CONTINUE
              END IF
          END IF
      ELSE
          IF (LSAME(TRANSA,'N')) THEN
*
*           Form  B := alpha*B*A.
*
              IF (UPPER) THEN
                  DO 180 J = N,1,-1
!                     TEMP = ALPHA
                      temph = alphah
                      templ = alphal
!                     IF (NOUNIT) TEMP = TEMP*A(J,J)
                      if(nounit) then
!<<<                      temp = temp * a(j,j)
                          t_ch = temph * ah(j,j)
                          t_u1 = 134217729.0 * temph
                          t_p1 = t_u1
     +                             - (t_u1 - temph)
                          t_p2 = temph - t_p1
                          t_u1 = 134217729.0 * ah(j,j)
                          t_r1 = t_u1
     +                             - (t_u1 - ah(j,j))
                          t_r2 = ah(j,j) - t_r1
                          t_cl = ((t_p1*t_r1
     +                             - t_ch)
     +                            + t_p1 * t_r2
     +                            + t_p2 * t_r1)
     +                            + t_p2 * t_r2
                          t_cl = t_cl
     +                             + (temph*al(j,j)
     +                             +  templ*ah(j,j))
                          t_s1 = t_ch + t_cl
                          templ = t_cl - (t_s1 - t_ch)
                          temph = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>                      temp = temp * a(j,j)
                      endif
!$omp parallel
!$omp do
!$omp+ private(I)
!     tmp vars -> private
!$omp+ private(t_ch, t_cl)
!$omp+ private(t_p1, t_p2)
!$omp+ private(t_q1, t_q2)
!$omp+ private(t_r1, t_r2)
!$omp+ private(t_s1, t_s2)
!$omp+ private(t_t1, t_t2)
!$omp+ private(t_u1, t_u2)
!$omp+ private(t_x1, t_x2)
!$omp+ private(t_y1, t_y2)
!$omp+ private(t_z1, t_z2)
!$omp+ private(t_x, t_ax)
!$omp+ private(t_t1h, t_t1l)
!$omp+ private(t_t2h, t_t2l)
                      DO 150 I = 1,M
!                         B(I,J) = TEMP*B(I,J)
!<<<                      b(i,j) = temp * b(i,j)
                          t_ch = temph * bh(i,j)
                          t_u1 = 134217729.0 * temph
                          t_p1 = t_u1
     +                             - (t_u1 - temph)
                          t_p2 = temph - t_p1
                          t_u1 = 134217729.0 * bh(i,j)
                          t_r1 = t_u1
     +                             - (t_u1 - bh(i,j))
                          t_r2 = bh(i,j) - t_r1
                          t_cl = ((t_p1*t_r1
     +                             - t_ch)
     +                            + t_p1 * t_r2
     +                            + t_p2 * t_r1)
     +                            + t_p2 * t_r2
                          t_cl = t_cl
     +                             + (temph*bl(i,j)
     +                             +  templ*bh(i,j))
                          t_s1 = t_ch + t_cl
                          bl(i,j) = t_cl - (t_s1 - t_ch)
                          bh(i,j) = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>                      b(i,j) = temp * b(i,j)
  150                 CONTINUE
!$omp end do
!$omp end parallel
                      DO 170 K = 1,J - 1
!                         IF (A(K,J).NE.ZERO) THEN
                          if(
!                           (a(k,j) .ne. zero)
     +                     ((ah(k,j) .ne. zeroh) .or.
     +                      (al(k,j) .ne. zerol))
     +                    ) then
!                             TEMP = ALPHA*A(K,J)
!<<<                        temp = alpha * a(k,j)
                            temph = alphah * ah(k,j)
                            t_u1 = 134217729.0 * alphah
                            t_p1 = t_u1
     +                               - (t_u1 - alphah)
                            t_p2 = alphah - t_p1
                            t_u1 = 134217729.0 * ah(k,j)
                            t_r1 = t_u1
     +                               - (t_u1 - ah(k,j))
                            t_r2 = ah(k,j) - t_r1
                            templ = ((t_p1*t_r1
     +                              - temph)
     +                              + t_p1 * t_r2
     +                              + t_p2 * t_r1)
     +                              + t_p2 * t_r2
                            templ = templ
     +                            + (alphah*al(k,j)
     +                            + alphal*ah(k,j))
                            t_s1 = temph + templ
                            templ = templ - (t_s1 - temph)
                            temph = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>                        temp = alpha * a(k,j)
!$omp parallel
!$omp do
!$omp+ private(I)
!     tmp vars -> private
!$omp+ private(t_ch, t_cl)
!$omp+ private(t_p1, t_p2)
!$omp+ private(t_q1, t_q2)
!$omp+ private(t_r1, t_r2)
!$omp+ private(t_s1, t_s2)
!$omp+ private(t_t1, t_t2)
!$omp+ private(t_u1, t_u2)
!$omp+ private(t_x1, t_x2)
!$omp+ private(t_y1, t_y2)
!$omp+ private(t_z1, t_z2)
!$omp+ private(t_x, t_ax)
!$omp+ private(t_t1h, t_t1l)
!$omp+ private(t_t2h, t_t2l)
!$omp+ private(ddmh, ddml)
                              DO 160 I = 1,M
!                                 B(I,J) = B(I,J) + TEMP*B(I,K)
!<<<                          ddm = temp * b(i,k)
                              ddmh = temph * bh(i,k)
                              t_u1 = 134217729.0 * temph
                              t_p1 = t_u1
     +                                 - (t_u1 - temph)
                              t_p2 = temph - t_p1
                              t_u1 = 134217729.0 * bh(i,k)
                              t_r1 = t_u1
     +                                 - (t_u1 - bh(i,k))
                              t_r2 = bh(i,k) - t_r1
                              ddml = ((t_p1*t_r1
     +                                - ddmh)
     +                                + t_p1 * t_r2
     +                                + t_p2 * t_r1)
     +                                + t_p2 * t_r2
                              ddml = ddml
     +                              + (temph*bl(i,k)
     +                              + templ*bh(i,k))
                              t_s1 = ddmh + ddml
                              ddml = ddml - (t_s1 - ddmh)
                              ddmh = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>                          ddm = temp * b(i,k)
!<<<                          b(i,j) = b(i,j) + ddm
                              t_p1 = bh(i,j) + ddmh
                              t_p2 = t_p1 - bh(i,j)
                              t_q1 = t_p1
                              t_q2 = (bh(i,j) - (t_p1 - t_p2))
     +                                 + (ddmh - t_p2)
                              t_q2 = t_q2 + bl(i,j) + ddml
                              bh(i,j) = t_q1 + t_q2
                              bl(i,j) = t_q2 - (bh(i,j) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>                          b(i,j) = b(i,j) + ddm
  160                         CONTINUE
!$omp end do
!$omp end parallel
                          END IF
  170                 CONTINUE
  180             CONTINUE
              ELSE
                  DO 220 J = 1,N
!                     TEMP = ALPHA
                      temph = alphah
                      templ = alphal
!                     IF (NOUNIT) TEMP = TEMP*A(J,J)
                      if(nounit) then
!<<<                      temp = temp * a(j,j)
                          t_ch = temph * ah(j,j)
                          t_u1 = 134217729.0 * temph
                          t_p1 = t_u1
     +                             - (t_u1 - temph)
                          t_p2 = temph - t_p1
                          t_u1 = 134217729.0 * ah(j,j)
                          t_r1 = t_u1
     +                             - (t_u1 - ah(j,j))
                          t_r2 = ah(j,j) - t_r1
                          t_cl = ((t_p1*t_r1
     +                             - t_ch)
     +                            + t_p1 * t_r2
     +                            + t_p2 * t_r1)
     +                            + t_p2 * t_r2
                          t_cl = t_cl
     +                             + (temph*al(j,j)
     +                             +  templ*ah(j,j))
                          t_s1 = t_ch + t_cl
                          templ = t_cl - (t_s1 - t_ch)
                          temph = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>                      temp = temp * a(j,j)
                      endif
!$omp parallel
!$omp do
!$omp+ private(I)
!     tmp vars -> private
!$omp+ private(t_ch, t_cl)
!$omp+ private(t_p1, t_p2)
!$omp+ private(t_q1, t_q2)
!$omp+ private(t_r1, t_r2)
!$omp+ private(t_s1, t_s2)
!$omp+ private(t_t1, t_t2)
!$omp+ private(t_u1, t_u2)
!$omp+ private(t_x1, t_x2)
!$omp+ private(t_y1, t_y2)
!$omp+ private(t_z1, t_z2)
!$omp+ private(t_x, t_ax)
!$omp+ private(t_t1h, t_t1l)
!$omp+ private(t_t2h, t_t2l)
                      DO 190 I = 1,M
!                         B(I,J) = TEMP*B(I,J)
!<<<                      b(i,j) = temp * b(i,j)
                          t_ch = temph * bh(i,j)
                          t_u1 = 134217729.0 * temph
                          t_p1 = t_u1
     +                             - (t_u1 - temph)
                          t_p2 = temph - t_p1
                          t_u1 = 134217729.0 * bh(i,j)
                          t_r1 = t_u1
     +                             - (t_u1 - bh(i,j))
                          t_r2 = bh(i,j) - t_r1
                          t_cl = ((t_p1*t_r1
     +                             - t_ch)
     +                            + t_p1 * t_r2
     +                            + t_p2 * t_r1)
     +                            + t_p2 * t_r2
                          t_cl = t_cl
     +                             + (temph*bl(i,j)
     +                             +  templ*bh(i,j))
                          t_s1 = t_ch + t_cl
                          bl(i,j) = t_cl - (t_s1 - t_ch)
                          bh(i,j) = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>                      b(i,j) = temp * b(i,j)
  190                 CONTINUE
!$omp end do
!$omp end parallel
                      DO 210 K = J + 1,N
!                         IF (A(K,J).NE.ZERO) THEN
                          if(
!                           (a(k,j) .ne. zero)
     +                     ((ah(k,j) .ne. zeroh) .or.
     +                      (al(k,j) .ne. zerol))
     +                    ) then
!                             TEMP = ALPHA*A(K,J)
!<<<                        temp = alpha * a(k,j)
                            temph = alphah * ah(k,j)
                            t_u1 = 134217729.0 * alphah
                            t_p1 = t_u1
     +                               - (t_u1 - alphah)
                            t_p2 = alphah - t_p1
                            t_u1 = 134217729.0 * ah(k,j)
                            t_r1 = t_u1
     +                               - (t_u1 - ah(k,j))
                            t_r2 = ah(k,j) - t_r1
                            templ = ((t_p1*t_r1
     +                              - temph)
     +                              + t_p1 * t_r2
     +                              + t_p2 * t_r1)
     +                              + t_p2 * t_r2
                            templ = templ
     +                            + (alphah*al(k,j)
     +                            + alphal*ah(k,j))
                            t_s1 = temph + templ
                            templ = templ - (t_s1 - temph)
                            temph = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>                        temp = alpha * a(k,j)
!$omp parallel
!$omp do
!$omp+ private(I)
!     tmp vars -> private
!$omp+ private(t_ch, t_cl)
!$omp+ private(t_p1, t_p2)
!$omp+ private(t_q1, t_q2)
!$omp+ private(t_r1, t_r2)
!$omp+ private(t_s1, t_s2)
!$omp+ private(t_t1, t_t2)
!$omp+ private(t_u1, t_u2)
!$omp+ private(t_x1, t_x2)
!$omp+ private(t_y1, t_y2)
!$omp+ private(t_z1, t_z2)
!$omp+ private(t_x, t_ax)
!$omp+ private(t_t1h, t_t1l)
!$omp+ private(t_t2h, t_t2l)
!$omp+ private(ddmh, ddml)
                              DO 200 I = 1,M
!                                 B(I,J) = B(I,J) + TEMP*B(I,K)
!<<<                          ddm = temp * b(i,k)
                              ddmh = temph * bh(i,k)
                              t_u1 = 134217729.0 * temph
                              t_p1 = t_u1
     +                                 - (t_u1 - temph)
                              t_p2 = temph - t_p1
                              t_u1 = 134217729.0 * bh(i,k)
                              t_r1 = t_u1
     +                                 - (t_u1 - bh(i,k))
                              t_r2 = bh(i,k) - t_r1
                              ddml = ((t_p1*t_r1
     +                                - ddmh)
     +                                + t_p1 * t_r2
     +                                + t_p2 * t_r1)
     +                                + t_p2 * t_r2
                              ddml = ddml
     +                              + (temph*bl(i,k)
     +                              + templ*bh(i,k))
                              t_s1 = ddmh + ddml
                              ddml = ddml - (t_s1 - ddmh)
                              ddmh = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>                          ddm = temp * b(i,k)
!<<<                          b(i,j) = b(i,j) + ddm
                              t_p1 = bh(i,j) + ddmh
                              t_p2 = t_p1 - bh(i,j)
                              t_q1 = t_p1
                              t_q2 = (bh(i,j) - (t_p1 - t_p2))
     +                                 + (ddmh - t_p2)
                              t_q2 = t_q2 + bl(i,j) + ddml
                              bh(i,j) = t_q1 + t_q2
                              bl(i,j) = t_q2 - (bh(i,j) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>                          b(i,j) = b(i,j) + ddm
  200                         CONTINUE
!$omp end do
!$omp end parallel
                          END IF
  210                 CONTINUE
  220             CONTINUE
              END IF
          ELSE
*
*           Form  B := alpha*B*A'.
*
              IF (UPPER) THEN
                  DO 260 K = 1,N
                      DO 240 J = 1,K - 1
!                         IF (A(J,K).NE.ZERO) THEN
                          if(
!                           (a(j,k) .ne. zero)
     +                     ((ah(j,k) .ne. zeroh) .or.
     +                      (al(j,k) .ne. zerol))
     +                    ) then
!                             TEMP = ALPHA*A(J,K)
!<<<                        temp = alpha * a(j,k)
                            temph = alphah * ah(j,k)
                            t_u1 = 134217729.0 * alphah
                            t_p1 = t_u1
     +                               - (t_u1 - alphah)
                            t_p2 = alphah - t_p1
                            t_u1 = 134217729.0 * ah(j,k)
                            t_r1 = t_u1
     +                               - (t_u1 - ah(j,k))
                            t_r2 = ah(j,k) - t_r1
                            templ = ((t_p1*t_r1
     +                              - temph)
     +                              + t_p1 * t_r2
     +                              + t_p2 * t_r1)
     +                              + t_p2 * t_r2
                            templ = templ
     +                            + (alphah*al(j,k)
     +                            + alphal*ah(j,k))
                            t_s1 = temph + templ
                            templ = templ - (t_s1 - temph)
                            temph = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>                        temp = alpha * a(j,k)
!$omp parallel
!$omp do
!$omp+ private(I)
!     tmp vars -> private
!$omp+ private(t_ch, t_cl)
!$omp+ private(t_p1, t_p2)
!$omp+ private(t_q1, t_q2)
!$omp+ private(t_r1, t_r2)
!$omp+ private(t_s1, t_s2)
!$omp+ private(t_t1, t_t2)
!$omp+ private(t_u1, t_u2)
!$omp+ private(t_x1, t_x2)
!$omp+ private(t_y1, t_y2)
!$omp+ private(t_z1, t_z2)
!$omp+ private(t_x, t_ax)
!$omp+ private(t_t1h, t_t1l)
!$omp+ private(t_t2h, t_t2l)
!$omp+ private(ddmh, ddml)
                              DO 230 I = 1,M
!                                 B(I,J) = B(I,J) + TEMP*B(I,K)
!<<<                          ddm = temp * b(i,k)
                              ddmh = temph * bh(i,k)
                              t_u1 = 134217729.0 * temph
                              t_p1 = t_u1
     +                                 - (t_u1 - temph)
                              t_p2 = temph - t_p1
                              t_u1 = 134217729.0 * bh(i,k)
                              t_r1 = t_u1
     +                                 - (t_u1 - bh(i,k))
                              t_r2 = bh(i,k) - t_r1
                              ddml = ((t_p1*t_r1
     +                                - ddmh)
     +                                + t_p1 * t_r2
     +                                + t_p2 * t_r1)
     +                                + t_p2 * t_r2
                              ddml = ddml
     +                              + (temph*bl(i,k)
     +                              + templ*bh(i,k))
                              t_s1 = ddmh + ddml
                              ddml = ddml - (t_s1 - ddmh)
                              ddmh = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>                          ddm = temp * b(i,k)
!<<<                          b(i,j) = b(i,j) + ddm
                              t_p1 = bh(i,j) + ddmh
                              t_p2 = t_p1 - bh(i,j)
                              t_q1 = t_p1
                              t_q2 = (bh(i,j) - (t_p1 - t_p2))
     +                                 + (ddmh - t_p2)
                              t_q2 = t_q2 + bl(i,j) + ddml
                              bh(i,j) = t_q1 + t_q2
                              bl(i,j) = t_q2 - (bh(i,j) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>                          b(i,j) = b(i,j) + ddm
  230                         CONTINUE
!$omp end do
!$omp end parallel
                          END IF
  240                 CONTINUE
!                     TEMP = ALPHA
                      temph = alphah
                      templ = alphal
!                     IF (NOUNIT) TEMP = TEMP*A(K,K)
                      if(nounit) then
!<<<                      temp = temp * a(k,k)
                          t_ch = temph * ah(k,k)
                          t_u1 = 134217729.0 * temph
                          t_p1 = t_u1
     +                             - (t_u1 - temph)
                          t_p2 = temph - t_p1
                          t_u1 = 134217729.0 * ah(k,k)
                          t_r1 = t_u1
     +                             - (t_u1 - ah(k,k))
                          t_r2 = ah(k,k) - t_r1
                          t_cl = ((t_p1*t_r1
     +                             - t_ch)
     +                            + t_p1 * t_r2
     +                            + t_p2 * t_r1)
     +                            + t_p2 * t_r2
                          t_cl = t_cl
     +                             + (temph*al(k,k)
     +                             +  templ*ah(k,k))
                          t_s1 = t_ch + t_cl
                          templ = t_cl - (t_s1 - t_ch)
                          temph = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>                      temp = temp * a(k,k)
                      endif
!                     IF (TEMP.NE.ONE) THEN
                      if(
!                       (temp .ne. one)
     +                 ((temph .ne. oneh) .or.
     +                  (templ .ne. onel))
     +                ) then
!$omp parallel
!$omp do
!$omp+ private(I)
!     tmp vars -> private
!$omp+ private(t_ch, t_cl)
!$omp+ private(t_p1, t_p2)
!$omp+ private(t_q1, t_q2)
!$omp+ private(t_r1, t_r2)
!$omp+ private(t_s1, t_s2)
!$omp+ private(t_t1, t_t2)
!$omp+ private(t_u1, t_u2)
!$omp+ private(t_x1, t_x2)
!$omp+ private(t_y1, t_y2)
!$omp+ private(t_z1, t_z2)
!$omp+ private(t_x, t_ax)
!$omp+ private(t_t1h, t_t1l)
!$omp+ private(t_t2h, t_t2l)
                          DO 250 I = 1,M
!                             B(I,K) = TEMP*B(I,K)
!<<<                          b(i,k) = temp * b(i,k)
                              t_ch = temph * bh(i,k)
                              t_u1 = 134217729.0 * temph
                              t_p1 = t_u1
     +                                 - (t_u1 - temph)
                              t_p2 = temph - t_p1
                              t_u1 = 134217729.0 * bh(i,k)
                              t_r1 = t_u1
     +                                 - (t_u1 - bh(i,k))
                              t_r2 = bh(i,k) - t_r1
                              t_cl = ((t_p1*t_r1
     +                                 - t_ch)
     +                                + t_p1 * t_r2
     +                                + t_p2 * t_r1)
     +                                + t_p2 * t_r2
                              t_cl = t_cl
     +                                 + (temph*bl(i,k)
     +                                 +  templ*bh(i,k))
                              t_s1 = t_ch + t_cl
                              bl(i,k) = t_cl - (t_s1 - t_ch)
                              bh(i,k) = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>                          b(i,k) = temp * b(i,k)
  250                     CONTINUE
!$omp end do
!$omp end parallel
                      END IF
  260             CONTINUE
              ELSE
                  DO 300 K = N,1,-1
                      DO 280 J = K + 1,N
!                         IF (A(J,K).NE.ZERO) THEN
                          if(
!                           (a(j,k) .ne. zero)
     +                     ((ah(j,k) .ne. zeroh) .or.
     +                      (al(j,k) .ne. zerol))
     +                    ) then
!                             TEMP = ALPHA*A(J,K)
!<<<                        temp = alpha * a(j,k)
                            temph = alphah * ah(j,k)
                            t_u1 = 134217729.0 * alphah
                            t_p1 = t_u1
     +                               - (t_u1 - alphah)
                            t_p2 = alphah - t_p1
                            t_u1 = 134217729.0 * ah(j,k)
                            t_r1 = t_u1
     +                               - (t_u1 - ah(j,k))
                            t_r2 = ah(j,k) - t_r1
                            templ = ((t_p1*t_r1
     +                              - temph)
     +                              + t_p1 * t_r2
     +                              + t_p2 * t_r1)
     +                              + t_p2 * t_r2
                            templ = templ
     +                            + (alphah*al(j,k)
     +                            + alphal*ah(j,k))
                            t_s1 = temph + templ
                            templ = templ - (t_s1 - temph)
                            temph = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>                        temp = alpha * a(j,k)
!$omp parallel
!$omp do
!$omp+ private(I)
!     tmp vars -> private
!$omp+ private(t_ch, t_cl)
!$omp+ private(t_p1, t_p2)
!$omp+ private(t_q1, t_q2)
!$omp+ private(t_r1, t_r2)
!$omp+ private(t_s1, t_s2)
!$omp+ private(t_t1, t_t2)
!$omp+ private(t_u1, t_u2)
!$omp+ private(t_x1, t_x2)
!$omp+ private(t_y1, t_y2)
!$omp+ private(t_z1, t_z2)
!$omp+ private(t_x, t_ax)
!$omp+ private(t_t1h, t_t1l)
!$omp+ private(t_t2h, t_t2l)
!$omp+ private(ddmh, ddml)
                              DO 270 I = 1,M
!                                 B(I,J) = B(I,J) + TEMP*B(I,K)
!<<<                          ddm = temp * b(i,k)
                              ddmh = temph * bh(i,k)
                              t_u1 = 134217729.0 * temph
                              t_p1 = t_u1
     +                                 - (t_u1 - temph)
                              t_p2 = temph - t_p1
                              t_u1 = 134217729.0 * bh(i,k)
                              t_r1 = t_u1
     +                                 - (t_u1 - bh(i,k))
                              t_r2 = bh(i,k) - t_r1
                              ddml = ((t_p1*t_r1
     +                                - ddmh)
     +                                + t_p1 * t_r2
     +                                + t_p2 * t_r1)
     +                                + t_p2 * t_r2
                              ddml = ddml
     +                              + (temph*bl(i,k)
     +                              + templ*bh(i,k))
                              t_s1 = ddmh + ddml
                              ddml = ddml - (t_s1 - ddmh)
                              ddmh = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>                          ddm = temp * b(i,k)
!<<<                          b(i,j) = b(i,j) + ddm
                              t_p1 = bh(i,j) + ddmh
                              t_p2 = t_p1 - bh(i,j)
                              t_q1 = t_p1
                              t_q2 = (bh(i,j) - (t_p1 - t_p2))
     +                                 + (ddmh - t_p2)
                              t_q2 = t_q2 + bl(i,j) + ddml
                              bh(i,j) = t_q1 + t_q2
                              bl(i,j) = t_q2 - (bh(i,j) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>                          b(i,j) = b(i,j) + ddm
  270                         CONTINUE
!$omp end do
!$omp end parallel
                          END IF
  280                 CONTINUE
!                     TEMP = ALPHA
                      temph = alphah
                      templ = alphal
!                     IF (NOUNIT) TEMP = TEMP*A(K,K)
                      if(nounit) then
!<<<                      temp = temp * a(k,k)
                          t_ch = temph * ah(k,k)
                          t_u1 = 134217729.0 * temph
                          t_p1 = t_u1
     +                             - (t_u1 - temph)
                          t_p2 = temph - t_p1
                          t_u1 = 134217729.0 * ah(k,k)
                          t_r1 = t_u1
     +                             - (t_u1 - ah(k,k))
                          t_r2 = ah(k,k) - t_r1
                          t_cl = ((t_p1*t_r1
     +                             - t_ch)
     +                            + t_p1 * t_r2
     +                            + t_p2 * t_r1)
     +                            + t_p2 * t_r2
                          t_cl = t_cl
     +                             + (temph*al(k,k)
     +                             +  templ*ah(k,k))
                          t_s1 = t_ch + t_cl
                          templ = t_cl - (t_s1 - t_ch)
                          temph = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>                      temp = temp * a(k,k)
                      endif
!                     IF (TEMP.NE.ONE) THEN
                      if(
!                       (temp .ne. one)
     +                 ((temph .ne. oneh) .or.
     +                  (templ .ne. onel))
     +                ) then
!$omp parallel
!$omp do
!$omp+ private(I)
!     tmp vars -> private
!$omp+ private(t_ch, t_cl)
!$omp+ private(t_p1, t_p2)
!$omp+ private(t_q1, t_q2)
!$omp+ private(t_r1, t_r2)
!$omp+ private(t_s1, t_s2)
!$omp+ private(t_t1, t_t2)
!$omp+ private(t_u1, t_u2)
!$omp+ private(t_x1, t_x2)
!$omp+ private(t_y1, t_y2)
!$omp+ private(t_z1, t_z2)
!$omp+ private(t_x, t_ax)
!$omp+ private(t_t1h, t_t1l)
!$omp+ private(t_t2h, t_t2l)
                          DO 290 I = 1,M
!                             B(I,K) = TEMP*B(I,K)
!<<<                          b(i,k) = temp * b(i,k)
                              t_ch = temph * bh(i,k)
                              t_u1 = 134217729.0 * temph
                              t_p1 = t_u1
     +                                 - (t_u1 - temph)
                              t_p2 = temph - t_p1
                              t_u1 = 134217729.0 * bh(i,k)
                              t_r1 = t_u1
     +                                 - (t_u1 - bh(i,k))
                              t_r2 = bh(i,k) - t_r1
                              t_cl = ((t_p1*t_r1
     +                                 - t_ch)
     +                                + t_p1 * t_r2
     +                                + t_p2 * t_r1)
     +                                + t_p2 * t_r2
                              t_cl = t_cl
     +                                 + (temph*bl(i,k)
     +                                 +  templ*bh(i,k))
                              t_s1 = t_ch + t_cl
                              bl(i,k) = t_cl - (t_s1 - t_ch)
                              bh(i,k) = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>                          b(i,k) = temp * b(i,k)
  290                     CONTINUE
!$omp end do
!$omp end parallel
                      END IF
  300             CONTINUE
              END IF
          END IF
      END IF
*
 9999 continue
#ifdef FPCOUNTER
      WRITE(6,1000) "MODULE    = ddtrmm"
!     WRITE(6,1005) SUBNAME,"DIM M     = ",M
      WRITE(6,1005) SUBNAME,"DIM N     = ",N
      WRITE(6,1005) SUBNAME,"DIM K     = ",K
      WRITE(6,'(2A)') "transa    = ",transa
#include "fout3.h"
#include "fformat.h"
#endif
      RETURN
*
*     End of DTRMM .
*
      END
