!      subroutine eigen_pbk_main1(n, a, nma, z, nmz, e, d,
!     &             v, nm, m, iblk, ss, tt)
      subroutine ddeigen_pbk_main1(n, ah, al, nma, zh, zl, nmz,
     &             eh, el, dh, dl, vh, vl,
     &             nm, m, iblk, ssh, ssl, tth, ttl)
!----
!      use communication_sx, only : reduce_dbl
!     &                           , datacast_dbl
!     &                           , bcast_dbl
!     &                           , get_loop_start
!     &                           , get_loop_end
!     &                           , get_loop_node
!     &                           , translate_g2l
!     &                           , translate_l2g
      use ddcommunication_sx, only : ddreduce_dbl
     &                             , dddatacast_dbl
     &                             , ddbcast_dbl
     &                             , get_loop_start
     &                             , get_loop_end
     &                             , get_loop_node
     &                             , translate_g2l
     &                             , translate_l2g
!----
      implicit double precision(a-h,o-z),integer(i-n)

!      real(8) :: a(1:nma,*)
!      real(8) :: z(1:nmz,*)
!      real(8) :: e(1:n)
!      real(8) :: d(1:n)
      real(8) :: ah(1:nma,*), al(1:nma,*)
      real(8) :: zh(1:nmz,*), zl(1*nmz,*)
      real(8) :: eh(1:n), el(1:n)
      real(8) :: dh(1:n), dl(1:n)

!      real(8) :: v(1:nm,*)
      real(8) :: vh(1:nm,*), vl(1:nm,*)

!      real(8) :: ss(*), tt(*)
      real(8) :: ssh(*), ssl(*), tth(*), ttl(*)

      include 'mpif.h'
!$    include 'omp_lib.h'
      include 'trd.h'
!----
      integer :: nodes(0:nsm-1)

!      real(8), pointer :: wk(:)
      real(8), pointer :: wkh(:), wkl(:)
      double precision tmp1h, tmp1l
      double precision oneh, onel
!     tmp vars
      double precision t_ch, t_cl
      double precision t_p1, t_p2
      double precision t_q1, t_q2
      double precision t_r1, t_r2
      double precision t_s1, t_s2
      double precision t_t1, t_t2
      double precision t_u1, t_u2
      double precision t_x1, t_x2
      double precision t_y1, t_y2
      double precision t_z1, t_z2
      double precision t_x, t_ax
      double precision t_t1h, t_t1l
      double precision t_t2h, t_t2l
      oneh = 1.0d+0
      onel = 0.0d+0

!----
!$omp master
      call mpi_barrier(mpi_comm_world,ierr)
      d1=mpi_wtime()

      lwk=((m-1)/size_of_row+1)*((n-1)/size_of_col+1)
!      allocate(wk(lwk))
      allocate(wkh(lwk), wkl(lwk))
!$omp end master
!----
      i_start = get_loop_start(1+iblk, size_of_row,my_row)
      i_end   = get_loop_end  (n,      size_of_row,my_row)
!----
!$omp master
!      d(1:n)=0.0
      dh(1:n) = 0.0d+0
      dl(1:n) = 0.0d+0
      do i0=i_start, i_end
!----    i = translate_l2g(i0, size_of_row,my_row)
         i = (i0-1)*size_of_row+my_row
         l = i-iblk
!----    owner_node_col = get_loop_node(l, size_of_col,my_col)
         owner_node_col = mod(l-1,size_of_col)+1
         if ( owner_node_col == my_col ) then
!----       j0 = translate_g2l(l, size_of_col,my_col)
            j0  = (l-1)/size_of_col+1
!            d(i) = a(j0,i0)
            dh(i) = ah(j0,i0)
            dl(i) = al(j0,i0)
         end if
      end do! i0
!      call reduce_dbl( d, v, n, 1, mpi_comm_world )
      call ddreduce_dbl( dh, dl, vh, vl, n, 1, mpi_comm_world )
      do i0=1+iblk,n
!         if ( e(i0)*d(i0) == 0.0d+00 ) then
!            s0 = 0.0
!         else
!            s0 = (1.0d0/d(i0))/e(i0)
!         end if
!         d(i0) = s0
!<<<     tmp1 = e(i0) * d(i0)
         t_ch = eh(i0) * dh(i0)
         t_u1 = 134217729.0 * eh(i0)
         t_p1 = t_u1
     +            - (t_u1 - eh(i0))
         t_p2 = eh(i0) - t_p1
         t_u1 = 134217729.0 * dh(i0)
         t_r1 = t_u1
     +            - (t_u1 - dh(i0))
         t_r2 = dh(i0) - t_r1
         t_cl = ((t_p1*t_r1
     +            - t_ch)
     +           + t_p1 * t_r2
     +           + t_p2 * t_r1)
     +           + t_p2 * t_r2
         t_cl = t_cl
     +            + (eh(i0)*dl(i0)
     +            +  el(i0)*dh(i0))
         t_s1 = t_ch + t_cl
         tmp1l = t_cl - (t_s1 - t_ch)
         tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>     tmp1 = e(i0) * d(i0)
         if (
!             (tmp1 .eq. 0.0)
     +       ((tmp1h .eq. 0.0d+0) .and.
     +        (tmp1l .eq. 0.0d+0))
     &   ) then
            s0h = 0.0d+0
            s0l = 0.0d+0
         else
!<<<        tmp1 = one / d(i0)
            t_q1 = oneh / dh(i0)
            t_ch = dh(i0) * t_q1
            t_u1 = 134217729.0 * dh(i0)
            t_p1 = t_u1
     +               - (t_u1 - dh(i0))
            t_p2 = dh(i0) - t_p1
            t_u1 = 134217729.0 * t_q1
            t_r1 = t_u1
     +               - (t_u1 - t_q1)
            t_r2 = t_q1 - t_r1
            t_cl = ((t_p1*t_r1
     +               - t_ch)
     +               + t_p1*t_r2
     +               + t_p2*t_r1)
     +               + t_p2*t_r2
            t_cl = t_cl
     +               + (dl(i0) * t_q1)
            t_s1 = t_ch + t_cl
            t_cl = t_cl
     +               - (t_s1 - t_ch)
            t_ch = t_s1
            t_s1 = oneh - t_ch
            t_r1 = t_s1 - oneh
            t_s2 = (oneh
     +               - (t_s1 - t_r1))
     +               - (t_ch + t_r1)
            t_s2 = t_s2 - t_cl
            t_s2 = t_s2 + onel
            t_q2 = (t_s1 + t_s2)
     +               / dh(i0)
            tmp1h = t_q1 + t_q2
            tmp1l = t_q2
     +            - (tmp1h - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>        tmp1 = one / d(i0)
!<<<        s0 = tmp1 / e(i0)
            t_q1 = tmp1h / eh(i0)
            t_ch = eh(i0) * t_q1
            t_u1 = 134217729.0 * eh(i0)
            t_p1 = t_u1
     +               - (t_u1 - eh(i0))
            t_p2 = eh(i0) - t_p1
            t_u1 = 134217729.0 * t_q1
            t_r1 = t_u1
     +               - (t_u1 - t_q1)
            t_r2 = t_q1 - t_r1
            t_cl = ((t_p1*t_r1
     +               - t_ch)
     +               + t_p1*t_r2
     +               + t_p2*t_r1)
     +               + t_p2*t_r2
            t_cl = t_cl
     +               + (el(i0) * t_q1)
            t_s1 = t_ch + t_cl
            t_cl = t_cl
     +               - (t_s1 - t_ch)
            t_ch = t_s1
            t_s1 = tmp1h - t_ch
            t_r1 = t_s1 - tmp1h
            t_s2 = (tmp1h
     +               - (t_s1 - t_r1))
     +               - (t_ch + t_r1)
            t_s2 = t_s2 - t_cl
            t_s2 = t_s2 + tmp1l
            t_q2 = (t_s1 + t_s2)
     +               / eh(i0)
            s0h = t_q1 + t_q2
            s0l = t_q2
     +            - (s0h - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>        s0 = tmp1 / e(i0)
         end if
         dh(i0) = s0h
         dl(i0) = s0l
      end do! i0
!$omp end master
!----
      i_2 = get_loop_start(1, size_of_row,my_row)
      i_3 = get_loop_end  (n, size_of_row,my_row)
!----
      nx = min(mod(n-(1+iblk)+1,m)+(1+iblk)-1,n)
!----
      do i=(1+iblk),nx
!----
!         if ( e(i) == 0.0 ) cycle
         if (
!             (e(i) .eq. 0.0)
     +       ((eh(i) .eq. 0.0d+0) .and.
     +        (el(i) .eq. 0.0d+0))
     &   ) then 
            cycle
         endif
!----
         j_2 = get_loop_start(1,   size_of_col,my_col)
         j_3 = get_loop_end  (i-iblk, size_of_col,my_col)
         i_4=mod(i_3-i_2+1,4)+i_2
!----
!$omp master
         nodes(0) = get_loop_node(i, size_of_row, my_row)
         if ( nodes(0) == my_row ) then
            i_1 = translate_g2l(i, size_of_row, my_row)
            do j_1=j_2,j_3
!               v(j_1,1) = a(j_1,i_1)
               vh(j_1,1) = ah(j_1,i_1)
               vl(j_1,1) = al(j_1,i_1)
            end do! j_1
         end if
!         call bcast_dbl(v(j_2,1), j_3-j_2+1, nodes(0), mpi_comm_row)
         call ddbcast_dbl(vh(j_2,1), vl(j_2,1),
     &                    j_3-j_2+1, nodes(0), mpi_comm_row)
!$omp end master
!----
!$omp barrier
!----
!$omp master
         if ( i_4 == i_2 + 1 ) then
            i_1 = i_2
!            s0=0.0d+00
            s0h = 0.0d+0
            s0l = 0.0d+0
            do j_1=j_2,j_3
!               s0=s0+v(j_1,1)*z(j_1,i_1+0)
!<<<           tmp1 = v(j_1,1) * z(j_1,i_1+0)
               t_ch = vh(j_1,1) * zh(j_1,i_1+0)
               t_u1 = 134217729.0 * vh(j_1,1)
               t_p1 = t_u1
     +                  - (t_u1 - vh(j_1,1))
               t_p2 = vh(j_1,1) - t_p1
               t_u1 = 134217729.0 * zh(j_1,i_1+0)
               t_r1 = t_u1
     +                  - (t_u1 - zh(j_1,i_1+0))
               t_r2 = zh(j_1,i_1+0) - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (vh(j_1,1)*zl(j_1,i_1+0)
     +                  +  vl(j_1,1)*zh(j_1,i_1+0))
               t_s1 = t_ch + t_cl
               tmp1l = t_cl - (t_s1 - t_ch)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp1 = v(j_1,1) * z(j_1,i_1+0)
!<<<           s0 = s0 + tmp1
               t_p1 = s0h + tmp1h
               t_p2 = t_p1 - s0h
               t_q1 = t_p1
               t_q2 = (s0h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + s0l + tmp1l
               s0h = t_q1 + t_q2
               s0l = t_q2 - (s0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           s0 = s0 + tmp1
            end do! j_1
!            ss(i_1+0)=s0
            ssh(i_1+0) = s0h
            ssl(i_1+0) = s0l
         end if
         if ( i_4 == i_2 + 2 ) then
            i_1 = i_2
!            s0=0.0d+00
!            s1=0.0d+00
            s0h = 0.0d+0
            s0l = 0.0d+0
            s1h = 0.0d+0
            s1l = 0.0d+0
            do j_1=j_2,j_3
!               s0=s0+v(j_1,1)*z(j_1,i_1+0)
!               s1=s1+v(j_1,1)*z(j_1,i_1+1)
!<<<           tmp1 = v(j_1,1) * z(j_1,i_1+0)
               t_ch = vh(j_1,1) * zh(j_1,i_1+0)
               t_u1 = 134217729.0 * vh(j_1,1)
               t_p1 = t_u1
     +                  - (t_u1 - vh(j_1,1))
               t_p2 = vh(j_1,1) - t_p1
               t_u1 = 134217729.0 * zh(j_1,i_1+0)
               t_r1 = t_u1
     +                  - (t_u1 - zh(j_1,i_1+0))
               t_r2 = zh(j_1,i_1+0) - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (vh(j_1,1)*zl(j_1,i_1+0)
     +                  +  vl(j_1,1)*zh(j_1,i_1+0))
               t_s1 = t_ch + t_cl
               tmp1l = t_cl - (t_s1 - t_ch)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp1 = v(j_1,1) * z(j_1,i_1+0)
!<<<           s0 = s0 + tmp1
               t_p1 = s0h + tmp1h
               t_p2 = t_p1 - s0h
               t_q1 = t_p1
               t_q2 = (s0h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + s0l + tmp1l
               s0h = t_q1 + t_q2
               s0l = t_q2 - (s0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           s0 = s0 + tmp1
!<<<           tmp1 = v(j_1,1) * z(j_1,i_1+1)
               t_ch = vh(j_1,1) * zh(j_1,i_1+1)
               t_u1 = 134217729.0 * vh(j_1,1)
               t_p1 = t_u1
     +                  - (t_u1 - vh(j_1,1))
               t_p2 = vh(j_1,1) - t_p1
               t_u1 = 134217729.0 * zh(j_1,i_1+1)
               t_r1 = t_u1
     +                  - (t_u1 - zh(j_1,i_1+1))
               t_r2 = zh(j_1,i_1+1) - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (vh(j_1,1)*zl(j_1,i_1+1)
     +                  +  vl(j_1,1)*zh(j_1,i_1+1))
               t_s1 = t_ch + t_cl
               tmp1l = t_cl - (t_s1 - t_ch)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp1 = v(j_1,1) * z(j_1,i_1+1)
!<<<           s1 = s1 + tmp1
               t_p1 = s1h + tmp1h
               t_p2 = t_p1 - s1h
               t_q1 = t_p1
               t_q2 = (s1h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + s1l + tmp1l
               s1h = t_q1 + t_q2
               s1l = t_q2 - (s1h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           s1 = s1 + tmp1
            end do! j_1
!            ss(i_1+0)=s0
!            ss(i_1+1)=s1
            ssh(i_1+0) = s0h
            ssl(i_1+0) = s0l
            ssh(i_1+1) = s1h
            ssl(i_1+1) = s1l
         end if
         if ( i_4 == i_2 + 3 ) then
            i_1 = i_2
!            s0=0.0d+00
!            s1=0.0d+00
!            s2=0.0d+00
            s0h = 0.0d+0
            s0l = 0.0d+0
            s1h = 0.0d+0
            s1l = 0.0d+0
            s2h = 0.0d+0
            s2l = 0.0d+0
            do j_1=j_2,j_3
!               s0=s0+v(j_1,1)*z(j_1,i_1+0)
!               s1=s1+v(j_1,1)*z(j_1,i_1+1)
!               s2=s2+v(j_1,1)*z(j_1,i_1+2)
!<<<           tmp1 = v(j_1,1) * z(j_1,i_1+0)
               t_ch = vh(j_1,1) * zh(j_1,i_1+0)
               t_u1 = 134217729.0 * vh(j_1,1)
               t_p1 = t_u1
     +                  - (t_u1 - vh(j_1,1))
               t_p2 = vh(j_1,1) - t_p1
               t_u1 = 134217729.0 * zh(j_1,i_1+0)
               t_r1 = t_u1
     +                  - (t_u1 - zh(j_1,i_1+0))
               t_r2 = zh(j_1,i_1+0) - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (vh(j_1,1)*zl(j_1,i_1+0)
     +                  +  vl(j_1,1)*zh(j_1,i_1+0))
               t_s1 = t_ch + t_cl
               tmp1l = t_cl - (t_s1 - t_ch)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp1 = v(j_1,1) * z(j_1,i_1+0)
!<<<           s0 = s0 + tmp1
               t_p1 = s0h + tmp1h
               t_p2 = t_p1 - s0h
               t_q1 = t_p1
               t_q2 = (s0h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + s0l + tmp1l
               s0h = t_q1 + t_q2
               s0l = t_q2 - (s0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           s0 = s0 + tmp1
!<<<           tmp1 = v(j_1,1) * z(j_1,i_1+1)
               t_ch = vh(j_1,1) * zh(j_1,i_1+1)
               t_u1 = 134217729.0 * vh(j_1,1)
               t_p1 = t_u1
     +                  - (t_u1 - vh(j_1,1))
               t_p2 = vh(j_1,1) - t_p1
               t_u1 = 134217729.0 * zh(j_1,i_1+1)
               t_r1 = t_u1
     +                  - (t_u1 - zh(j_1,i_1+1))
               t_r2 = zh(j_1,i_1+1) - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (vh(j_1,1)*zl(j_1,i_1+1)
     +                  +  vl(j_1,1)*zh(j_1,i_1+1))
               t_s1 = t_ch + t_cl
               tmp1l = t_cl - (t_s1 - t_ch)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp1 = v(j_1,1) * z(j_1,i_1+1)
!<<<           s1 = s1 + tmp1
               t_p1 = s1h + tmp1h
               t_p2 = t_p1 - s1h
               t_q1 = t_p1
               t_q2 = (s1h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + s1l + tmp1l
               s1h = t_q1 + t_q2
               s1l = t_q2 - (s1h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           s1 = s1 + tmp1
!<<<           tmp1 = v(j_1,1) * z(j_1,i_1+2)
               t_ch = vh(j_1,1) * zh(j_1,i_1+2)
               t_u1 = 134217729.0 * vh(j_1,1)
               t_p1 = t_u1
     +                  - (t_u1 - vh(j_1,1))
               t_p2 = vh(j_1,1) - t_p1
               t_u1 = 134217729.0 * zh(j_1,i_1+2)
               t_r1 = t_u1
     +                  - (t_u1 - zh(j_1,i_1+2))
               t_r2 = zh(j_1,i_1+2) - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (vh(j_1,1)*zl(j_1,i_1+2)
     +                  +  vl(j_1,1)*zh(j_1,i_1+2))
               t_s1 = t_ch + t_cl
               tmp1l = t_cl - (t_s1 - t_ch)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp1 = v(j_1,1) * z(j_1,i_1+2)
!<<<           s2 = s2 + tmp1
               t_p1 = s2h + tmp1h
               t_p2 = t_p1 - s2h
               t_q1 = t_p1
               t_q2 = (s2h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + s2l + tmp1l
               s2h = t_q1 + t_q2
               s2l = t_q2 - (s2h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           s2 = s2 + tmp1
            end do! j_1
!            ss(i_1+0)=s0
!            ss(i_1+1)=s1
!            ss(i_1+2)=s2
            ssh(i_1+0) = s0h
            ssl(i_1+0) = s0l
            ssh(i_1+1) = s1h
            ssl(i_1+1) = s1l
            ssh(i_1+2) = s2h
            ssl(i_1+2) = s2l
         end if
!$omp end master
!$omp do
         do i_1=i_4,i_3,4
!            s0=0.0d+00
!            s1=0.0d+00
!            s2=0.0d+00
!            s3=0.0d+00
            s0h = 0.0d+0
            s0l = 0.0d+0
            s1h = 0.0d+0
            s1l = 0.0d+0
            s2h = 0.0d+0
            s2l = 0.0d+0
            s3h = 0.0d+0
            s3l = 0.0d+0
            do j_1=j_2,j_3
!               s0=s0+v(j_1,1)*z(j_1,i_1+0)
!               s1=s1+v(j_1,1)*z(j_1,i_1+1)
!               s2=s2+v(j_1,1)*z(j_1,i_1+2)
!               s3=s3+v(j_1,1)*z(j_1,i_1+3)
!<<<        tmp1 = v(j_1,1) * z(j_1,i_1+0)
            t_ch = vh(j_1,1) * zh(j_1,i_1+0)
            t_u1 = 134217729.0 * vh(j_1,1)
            t_p1 = t_u1
     +               - (t_u1 - vh(j_1,1))
            t_p2 = vh(j_1,1) - t_p1
            t_u1 = 134217729.0 * zh(j_1,i_1+0)
            t_r1 = t_u1
     +               - (t_u1 - zh(j_1,i_1+0))
            t_r2 = zh(j_1,i_1+0) - t_r1
            t_cl = ((t_p1*t_r1
     +               - t_ch)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            t_cl = t_cl
     +               + (vh(j_1,1)*zl(j_1,i_1+0)
     +               +  vl(j_1,1)*zh(j_1,i_1+0))
            t_s1 = t_ch + t_cl
            tmp1l = t_cl - (t_s1 - t_ch)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>        tmp1 = v(j_1,1) * z(j_1,i_1+0)
!<<<        s0 = s0 + tmp1
            t_p1 = s0h + tmp1h
            t_p2 = t_p1 - s0h
            t_q1 = t_p1
            t_q2 = (s0h - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + s0l + tmp1l
            s0h = t_q1 + t_q2
            s0l = t_q2 - (s0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        s0 = s0 + tmp1
!<<<        tmp1 = v(j_1,1) * z(j_1,i_1+1)
            t_ch = vh(j_1,1) * zh(j_1,i_1+1)
            t_u1 = 134217729.0 * vh(j_1,1)
            t_p1 = t_u1
     +               - (t_u1 - vh(j_1,1))
            t_p2 = vh(j_1,1) - t_p1
            t_u1 = 134217729.0 * zh(j_1,i_1+1)
            t_r1 = t_u1
     +               - (t_u1 - zh(j_1,i_1+1))
            t_r2 = zh(j_1,i_1+1) - t_r1
            t_cl = ((t_p1*t_r1
     +               - t_ch)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            t_cl = t_cl
     +               + (vh(j_1,1)*zl(j_1,i_1+1)
     +               +  vl(j_1,1)*zh(j_1,i_1+1))
            t_s1 = t_ch + t_cl
            tmp1l = t_cl - (t_s1 - t_ch)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>        tmp1 = v(j_1,1) * z(j_1,i_1+1)
!<<<        s1 = s1 + tmp1
            t_p1 = s1h + tmp1h
            t_p2 = t_p1 - s1h
            t_q1 = t_p1
            t_q2 = (s1h - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + s1l + tmp1l
            s1h = t_q1 + t_q2
            s1l = t_q2 - (s1h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        s1 = s1 + tmp1
!<<<        tmp1 = v(j_1,1) * z(j_1,i_1+2)
            t_ch = vh(j_1,1) * zh(j_1,i_1+2)
            t_u1 = 134217729.0 * vh(j_1,1)
            t_p1 = t_u1
     +               - (t_u1 - vh(j_1,1))
            t_p2 = vh(j_1,1) - t_p1
            t_u1 = 134217729.0 * zh(j_1,i_1+2)
            t_r1 = t_u1
     +               - (t_u1 - zh(j_1,i_1+2))
            t_r2 = zh(j_1,i_1+2) - t_r1
            t_cl = ((t_p1*t_r1
     +               - t_ch)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            t_cl = t_cl
     +               + (vh(j_1,1)*zl(j_1,i_1+2)
     +               +  vl(j_1,1)*zh(j_1,i_1+2))
            t_s1 = t_ch + t_cl
            tmp1l = t_cl - (t_s1 - t_ch)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>        tmp1 = v(j_1,1) * z(j_1,i_1+2)
!<<<        s2 = s2 + tmp1
            t_p1 = s2h + tmp1h
            t_p2 = t_p1 - s2h
            t_q1 = t_p1
            t_q2 = (s2h - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + s2l + tmp1l
            s2h = t_q1 + t_q2
            s2l = t_q2 - (s2h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        s2 = s2 + tmp1
!<<<        tmp1 = v(j_1,1) * z(j_1,i_1+3)
            t_ch = vh(j_1,1) * zh(j_1,i_1+3)
            t_u1 = 134217729.0 * vh(j_1,1)
            t_p1 = t_u1
     +               - (t_u1 - vh(j_1,1))
            t_p2 = vh(j_1,1) - t_p1
            t_u1 = 134217729.0 * zh(j_1,i_1+3)
            t_r1 = t_u1
     +               - (t_u1 - zh(j_1,i_1+3))
            t_r2 = zh(j_1,i_1+3) - t_r1
            t_cl = ((t_p1*t_r1
     +               - t_ch)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            t_cl = t_cl
     +               + (vh(j_1,1)*zl(j_1,i_1+3)
     +               +  vl(j_1,1)*zh(j_1,i_1+3))
            t_s1 = t_ch + t_cl
            tmp1l = t_cl - (t_s1 - t_ch)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>        tmp1 = v(j_1,1) * z(j_1,i_1+3)
!<<<        s3 = s3 + tmp1
            t_p1 = s3h + tmp1h
            t_p2 = t_p1 - s3h
            t_q1 = t_p1
            t_q2 = (s3h - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + s3l + tmp1l
            s3h = t_q1 + t_q2
            s3l = t_q2 - (s3h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        s3 = s3 + tmp1
            end do! j_1
!            ss(i_1+0)=s0
!            ss(i_1+1)=s1
!            ss(i_1+2)=s2
!            ss(i_1+3)=s3
            ssh(i_1+0) = s0h
            ssl(i_1+0) = s0l
            ssh(i_1+1) = s1h
            ssl(i_1+1) = s1l
            ssh(i_1+2) = s2h
            ssl(i_1+2) = s2l
            ssh(i_1+3) = s3h
            ssl(i_1+3) = s3l
         end do! i_1
!$omp end do
!----
!$omp barrier
!----
!$omp master
!         call reduce_dbl(ss(i_2),tt, i_3-i_2+1, 1, mpi_comm_col)
         call ddreduce_dbl(ssh(i_2), ssl(i_2), tth, ttl,
     &                     i_3-i_2+1, 1, mpi_comm_col)

!         s0 = d(i)
         s0h = dh(i)
         s0l = dl(i)
         do i_1=i_2,i_3
!            ss(i_1) = ss(i_1) * s0
!<<<        ss(i_1) = ss(i_1) * s0
            t_ch = ssh(i_1) * s0h
            t_u1 = 134217729.0 * ssh(i_1)
            t_p1 = t_u1
     +               - (t_u1 - ssh(i_1))
            t_p2 = ssh(i_1) - t_p1
            t_u1 = 134217729.0 * s0h
            t_r1 = t_u1
     +               - (t_u1 - s0h)
            t_r2 = s0h - t_r1
            t_cl = ((t_p1*t_r1
     +               - t_ch)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            t_cl = t_cl
     +               + (ssh(i_1)*s0l
     +               +  ssl(i_1)*s0h)
            t_s1 = t_ch + t_cl
            ssl(i_1) = t_cl - (t_s1 - t_ch)
            ssh(i_1) = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>        ss(i_1) = ss(i_1) * s0
         end do! i_1
!$omp end master

!$omp barrier

         j_2 = get_loop_start(1,      size_of_col,my_col)
         j_3 = get_loop_end  (i-iblk, size_of_col,my_col)
         i_4=mod(i_3-i_2+1,4)+i_2

!$omp master
         if ( i_4 == i_2 + 1 ) then
            i_1 = i_2
!            s0 = ss(i_1+0)
            s0h = ssh(i_1+0)
            s0l = ssl(i_1+0)
            do j_1=j_2,j_3
!               z(j_1,i_1+0) = z(j_1,i_1+0) + s0 * v(j_1,1)
!<<<           tmp1 = s0 * v(j_1,1)
               t_ch = s0h * vh(j_1,1)
               t_u1 = 134217729.0 * s0h
               t_p1 = t_u1
     +                  - (t_u1 - s0h)
               t_p2 = s0h - t_p1
               t_u1 = 134217729.0 * vh(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vh(j_1,1))
               t_r2 = vh(j_1,1) - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (s0h*vl(j_1,1)
     +                  +  s0l*vh(j_1,1))
               t_s1 = t_ch + t_cl
               tmp1l = t_cl - (t_s1 - t_ch)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp1 = s0 * v(j_1,1)
!<<<           z(j_1,i_1+0) = z(j_1,i_1+0) + tmp1
               p1 = zh(j_1,i_1+0) + tmp1h
               p2 = p1 - zh(j_1,i_1+0)
               q1 = p1
               q2 = (zh(j_1,i_1+0) - (p1 - p2))
     +                  + (tmp1h - p2)
               q2 = q2 + zl(j_1,i_1+0) + tmp1l
               zh(j_1,i_1+0) = q1 + q2
               zl(j_1,i_1+0) = q2 - (zh(j_1,i_1+0) - q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           z(j_1,i_1+0) = z(j_1,i_1+0) + tmp1
            end do! j_1
         end if
         if ( i_4 == i_2 + 2 ) then
            i_1 = i_2
!            s0 = ss(i_1+0)
!            s1 = ss(i_1+1)
            s0h = ssh(i_1+0)
            s0l = ssl(i_1+0)
            s1h = ssh(i_1+1)
            s1l = ssl(i_1+1)
            do j_1=j_2,j_3
!               z(j_1,i_1+0) = z(j_1,i_1+0) + s0 * v(j_1,1)
!               z(j_1,i_1+1) = z(j_1,i_1+1) + s1 * v(j_1,1)
!<<<           tmp1 = s0 * v(j_1,1)
               t_ch = s0h * vh(j_1,1)
               t_u1 = 134217729.0 * s0h
               t_p1 = t_u1
     +                  - (t_u1 - s0h)
               t_p2 = s0h - t_p1
               t_u1 = 134217729.0 * vh(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vh(j_1,1))
               t_r2 = vh(j_1,1) - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (s0h*vl(j_1,1)
     +                  +  s0l*vh(j_1,1))
               t_s1 = t_ch + t_cl
               tmp1l = t_cl - (t_s1 - t_ch)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp1 = s0 * v(j_1,1)
!<<<           z(j_1,i_1+0) = z(j_1,i_1+0) + tmp1
               t_p1 = zh(j_1,i_1+0) + tmp1h
               t_p2 = t_p1 - zh(j_1,i_1+0)
               t_q1 = t_p1
               t_q2 = (zh(j_1,i_1+0) - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + zl(j_1,i_1+0) + tmp1l
               zh(j_1,i_1+0) = t_q1 + t_q2
               zl(j_1,i_1+0) = t_q2 - (zh(j_1,i_1+0) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           z(j_1,i_1+0) = z(j_1,i_1+0) + tmp1
!<<<           tmp1 = s1 * v(j_1,1)
               t_ch = s1h * vh(j_1,1)
               t_u1 = 134217729.0 * s1h
               t_p1 = t_u1
     +                  - (t_u1 - s1h)
               t_p2 = s1h - t_p1
               t_u1 = 134217729.0 * vh(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vh(j_1,1))
               t_r2 = vh(j_1,1) - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (s1h*vl(j_1,1)
     +                  +  s1l*vh(j_1,1))
               t_s1 = t_ch + t_cl
               tmp1l = t_cl - (t_s1 - t_ch)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp1 = s1 * v(j_1,1)
!<<<           z(j_1,i_1+1) = z(j_1,i_1+1) + tmp1
               t_p1 = zh(j_1,i_1+1) + tmp1h
               t_p2 = t_p1 - zh(j_1,i_1+1)
               t_q1 = t_p1
               t_q2 = (zh(j_1,i_1+1) - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + zl(j_1,i_1+1) + tmp1l
               zh(j_1,i_1+1) = t_q1 + t_q2
               zl(j_1,i_1+1) = t_q2 - (zh(j_1,i_1+1) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           z(j_1,i_1+1) = z(j_1,i_1+1) + tmp1
            end do! j_1
         end if
         if ( i_4 == i_2 + 3 ) then
            i_1 = i_2
!            s0 = ss(i_1+0)
!            s1 = ss(i_1+1)
!            s2 = ss(i_1+2)
            s0h = ssh(i_1+0)
            s0l = ssl(i_1+0)
            s1h = ssh(i_1+1)
            s1l = ssl(i_1+1)
            s2h = ssh(i_1+2)
            s2l = ssl(i_1+2)
            do j_1=j_2,j_3
!               z(j_1,i_1+0) = z(j_1,i_1+0) + s0 * v(j_1,1)
!               z(j_1,i_1+1) = z(j_1,i_1+1) + s1 * v(j_1,1)
!               z(j_1,i_1+2) = z(j_1,i_1+2) + s2 * v(j_1,1)
!<<<           tmp1 = s0 * v(j_1,1)
               t_ch = s0h * vh(j_1,1)
               t_u1 = 134217729.0 * s0h
               t_p1 = t_u1
     +                  - (t_u1 - s0h)
               t_p2 = s0h - t_p1
               t_u1 = 134217729.0 * vh(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vh(j_1,1))
               t_r2 = vh(j_1,1) - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (s0h*vl(j_1,1)
     +                  +  s0l*vh(j_1,1))
               t_s1 = t_ch + t_cl
               tmp1l = t_cl - (t_s1 - t_ch)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp1 = s0 * v(j_1,1)
!<<<           z(j_1,i_1+0) = z(j_1,i_1+0) + tmp1
               p1 = zh(j_1,i_1+0) + tmp1h
               p2 = p1 - zh(j_1,i_1+0)
               q1 = p1
               q2 = (zh(j_1,i_1+0) - (p1 - p2))
     +                  + (tmp1h - p2)
               q2 = q2 + zl(j_1,i_1+0) + tmp1l
               zh(j_1,i_1+0) = q1 + q2
               zl(j_1,i_1+0) = q2 - (zh(j_1,i_1+0) - q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           z(j_1,i_1+0) = z(j_1,i_1+0) + tmp1
!<<<           tmp1 = s1 * v(j_1,1)
               t_ch = s1h * vh(j_1,1)
               t_u1 = 134217729.0 * s1h
               t_p1 = t_u1
     +                  - (t_u1 - s1h)
               t_p2 = s1h - t_p1
               t_u1 = 134217729.0 * vh(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vh(j_1,1))
               t_r2 = vh(j_1,1) - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (s1h*vl(j_1,1)
     +                  +  s1l*vh(j_1,1))
               t_s1 = t_ch + t_cl
               tmp1l = t_cl - (t_s1 - t_ch)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp1 = s1 * v(j_1,1)
!<<<           z(j_1,i_1+1) = z(j_1,i_1+1) + tmp1
               t_p1 = zh(j_1,i_1+1) + tmp1h
               t_p2 = t_p1 - zh(j_1,i_1+1)
               t_q1 = t_p1
               t_q2 = (zh(j_1,i_1+1) - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + zl(j_1,i_1+1) + tmp1l
               zh(j_1,i_1+1) = t_q1 + t_q2
               zl(j_1,i_1+1) = t_q2 - (zh(j_1,i_1+1) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           z(j_1,i_1+1) = z(j_1,i_1+1) + tmp1
!<<<           tmp1 = s2 * v(j_1,1)
               t_ch = s2h * vh(j_1,1)
               t_u1 = 134217729.0 * s2h
               t_p1 = t_u1
     +                  - (t_u1 - s2h)
               t_p2 = s2h - t_p1
               t_u1 = 134217729.0 * vh(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vh(j_1,1))
               t_r2 = vh(j_1,1) - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (s2h*vl(j_1,1)
     +                  +  s2l*vh(j_1,1))
               t_s1 = t_ch + t_cl
               tmp1l = t_cl - (t_s1 - t_ch)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp1 = s2 * v(j_1,1)
!<<<           z(j_1,i_1+2) = z(j_1,i_1+2) + tmp1
               t_p1 = zh(j_1,i_1+2) + tmp1h
               t_p2 = t_p1 - zh(j_1,i_1+2)
               t_q1 = t_p1
               t_q2 = (zh(j_1,i_1+2) - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + zl(j_1,i_1+2) + tmp1l
               zh(j_1,i_1+2) = t_q1 + t_q2
               zl(j_1,i_1+2) = t_q2 - (zh(j_1,i_1+2) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           z(j_1,i_1+2) = z(j_1,i_1+2) + tmp1
            end do! j_1
         end if
!$omp end master
!$omp do
         do i_1=i_4,i_3,4
!            s0 = ss(i_1+0)
!            s1 = ss(i_1+1)
!            s2 = ss(i_1+2)
!            s3 = ss(i_1+3)
            s0h = ssh(i_1+0)
            s0l = ssl(i_1+0)
            s1h = ssh(i_1+1)
            s1l = ssl(i_1+1)
            s2h = ssh(i_1+2)
            s2l = ssl(i_1+2)
            s3h = ssh(i_1+3)
            s3l = ssl(i_1+3)
            do j_1=j_2,j_3
!               z(j_1,i_1+0) = z(j_1,i_1+0) + s0 * v(j_1,1)
!               z(j_1,i_1+1) = z(j_1,i_1+1) + s1 * v(j_1,1)
!               z(j_1,i_1+2) = z(j_1,i_1+2) + s2 * v(j_1,1)
!               z(j_1,i_1+3) = z(j_1,i_1+3) + s3 * v(j_1,1)
!<<<           tmp1 = s0 * v(j_1,1)
               t_ch = s0h * vh(j_1,1)
               t_u1 = 134217729.0 * s0h
               t_p1 = t_u1
     +                  - (t_u1 - s0h)
               t_p2 = s0h - t_p1
               t_u1 = 134217729.0 * vh(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vh(j_1,1))
               t_r2 = vh(j_1,1) - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (s0h*vl(j_1,1)
     +                  +  s0l*vh(j_1,1))
               t_s1 = t_ch + t_cl
               tmp1l = t_cl - (t_s1 - t_ch)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp1 = s0 * v(j_1,1)
!<<<           z(j_1,i_1+0) = z(j_1,i_1+0) + tmp1
               t_p1 = zh(j_1,i_1+0) + tmp1h
               t_p2 = t_p1 - zh(j_1,i_1+0)
               t_q1 = t_p1
               t_q2 = (zh(j_1,i_1+0) - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + zl(j_1,i_1+0) + tmp1l
               zh(j_1,i_1+0) = t_q1 + t_q2
               zl(j_1,i_1+0) = t_q2 - (zh(j_1,i_1+0) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           z(j_1,i_1+0) = z(j_1,i_1+0) + tmp1
!<<<           tmp1 = s1 * v(j_1,1)
               t_ch = s1h * vh(j_1,1)
               t_u1 = 134217729.0 * s1h
               t_p1 = t_u1
     +                  - (t_u1 - s1h)
               t_p2 = s1h - t_p1
               t_u1 = 134217729.0 * vh(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vh(j_1,1))
               t_r2 = vh(j_1,1) - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (s1h*vl(j_1,1)
     +                  +  s1l*vh(j_1,1))
               t_s1 = t_ch + t_cl
               tmp1l = t_cl - (t_s1 - t_ch)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp1 = s1 * v(j_1,1)
!<<<           z(j_1,i_1+1) = z(j_1,i_1+1) + tmp1
               t_p1 = zh(j_1,i_1+1) + tmp1h
               t_p2 = t_p1 - zh(j_1,i_1+1)
               t_q1 = t_p1
               t_q2 = (zh(j_1,i_1+1) - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + zl(j_1,i_1+1) + tmp1l
               zh(j_1,i_1+1) = t_q1 + t_q2
               zl(j_1,i_1+1) = t_q2 - (zh(j_1,i_1+1) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           z(j_1,i_1+1) = z(j_1,i_1+1) + tmp1
!<<<           tmp1 = s2 * v(j_1,1)
               t_ch = s2h * vh(j_1,1)
               t_u1 = 134217729.0 * s2h
               t_p1 = t_u1
     +                  - (t_u1 - s2h)
               t_p2 = s2h - t_p1
               t_u1 = 134217729.0 * vh(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vh(j_1,1))
               t_r2 = vh(j_1,1) - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (s2h*vl(j_1,1)
     +                  +  s2l*vh(j_1,1))
               t_s1 = t_ch + t_cl
               tmp1l = t_cl - (t_s1 - t_ch)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp1 = s2 * v(j_1,1)
!<<<           z(j_1,i_1+2) = z(j_1,i_1+2) + tmp1
               t_p1 = zh(j_1,i_1+2) + tmp1h
               t_p2 = t_p1 - zh(j_1,i_1+2)
               t_q1 = t_p1
               t_q2 = (zh(j_1,i_1+2) - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + zl(j_1,i_1+2) + tmp1l
               zh(j_1,i_1+2) = t_q1 + t_q2
               zl(j_1,i_1+2) = t_q2 - (zh(j_1,i_1+2) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           z(j_1,i_1+2) = z(j_1,i_1+2) + tmp1
!<<<           tmp1 = s3 * v(j_1,1)
               t_ch = s3h * vh(j_1,1)
               t_u1 = 134217729.0 * s3h
               t_p1 = t_u1
     +                  - (t_u1 - s3h)
               t_p2 = s3h - t_p1
               t_u1 = 134217729.0 * vh(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vh(j_1,1))
               t_r2 = vh(j_1,1) - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (s3h*vl(j_1,1)
     +                  +  s3l*vh(j_1,1))
               t_s1 = t_ch + t_cl
               tmp1l = t_cl - (t_s1 - t_ch)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp1 = s3 * v(j_1,1)
!<<<           z(j_1,i_1+3) = z(j_1,i_1+3) + tmp1
               t_p1 = zh(j_1,i_1+3) + tmp1h
               t_p2 = t_p1 - zh(j_1,i_1+3)
               t_q1 = t_p1
               t_q2 = (zh(j_1,i_1+3) - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + zl(j_1,i_1+3) + tmp1l
               zh(j_1,i_1+3) = t_q1 + t_q2
               zl(j_1,i_1+3) = t_q2 - (zh(j_1,i_1+3) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           z(j_1,i_1+3) = z(j_1,i_1+3) + tmp1
            end do! j_1
         end do! i_1
!$omp enddo
!----
!$omp barrier
!----
      end do !i
!----
      do i=nx+1, n, m
!----
!$omp master
         ds=mpi_wtime()

         if ( m > size_of_row ) then

            do j=0,m-1
               nodes(j) = get_loop_node(i+j, size_of_row, my_row)
            enddo

            do iy=1,size_of_row

               k0=0
               do j=0,m-1
                  if ( nodes(j) == iy ) then
                     i_1 = translate_g2l(i+j, size_of_row, iy)
                     j_2 = get_loop_start(1,    size_of_col,my_col)
                     j_3 = get_loop_end  (i+m-1-iblk,size_of_col,my_col)
                     if ( my_row == iy ) then
                        do j_1=j_2,j_3
!                           wk(k0+j_1) = a(j_1,i_1)
                           wkh(k0+j_1) = ah(j_1,i_1)
                           wkl(k0+j_1) = al(j_1,i_1)
                        end do! k
                     endif
                     k0=k0+(j_3-j_2+1)
                  endif
               enddo

!               call bcast_dbl(wk, k0, iy, mpi_comm_row)
               call ddbcast_dbl(wkh, wkl, k0, iy, mpi_comm_row)

               k0=0
               do j=0,m-1
                  if ( nodes(j) == iy ) then
                     i_1 = translate_g2l(i+j, size_of_row, iy)
                     j_2 = get_loop_start(1,    size_of_col,my_col)
                     j_3 = get_loop_end  (i+m-1-iblk,size_of_col,my_col)
                     do j_1=j_2,j_3
!                        v(j_1,j+1) = wk(k0+j_1)
                        vh(j_1,j+1) = wkh(k0+j_1)
                        vl(j_1,j+1) = wkl(k0+j_1)
                     end do! k
                     k0=k0+(j_3-j_2+1)
                     j_2 = get_loop_start(i+j,  size_of_col,my_col)
                     j_3 = get_loop_end  (i+m-1-iblk,size_of_col,my_col)
                     do j_1=j_2,j_3
!                        v(j_1,j+1) = 0.0d+00
                        vh(j_1,j+1) = 0.0d+0
                        vl(j_1,j+1) = 0.0d+0
                     end do
                  endif
               enddo

            enddo

         else

            do j=0,m-1
               nodes(j) = get_loop_node(i+j, size_of_row, my_row)
               if ( nodes(j) == my_row ) then
                  i_1 = translate_g2l(i+j, size_of_row, my_row)
                  j_2 = get_loop_start(1,    size_of_col,my_col)
                  j_3 = get_loop_end  (i+m-1-iblk,size_of_col,my_col)
                  do j_1=j_2,j_3
!                     v(j_1,j+1) = a(j_1,i_1)
                     vh(j_1,j+1) = ah(j_1,i_1)
                     vl(j_1,j+1) = al(j_1,i_1)
                  end do! k
                  j_2 = get_loop_start(i+j,  size_of_col,my_col)
                  j_3 = get_loop_end  (i+m-1-iblk,size_of_col,my_col)
!cdir novector
                  do j_1=j_2,j_3
!                     v(j_1,j+1) = 0.0d+00
                     vh(j_1,j+1) = 0.0d+0
                     vl(j_1,j+1) = 0.0d+0
                  end do
               end if
            end do
            j_2 = get_loop_start(1,     size_of_col,my_col)
            j_3 = get_loop_end  (i+m-1-iblk, size_of_col,my_col)
            do j=0,m-1
!               call bcast_dbl(v(1,j+1), j_3-j_2+1,
!     &                        nodes(j), mpi_comm_row)
               call ddbcast_dbl(vh(1,j+1), vl(1,j+1), j_3-j_2+1,
     &                          nodes(j), mpi_comm_row)
            enddo

         endif
!$omp end master
!----
!$omp barrier
!----
!         call eigen_pbk_main2(i_3, z, nmz,
!     $           d, v, nm, m, iblk, i, ss, tt)
         call ddeigen_pbk_main2(i_3, zh, zl, nmz,
     $           dh, dl, vh, vl, nm, m, iblk, i, ssh, ssl, tth, ttl)
!----
!$omp barrier
!----
      end do !i
!----
!$omp master
!      deallocate(wk)
      deallocate(wkh, wkl)
      call mpi_barrier(mpi_comm_world,ierr)
!$omp end master
!----
      return
      end subroutine
