!      subroutine eigen_pbk_main2(n, z, nmz,
!     &           d, v, nm, m, iblk,
!     &           i, ss, tt)
      subroutine ddeigen_pbk_main2(n, zh, zl, nmz,
     &           dh, dl, vh, vl, nm, m, iblk,
     &           i, ssh, ssl, tth, ttl)
!----
!      use communication_sx, only : reduce_dbl
!     &                           , get_loop_start
!     &                           , get_loop_end
      use ddcommunication_sx, only : ddreduce_dbl
     &                             , get_loop_start
     &                             , get_loop_end
!----
      implicit double precision(a-h,o-z),integer(i-n)
!----
      integer :: n, nmz, nm, m, iblk, i
!      real(8) :: z(nmz,*),d(*),v(nm,*)
!      real(8) :: ss(*), tt(*)
      real(8) :: zh(nmz,*),dh(*),vh(nm,*)
      real(8) :: zl(nmz,*),dl(*),vl(nm,*)
      real(8) :: ssh(*), tth(*)
      real(8) :: ssl(*), ttl(*)
!----
      include 'mpif.h'
!$    include 'omp_lib.h'
      include 'trd.h'
!----
      i_2 = 1
      i_3 = n
!----
      j_2 = get_loop_start(1,         size_of_col,my_col)
      j_3 = get_loop_end  (i+m-1-iblk,size_of_col,my_col)
!----
!$omp master
! sm:= 0
! ss:= 0
!      ss(1:(i_3-i_2+1)*m+nsm*nsm) = 0.0d+0
      ssh(1:(i_3-i_2+1)*m+nsm*nsm) = 0.0d+0
      ssl(1:(i_3-i_2+1)*m+nsm*nsm) = 0.0d+0
!$omp end master
!----
!$omp barrier
! sm:= sm+lower(v^tv)
! ss(1:m,1:n):= ss+v(j_2:j_3,1:m)^t*z(j_2:j_3,1:n)
!      call eigen_pbk_step1(z, nmz,
!     &           v, nm, m, ss(1+nsm*nsm), ss(1),
!     &           i_2,i_3,j_2,j_3)
      call ddeigen_pbk_step1(zh, zl, nmz,
     &           vh, vl, nm, m, ssh(1+nsm*nsm), ssl(1+nsm*nsm),
     &           ssh(1), ssl(1), i_2,i_3,j_2,j_3)
!$omp barrier

!$omp master
!----
!      call reduce_dbl(ss, tt, (i_3-i_2+1)*m+nsm*nsm,
!     &                1, mpi_comm_col)
      call ddreduce_dbl(ssh, ssl, tth, ttl, (i_3-i_2+1)*m+nsm*nsm,
     &                1, mpi_comm_col)
!----
! sm:= d*sm
      do m_0=1,m-1
!dir$ ivdep
         do i_0=m_0+1,m
!            ss(i_0+(m_0-1)*nsm) = ss(i_0+(m_0-1)*nsm) * d(i+i_0-1)
!<<<        ss(i_0+(m_0-1)*nsm) = ss(i_0+(m_0-1)*nsm) * d(i+i_0-1)
            ch = ssh(i_0+(m_0-1)*nsm) * dh(i+i_0-1)
            u1 = 134217729.0 * ssh(i_0+(m_0-1)*nsm)
            p1 = u1
     +               - (u1 - ssh(i_0+(m_0-1)*nsm))
            p2 = ssh(i_0+(m_0-1)*nsm) - p1
            u1 = 134217729.0 * dh(i+i_0-1)
            r1 = u1
     +               - (u1 - dh(i+i_0-1))
            r2 = dh(i+i_0-1) - r1
            cl = ((p1*r1
     +               - ch)
     +              + p1 * r2
     +              + p2 * r1)
     +              + p2 * r2
            cl = cl
     +               + (ssh(i_0+(m_0-1)*nsm)*dl(i+i_0-1)
     +               +  ssl(i_0+(m_0-1)*nsm)*dh(i+i_0-1))
            s1 = ch + cl
            ssl(i_0+(m_0-1)*nsm) = cl - (s1 - ch)
            ssh(i_0+(m_0-1)*nsm) = s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>        ss(i_0+(m_0-1)*nsm) = ss(i_0+(m_0-1)*nsm) * d(i+i_0-1)
         end do! i_0
      end do! m_0
!----
! ss:= d*ss
      i_4 = mod(i_3-i_2+1,4)+i_2
      do i_1=i_2,i_4-1                       ! 0
!dir$ ivdep
         do m_0=1,m
!            ss((i_1+0-i_2)*m+m_0+nsm*nsm) =
!     &      ss((i_1+0-i_2)*m+m_0+nsm*nsm) * d(i+m_0-1)
!<<<        ss((i_1+0-i_2)*m+m_0+nsm*nsm) = ss((i_1+0-i_2)*m+m_0+nsm*nsm) * d(i+m_0-1)
            ch = ssh((i_1+0-i_2)*m+m_0+nsm*nsm) * dh(i+m_0-1)
            u1 = 134217729.0 * ssh((i_1+0-i_2)*m+m_0+nsm*nsm)
            p1 = u1
     +               - (u1 - ssh((i_1+0-i_2)*m+m_0+nsm*nsm))
            p2 = ssh((i_1+0-i_2)*m+m_0+nsm*nsm) - p1
            u1 = 134217729.0 * dh(i+m_0-1)
            r1 = u1
     +               - (u1 - dh(i+m_0-1))
            r2 = dh(i+m_0-1) - r1
            cl = ((p1*r1
     +               - ch)
     +              + p1 * r2
     +              + p2 * r1)
     +              + p2 * r2
            cl = cl
     +               + (ssh((i_1+0-i_2)*m+m_0+nsm*nsm)*dl(i+m_0-1)
     +               +  ssl((i_1+0-i_2)*m+m_0+nsm*nsm)*dh(i+m_0-1))
            s1 = ch + cl
            ssl((i_1+0-i_2)*m+m_0+nsm*nsm) = cl - (s1 - ch)
            ssh((i_1+0-i_2)*m+m_0+nsm*nsm) = s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>        ss((i_1+0-i_2)*m+m_0+nsm*nsm) = ss((i_1+0-i_2)*m+m_0+nsm*nsm) * d(i+m_0-1)
         end do! m_0
      end do! i_1
      do i_1=i_4,i_3,4                  ! 3
!dir$ ivdep
         do m_0=1,m
!            ss((i_1+0-i_2)*m+m_0+nsm*nsm) =
!     &      ss((i_1+0-i_2)*m+m_0+nsm*nsm) * d(i+m_0-1)
!            ss((i_1+1-i_2)*m+m_0+nsm*nsm) =
!     &      ss((i_1+1-i_2)*m+m_0+nsm*nsm) * d(i+m_0-1)
!            ss((i_1+2-i_2)*m+m_0+nsm*nsm) =
!     &      ss((i_1+2-i_2)*m+m_0+nsm*nsm) * d(i+m_0-1)
!            ss((i_1+3-i_2)*m+m_0+nsm*nsm) =
!     &      ss((i_1+3-i_2)*m+m_0+nsm*nsm) * d(i+m_0-1)
!<<<        ss((i_1+0-i_2)*m+m_0+nsm*nsm) = ss((i_1+0-i_2)*m+m_0+nsm*nsm) * d(i+m_0-1)
            ch = ssh((i_1+0-i_2)*m+m_0+nsm*nsm) * dh(i+m_0-1)
            u1 = 134217729.0 * ssh((i_1+0-i_2)*m+m_0+nsm*nsm)
            p1 = u1
     +               - (u1 - ssh((i_1+0-i_2)*m+m_0+nsm*nsm))
            p2 = ssh((i_1+0-i_2)*m+m_0+nsm*nsm) - p1
            u1 = 134217729.0 * dh(i+m_0-1)
            r1 = u1
     +               - (u1 - dh(i+m_0-1))
            r2 = dh(i+m_0-1) - r1
            cl = ((p1*r1
     +               - ch)
     +              + p1 * r2
     +              + p2 * r1)
     +              + p2 * r2
            cl = cl
     +               + (ssh((i_1+0-i_2)*m+m_0+nsm*nsm)*dl(i+m_0-1)
     +               +  ssl((i_1+0-i_2)*m+m_0+nsm*nsm)*dh(i+m_0-1))
            s1 = ch + cl
            ssl((i_1+0-i_2)*m+m_0+nsm*nsm) = cl - (s1 - ch)
            ssh((i_1+0-i_2)*m+m_0+nsm*nsm) = s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>        ss((i_1+0-i_2)*m+m_0+nsm*nsm) = ss((i_1+0-i_2)*m+m_0+nsm*nsm) * d(i+m_0-1)
!<<<        ss((i_1+1-i_2)*m+m_0+nsm*nsm) = ss((i_1+1-i_2)*m+m_0+nsm*nsm) * d(i+m_0-1)
            ch = ssh((i_1+1-i_2)*m+m_0+nsm*nsm) * dh(i+m_0-1)
            u1 = 134217729.0 * ssh((i_1+1-i_2)*m+m_0+nsm*nsm)
            p1 = u1
     +               - (u1 - ssh((i_1+1-i_2)*m+m_0+nsm*nsm))
            p2 = ssh((i_1+1-i_2)*m+m_0+nsm*nsm) - p1
            u1 = 134217729.0 * dh(i+m_0-1)
            r1 = u1
     +               - (u1 - dh(i+m_0-1))
            r2 = dh(i+m_0-1) - r1
            cl = ((p1*r1
     +               - ch)
     +              + p1 * r2
     +              + p2 * r1)
     +              + p2 * r2
            cl = cl
     +               + (ssh((i_1+1-i_2)*m+m_0+nsm*nsm)*dl(i+m_0-1)
     +               +  ssl((i_1+1-i_2)*m+m_0+nsm*nsm)*dh(i+m_0-1))
            s1 = ch + cl
            ssl((i_1+1-i_2)*m+m_0+nsm*nsm) = cl - (s1 - ch)
            ssh((i_1+1-i_2)*m+m_0+nsm*nsm) = s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>        ss((i_1+1-i_2)*m+m_0+nsm*nsm) = ss((i_1+1-i_2)*m+m_0+nsm*nsm) * d(i+m_0-1)
!<<<        ss((i_1+2-i_2)*m+m_0+nsm*nsm) = ss((i_1+2-i_2)*m+m_0+nsm*nsm) * d(i+m_0-1)
            ch = ssh((i_1+2-i_2)*m+m_0+nsm*nsm) * dh(i+m_0-1)
            u1 = 134217729.0 * ssh((i_1+2-i_2)*m+m_0+nsm*nsm)
            p1 = u1
     +               - (u1 - ssh((i_1+2-i_2)*m+m_0+nsm*nsm))
            p2 = ssh((i_1+2-i_2)*m+m_0+nsm*nsm) - p1
            u1 = 134217729.0 * dh(i+m_0-1)
            r1 = u1
     +               - (u1 - dh(i+m_0-1))
            r2 = dh(i+m_0-1) - r1
            cl = ((p1*r1
     +               - ch)
     +              + p1 * r2
     +              + p2 * r1)
     +              + p2 * r2
            cl = cl
     +               + (ssh((i_1+2-i_2)*m+m_0+nsm*nsm)*dl(i+m_0-1)
     +               +  ssl((i_1+2-i_2)*m+m_0+nsm*nsm)*dh(i+m_0-1))
            s1 = ch + cl
            ssl((i_1+2-i_2)*m+m_0+nsm*nsm) = cl - (s1 - ch)
            ssh((i_1+2-i_2)*m+m_0+nsm*nsm) = s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>        ss((i_1+2-i_2)*m+m_0+nsm*nsm) = ss((i_1+2-i_2)*m+m_0+nsm*nsm) * d(i+m_0-1)
!<<<        ss((i_1+3-i_2)*m+m_0+nsm*nsm) = ss((i_1+3-i_2)*m+m_0+nsm*nsm) * d(i+m_0-1)
            ch = ssh((i_1+3-i_2)*m+m_0+nsm*nsm) * dh(i+m_0-1)
            u1 = 134217729.0 * ssh((i_1+3-i_2)*m+m_0+nsm*nsm)
            p1 = u1
     +               - (u1 - ssh((i_1+3-i_2)*m+m_0+nsm*nsm))
            p2 = ssh((i_1+3-i_2)*m+m_0+nsm*nsm) - p1
            u1 = 134217729.0 * dh(i+m_0-1)
            r1 = u1
     +               - (u1 - dh(i+m_0-1))
            r2 = dh(i+m_0-1) - r1
            cl = ((p1*r1
     +               - ch)
     +              + p1 * r2
     +              + p2 * r1)
     +              + p2 * r2
            cl = cl
     +               + (ssh((i_1+3-i_2)*m+m_0+nsm*nsm)*dl(i+m_0-1)
     +               +  ssl((i_1+3-i_2)*m+m_0+nsm*nsm)*dh(i+m_0-1))
            s1 = ch + cl
            ssl((i_1+3-i_2)*m+m_0+nsm*nsm) = cl - (s1 - ch)
            ssh((i_1+3-i_2)*m+m_0+nsm*nsm) = s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>        ss((i_1+3-i_2)*m+m_0+nsm*nsm) = ss((i_1+3-i_2)*m+m_0+nsm*nsm) * d(i+m_0-1)
         end do! m_0
      end do! i_1
!$omp end master
!----
!$omp barrier
! v:= v*(i-sm)^{-1}
! z(j_2:j_3,1:n):= z + v(j_2:j_3,1:m)*ss(1:m,1:n)
!      call eigen_pbk_step2( z, nmz,
!     &            v, nm, m,
!     &            ss(1+nsm*nsm), ss(1),
!     &            i_2,i_3,j_2,j_3 )
      call ddeigen_pbk_step2( zh, zl, nmz,
     &            vh, vl, nm, m,
     &            ssh(1+nsm*nsm), ssl(1+nsm*nsm), ssh(1), ssl(1),
     &            i_2,i_3,j_2,j_3 )
!$omp barrier
!----
      return
      end subroutine ! ddeigen_pbk_main2
