!      subroutine eigen_pbk_step1(z, nmz,
!     &                 v, nm, m, ss, sm, i_2,i_3,j_2,j_3)
      subroutine ddeigen_pbk_step1(zh, zl, nmz,
     &               vh, vl, nm, m, ssh, ssl, smh, sml, i_2,i_3,j_2,j_3)
      implicit double precision(a-h,o-z),integer(i-n)
!----
      integer :: nmz, nm, m
!      real(8) :: z(nmz,*),v(nm,*)
!      real(8) :: ss(m,*)
      real(8) :: zh(nmz,*),vh(nm,*)
      real(8) :: zl(nmz,*),vl(nm,*)
      real(8) :: ssh(m,*), ssl(m,*)
!----
      include 'mpif.h'
!$    include 'omp_lib.h'
      include 'trd.h'
!----
      real(8) :: smh(nsm,nsm), sml(nsm,nsm)
      integer :: thread_rank, thread_size
      double precision tmp1h, tmp1l
!     tmp vars
      double precision t_ch, t_cl
      double precision t_p1, t_p2
      double precision t_q1, t_q2
      double precision t_r1, t_r2
      double precision t_s1, t_s2
      double precision t_t1, t_t2
      double precision t_u1, t_u2
      double precision t_x1, t_x2
      double precision t_y1, t_y2
      double precision t_z1, t_z2
      double precision t_x, t_ax
      double precision t_t1h, t_t1l
      double precision t_t2h, t_t2l
!----
      thread_size = 1
      thread_rank = 0
!$    thread_size = omp_get_num_threads()
!$    thread_rank = omp_get_thread_num()
!----
      do j_0=j_2,j_3,nsx; j_4=min(j_0+nsx-1,j_3)

         do m_0=1+thread_rank,m-1,thread_size

            i_0 = m_0 + 1
            i_4 = mod(m-m_0-1+1,4)+i_0
            if ( i_0 == i_4 - 1 ) then
!               s0 = sm(i_0+0,m_0)
               s0h = smh(i_0+0,m_0)
               s0l = sml(i_0+0,m_0)
!dir$ ivdep
!dir$ vector aligned
               do j_1=j_0,j_4
!                  t0 = v(j_1,m_0)
!                  v0 = v(j_1,i_0+0)
!                  s0 = s0+v0*t0
                  t0h = vh(j_1,m_0)
                  t0l = vl(j_1,m_0)
                  v0h = vh(j_1,i_0+0)
                  v0l = vl(j_1,i_0+0)
!<<<              tmp1 = v0 * t0
                  t_ch = v0h * t0h
                  t_u1 = 134217729.0 * v0h
                  t_p1 = t_u1
     +                     - (t_u1 - v0h)
                  t_p2 = v0h - t_p1
                  t_u1 = 134217729.0 * t0h
                  t_r1 = t_u1
     +                     - (t_u1 - t0h)
                  t_r2 = t0h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (v0h*t0l
     +                     +  v0l*t0h)
                  t_s1 = t_ch + t_cl
                  tmp1l = t_cl - (t_s1 - t_ch)
                  tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp1 = v0 * t0
!<<<              s0 = s0 + tmp1
                  t_p1 = s0h + tmp1h
                  t_p2 = t_p1 - s0h
                  t_q1 = t_p1
                  t_q2 = (s0h - (t_p1 - t_p2))
     +                     + (tmp1h - t_p2)
                  t_q2 = t_q2 + s0l + tmp1l
                  s0h = t_q1 + t_q2
                  s0l = t_q2 - (s0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>              s0 = s0 + tmp1
               end do! k
!               sm(i_0+0,m_0) = s0
               smh(i_0+0,m_0) = s0h
               sml(i_0+0,m_0) = s0l
            end if
            if ( i_0 == i_4 - 2 ) then
!               s0 = sm(i_0+0,m_0)
!               s1 = sm(i_0+1,m_0)
               s0h = smh(i_0+0,m_0)
               s0l = sml(i_0+0,m_0)
               s1h = smh(i_0+1,m_0)
               s1l = sml(i_0+1,m_0)
!dir$ ivdep
!dir$ vector aligned
               do j_1=j_0,j_4
!                  t0 = v(j_1,m_0)
!                  v0 = v(j_1,i_0+0)
!                  v1 = v(j_1,i_0+1)
                  t0h = vh(j_1,m_0)
                  t0l = vl(j_1,m_0)
                  v0h = vh(j_1,i_0+0)
                  v0l = vl(j_1,i_0+0)
                  v1h = vh(j_1,i_0+1)
                  v1l = vl(j_1,i_0+1)
!                  s0 = s0+v0*t0
!                  s1 = s1+v1*t0
!<<<              tmp1 = v0 * t0
                  t_ch = v0h * t0h
                  t_u1 = 134217729.0 * v0h
                  t_p1 = t_u1
     +                     - (t_u1 - v0h)
                  t_p2 = v0h - t_p1
                  t_u1 = 134217729.0 * t0h
                  t_r1 = t_u1
     +                     - (t_u1 - t0h)
                  t_r2 = t0h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (v0h*t0l
     +                     +  v0l*t0h)
                  t_s1 = t_ch + t_cl
                  tmp1l = t_cl - (t_s1 - t_ch)
                  tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp1 = v0 * t0
!<<<              s0 = s0 + tmp1
                  t_p1 = s0h + tmp1h
                  t_p2 = t_p1 - s0h
                  t_q1 = t_p1
                  t_q2 = (s0h - (t_p1 - t_p2))
     +                     + (tmp1h - t_p2)
                  t_q2 = t_q2 + s0l + tmp1l
                  s0h = t_q1 + t_q2
                  s0l = t_q2 - (s0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>              s0 = s0 + tmp1
!<<<              tmp1 = v1 * t0
                  t_ch = v1h * t0h
                  t_u1 = 134217729.0 * v1h
                  t_p1 = t_u1
     +                     - (t_u1 - v1h)
                  t_p2 = v1h - t_p1
                  t_u1 = 134217729.0 * t0h
                  t_r1 = t_u1
     +                     - (t_u1 - t0h)
                  t_r2 = t0h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (v1h*t0l
     +                     +  v1l*t0h)
                  t_s1 = t_ch + t_cl
                  tmp1l = t_cl - (t_s1 - t_ch)
                  tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp1 = v1 * t0
!<<<              s1 = s1 + tmp1
                  t_p1 = s1h + tmp1h
                  t_p2 = t_p1 - s1h
                  t_q1 = t_p1
                  t_q2 = (s1h - (t_p1 - t_p2))
     +                     + (tmp1h - t_p2)
                  t_q2 = t_q2 + s1l + tmp1l
                  s1h = t_q1 + t_q2
                  s1l = t_q2 - (s1h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>              s1 = s1 + tmp1
               end do! k
!               sm(i_0+0,m_0) = s0
!               sm(i_0+1,m_0) = s1
               smh(i_0+0,m_0) = s0h
               sml(i_0+0,m_0) = s0l
               smh(i_0+1,m_0) = s1h
               sml(i_0+1,m_0) = s1l
            end if
            if ( i_0 == i_4 - 3 ) then
!               s0 = sm(i_0+0,m_0)
!               s1 = sm(i_0+1,m_0)
!               s2 = sm(i_0+2,m_0)
               s0h = smh(i_0+0,m_0)
               s0l = sml(i_0+0,m_0)
               s1h = smh(i_0+1,m_0)
               s1l = sml(i_0+1,m_0)
               s2h = smh(i_0+2,m_0)
               s2l = sml(i_0+2,m_0)
!dir$ ivdep
!dir$ vector aligned
               do j_1=j_0,j_4
!                  t0 = v(j_1,m_0)
!                  v0 = v(j_1,i_0+0)
!                  v1 = v(j_1,i_0+1)
!                  v2 = v(j_1,i_0+2)
                  t0h = vh(j_1,m_0)
                  t0l = vl(j_1,m_0)
                  v0h = vh(j_1,i_0+0)
                  v0l = vl(j_1,i_0+0)
                  v1h = vh(j_1,i_0+1)
                  v1l = vl(j_1,i_0+1)
                  v2h = vh(j_1,i_0+2)
                  v2l = vl(j_1,i_0+2)
!                  s0 = s0+v0*t0
!                  s1 = s1+v1*t0
!                  s2 = s2+v2*t0
!<<<              tmp1 = v0 * t0
                  t_ch = v0h * t0h
                  t_u1 = 134217729.0 * v0h
                  t_p1 = t_u1
     +                     - (t_u1 - v0h)
                  t_p2 = v0h - t_p1
                  t_u1 = 134217729.0 * t0h
                  t_r1 = t_u1
     +                     - (t_u1 - t0h)
                  t_r2 = t0h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (v0h*t0l
     +                     +  v0l*t0h)
                  t_s1 = t_ch + t_cl
                  tmp1l = t_cl - (t_s1 - t_ch)
                  tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp1 = v0 * t0
!<<<              s0 = s0 + tmp1
                  t_p1 = s0h + tmp1h
                  t_p2 = t_p1 - s0h
                  t_q1 = t_p1
                  t_q2 = (s0h - (t_p1 - t_p2))
     +                     + (tmp1h - t_p2)
                  t_q2 = t_q2 + s0l + tmp1l
                  s0h = t_q1 + t_q2
                  s0l = t_q2 - (s0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>              s0 = s0 + tmp1
!<<<              tmp1 = v1 * t0
                  t_ch = v1h * t0h
                  t_u1 = 134217729.0 * v1h
                  t_p1 = t_u1
     +                     - (t_u1 - v1h)
                  t_p2 = v1h - t_p1
                  t_u1 = 134217729.0 * t0h
                  t_r1 = t_u1
     +                     - (t_u1 - t0h)
                  t_r2 = t0h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (v1h*t0l
     +                     +  v1l*t0h)
                  t_s1 = t_ch + t_cl
                  tmp1l = t_cl - (t_s1 - t_ch)
                  tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp1 = v1 * t0
!<<<              s1 = s1 + tmp1
                  t_p1 = s1h + tmp1h
                  t_p2 = t_p1 - s1h
                  t_q1 = t_p1
                  t_q2 = (s1h - (t_p1 - t_p2))
     +                     + (tmp1h - t_p2)
                  t_q2 = t_q2 + s1l + tmp1l
                  s1h = t_q1 + t_q2
                  s1l = t_q2 - (s1h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>              s1 = s1 + tmp1
!<<<              tmp1 = v2 * t0
                  t_ch = v2h * t0h
                  t_u1 = 134217729.0 * v2h
                  t_p1 = t_u1
     +                     - (t_u1 - v2h)
                  t_p2 = v2h - t_p1
                  t_u1 = 134217729.0 * t0h
                  t_r1 = t_u1
     +                     - (t_u1 - t0h)
                  t_r2 = t0h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (v2h*t0l
     +                     +  v2l*t0h)
                  t_s1 = t_ch + t_cl
                  tmp1l = t_cl - (t_s1 - t_ch)
                  tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp1 = v2 * t0
!<<<              s2 = s2 + tmp1
                  t_p1 = s2h + tmp1h
                  t_p2 = t_p1 - s2h
                  t_q1 = t_p1
                  t_q2 = (s2h - (t_p1 - t_p2))
     +                     + (tmp1h - t_p2)
                  t_q2 = t_q2 + s2l + tmp1l
                  s2h = t_q1 + t_q2
                  s2l = t_q2 - (s2h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>              s2 = s2 + tmp1
               end do! k
!               sm(i_0+0,m_0) = s0
!               sm(i_0+1,m_0) = s1
!               sm(i_0+2,m_0) = s2
               smh(i_0+0,m_0) = s0h
               sml(i_0+0,m_0) = s0l
               smh(i_0+1,m_0) = s1h
               sml(i_0+1,m_0) = s1l
               smh(i_0+2,m_0) = s2h
               sml(i_0+2,m_0) = s2l
            end if
            do i_0=i_4,m,4              ! 3
!               s0 = sm(i_0+0,m_0)
!               s1 = sm(i_0+1,m_0)
!               s2 = sm(i_0+2,m_0)
!               s3 = sm(i_0+3,m_0)
               s0h = smh(i_0+0,m_0)
               s0l = sml(i_0+0,m_0)
               s1h = smh(i_0+1,m_0)
               s1l = sml(i_0+1,m_0)
               s2h = smh(i_0+2,m_0)
               s2l = sml(i_0+2,m_0)
               s3h = smh(i_0+3,m_0)
               s3l = sml(i_0+3,m_0)
!dir$ ivdep
!dir$ ivdep
!dir$ vector aligned
               do j_1=j_0,j_4
!                  t0 = v(j_1,m_0)
!                  v0 = v(j_1,i_0+0)
                  t0h = vh(j_1,m_0)
                  t0l = vl(j_1,m_0)
                  v0h = vh(j_1,i_0+0)
                  v0l = vl(j_1,i_0+0)
!                  s0 = s0+v0*t0
!<<<              tmp1 = v0 * t0
                  t_ch = v0h * t0h
                  t_u1 = 134217729.0 * v0h
                  t_p1 = t_u1
     +                     - (t_u1 - v0h)
                  t_p2 = v0h - t_p1
                  t_u1 = 134217729.0 * t0h
                  t_r1 = t_u1
     +                     - (t_u1 - t0h)
                  t_r2 = t0h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (v0h*t0l
     +                     +  v0l*t0h)
                  t_s1 = t_ch + t_cl
                  tmp1l = t_cl - (t_s1 - t_ch)
                  tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp1 = v0 * t0
!<<<              s0 = s0 + tmp1
                  t_p1 = s0h + tmp1h
                  t_p2 = t_p1 - s0h
                  t_q1 = t_p1
                  t_q2 = (s0h - (t_p1 - t_p2))
     +                     + (tmp1h - t_p2)
                  t_q2 = t_q2 + s0l + tmp1l
                  s0h = t_q1 + t_q2
                  s0l = t_q2 - (s0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>              s0 = s0 + tmp1
!                  v1 = v(j_1,i_0+1)
!                  s1 = s1+v1*t0
                  v1h = vh(j_1,i_0+1)
                  v1l = vl(j_1,i_0+1)
!<<<              tmp1 = v1 * t0
                  t_ch = v1h * t0h
                  t_u1 = 134217729.0 * v1h
                  t_p1 = t_u1
     +                     - (t_u1 - v1h)
                  t_p2 = v1h - t_p1
                  t_u1 = 134217729.0 * t0h
                  t_r1 = t_u1
     +                     - (t_u1 - t0h)
                  t_r2 = t0h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (v1h*t0l
     +                     +  v1l*t0h)
                  t_s1 = t_ch + t_cl
                  tmp1l = t_cl - (t_s1 - t_ch)
                  tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp1 = v1 * t0
!<<<              s1 = s1 + tmp1
                  t_p1 = s1h + tmp1h
                  t_p2 = t_p1 - s1h
                  t_q1 = t_p1
                  t_q2 = (s1h - (t_p1 - t_p2))
     +                     + (tmp1h - t_p2)
                  t_q2 = t_q2 + s1l + tmp1l
                  s1h = t_q1 + t_q2
                  s1l = t_q2 - (s1h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>              s1 = s1 + tmp1
!                  v2 = v(j_1,i_0+2)
!                  s2 = s2+v2*t0
                  v2h = vh(j_1,i_0+2)
                  v2l = vl(j_1,i_0+2)
!<<<              tmp1 = v2 * t0
                  t_ch = v2h * t0h
                  t_u1 = 134217729.0 * v2h
                  t_p1 = t_u1
     +                     - (t_u1 - v2h)
                  t_p2 = v2h - t_p1
                  t_u1 = 134217729.0 * t0h
                  t_r1 = t_u1
     +                     - (t_u1 - t0h)
                  t_r2 = t0h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (v2h*t0l
     +                     +  v2l*t0h)
                  t_s1 = t_ch + t_cl
                  tmp1l = t_cl - (t_s1 - t_ch)
                  tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp1 = v2 * t0
!<<<              s2 = s2 + tmp1
                  t_p1 = s2h + tmp1h
                  t_p2 = t_p1 - s2h
                  t_q1 = t_p1
                  t_q2 = (s2h - (t_p1 - t_p2))
     +                     + (tmp1h - t_p2)
                  t_q2 = t_q2 + s2l + tmp1l
                  s2h = t_q1 + t_q2
                  s2l = t_q2 - (s2h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>              s2 = s2 + tmp1
!                  v3 = v(j_1,i_0+3)
!                  s3 = s3+v3*t0
                  v3h = vh(j_1,i_0+3)
                  v3l = vl(j_1,i_0+3)
!<<<              tmp1 = v3 * t0
                  t_ch = v3h * t0h
                  t_u1 = 134217729.0 * v3h
                  t_p1 = t_u1
     +                     - (t_u1 - v3h)
                  t_p2 = v3h - t_p1
                  t_u1 = 134217729.0 * t0h
                  t_r1 = t_u1
     +                     - (t_u1 - t0h)
                  t_r2 = t0h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (v3h*t0l
     +                     +  v3l*t0h)
                  t_s1 = t_ch + t_cl
                  tmp1l = t_cl - (t_s1 - t_ch)
                  tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp1 = v3 * t0
!<<<              s3 = s3 + tmp1
                  t_p1 = s3h + tmp1h
                  t_p2 = t_p1 - s3h
                  t_q1 = t_p1
                  t_q2 = (s3h - (t_p1 - t_p2))
     +                     + (tmp1h - t_p2)
                  t_q2 = t_q2 + s3l + tmp1l
                  s3h = t_q1 + t_q2
                  s3l = t_q2 - (s3h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>              s3 = s3 + tmp1
               end do! k
!               sm(i_0+0,m_0) = s0
!               sm(i_0+1,m_0) = s1
!               sm(i_0+2,m_0) = s2
!               sm(i_0+3,m_0) = s3
               smh(i_0+0,m_0) = s0h
               sml(i_0+0,m_0) = s0l
               smh(i_0+1,m_0) = s1h
               sml(i_0+1,m_0) = s1l
               smh(i_0+2,m_0) = s2h
               sml(i_0+2,m_0) = s2l
               smh(i_0+3,m_0) = s3h
               sml(i_0+3,m_0) = s3l
            end do! i_0

         end do! m_0

      end do! j_0
!----
      if(.true.)then
         j_5 = j_3 - j_2 + 1

         do ii_2 = i_2, i_3, (1024*thread_size)

            ii_3 = min(ii_2+(1024*thread_size)-1,i_3)
            ii_4 = ii_2-i_2+1

            i_0 = (ii_3-ii_2) / thread_size + 1
            i_4 = i_0 * thread_rank
            i_5 = min(i_0, ii_3-(ii_2+i_4)+1)

            if ( j_5 > 0 .and. i_5 > 0 ) then
!               call dgemm('t','n',
!     &                     m, i_5, j_5,
!     &                     1.0d+00, v (j_2    ,1       ), nm,
!     &                     z (j_2    ,ii_2+i_4), nmz,
!     &                     1.0d+00, ss(1      ,ii_4+i_4), m)
               call ddgemm('t','n',
     &                m, i_5, j_5,
     &                1.0d+00, 0.0d+00,
     &                vh (j_2    ,1       ), vl (j_2    ,1       ), nm,
     &                zh (j_2    ,ii_2+i_4), zl (j_2    ,ii_2+i_4), nmz,
     &                1.0d+00, 0.0d+00,
     &                ssh(1      ,ii_4+i_4), ssl(1      ,ii_4+i_4), m)

            endif
         end do

      else

         j_5 = j_3 - j_2 + 1
         ii_step=0
         do i_1=i_2,i_3, 1024
            i_5 = min(i_3-i_1+1,1024)
            do m_1=1,m,32
               m_5 = min(m-m_1+1,32)

               if ( m_5 > 0 .and. i_5 > 0 ) then
                  ii_step=ii_step+1
                  if ( mod(ii_step-1,thread_size)==thread_rank ) then
!                     call dgemm('t','n',
!     &                    m_5, i_5, j_5,
!     &                    1.0d+00, v (j_2    ,m_1      ), nm,
!     &                             z (j_2    ,i_1      ), nmz,
!     &                    1.0d+00, ss(m_1    ,i_1-i_2+1), m)
                     call ddgemm('t','n',
     &                     m_5, i_5, j_5,
     &                    1.0d+00, 0.0d+00, 
     &                    vh (j_2    ,m_1      ),vl (j_2    ,m_1      ),
     &                    nm,
     &                    zh (j_2    ,i_1      ),zl (j_2    ,i_1      ),
     &                    nmz,
     &                    1.0d+00, 0.0d+00, 
     &                    ssh(m_1    ,i_1-i_2+1),ssl(m_1    ,i_1-i_2+1),
     &                    m)
                  endif
               endif

            end do

         end do

      endif

      return
      end subroutine ! ddeigen_pbk_step1

!----
!      subroutine eigen_pbk_step2( z, nmz,
!     &                  v, nm, m, ss, sm, i_2,i_3, j_2,j_3 )
      subroutine ddeigen_pbk_step2( zh, zl, nmz,
     &             vh, vl, nm, m, ssh, ssl, smh, sml, i_2,i_3, j_2,j_3 )
      implicit double precision(a-h,o-z),integer(i-n)
!----
      integer :: nmz, nm, m
!      real(8) :: z(nmz,*)
!      real(8) :: v(nm,*)
!      real(8) :: ss(m,*)
      real(8) :: zh(nmz,*), zl(nmz,*)
      real(8) :: vh(nm,*), vl(nm,*)
      real(8) :: ssh(m,*), ssl(m,*)
!----
      include 'mpif.h'
!$    include 'omp_lib.h'
      include 'trd.h'
!----
!      real(8) :: sm(nsm,*)
      real(8) :: smh(nsm,*), sml(nsm,*)
      integer :: thread_rank, thread_size
      double precision tmp1h, tmp1l
      double precision tmp2h, tmp2l
      double precision tmp3h, tmp3l
!     tmp vars
      double precision t_ch, t_cl
      double precision t_p1, t_p2
      double precision t_q1, t_q2
      double precision t_r1, t_r2
      double precision t_s1, t_s2
      double precision t_t1, t_t2
      double precision t_u1, t_u2
      double precision t_x1, t_x2
      double precision t_y1, t_y2
      double precision t_z1, t_z2
      double precision t_x, t_ax
      double precision t_t1h, t_t1l
      double precision t_t2h, t_t2l

      thread_size = 1
      thread_rank = 0
!$    thread_size = omp_get_num_threads()
!$    thread_rank = omp_get_thread_num()
!----
      j_5 = (j_3-j_2) / thread_size + 1
      j_5 = ((j_5-1)/2+1)*2
      j_4 = j_5 * thread_rank
      j_5 = min(j_5, j_3-(j_2+j_4)+1)
      j_6 = j_2+j_4
      j_7 = j_6+j_5-1
         
      do j_0=j_6,j_7,nsx; j_8=min(j_0+nsx-1,j_7)

         do m_0=m,1,-2

            i_0 = m
            i_4 = mod(m-m_0, 3)
            if ( i_4 == 1 ) then
!dir$ ivdep
!dir$ vector aligned
               do j_1=j_0,j_8
!                  v0 = v(j_1,i_0-0)
!                  u0 =
!     &               + sm(i_0-0,m_0  ) * v0
!                  u1 =
!     &               + sm(i_0-0,m_0-1) * v0
!                  v(j_1,m_0  ) = v(j_1,m_0  ) + u0
!                  v(j_1,m_0-1) = v(j_1,m_0-1) + u1
                  v0h = vh(j_1,i_0-0)
                  v0l = vl(j_1,i_0-0)
!<<<              u0 = sm(i_0-0,m_0) * v0
                  t_ch = smh(i_0-0,m_0) * v0h
                  t_u1 = 134217729.0 * smh(i_0-0,m_0)
                  t_p1 = t_u1
     +                     - (t_u1 - smh(i_0-0,m_0))
                  t_p2 = smh(i_0-0,m_0) - t_p1
                  t_u1 = 134217729.0 * v0h
                  t_r1 = t_u1
     +                     - (t_u1 - v0h)
                  t_r2 = v0h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (smh(i_0-0,m_0)*v0l
     +                     +  sml(i_0-0,m_0)*v0h)
                  t_s1 = t_ch + t_cl
                  u0l = t_cl - (t_s1 - t_ch)
                  u0h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              u0 = sm(i_0-0,m_0) * v0
!<<<              u1 = sm(i_0-0,m_0-1) * v0
                  t_ch = smh(i_0-0,m_0-1) * v0h
                  t_u1 = 134217729.0 * smh(i_0-0,m_0-1)
                  t_p1 = t_u1
     +                     - (t_u1 - smh(i_0-0,m_0-1))
                  t_p2 = smh(i_0-0,m_0-1) - t_p1
                  t_u1 = 134217729.0 * v0h
                  t_r1 = t_u1
     +                     - (t_u1 - v0h)
                  t_r2 = v0h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (smh(i_0-0,m_0-1)*v0l
     +                     +  sml(i_0-0,m_0-1)*v0h)
                  t_s1 = t_ch + t_cl
                  u1l = t_cl - (t_s1 - t_ch)
                  u1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              u1 = sm(i_0-0,m_0-1) * v0
!<<<              v(j_1,m_0) = v(j_1,m_0) + u0
                  t_p1 = vh(j_1,m_0) + u0h
                  t_p2 = t_p1 - vh(j_1,m_0)
                  t_q1 = t_p1
                  t_q2 = (vh(j_1,m_0) - (t_p1 - t_p2))
     +                     + (u0h - t_p2)
                  t_q2 = t_q2 + vl(j_1,m_0) + u0l
                  vh(j_1,m_0) = t_q1 + t_q2
                  vl(j_1,m_0) = t_q2 - (vh(j_1,m_0) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>              v(j_1,m_0) = v(j_1,m_0) + u0
!<<<              v(j_1,m_0-1) = v(j_1,m_0-1) + u1
                  t_p1 = vh(j_1,m_0-1) + u1h
                  t_p2 = t_p1 - vh(j_1,m_0-1)
                  t_q1 = t_p1
                  t_q2 = (vh(j_1,m_0-1) - (t_p1 - t_p2))
     +                     + (u1h - t_p2)
                  t_q2 = t_q2 + vl(j_1,m_0-1) + u1l
                  vh(j_1,m_0-1) = t_q1 + t_q2
                  vl(j_1,m_0-1) = t_q2 - (vh(j_1,m_0-1) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>              v(j_1,m_0-1) = v(j_1,m_0-1) + u1
               end do! j_1
            end if
            if ( i_4 == 2 ) then
!dir$ ivdep
!dir$ vector aligned
               do j_1=j_0,j_8
!                  v0 = v(j_1,i_0-0)
!                  v1 = v(j_1,i_0-1)
!                  u0 =
!     &               + sm(i_0-0,m_0  ) * v0
!     &               + sm(i_0-1,m_0  ) * v1
!                  u1 =
!     &               + sm(i_0-0,m_0-1) * v0
!     &               + sm(i_0-1,m_0-1) * v1
!                  v(j_1,m_0  ) = v(j_1,m_0  ) + u0
!                  v(j_1,m_0-1) = v(j_1,m_0-1) + u1
                  v0h = vh(j_1,i_0-0)
                  v0l = vl(j_1,i_0-0)
                  v1h = vh(j_1,i_0-1)
                  v1l = vl(j_1,i_0-1)
!<<<              tmp1 = sm(i_0-0,m_0) * v0
                  t_ch = smh(i_0-0,m_0) * v0h
                  t_u1 = 134217729.0 * smh(i_0-0,m_0)
                  t_p1 = t_u1
     +                     - (t_u1 - smh(i_0-0,m_0))
                  t_p2 = smh(i_0-0,m_0) - t_p1
                  t_u1 = 134217729.0 * v0h
                  t_r1 = t_u1
     +                     - (t_u1 - v0h)
                  t_r2 = v0h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (smh(i_0-0,m_0)*v0l
     +                     +  sml(i_0-0,m_0)*v0h)
                  t_s1 = t_ch + t_cl
                  tmp1l = t_cl - (t_s1 - t_ch)
                  tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp1 = sm(i_0-0,m_0) * v0
!<<<              tmp2 = sm(i_0-1,m_0) * v1
                  t_ch = smh(i_0-1,m_0) * v1h
                  t_u1 = 134217729.0 * smh(i_0-1,m_0)
                  t_p1 = t_u1
     +                     - (t_u1 - smh(i_0-1,m_0))
                  t_p2 = smh(i_0-1,m_0) - t_p1
                  t_u1 = 134217729.0 * v1h
                  t_r1 = t_u1
     +                     - (t_u1 - v1h)
                  t_r2 = v1h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (smh(i_0-1,m_0)*v1l
     +                     +  sml(i_0-1,m_0)*v1h)
                  t_s1 = t_ch + t_cl
                  tmp2l = t_cl - (t_s1 - t_ch)
                  tmp2h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp2 = sm(i_0-1,m_0) * v1
!<<<              u0 = tmp1 + tmp2
                  t_p1 = tmp1h + tmp2h
                  t_p2 = t_p1 - tmp1h
                  t_q1 = t_p1
                  t_q2 = (tmp1h - (t_p1 - t_p2))
     +                     + (tmp2h - t_p2)
                  t_q2 = t_q2 + tmp1l + tmp2l
                  u0h = t_q1 + t_q2
                  u0l = t_q2 - (u0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>              u0 = tmp1 + tmp2
!<<<              tmp1 = sm(i_0-0,m_0-1) * v0
                  t_ch = smh(i_0-0,m_0-1) * v0h
                  t_u1 = 134217729.0 * smh(i_0-0,m_0-1)
                  t_p1 = t_u1
     +                     - (t_u1 - smh(i_0-0,m_0-1))
                  t_p2 = smh(i_0-0,m_0-1) - t_p1
                  t_u1 = 134217729.0 * v0h
                  t_r1 = t_u1
     +                     - (t_u1 - v0h)
                  t_r2 = v0h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (smh(i_0-0,m_0-1)*v0l
     +                     +  sml(i_0-0,m_0-1)*v0h)
                  t_s1 = t_ch + t_cl
                  tmp1l = t_cl - (t_s1 - t_ch)
                  tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp1 = sm(i_0-0,m_0-1) * v0
!<<<              tmp2 = sm(i_0-1,m_0-1) * v1
                  t_ch = smh(i_0-1,m_0-1) * v1h
                  t_u1 = 134217729.0 * smh(i_0-1,m_0-1)
                  t_p1 = t_u1
     +                     - (t_u1 - smh(i_0-1,m_0-1))
                  t_p2 = smh(i_0-1,m_0-1) - t_p1
                  t_u1 = 134217729.0 * v1h
                  t_r1 = t_u1
     +                     - (t_u1 - v1h)
                  t_r2 = v1h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (smh(i_0-1,m_0-1)*v1l
     +                     +  sml(i_0-1,m_0-1)*v1h)
                  t_s1 = t_ch + t_cl
                  tmp2l = t_cl - (t_s1 - t_ch)
                  tmp2h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp2 = sm(i_0-1,m_0-1) * v1
!<<<              u1 = tmp1 + tmp2
                  t_p1 = tmp1h + tmp2h
                  t_p2 = t_p1 - tmp1h
                  t_q1 = t_p1
                  t_q2 = (tmp1h - (t_p1 - t_p2))
     +                     + (tmp2h - t_p2)
                  t_q2 = t_q2 + tmp1l + tmp2l
                  u1h = t_q1 + t_q2
                  u1l = t_q2 - (u1h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>              u1 = tmp1 + tmp2
!<<<              v(j_1,m_0) = v(j_1,m_0) + u0
                  t_p1 = vh(j_1,m_0) + u0h
                  t_p2 = t_p1 - vh(j_1,m_0)
                  t_q1 = t_p1
                  t_q2 = (vh(j_1,m_0) - (t_p1 - t_p2))
     +                     + (u0h - t_p2)
                  t_q2 = t_q2 + vl(j_1,m_0) + u0l
                  vh(j_1,m_0) = t_q1 + t_q2
                  vl(j_1,m_0) = t_q2 - (vh(j_1,m_0) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>              v(j_1,m_0) = v(j_1,m_0) + u0
!<<<              v(j_1,m_0-1) = v(j_1,m_0-1) + u1
                  t_p1 = vh(j_1,m_0-1) + u1h
                  t_p2 = t_p1 - vh(j_1,m_0-1)
                  t_q1 = t_p1
                  t_q2 = (vh(j_1,m_0-1) - (t_p1 - t_p2))
     +                     + (u1h - t_p2)
                  t_q2 = t_q2 + vl(j_1,m_0-1) + u1l
                  vh(j_1,m_0-1) = t_q1 + t_q2
                  vl(j_1,m_0-1) = t_q2 - (vh(j_1,m_0-1) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>              v(j_1,m_0-1) = v(j_1,m_0-1) + u1
               end do! j_1
            end if

            do i_0=m-i_4,m_0+1,-3
!dir$ ivdep
!dir$ vector aligned
               do j_1=j_0,j_8
!                  v0 = v(j_1,i_0-0)
!                  v1 = v(j_1,i_0-1)
!                  v2 = v(j_1,i_0-2)
                  v0h = vh(j_1,i_0-0)
                  v0l = vl(j_1,i_0-0)
                  v1h = vh(j_1,i_0-1)
                  v1l = vl(j_1,i_0-1)
                  v2h = vh(j_1,i_0-2)
                  v2l = vl(j_1,i_0-2)
!                  u0 =
!     &               + sm(i_0-0,m_0  ) * v0
!     &               + sm(i_0-1,m_0  ) * v1
!     &               + sm(i_0-2,m_0  ) * v2
!                  u1 =
!     &               + sm(i_0-0,m_0-1) * v0
!     &               + sm(i_0-1,m_0-1) * v1
!     &               + sm(i_0-2,m_0-1) * v2
!<<<              tmp1 = sm(i_0-0,m_0) * v0
                  t_ch = smh(i_0-0,m_0) * v0h
                  t_u1 = 134217729.0 * smh(i_0-0,m_0)
                  t_p1 = t_u1
     +                     - (t_u1 - smh(i_0-0,m_0))
                  t_p2 = smh(i_0-0,m_0) - t_p1
                  t_u1 = 134217729.0 * v0h
                  t_r1 = t_u1
     +                     - (t_u1 - v0h)
                  t_r2 = v0h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (smh(i_0-0,m_0)*v0l
     +                     +  sml(i_0-0,m_0)*v0h)
                  t_s1 = t_ch + t_cl
                  tmp1l = t_cl - (t_s1 - t_ch)
                  tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp1 = sm(i_0-0,m_0) * v0
!<<<              tmp2 = sm(i_0-1,m_0) * v1
                  t_ch = smh(i_0-1,m_0) * v1h
                  t_u1 = 134217729.0 * smh(i_0-1,m_0)
                  t_p1 = t_u1
     +                     - (t_u1 - smh(i_0-1,m_0))
                  t_p2 = smh(i_0-1,m_0) - t_p1
                  t_u1 = 134217729.0 * v1h
                  t_r1 = t_u1
     +                     - (t_u1 - v1h)
                  t_r2 = v1h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (smh(i_0-1,m_0)*v1l
     +                     +  sml(i_0-1,m_0)*v1h)
                  t_s1 = t_ch + t_cl
                  tmp2l = t_cl - (t_s1 - t_ch)
                  tmp2h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp2 = sm(i_0-1,m_0) * v1
!<<<              tmp3 = sm(i_0-2,m_0) * v2
                  t_ch = smh(i_0-2,m_0) * v2h
                  t_u1 = 134217729.0 * smh(i_0-2,m_0)
                  t_p1 = t_u1
     +                     - (t_u1 - smh(i_0-2,m_0))
                  t_p2 = smh(i_0-2,m_0) - t_p1
                  t_u1 = 134217729.0 * v2h
                  t_r1 = t_u1
     +                     - (t_u1 - v2h)
                  t_r2 = v2h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (smh(i_0-2,m_0)*v2l
     +                     +  sml(i_0-2,m_0)*v2h)
                  t_s1 = t_ch + t_cl
                  tmp3l = t_cl - (t_s1 - t_ch)
                  tmp3h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp3 = sm(i_0-2,m_0) * v2
!<<<              u0 = tmp1 + tmp2
                  t_p1 = tmp1h + tmp2h
                  t_p2 = t_p1 - tmp1h
                  t_q1 = t_p1
                  t_q2 = (tmp1h - (t_p1 - t_p2))
     +                     + (tmp2h - t_p2)
                  t_q2 = t_q2 + tmp1l + tmp2l
                  u0h = t_q1 + t_q2
                  u0l = t_q2 - (u0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>              u0 = tmp1 + tmp2
!<<<              u0 = u0 + tmp3
                  t_p1 = u0h + tmp3h
                  t_p2 = t_p1 - u0h
                  t_q1 = t_p1
                  t_q2 = (u0h - (t_p1 - t_p2))
     +                     + (tmp3h - t_p2)
                  t_q2 = t_q2 + u0l + tmp3l
                  u0h = t_q1 + t_q2
                  u0l = t_q2 - (u0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>              u0 = u0 + tmp3
!<<<              tmp1 = sm(i_0-0,m_0-1) * v0
                  t_ch = smh(i_0-0,m_0-1) * v0h
                  t_u1 = 134217729.0 * smh(i_0-0,m_0-1)
                  t_p1 = t_u1
     +                     - (t_u1 - smh(i_0-0,m_0-1))
                  t_p2 = smh(i_0-0,m_0-1) - t_p1
                  t_u1 = 134217729.0 * v0h
                  t_r1 = t_u1
     +                     - (t_u1 - v0h)
                  t_r2 = v0h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (smh(i_0-0,m_0-1)*v0l
     +                     +  sml(i_0-0,m_0-1)*v0h)
                  t_s1 = t_ch + t_cl
                  tmp1l = t_cl - (t_s1 - t_ch)
                  tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp1 = sm(i_0-0,m_0-1) * v0
!<<<              tmp2 = sm(i_0-1,m_0-1) * v1
                  t_ch = smh(i_0-1,m_0-1) * v1h
                  t_u1 = 134217729.0 * smh(i_0-1,m_0-1)
                  t_p1 = t_u1
     +                     - (t_u1 - smh(i_0-1,m_0-1))
                  t_p2 = smh(i_0-1,m_0-1) - t_p1
                  t_u1 = 134217729.0 * v1h
                  t_r1 = t_u1
     +                     - (t_u1 - v1h)
                  t_r2 = v1h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (smh(i_0-1,m_0-1)*v1l
     +                     +  sml(i_0-1,m_0-1)*v1h)
                  t_s1 = t_ch + t_cl
                  tmp2l = t_cl - (t_s1 - t_ch)
                  tmp2h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp2 = sm(i_0-1,m_0-1) * v1
!<<<              tmp3 = sm(i_0-2,m_0-1) * v2
                  t_ch = smh(i_0-2,m_0-1) * v2h
                  t_u1 = 134217729.0 * smh(i_0-2,m_0-1)
                  t_p1 = t_u1
     +                     - (t_u1 - smh(i_0-2,m_0-1))
                  t_p2 = smh(i_0-2,m_0-1) - t_p1
                  t_u1 = 134217729.0 * v2h
                  t_r1 = t_u1
     +                     - (t_u1 - v2h)
                  t_r2 = v2h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (smh(i_0-2,m_0-1)*v2l
     +                     +  sml(i_0-2,m_0-1)*v2h)
                  t_s1 = t_ch + t_cl
                  tmp3l = t_cl - (t_s1 - t_ch)
                  tmp3h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp3 = sm(i_0-2,m_0-1) * v2
!<<<              u1 = tmp1 + tmp2
                  t_p1 = tmp1h + tmp2h
                  t_p2 = t_p1 - tmp1h
                  t_q1 = t_p1
                  t_q2 = (tmp1h - (t_p1 - t_p2))
     +                     + (tmp2h - t_p2)
                  t_q2 = t_q2 + tmp1l + tmp2l
                  u1h = t_q1 + t_q2
                  u1l = t_q2 - (u1h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>              u1 = tmp1 + tmp2
!<<<              u1 = u1 + tmp3
                  t_p1 = u1h + tmp3h
                  t_p2 = t_p1 - u1h
                  t_q1 = t_p1
                  t_q2 = (u1h - (t_p1 - t_p2))
     +                     + (tmp3h - t_p2)
                  t_q2 = t_q2 + u1l + tmp3l
                  u1h = t_q1 + t_q2
                  u1l = t_q2 - (u1h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>              u1 = u1 + tmp3
!                  v(j_1,m_0  ) = v(j_1,m_0  ) + u0
!                  v(j_1,m_0-1) = v(j_1,m_0-1) + u1
!<<<              v(j_1,m_0) = v(j_1,m_0) + u0
                  t_p1 = vh(j_1,m_0) + u0h
                  t_p2 = t_p1 - vh(j_1,m_0)
                  t_q1 = t_p1
                  t_q2 = (vh(j_1,m_0) - (t_p1 - t_p2))
     +                     + (u0h - t_p2)
                  t_q2 = t_q2 + vl(j_1,m_0) + u0l
                  vh(j_1,m_0) = t_q1 + t_q2
                  vl(j_1,m_0) = t_q2 - (vh(j_1,m_0) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>              v(j_1,m_0) = v(j_1,m_0) + u0
!<<<              v(j_1,m_0-1) = v(j_1,m_0-1) + u1
                  t_p1 = vh(j_1,m_0-1) + u1h
                  t_p2 = t_p1 - vh(j_1,m_0-1)
                  t_q1 = t_p1
                  t_q2 = (vh(j_1,m_0-1) - (t_p1 - t_p2))
     +                     + (u1h - t_p2)
                  t_q2 = t_q2 + vl(j_1,m_0-1) + u1l
                  vh(j_1,m_0-1) = t_q1 + t_q2
                  vl(j_1,m_0-1) = t_q2 - (vh(j_1,m_0-1) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>              v(j_1,m_0-1) = v(j_1,m_0-1) + u1
               end do! j_1
            end do! i_0

            i_0=m_0
!dir$ ivdep
!dir$ vector aligned
            do j_1=j_0,j_8
!               v0 = v(j_1,i_0-0)
!               u1 =
!     &            + sm(i_0-0,m_0-1) * v0
!               v(j_1,m_0-1) = v(j_1,m_0-1) + u1
               v0h = vh(j_1,i_0-0)
               v0l = vl(j_1,i_0-0)
!<<<           u1 = sm(i_0-0,m_0-1) * v0
               t_ch = smh(i_0-0,m_0-1) * v0h
               t_u1 = 134217729.0 * smh(i_0-0,m_0-1)
               t_p1 = t_u1
     +                  - (t_u1 - smh(i_0-0,m_0-1))
               t_p2 = smh(i_0-0,m_0-1) - t_p1
               t_u1 = 134217729.0 * v0h
               t_r1 = t_u1
     +                  - (t_u1 - v0h)
               t_r2 = v0h - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (smh(i_0-0,m_0-1)*v0l
     +                  +  sml(i_0-0,m_0-1)*v0h)
               t_s1 = t_ch + t_cl
               u1l = t_cl - (t_s1 - t_ch)
               u1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           u1 = sm(i_0-0,m_0-1) * v0
!<<<           v(j_1,m_0-1) = v(j_1,m_0-1) + u1
               t_p1 = vh(j_1,m_0-1) + u1h
               t_p2 = t_p1 - vh(j_1,m_0-1)
               t_q1 = t_p1
               t_q2 = (vh(j_1,m_0-1) - (t_p1 - t_p2))
     +                  + (u1h - t_p2)
               t_q2 = t_q2 + vl(j_1,m_0-1) + u1l
               vh(j_1,m_0-1) = t_q1 + t_q2
               vl(j_1,m_0-1) = t_q2 - (vh(j_1,m_0-1) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           v(j_1,m_0-1) = v(j_1,m_0-1) + u1
            end do! j_1

         end do! m_0

      end do! j_0

!$omp barrier

      j_5 = j_3 - j_2 + 1

      i_5 = (i_3-i_2) / thread_size + 1
      i_4 = i_5 * thread_rank
      i_5 = min(i_5, i_3-(i_2+i_4)+1)

      if ( j_5 > 0 .and. i_5 > 0 ) then
!         call dgemm('n','n',
!     &               j_5, i_5, m,
!     &               1.0d+00, v (j_2    ,1      ), nm,
!     &                        ss(1      ,1  +i_4), m,
!     &               1.0d+00, z (j_2    ,i_2+i_4), nmz)
         call ddgemm('n','n',
     &               j_5, i_5, m,
     &               1.0d+00, 0.0d+00,
     &               vh (j_2    ,1      ), vl (j_2    ,1      ), nm,
     &               ssh(1      ,1  +i_4), ssl(1      ,1  +i_4), m,
     &               1.0d+00, 0.0d+00,
     &               zh (j_2    ,i_2+i_4), zl(j_2     ,i_2+i_4), nmz)
      end if

      return
      end subroutine ! ddeigen_pbk_step2
