!          SUBROUTINE EIGEN_PDLAED0(N, HBW, D, E, LDE, Q, IQ, JQ,
!!     $                 DESCQ, WORK, IWORK, LDQ, CQ, INFO)
!     $                 DESCQ, WORK, IWORK, CP, CQ, INFO)
          SUBROUTINE DDEIGEN_PDDLAED0(N, HBW, Dh, Dl, Eh, El, LDE,
     $                 Qh, Ql, IQ, JQ,
!     $                 DESCQ, WORK, IWORK, LDQ, CQ, INFO)
     $                 DESCQ, WORKh, WORKl, IWORK, CP, CQ, INFO)
*
        IMPLICIT NONE
        
*  -- ScaLAPACK auxiliary routine (version 1.7) --
*     University of Tennessee, Knoxville, Oak Ridge National Laboratory,
*     and University of California, Berkeley.
*     December 31, 1998
*
*     .. Scalar Arguments ..
!      INTEGER            INFO, IQ, JQ, N, LDQ, CQ, HBW, LDE
      INTEGER            INFO, IQ, JQ, N, CP, CQ, HBW, LDE
      INTEGER :: LDQ
*     ..
*     .. Array Arguments ..
      INTEGER            DESCQ( * ), IWORK( * )
!      DOUBLE PRECISION   D( * ), Q( * ), WORK( * )
!      DOUBLE PRECISION   E( LDE, HBW )
      double precision Dh(*), Dl(*)
      double precision Qh(*), Ql(*)
      double precision WORKh(*), WORKl(*)
      double precision Eh(LDE,HBW), El(LDE,HBW)
!     tmp vars
      double precision t_ch, t_cl
      double precision t_p1, t_p2
      double precision t_q1, t_q2
      double precision t_r1, t_r2
      double precision t_s1, t_s2
      double precision t_t1, t_t2
      double precision t_u1, t_u2
      double precision t_x1, t_x2
      double precision t_y1, t_y2
      double precision t_z1, t_z2
      double precision t_x, t_ax
      double precision t_t1h, t_t1l
      double precision t_t2h, t_t2l
#ifdef COMM_MPI
      include 'mpif.h'
      integer ireq(2),ierr
      integer DEST,TAG,COMM
      integer myrank
      integer status(MPI_STATUS_SIZE)
      double precision DBUFF(2*N)
#endif
*     ..
*
*  Purpose
*  =======
*
*  EIGEN_PDLAED0 computes all eigenvalues and corresponding eigenvectors
*  of a symmetric tridiagonal matrix using the divide and conquer method.
*
*
*  Arguments
*  =========
*
*  N       (global input) INTEGER
*          The order of the tridiagonal matrix T.  N >= 0.
*
*  D       (global input/output) DOUBLE PRECISION array, dimension (N)
*          On entry, the diagonal elements of the tridiagonal matrix.
*          On exit, if INFO = 0, the eigenvalues in descending order.
*
*  E1      (global input/output) DOUBLE PRECISION array, dimension (N-1)
*          On entry, the subdiagonal elements of the tridiagonal matrix.
*          On exit, E has been destroyed.

*              (added by Phuong) 
*  E2          (global input) DOUBLE PRECISION array, dimention (N-2)
*          On entry, the second subdiagonal of the matrix
*          On exit, E has been destroyed(?)


*
*  Q       (local output) DOUBLE PRECISION array,
*          global dimension (N, N),
*          local dimension ( LLD_Q, LOCc(JQ+N-1))
*          Q  contains the orthonormal eigenvectors of the symmetric
*          tridiagonal matrix.
*          On output, Q is distributed across the P processes in block
*          cyclic format.
*
*  IQ      (global input) INTEGER
*          Q's global row index, which points to the beginning of the
*          submatrix which is to be operated on.
*
*  JQ      (global input) INTEGER
*          Q's global column index, which points to the beginning of
*          the submatrix which is to be operated on.
*
*  DESCQ   (global and local input) INTEGER array of dimension DLEN_.
*          The array descriptor for the distributed matrix Z.
*
*
*  WORK    (local workspace ) DOUBLE PRECISION array, dimension (LWORK)
*          LWORK = 6*N + 2*NP*NQ, with
*          NP = NUMROC( N, MB_Q, MYROW, IQROW, NPROW )
*          NQ = NUMROC( N, NB_Q, MYCOL, IQCOL, NPCOL )
*          IQROW = INDXG2P( IQ, NB_Q, MYROW, RSRC_Q, NPROW )
*          IQCOL = INDXG2P( JQ, MB_Q, MYCOL, CSRC_Q, NPCOL )
*
*  IWORK   (local workspace/output) INTEGER array, dimension (LIWORK)
*          LIWORK = 2 + 7*N + 8*NPCOL
*
*  INFO    (global output) INTEGER
*          = 0:  successful exit
*          < 0:  If the i-th argument is an array and the j-entry had
*                an illegal value, then INFO = -(i*100+j), if the i-th
*                argument is a scalar and had an illegal value, then
*                INFO = -i.
*          > 0:  The algorithm failed to compute the INFO/(N+1) th
*                eigenvalue while working on the submatrix lying in
*                global rows and columns mod(INFO,N+1).
*
*  =====================================================================
*
*     .. Parameters ..
*   
      INTEGER            BLOCK_CYCLIC_2D, DLEN_, DTYPE_, CTXT_, M_, N_,
     $                   MB_, NB_, RSRC_, CSRC_, LLD_
      PARAMETER          ( BLOCK_CYCLIC_2D = 1, DLEN_ = 9, DTYPE_ = 1,
     $                   CTXT_ = 2, M_ = 3, N_ = 4, MB_ = 5, NB_ = 6,
     $                   RSRC_ = 7, CSRC_ = 8, LLD_ = 9  )
     $                     

*     ..
*     .. Local Scalars ..
      INTEGER            I, ID, IDCOL, IDROW, IID, IINFO, IIQ, IM1, IM2,
     $                   IPQ, IQCOL, IQROW, J, K, JJD, JJQ, MATSIZ,
     $                   MYCOL, MYROW, N1, NB, NBL, NBL1, NPCOL, NPROW,
     $                   SUBPBS, TSUBPBS
     $                   
#ifdef COMM_BLACS2
      integer l, MATSIZ2, N2
      double precision D(2*N)
      double precision W(2*N)
      double precision E(2*(N-1))
      double precision Q(2*N)
      double precision WORK(2*N)
#endif
!      DOUBLE PRECISION   RHO
      double precision RHOh, RHOl
*       .. Local Arrays ..

        INTEGER          DESCZ( 50 )

!       real(8) :: C(HBW,HBW), S(HBW), U(HBW,HBW), VVT(HBW, HBW),
!     $            VT(HBW,HBW), UUT(HBW,HBW), V(HBW*HBW, HBW)
      double precision Ch(HBW,HBW), Cl(HBW,HBW)
      double precision Sh(HBW), Sl(HBW)
      double precision Uh(HBW,HBW), Ul(HBW,HBW)
      double precision VVTh(HBW,HBW), VVTl(HBW,HBW)
      double precision VTh(HBW,HBW), VTl(HBW,HBW)
      double precision UUTh(HBW,HBW), UUTl(HBW,HBW)
      double precision Vh(HBW*HBW,HBW), Vl(HBW*HBW,HBW)
!       real(8), pointer :: W(:)
!       real(8), pointer :: MA(:), AX(:)
       real(8), pointer :: Wh(:), Wl(:)
       real(8), pointer :: MAh(:), MAl(:), AXh(:), AXl(:)
*     ..
*     .. External Subroutines ..
!      EXTERNAL           BLACS_GRIDINFO, DGEBR2D, DGEBS2D, DGERV2D,
!     $                   DGESD2D, DSTEQR, INFOG2L, EIGEN_PDLAED1,
!     $                   PXERBLA, EIGEN_PDLAEDZ
      EXTERNAL           BLACS_GRIDINFO, DDGEBR2D, DDGEBS2D, DDGERV2D,
     $                   DDGESD2D, DDSTEQR, INFOG2L, DDEIGEN_PDDLAED1,
     $                   PXERBLA, DDEIGEN_PDDLAEDZ, DDNRM2
#ifdef COMM_MPI
      EXTERNAL           MakeMpiInfo
#endif
*     ..
*     .. External Functions ..
*     ..
!      DOUBLE PRECISION               DNRM2
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MIN, MAX

      real(8) :: t1,t2
      integer :: MY_RANK
      double precision tmp1h, tmp1l
      double precision rho_1h, rho_1l
      double precision oneh, onel

      oneh = 1.0d+0
      onel = 0.0d+0
*     ..
*     .. Executable Statements ..
*
#ifdef COMM_MPI
      Call mpi_comm_rank(MPI_COMM_WORLD,myrank,ierr)
#endif
*       This is just to keep ftnchek and toolpack/1 happy
      IF( BLOCK_CYCLIC_2D*CSRC_*CTXT_*DLEN_*DTYPE_*LLD_*MB_*M_*NB_*N_*
     $    RSRC_.LT.0 )RETURN


*
*     Test the input parameters.
*
      CALL BLACS_GRIDINFO( DESCQ( CTXT_ ), NPROW, NPCOL, MYROW, MYCOL )


      INFO = 0
      IF( DESCQ( NB_ ).GT.N .OR. N.LT.2 )
     $   INFO = -1
   
      IF( INFO.NE.0 ) THEN
         CALL PXERBLA( DESCQ( CTXT_ ), 'EIGEN_PDLAED0', -INFO )
         RETURN
      END IF


*
*
!      allocate( W(N) )
      allocate( Wh(N), Wl(N) )
      NB = DESCQ( NB_ )
      LDQ = DESCQ( LLD_ )
      CALL INFOG2L( IQ, JQ, DESCQ, NPROW, NPCOL, MYROW, MYCOL, IIQ, JJQ,
     $              IQROW, IQCOL )

*
*     Determine the size and placement of the submatrices, and save in
*     the leading elements of IWORK.
*

      TSUBPBS = ( N-1 ) / NB + 1
      IWORK( 1 ) = TSUBPBS
      SUBPBS = 1
   10 CONTINUE
      IF( IWORK( SUBPBS ).GT.1 ) THEN
         DO 20 J = SUBPBS, 1, -1
            IWORK( 2*J ) = ( IWORK( J )+1 ) / 2
            IWORK( 2*J-1 ) = IWORK( J ) / 2
   20    CONTINUE
         SUBPBS = 2*SUBPBS
         GO TO 10
      END IF
      DO 30 J = 2, SUBPBS
         IWORK( J ) = IWORK( J ) + IWORK( J-1 )
   30 CONTINUE

*
*     Divide the matrix into TSUBPBS submatrices of size at most NB
*     using rank-1 modifications (cuts).
*


      DO 40 I = NB + 1, N, NB
          IM1 = I - 1
          
!          C(1:HBW, 1:HBW) = 0
         Ch(1:HBW,1:HBW) = 0.0d+0
         Cl(1:HBW,1:HBW) = 0.0d+0

          DO J = 1, HBW
             DO K=1, J
!                C(HBW+K-J, K) = E(IM1-J+K, J)
            Ch(HBW+K-J,K) = Eh(IM1-J+K,J)
            Cl(HBW+K-J,K) = El(IM1-J+K,J)
             END DO      
          END DO


*         SVD : C = U*S*VT
!          CALL DGESVD('A', 'A', HBW, HBW, C, HBW, S, U, HBW,  
!     $                VT, HBW, WORK, 7*HBW, IINFO)        ! WORK size should be much larger than 7HBW
          CALL DDGESVD('A', 'A', HBW, HBW, Ch, Cl, HBW,
     $                 Sh, Sl, Uh, Ul, HBW,  
     $                 VTh, VTl, HBW, WORKh, WORKl, 7*HBW, IINFO) ! WORK size should be much larger than 7HBW


          
          DO  J = 1, HBW
             DO  K = 1, HBW
!                U(K, J)  = U(K, J)  * SQRT(S(J))
!                VT(K,J) =  VT(K,J)  * SQRT(S(K))
!<<<           tmp1 = sqrt(S(J))
               if (Sh(J).eq.0.0D+0.and.Sl(J).eq.0.0D+0) then
                 tmp1h = 0.0d+0
                 tmp1l = 0.0d+0
               else
               if (Sh(J).lt.0.0d+0.or.
     +            (Sh(J).eq.0.0d+0.and.Sl(J).lt.0.0d+0)) then
                 write(6,'(a)')
     +              'SQRT CALLED WITH NEGATIVE ARGUMENT'
                 tmp1h = 0.0d+0
                 tmp1l = 0.0d+0
                 return
               endif
               t_x = 1.0D+0/sqrt(Sh(J))
               t_ax = Sh(J) * t_x
!                  call dd_mul(t_y1,t_y2,t_x,
!                              0.0,0.5,0.0)
                   t_y1 = t_x * 0.5d+0
                   t_u1 = 134217729.0 * t_x
                   t_p1 = t_u1
     +                      - (t_u1 - t_x)
                   t_p2 = t_x - t_p1
                   t_u1 = 134217729.0 * 0.5d+0
                   t_r1 = t_u1
     +                      - (t_u1 - 0.5d+0)
                   t_r2 = 0.5d+0 - t_r1
                   t_y2 = ((t_p1*t_r1
     +                      - t_y1)
     +                      + t_p1*t_r2
     +                      + t_p2 * t_r1)
     +                      + t_p2 * t_r2
                   t_s1 = t_y1 + t_y2
                   t_y2 = t_y2
     +                      - (t_s1 - t_y1)
                   t_y1 = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!                  call dd_mul(t_z1,t_z2,t_ax,
!                              0.0,t_ax,0.0)
                   t_z1 = t_ax * t_ax
                   t_u1 = 134217729.0 * t_ax
                   t_p1 = t_u1
     +                      - (t_u1 - t_ax)
                   t_p2 = t_ax - t_p1
                   t_u1 = 134217729.0 * t_ax
                   t_r1 = t_u1
     +                      - (t_u1 - t_ax)
                   t_r2 = t_ax - t_r1
                   t_z2 = ((t_p1 * t_r1
     +                      - t_z1)
     +                      + t_p1 * t_r2
     +                      + t_p2 * t_r1)
     +                      + t_p2*t_r2
                   t_s1 = t_z1 + t_z2
                   t_z2 = t_z2
     +                      - (t_s1 - t_z1)
                   t_z1 = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!                  call dd_sub(t_t2h,t_t2l,
!                           Sh(J),Sl(J),t_z1,t_z2)
                   t_p1 = Sh(J) - t_z1
                   t_p2 = t_p1 - Sh(J)
                   t_t2l = (Sh(J)
     +                      -(t_p1 - t_p2))
     +                      -(t_z1 + t_p2)
                   t_t2h = t_p1
                   t_t2l = t_t2l
     +                      + Sl(J) - t_z2
                   t_s1 = t_t2h + t_t2l
                   t_t2l = t_t2l
     +                      - (t_s1 - t_t2h)
                   t_t2h = t_s1
#ifdef FPCOUNTER
#include "fsub.h"
#endif
!                  call dd_mul(t_t1h,t_t1l,
!                              t_t2h,t_t2l,
!                              t_y1,t_y2)
                   t_t1h = t_t2h * t_y1
                   t_u1 = 134217729.0 * t_t2h
                   t_p1 = t_u1
     +                      - (t_u1 - t_t2h)
                   t_p2 = t_t2h - t_p1
                   t_u1 = 134217729.0 * t_y1
                   t_r1 = t_u1
     +                      - (t_u1 - t_y1)
                   t_r2 = t_y1 - t_r1
                   t_t1l = ((t_p1*t_r1
     +                      - t_t1h)
     +                      + t_p1*t_r2
     +                      + t_p2*t_r1)
     +                      + t_p2*t_r2
                   t_t1l = t_t1l
     +                      + (t_t2h * t_y2
     +                      +  t_t2l * t_y1)
                   t_s1 = t_t1h + t_t1l
                   t_t1l = t_t1l - (t_s1
     +                       - t_t1h)
                   t_t1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!                  call dd_selfadd(t_t1h,t_t1l,
!                              t_ax,0.0)
                   t_p1 = t_t1h + t_ax
                   t_p2 = t_p1 - t_t1h
                   t_q2 = (t_t1h
     +                      - (t_p1 - t_p2))
     +                      + (t_ax - t_p2)
                   t_q1 = t_p1
                   t_q2 = t_q2 + t_t1l
                   t_t1h = t_q1 + t_q2
                   t_t1l = t_q2
     +                       - (t_t1h - t_q1)
                   tmp1h = t_t1h
                   tmp1l = t_t1l
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
               endif
!>>>           tmp1 = sqrt(S(J))
!<<<           U(K,J) = U(K,J) * tmp1
               t_ch = Uh(K,J) * tmp1h
               t_u1 = 134217729.0 * Uh(K,J)
               t_p1 = t_u1
     +                  - (t_u1 - Uh(K,J))
               t_p2 = Uh(K,J) - t_p1
               t_u1 = 134217729.0 * tmp1h
               t_r1 = t_u1
     +                  - (t_u1 - tmp1h)
               t_r2 = tmp1h - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (Uh(K,J)*tmp1l
     +                  +  Ul(K,J)*tmp1h)
               t_s1 = t_ch + t_cl
               Ul(K,J) = t_cl - (t_s1 - t_ch)
               Uh(K,J) = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           U(K,J) = U(K,J) * tmp1
!<<<           tmp1 = sqrt(S(K))
               if (Sh(K).eq.0.0D+0.and.Sl(K).eq.0.0D+0) then
                 tmp1h = 0.0d+0
                 tmp1l = 0.0d+0
               else
               if (Sh(K).lt.0.0d+0.or.
     +            (Sh(K).eq.0.0d+0.and.Sl(K).lt.0.0d+0)) then
                 write(6,'(a)')
     +              'SQRT CALLED WITH NEGATIVE ARGUMENT'
                 tmp1h = 0.0d+0
                 tmp1l = 0.0d+0
                 return
               endif
               t_x = 1.0D+0/sqrt(Sh(K))
               t_ax = Sh(K) * t_x
!                  call dd_mul(t_y1,t_y2,t_x,
!                              0.0,0.5,0.0)
                   t_y1 = t_x * 0.5d+0
                   t_u1 = 134217729.0 * t_x
                   t_p1 = t_u1
     +                      - (t_u1 - t_x)
                   t_p2 = t_x - t_p1
                   t_u1 = 134217729.0 * 0.5d+0
                   t_r1 = t_u1
     +                      - (t_u1 - 0.5d+0)
                   t_r2 = 0.5d+0 - t_r1
                   t_y2 = ((t_p1*t_r1
     +                      - t_y1)
     +                      + t_p1*t_r2
     +                      + t_p2 * t_r1)
     +                      + t_p2 * t_r2
                   t_s1 = t_y1 + t_y2
                   t_y2 = t_y2
     +                      - (t_s1 - t_y1)
                   t_y1 = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!                  call dd_mul(t_z1,t_z2,t_ax,
!                              0.0,t_ax,0.0)
                   t_z1 = t_ax * t_ax
                   t_u1 = 134217729.0 * t_ax
                   t_p1 = t_u1
     +                      - (t_u1 - t_ax)
                   t_p2 = t_ax - t_p1
                   t_u1 = 134217729.0 * t_ax
                   t_r1 = t_u1
     +                      - (t_u1 - t_ax)
                   t_r2 = t_ax - t_r1
                   t_z2 = ((t_p1 * t_r1
     +                      - t_z1)
     +                      + t_p1 * t_r2
     +                      + t_p2 * t_r1)
     +                      + t_p2*t_r2
                   t_s1 = t_z1 + t_z2
                   t_z2 = t_z2
     +                      - (t_s1 - t_z1)
                   t_z1 = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!                  call dd_sub(t_t2h,t_t2l,
!                           Sh(K),Sl(K),t_z1,t_z2)
                   t_p1 = Sh(K) - t_z1
                   t_p2 = t_p1 - Sh(K)
                   t_t2l = (Sh(K)
     +                      -(t_p1 - t_p2))
     +                      -(t_z1 + t_p2)
                   t_t2h = t_p1
                   t_t2l = t_t2l
     +                      + Sl(K) - t_z2
                   t_s1 = t_t2h + t_t2l
                   t_t2l = t_t2l
     +                      - (t_s1 - t_t2h)
                   t_t2h = t_s1
#ifdef FPCOUNTER
#include "fsub.h"
#endif
!                  call dd_mul(t_t1h,t_t1l,
!                              t_t2h,t_t2l,
!                              t_y1,t_y2)
                   t_t1h = t_t2h * t_y1
                   t_u1 = 134217729.0 * t_t2h
                   t_p1 = t_u1
     +                      - (t_u1 - t_t2h)
                   t_p2 = t_t2h - t_p1
                   t_u1 = 134217729.0 * t_y1
                   t_r1 = t_u1
     +                      - (t_u1 - t_y1)
                   t_r2 = t_y1 - t_r1
                   t_t1l = ((t_p1*t_r1
     +                      - t_t1h)
     +                      + t_p1*t_r2
     +                      + t_p2*t_r1)
     +                      + t_p2*t_r2
                   t_t1l = t_t1l
     +                      + (t_t2h * t_y2
     +                      +  t_t2l * t_y1)
                   t_s1 = t_t1h + t_t1l
                   t_t1l = t_t1l - (t_s1
     +                       - t_t1h)
                   t_t1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!                  call dd_selfadd(t_t1h,t_t1l,
!                              t_ax,0.0)
                   t_p1 = t_t1h + t_ax
                   t_p2 = t_p1 - t_t1h
                   t_q2 = (t_t1h
     +                      - (t_p1 - t_p2))
     +                      + (t_ax - t_p2)
                   t_q1 = t_p1
                   t_q2 = t_q2 + t_t1l
                   t_t1h = t_q1 + t_q2
                   t_t1l = t_q2
     +                       - (t_t1h - t_q1)
                   tmp1h = t_t1h
                   tmp1l = t_t1l
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
               endif
!>>>           tmp1 = sqrt(S(K))
!<<<           VT(K,J) = VT(K,J) * tmp1
               t_ch = VTh(K,J) * tmp1h
               t_u1 = 134217729.0 * VTh(K,J)
               t_p1 = t_u1
     +                  - (t_u1 - VTh(K,J))
               t_p2 = VTh(K,J) - t_p1
               t_u1 = 134217729.0 * tmp1h
               t_r1 = t_u1
     +                  - (t_u1 - tmp1h)
               t_r2 = tmp1h - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (VTh(K,J)*tmp1l
     +                  +  VTl(K,J)*tmp1h)
               t_s1 = t_ch + t_cl
               VTl(K,J) = t_cl - (t_s1 - t_ch)
               VTh(K,J) = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           VT(K,J) = VT(K,J) * tmp1
             END DO
          END DO


!          CALL DGEMM('N', 'T', HBW, HBW, HBW, 1.0D+0, U, HBW, U, 
!     $          HBW, 0.0D+0, UUT, HBW)
!
!          CALL DGEMM('T', 'N', HBW, HBW, HBW, 1.0D+0, VT, HBW, VT, 
!     $          HBW, 0.0D+0, VVT, HBW)
          CALL DDGEMM('N', 'T', HBW, HBW, HBW,
     $          1.0D+0, 0.0d0, Uh, Ul, HBW, Uh, Ul, 
     $          HBW, 0.0D+0, 0.0d0, UUTh, UUTl, HBW)

          CALL DDGEMM('T', 'N', HBW, HBW, HBW,
     $          1.0D+0, 0.0d0, VTh, VTl, HBW, VTh, VTl, 
     $          HBW, 0.0D+0, 0.0d0, VVTh, VVTl, HBW)
          
         
          DO J = 1, HBW
!            D(IM1-HBW+J) = D(IM1-HBW+J) - UUT(J, J)
!            D(IM1+J)       = D(IM1+J)       - VVT(J, J)
!<<<        D(IM1-HBW+J) = D(IM1-HBW+J) - UUT(J,J)
            t_p1 = Dh(IM1-HBW+J) - UUTh(J,J)
            t_p2 = t_p1 - Dh(IM1-HBW+J)
            t_ch = t_p1
            t_cl = (Dh(IM1-HBW+J) - (t_p1 - t_p2))
     +               - (UUTh(J,J) + t_p2)
            t_cl = t_cl + Dl(IM1-HBW+J) - UUTl(J,J)
            t_s1 = t_ch + t_cl
            Dl(IM1-HBW+J) = t_cl - (t_s1 - t_ch)
            Dh(IM1-HBW+J) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>        D(IM1-HBW+J) = D(IM1-HBW+J) - UUT(J,J)
!<<<        D(IM1+J) = D(IM1+J) - VVT(J,J)
            t_p1 = Dh(IM1+J) - VVTh(J,J)
            t_p2 = t_p1 - Dh(IM1+J)
            t_ch = t_p1
            t_cl = (Dh(IM1+J) - (t_p1 - t_p2))
     +               - (VVTh(J,J) + t_p2)
            t_cl = t_cl + Dl(IM1+J) - VVTl(J,J)
            t_s1 = t_ch + t_cl
            Dl(IM1+J) = t_cl - (t_s1 - t_ch)
            Dh(IM1+J) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>        D(IM1+J) = D(IM1+J) - VVT(J,J)
          END DO
         
          DO J = 1, HBW-1
             DO  K = HBW-J, 1, -1
!                E(IM1-K-J+1, J) = E(IM1-K-J+1, J) 
!     $                - UUT(HBW-K+1, 1-K+HBW-J) 
!                E(IM1+HBW-K-J+1,J) = E(IM1+HBW-K-J+1,J)
!     $                             - VVT(HBW-K+1,1-K+HBW-J) 
!<<<           E(IM1-K-J+1,J) = E(IM1-K-J+1,J) - UUT(HBW-K+1,1-K+HBW-J)
               t_p1 = Eh(IM1-K-J+1,J) - UUTh(HBW-K+1,1-K+HBW-J)
               t_p2 = t_p1 - Eh(IM1-K-J+1,J)
               t_ch = t_p1
               t_cl = (Eh(IM1-K-J+1,J) - (t_p1 - t_p2))
     +                  - (UUTh(HBW-K+1,1-K+HBW-J) + t_p2)
               t_cl = t_cl + El(IM1-K-J+1,J) - UUTl(HBW-K+1,1-K+HBW-J)
               t_s1 = t_ch + t_cl
               El(IM1-K-J+1,J) = t_cl - (t_s1 - t_ch)
               Eh(IM1-K-J+1,J) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           E(IM1-K-J+1,J) = E(IM1-K-J+1,J) - UUT(HBW-K+1,1-K+HBW-J)
!<<<           E(IM1+HBW-K-J+1,J) = E(IM1+HBW-K-J+1,J) - VVT(HBW-K+1,1-K+HBW-J)
               t_p1 = Eh(IM1+HBW-K-J+1,J) - VVTh(HBW-K+1,1-K+HBW-J)
               t_p2 = t_p1 - Eh(IM1+HBW-K-J+1,J)
               t_ch = t_p1
               t_cl = (Eh(IM1+HBW-K-J+1,J) - (t_p1 - t_p2))
     +                  - (VVTh(HBW-K+1,1-K+HBW-J) + t_p2)
               t_cl = t_cl + El(IM1+HBW-K-J+1,J)-VVTl(HBW-K+1,1-K+HBW-J)
               t_s1 = t_ch + t_cl
               El(IM1+HBW-K-J+1,J) = t_cl - (t_s1 - t_ch)
               Eh(IM1+HBW-K-J+1,J) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           E(IM1+HBW-K-J+1,J) = E(IM1+HBW-K-J+1,J) - VVT(HBW-K+1,1-K+HBW-J)
               IF (MYROW.EQ.0 .AND. MYCOL.EQ.0) THEN

               ENDIF
             END DO
          END DO    


   40 CONTINUE

*
*     Solve each submatrix eigenproblem at the bottom of the divide and
*     conquer tree. D is the same on each process.
*


      DO 50 ID = 1, N, NB
         CALL INFOG2L( IQ-1+ID, JQ-1+ID, DESCQ, NPROW, NPCOL, MYROW,
     $                 MYCOL, IID, JJD, IDROW, IDCOL )
         MATSIZ = MIN( NB, N-ID+1 )
         IF( MYROW.EQ.IDROW .AND. MYCOL.EQ.IDCOL ) THEN
            IPQ = IID + ( JJD-1 )*LDQ
!            CALL LAPACK_EIGEN2(N, MATSIZ, HBW, ID, D, 
!     $                            E, LDE, Q( IPQ ), LDQ)     
            CALL DDLAPACK_EIGEN2(N, MATSIZ, HBW, ID, Dh, Dl, 
     $                           Eh, El, LDE, Qh( IPQ ), Ql( IPQ ), LDQ)
            IF( INFO.NE.0 ) THEN
               CALL PXERBLA( DESCQ( CTXT_ ), 'DSTEQR', -INFO )
               RETURN
            END IF
            IF( MYROW.NE.IQROW .OR. MYCOL.NE.IQCOL ) THEN
!               CALL DGESD2D( DESCQ( CTXT_ ), MATSIZ, 1, D( ID ), MATSIZ,
!     $                       IQROW, IQCOL )
#if defined COMM_MPI
               CALL MakeMpiInfo('A',DESCQ( CTXT_ ),
     &                          IQROW, IQCOL,DEST,COMM,TAG )
               CALL MPI_Isend_dd(Dh(ID),Dl(ID),MATSIZ,
     &              MPI_DOUBLE_PRECISION,DEST,1,COMM,ireq,ierr)
               CALL MPI_Wait_dd(ireq,status,ierr)
#elif defined COMM_BLACS2
               J=ID
               DO l = 1, MATSIZ
                  D(l)        = Dh(J)
                  D(l+MATSIZ) = Dl(J)
                  J = l+ID
               END DO
               MATSIZ2 = MATSIZ*2
               CALL DGESD2D( DESCQ( CTXT_ ), MATSIZ2, 1, D,
     $              MATSIZ2, IQROW, IQCOL )
#else
               CALL DGESD2D( DESCQ( CTXT_ ), MATSIZ, 1, Dh( ID ),
     $                       MATSIZ, IQROW, IQCOL )
               CALL DGESD2D( DESCQ( CTXT_ ), MATSIZ, 1, Dl( ID ),
     $                       MATSIZ, IQROW, IQCOL )
#endif

            END IF
         ELSE IF( MYROW.EQ.IQROW .AND. MYCOL.EQ.IQCOL ) THEN
!            CALL DGERV2D( DESCQ( CTXT_ ), MATSIZ, 1, D( ID ), MATSIZ,
!     $                    IDROW, IDCOL )
#if defined COMM_MPI
            CALL MakeMpiInfo('A',DESCQ( CTXT_ ), 
     $           IDROW, IDCOL,DEST,COMM,TAG )
            DBUFF(1:MATSIZ)          = Dh(ID:ID+MATSIZ-1)
            DBUFF(1+MATSIZ:2*MATSIZ) = Dl(ID:ID+MATSIZ-1)
            CALL MPI_Irecv_dd(DBUFF,MATSIZ,
     $           MPI_DOUBLE_PRECISION,DEST,1,COMM,ireq,ierr)
            CALL MPI_WaitIrecv_dd(Dh(ID),Dl(ID),DBUFF,MATSIZ,
     $                            ireq,status,ierr)
#elif defined COMM_BLACS2
            MATSIZ2 = MATSIZ*2
            CALL DGERV2D( DESCQ( CTXT_ ), MATSIZ2, 1, D,
     $                    MATSIZ2, IDROW, IDCOL )
            J = ID
            DO l = 1, MATSIZ
               Dh(J) = D(l) 
               Dl(J) = D(l+MATSIZ)
               J = l+ID
            END DO
#else
            CALL DDGERV2D( DESCQ( CTXT_ ), MATSIZ, 1,
     $                     Dh( ID ), Dl( ID ), MATSIZ,
     $                     IDROW, IDCOL )
#endif
         END IF
   50 CONTINUE
*            
            
            
      IF( MYROW.EQ.IQROW .AND. MYCOL.EQ.IQCOL ) THEN
!         CALL DGEBS2D( DESCQ( CTXT_ ), 'A', ' ', N, 1, D, N )
#if defined COMM_MPI
         CALL MakeMpiInfo('S',DESCQ( CTXT_ ),
     &                    0, 0,DEST,COMM,TAG )
         CALL MPI_Bcast_dd(Dh,Dl,N,
     $        MPI_DOUBLE_PRECISION,DEST,COMM,ierr)
#elif defined COMM_BLACS2
         DO l = 1, N
            D(l)   = Dh(l) 
            D(l+N) = Dl(l)
         END DO
         N2 = N*2
         CALL DGEBS2D( DESCQ( CTXT_ ), 'A', ' ', N2, 1, D, N2 )
#else
         CALL DGEBS2D( DESCQ( CTXT_ ), 'A', ' ', N, 1, Dh, N )
         CALL DGEBS2D( DESCQ( CTXT_ ), 'A', ' ', N, 1, Dl, N )
#endif
      ELSE
!         CALL DGEBR2D( DESCQ( CTXT_ ), 'A', ' ', N, 1, D, N, IQROW,
!     $                 IQCOL )
#if defined COMM_MPI
         CALL MakeMpiInfo('B',DESCQ( CTXT_ ), 
     &                    IQROW, IQCOL,DEST,COMM,TAG )
         CALL MPI_Bcast_dd(Dh,Dl,N,
     $        MPI_DOUBLE_PRECISION,DEST,COMM,ierr)
#elif defined COMM_BLACS2
         N2 = N*2
         CALL DGEBR2D( DESCQ( CTXT_ ), 'A', ' ', N2, 1, D, N2, IQROW,
     $                 IQCOL )
         DO l = 1, N
            Dh(l) = D(l)
            Dl(l) = D(l+N)
         END DO
#else
         CALL DGEBR2D( DESCQ( CTXT_ ), 'A', ' ', N, 1, Dh, N, IQROW,
     $                  IQCOL )
         CALL DGEBR2D( DESCQ( CTXT_ ), 'A', ' ', N, 1, Dl, N, IQROW,
     $                  IQCOL )
#endif
      END IF

*
*     Successively merge eigensystems of adjacent submatrices
*     into eigensystem for the corresponding larger matrix.
*



*     while ( SUBPBS > 1 )
*
   60 CONTINUE
      IF( SUBPBS.GT.1 ) THEN       

         IM2 = SUBPBS - 2
         DO 80 I = 0, IM2, 2   
            IF( I.EQ.0 ) THEN
               NBL = IWORK( 2 )
               NBL1 = IWORK( 1 )
               IF( NBL1.EQ.0 )
     $            GO TO 70
               ID = 1
               MATSIZ = MIN( N, NBL*NB )
               N1 = NBL1*NB
            ELSE
               NBL = IWORK( I+2 ) - IWORK( I )
               NBL1 = NBL / 2
               IF( NBL1.EQ.0 )
     $            GO TO 70
               ID = IWORK( I )*NB + 1
               MATSIZ = MIN( NB*NBL, N-ID+1 )
               N1 = NBL1*NB
            END IF

        CALL DESCINIT( DESCZ, MATSIZ, 1, MATSIZ, 1, 0, 0, DESCQ(CTXT_), 
     $                        MATSIZ, IINFO)    

*
*     Merge lower order eigensystems (of size N1 and MATSIZ - N1)
*     into an eigensystem of size MATSIZ.
*
         IM1 =  ID+N1 - 1

!          C(1:HBW, 1:HBW) = 0
         Ch(1:HBW,1:HBW) = 0.0d+0
         Cl(1:HBW,1:HBW) = 0.0d+0

          DO J = 1, HBW
             DO K=1, J
!                C(HBW+K-J, K) = E(IM1-J+K, J)
               Ch(HBW+K-J,K) = Eh(IM1-J+K,J)
               Cl(HBW+K-J,K) = El(IM1-J+K,J)
             END DO
          END DO
!          CALL DGESVD('A', 'A', HBW, HBW, C, HBW, S, U, HBW, VT,  
!     $                HBW, WORK, 7*HBW, IINFO)
          CALL DDGESVD('A', 'A', HBW, HBW,
     $                 Ch, Cl, HBW, Sh, Sl, Uh, Ul, HBW, VTh, VTl,  
     $                 HBW, WORKh, WORKl, 7*HBW, IINFO)
          DO J = 1, HBW
             DO K = 1, HBW
!                U(K, J)  = U(K,J)  * SQRT(S(J))
!                VT(K,J) = VT(K,J) * SQRT(S(K))
!<<<           tmp1 = sqrt(S(J))
               if (Sh(J).eq.0.0D+0.and.Sl(J).eq.0.0D+0) then
                 tmp1h = 0.0d+0
                 tmp1l = 0.0d+0
               else
               if (Sh(J).lt.0.0d+0.or.
     +            (Sh(J).eq.0.0d+0.and.Sl(J).lt.0.0d+0)) then
                 write(6,'(a)')
     +              'SQRT CALLED WITH NEGATIVE ARGUMENT'
                 tmp1h = 0.0d+0
                 tmp1l = 0.0d+0
                 return
               endif
               t_x = 1.0D+0/sqrt(Sh(J))
               t_ax = Sh(J) * t_x
!                  call dd_mul(t_y1,t_y2,t_x,
!                              0.0,0.5,0.0)
                   t_y1 = t_x * 0.5d+0
                   t_u1 = 134217729.0 * t_x
                   t_p1 = t_u1
     +                      - (t_u1 - t_x)
                   t_p2 = t_x - t_p1
                   t_u1 = 134217729.0 * 0.5d+0
                   t_r1 = t_u1
     +                      - (t_u1 - 0.5d+0)
                   t_r2 = 0.5d+0 - t_r1
                   t_y2 = ((t_p1*t_r1
     +                      - t_y1)
     +                      + t_p1*t_r2
     +                      + t_p2 * t_r1)
     +                      + t_p2 * t_r2
                   t_s1 = t_y1 + t_y2
                   t_y2 = t_y2
     +                      - (t_s1 - t_y1)
                   t_y1 = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!                  call dd_mul(t_z1,t_z2,t_ax,
!                              0.0,t_ax,0.0)
                   t_z1 = t_ax * t_ax
                   t_u1 = 134217729.0 * t_ax
                   t_p1 = t_u1
     +                      - (t_u1 - t_ax)
                   t_p2 = t_ax - t_p1
                   t_u1 = 134217729.0 * t_ax
                   t_r1 = t_u1
     +                      - (t_u1 - t_ax)
                   t_r2 = t_ax - t_r1
                   t_z2 = ((t_p1 * t_r1
     +                      - t_z1)
     +                      + t_p1 * t_r2
     +                      + t_p2 * t_r1)
     +                      + t_p2*t_r2
                   t_s1 = t_z1 + t_z2
                   t_z2 = t_z2
     +                      - (t_s1 - t_z1)
                   t_z1 = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!                  call dd_sub(t_t2h,t_t2l,
!                           Sh(J),Sl(J),t_z1,t_z2)
                   t_p1 = Sh(J) - t_z1
                   t_p2 = t_p1 - Sh(J)
                   t_t2l = (Sh(J)
     +                      -(t_p1 - t_p2))
     +                      -(t_z1 + t_p2)
                   t_t2h = t_p1
                   t_t2l = t_t2l
     +                      + Sl(J) - t_z2
                   t_s1 = t_t2h + t_t2l
                   t_t2l = t_t2l
     +                      - (t_s1 - t_t2h)
                   t_t2h = t_s1
#ifdef FPCOUNTER
#include "fsub.h"
#endif
!                  call dd_mul(t_t1h,t_t1l,
!                              t_t2h,t_t2l,
!                              t_y1,t_y2)
                   t_t1h = t_t2h * t_y1
                   t_u1 = 134217729.0 * t_t2h
                   t_p1 = t_u1
     +                      - (t_u1 - t_t2h)
                   t_p2 = t_t2h - t_p1
                   t_u1 = 134217729.0 * t_y1
                   t_r1 = t_u1
     +                      - (t_u1 - t_y1)
                   t_r2 = t_y1 - t_r1
                   t_t1l = ((t_p1*t_r1
     +                      - t_t1h)
     +                      + t_p1*t_r2
     +                      + t_p2*t_r1)
     +                      + t_p2*t_r2
                   t_t1l = t_t1l
     +                      + (t_t2h * t_y2
     +                      +  t_t2l * t_y1)
                   t_s1 = t_t1h + t_t1l
                   t_t1l = t_t1l - (t_s1
     +                       - t_t1h)
                   t_t1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!                  call dd_selfadd(t_t1h,t_t1l,
!                              t_ax,0.0)
                   t_p1 = t_t1h + t_ax
                   t_p2 = t_p1 - t_t1h
                   t_q2 = (t_t1h
     +                      - (t_p1 - t_p2))
     +                      + (t_ax - t_p2)
                   t_q1 = t_p1
                   t_q2 = t_q2 + t_t1l
                   t_t1h = t_q1 + t_q2
                   t_t1l = t_q2
     +                       - (t_t1h - t_q1)
                   tmp1h = t_t1h
                   tmp1l = t_t1l
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
               endif
!>>>           tmp1 = sqrt(S(J))
!<<<           U(K,J) = U(K,J) * tmp1
               t_ch = Uh(K,J) * tmp1h
               t_u1 = 134217729.0 * Uh(K,J)
               t_p1 = t_u1
     +                  - (t_u1 - Uh(K,J))
               t_p2 = Uh(K,J) - t_p1
               t_u1 = 134217729.0 * tmp1h
               t_r1 = t_u1
     +                  - (t_u1 - tmp1h)
               t_r2 = tmp1h - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (Uh(K,J)*tmp1l
     +                  +  Ul(K,J)*tmp1h)
               t_s1 = t_ch + t_cl
               Ul(K,J) = t_cl - (t_s1 - t_ch)
               Uh(K,J) = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           U(K,J) = U(K,J) * tmp1
!<<<           tmp1 = sqrt(S(K))
               if (Sh(K).eq.0.0D+0.and.Sl(K).eq.0.0D+0) then
                 tmp1h = 0.0d+0
                 tmp1l = 0.0d+0
               else
               if (Sh(K).lt.0.0d+0.or.
     +            (Sh(K).eq.0.0d+0.and.Sl(K).lt.0.0d+0)) then
                 write(6,'(a)')
     +              'SQRT CALLED WITH NEGATIVE ARGUMENT'
                 tmp1h = 0.0d+0
                 tmp1l = 0.0d+0
                 return
               endif
               t_x = 1.0D+0/sqrt(Sh(K))
               t_ax = Sh(K) * t_x
!                  call dd_mul(t_y1,t_y2,t_x,
!                              0.0,0.5,0.0)
                   t_y1 = t_x * 0.5d+0
                   t_u1 = 134217729.0 * t_x
                   t_p1 = t_u1
     +                      - (t_u1 - t_x)
                   t_p2 = t_x - t_p1
                   t_u1 = 134217729.0 * 0.5d+0
                   t_r1 = t_u1
     +                      - (t_u1 - 0.5d+0)
                   t_r2 = 0.5d+0 - t_r1
                   t_y2 = ((t_p1*t_r1
     +                      - t_y1)
     +                      + t_p1*t_r2
     +                      + t_p2 * t_r1)
     +                      + t_p2 * t_r2
                   t_s1 = t_y1 + t_y2
                   t_y2 = t_y2
     +                      - (t_s1 - t_y1)
                   t_y1 = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!                  call dd_mul(t_z1,t_z2,t_ax,
!                              0.0,t_ax,0.0)
                   t_z1 = t_ax * t_ax
                   t_u1 = 134217729.0 * t_ax
                   t_p1 = t_u1
     +                      - (t_u1 - t_ax)
                   t_p2 = t_ax - t_p1
                   t_u1 = 134217729.0 * t_ax
                   t_r1 = t_u1
     +                      - (t_u1 - t_ax)
                   t_r2 = t_ax - t_r1
                   t_z2 = ((t_p1 * t_r1
     +                      - t_z1)
     +                      + t_p1 * t_r2
     +                      + t_p2 * t_r1)
     +                      + t_p2*t_r2
                   t_s1 = t_z1 + t_z2
                   t_z2 = t_z2
     +                      - (t_s1 - t_z1)
                   t_z1 = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!                  call dd_sub(t_t2h,t_t2l,
!                           Sh(K),Sl(K),t_z1,t_z2)
                   t_p1 = Sh(K) - t_z1
                   t_p2 = t_p1 - Sh(K)
                   t_t2l = (Sh(K)
     +                      -(t_p1 - t_p2))
     +                      -(t_z1 + t_p2)
                   t_t2h = t_p1
                   t_t2l = t_t2l
     +                      + Sl(K) - t_z2
                   t_s1 = t_t2h + t_t2l
                   t_t2l = t_t2l
     +                      - (t_s1 - t_t2h)
                   t_t2h = t_s1
#ifdef FPCOUNTER
#include "fsub.h"
#endif
!                  call dd_mul(t_t1h,t_t1l,
!                              t_t2h,t_t2l,
!                              t_y1,t_y2)
                   t_t1h = t_t2h * t_y1
                   t_u1 = 134217729.0 * t_t2h
                   t_p1 = t_u1
     +                      - (t_u1 - t_t2h)
                   t_p2 = t_t2h - t_p1
                   t_u1 = 134217729.0 * t_y1
                   t_r1 = t_u1
     +                      - (t_u1 - t_y1)
                   t_r2 = t_y1 - t_r1
                   t_t1l = ((t_p1*t_r1
     +                      - t_t1h)
     +                      + t_p1*t_r2
     +                      + t_p2*t_r1)
     +                      + t_p2*t_r2
                   t_t1l = t_t1l
     +                      + (t_t2h * t_y2
     +                      +  t_t2l * t_y1)
                   t_s1 = t_t1h + t_t1l
                   t_t1l = t_t1l - (t_s1
     +                       - t_t1h)
                   t_t1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!                  call dd_selfadd(t_t1h,t_t1l,
!                              t_ax,0.0)
                   t_p1 = t_t1h + t_ax
                   t_p2 = t_p1 - t_t1h
                   t_q2 = (t_t1h
     +                      - (t_p1 - t_p2))
     +                      + (t_ax - t_p2)
                   t_q1 = t_p1
                   t_q2 = t_q2 + t_t1l
                   t_t1h = t_q1 + t_q2
                   t_t1l = t_q2
     +                       - (t_t1h - t_q1)
                   tmp1h = t_t1h
                   tmp1l = t_t1l
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
               endif
!>>>           tmp1 = sqrt(S(K))
!<<<           VT(K,J) = VT(K,J) * tmp1
               t_ch = VTh(K,J) * tmp1h
               t_u1 = 134217729.0 * VTh(K,J)
               t_p1 = t_u1
     +                  - (t_u1 - VTh(K,J))
               t_p2 = VTh(K,J) - t_p1
               t_u1 = 134217729.0 * tmp1h
               t_r1 = t_u1
     +                  - (t_u1 - tmp1h)
               t_r2 = tmp1h - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (VTh(K,J)*tmp1l
     +                  +  VTl(K,J)*tmp1h)
               t_s1 = t_ch + t_cl
               VTl(K,J) = t_cl - (t_s1 - t_ch)
               VTh(K,J) = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           VT(K,J) = VT(K,J) * tmp1
             END DO
          END DO

        DO K=1, HBW
          DO J = 1, HBW
!            V(J,K) = U(J,K);   V(HBW+J, K) = VT(K,J);
            Vh(J,K) = Uh(J,K)
            Vl(J,K) = Ul(J,K)
            Vh(HBW+J,K) = VTh(K,J)
            Vl(HBW+J,K) = VTl(K,J)
          END DO
        ENDDO


        DO 61 K=1, HBW
           IF (K.EQ.1) THEN
!              CALL EIGEN_PDLAEDZ('H', HBW, MATSIZ, N1, ID, Q, IQ, JQ,
!     $                           LDQ, DESCQ, W, WORK (1 + N), V(1,K))
              CALL DDEIGEN_PDDLAEDZ(
     $               'H', HBW, MATSIZ, N1, ID, Qh, Ql, IQ, JQ,
     $               LDQ, DESCQ, Wh, Wl, WORKh(1+N), WORKl(1+N),
     $               Vh(1,K), Vl(1,K))
           ELSE
!              CALL EIGEN_PDLAEDZ('F', HBW, MATSIZ, N1, ID, Q, IQ, JQ,
!     $                           LDQ, DESCQ, W, WORK (1 + N), V(1,K)) 
              CALL DDEIGEN_PDDLAEDZ(
     $               'F', HBW, MATSIZ, N1, ID, Qh, Ql, IQ, JQ,
     $               LDQ, DESCQ, Wh, Wl, WORKh(1+N), WORKl(1+N),
     $               Vh(1,K), Vl(1,K))
           END IF


           IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
!              CALL DGEBS2D ( DESCQ( CTXT_ ), 'All', ' ', MATSIZ, 
!     $              1,W,MATSIZ)
#if defined COMM_MPI
              CALL MakeMpiInfo('S',DESCQ( CTXT_ ),
     &                         0, 0, DEST, COMM, TAG )
              CALL MPI_Bcast_dd(Wh,Wl,MATSIZ,
     $             MPI_DOUBLE_PRECISION,DEST,COMM,ierr)
#elif defined COMM_BLACS2
              DO l = 1, MATSIZ
                 W(l)        = Wh(l) 
                 W(l+MATSIZ) = Wl(l)
              END DO
              MATSIZ2 = MATSIZ*2
              CALL DGEBS2D( DESCQ( CTXT_ ), 'A', ' ',
     &                      MATSIZ2, 1, W, MATSIZ2 )
#else
              CALL DGEBS2D ( DESCQ( CTXT_ ), 'All', ' ', MATSIZ, 
     $              1,Wh,MATSIZ)
              CALL DGEBS2D ( DESCQ( CTXT_ ), 'All', ' ', MATSIZ, 
     $              1,Wl,MATSIZ)
#endif
           ELSE
!              CALL DGEBR2D ( DESCQ( CTXT_ ), 'All', ' ', MATSIZ, 
!     $                1, W, MATSIZ, 0, 0)
#if defined COMM_MPI
              CALL MakeMpiInfo('B',DESCQ( CTXT_ ), 
     &                         0, 0, DEST, COMM, TAG )
              CALL MPI_Bcast_dd(Wh,Wl,MATSIZ,
     $             MPI_DOUBLE_PRECISION,DEST,COMM,ierr)
#elif defined COMM_BLACS2
              MATSIZ2 = MATSIZ*2
              CALL DGEBR2D( DESCQ( CTXT_ ), 'A', ' ',
     &                      MATSIZ2, 1, W, MATSIZ2, 0, 0 )
              DO l = 1, MATSIZ
                 Wh(l) = W(l)
                 Wl(l) = W(l+MATSIZ)
              END DO
#else
              CALL DGEBR2D ( DESCQ( CTXT_ ), 'All', ' ', MATSIZ, 
     $                1, Wh, MATSIZ, 0, 0)
              CALL DGEBR2D ( DESCQ( CTXT_ ), 'All', ' ', MATSIZ, 
     $                1, Wl, MATSIZ, 0, 0)
#endif
           END IF
        
!           RHO = DNRM2(MATSIZ, W, 1)
           CALL DDNRM2(MATSIZ, Wh, Wl, 1, RHOh, RHOl)
!           IF(RHO .EQ. 0) GOTO 61
           IF(
!               (RHO .eq. 0.0)
     +         ((RHOh .eq. 0.0d+0) .and.
     +          (RHOl .eq. 0.0d+0))
     $     ) THEN
              GOTO 61
           ENDIF
!           CALL DSCAL( MATSIZ, 1/RHO, W, 1)
!<<<       rho_1 = one / rho
           t_q1 = oneh / rhoh
           t_ch = rhoh * t_q1
           t_u1 = 134217729.0 * rhoh
           t_p1 = t_u1
     +              - (t_u1 - rhoh)
           t_p2 = rhoh - t_p1
           t_u1 = 134217729.0 * t_q1
           t_r1 = t_u1
     +              - (t_u1 - t_q1)
           t_r2 = t_q1 - t_r1
           t_cl = ((t_p1*t_r1
     +              - t_ch)
     +              + t_p1*t_r2
     +              + t_p2*t_r1)
     +              + t_p2*t_r2
           t_cl = t_cl
     +              + (rhol * t_q1)
           t_s1 = t_ch + t_cl
           t_cl = t_cl
     +              - (t_s1 - t_ch)
           t_ch = t_s1
           t_s1 = oneh - t_ch
           t_r1 = t_s1 - oneh
           t_s2 = (oneh
     +              - (t_s1 - t_r1))
     +              - (t_ch + t_r1)
           t_s2 = t_s2 - t_cl
           t_s2 = t_s2 + onel
           t_q2 = (t_s1 + t_s2)
     +              / rhoh
           rho_1h = t_q1 + t_q2
           rho_1l = t_q2
     +           - (rho_1h - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>       rho_1 = one / rho
!           CALL DSCAL( MATSIZ, 1/RHO, W, 1)
           CALL DDSCAL( MATSIZ, rho_1h, rho_1l, Wh, Wl, 1)
!           RHO = RHO*RHO
!<<<       RHO = RHO * RHO
           t_ch = RHOh * RHOh
           t_u1 = 134217729.0 * RHOh
           t_p1 = t_u1
     +              - (t_u1 - RHOh)
           t_p2 = RHOh - t_p1
           t_u1 = 134217729.0 * RHOh
           t_r1 = t_u1
     +              - (t_u1 - RHOh)
           t_r2 = RHOh - t_r1
           t_cl = ((t_p1*t_r1
     +              - t_ch)
     +             + t_p1 * t_r2
     +             + t_p2 * t_r1)
     +             + t_p2 * t_r2
           t_cl = t_cl
     +              + (RHOh*RHOl
     +              +  RHOl*RHOh)
           t_s1 = t_ch + t_cl
           RHOl = t_cl - (t_s1 - t_ch)
           RHOh = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>       RHO = RHO * RHO
           IF (K.EQ.1) THEN
!              CALL EIGEN_PDLAED1( MATSIZ, N1, D( ID ), ID, Q, IQ, JQ,  
!     $        DESCQ, RHO, WORK, IWORK( SUBPBS+1 ), W, 1, IINFO )
              CALL DDEIGEN_PDDLAED1( MATSIZ, N1, Dh( ID ), Dl( ID ), ID,
     $        Qh, Ql, IQ, JQ,  
     $        DESCQ, RHOh, RHOl, WORKh, WORKl, IWORK( SUBPBS+1 ),
     $        Wh, Wl, 1, IINFO )
           ELSE
!              CALL EIGEN_PDLAED1( MATSIZ, N1, D( ID ), ID, Q, IQ, JQ,  
!     $        DESCQ, RHO, WORK, IWORK( SUBPBS+1 ), W, 2, IINFO )
              CALL DDEIGEN_PDDLAED1( MATSIZ, N1, Dh( ID ), Dl( ID ), ID,
     $        Qh, Ql, IQ, JQ,  
     $        DESCQ, RHOh, RHOl, WORKh, WORKl, IWORK( SUBPBS+1 ),
     $        Wh, Wl, 2, IINFO )
           ENDIF
61      CONTINUE
    
           IF( IINFO.NE.0 ) THEN
               INFO = IINFO*( N+1 ) + ID
            END IF

   70       CONTINUE
            IWORK( I / 2+1 ) = IWORK( I+2 )
   80    CONTINUE
         SUBPBS = SUBPBS / 2

         GO TO 60

      END IF


*
*     end while
*
   90 CONTINUE

!      deallocate( w )
      deallocate( wh, wl )

      RETURN
*
*     End of EIGEN_PDLAED0
*
      END
