!      SUBROUTINE EIGEN_PDLAEDZ(COMPZ, HBW, N, N1, ID, Q, IQ, JQ, LDQ, 
!     $                       DESCQ, Z, WORK, V )
      SUBROUTINE DDEIGEN_PDDLAEDZ(
     $                       COMPZ, HBW, N, N1, ID, Qh, Ql, IQ, JQ, LDQ,
     $                       DESCQ, Zh, Zl, WORKh, WORKl, Vh, Vl )

       IMPLICIT NONE
*  -- ScaLAPACK auxiliary routine (version 1.7) --
*     University of Tennessee, Knoxville, Oak Ridge National Laboratory,
*     and University of California, Berkeley.
*     December 31, 1998
*
*     .. Scalar Arguments ..
      CHARACTER          COMPZ
      INTEGER            ID, IQ, JQ, LDQ, N, N1, HBW
*     ..
*     .. Array Arguments ..
      INTEGER            DESCQ( * )
!      DOUBLE PRECISION   Q( LDQ, * ), WORK( * ), Z( * ),
!     $                   V( * )
      double precision Qh(LDQ,*), Ql(LDQ,*)
      double precision WORKh(*), WORKl(*)
      double precision Zh(*), Zl(*)
      double precision Vh(*), Vl(*)
!     tmp vars
      double precision t_ch, t_cl
      double precision t_p1, t_p2
      double precision t_q1, t_q2
      double precision t_r1, t_r2
      double precision t_s1, t_s2
      double precision t_t1, t_t2
      double precision t_u1, t_u2
      double precision t_x1, t_x2
      double precision t_y1, t_y2
      double precision t_z1, t_z2
      double precision t_x, t_ax
      double precision t_t1h, t_t1l
      double precision t_t2h, t_t2l
#ifdef COMM_MPI
      include 'mpif.h'
      integer ireq(2),ierr
      integer DEST,TAG,COMM
      integer myrank
      integer status(MPI_STATUS_SIZE)
      double precision DBUFF(2*N)
#endif
*     ..
*
*  Purpose
*  =======
*
*  EIGEN_PDLAEDZ Form the z-vector which consists of the last row of Q_1
*  and the first row of Q_2.
*  =====================================================================
*
*     .. Parameters ..
*
      INTEGER            BLOCK_CYCLIC_2D, DLEN_, DTYPE_, CTXT_, M_, N_,
     $                   MB_, NB_, RSRC_, CSRC_, LLD_
      PARAMETER          ( BLOCK_CYCLIC_2D = 1, DLEN_ = 9, DTYPE_ = 1,
     $                   CTXT_ = 2, M_ = 3, N_ = 4, MB_ = 5, NB_ = 6,
     $                   RSRC_ = 7, CSRC_ = 8, LLD_ = 9 )
*     ..
*     .. Local Scalars ..
*
      INTEGER            COL, I, IBUF, ICTXT, IIQ, IIZ1, IIZ2, IQCOL,
     $                   IQROW, IZ, IZ1, IZ1COL, IZ1ROW, IZ2, IZ2COL,
     $                   IZ2ROW, J, JJQ, JJZ1, JJZ2, MYCOL, MYROW, N2,
     $                   NB, NBLOC, NPCOL, NPROW, NQ1, NQ2, ZSIZ, 
     $                    K
    
#ifdef COMM_BLACS2
      integer l, NBUF2
      double precision Z(2*N)
      double precision WORK(2*N)
#endif
     
*       .. Local Arrays
*        ..
!        DOUBLE PRECISION   TEMP( N )
      double precision TEMPh(N), TEMPl(N)
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MIN, MOD
*     ..
*     .. External Subroutines ..
!      EXTERNAL           BLACS_GRIDINFO, DCOPY, DGEBR2D, DGEBS2D,
!     $                   DGERV2D, DGESD2D, INFOG2L, DAXPY
      EXTERNAL           BLACS_GRIDINFO, DDCOPY, DDGEBR2D, DDGEBS2D,
     $                   DDGERV2D, DDGESD2D, INFOG2L, DDAXPY
*     ..
*     .. External Functions ..
      INTEGER            NUMROC
      EXTERNAL           NUMROC
#ifdef COMM_MPI
      EXTERNAL           MakeMpiInfo
#endif

*     ..
*     .. Executable Statements ..
*
!... MPI ...
#ifdef COMM_MPI
      Call mpi_comm_rank(MPI_COMM_WORLD,myrank,ierr)
#endif

*       This is just to keep ftnchek and toolpack/1 happy
       

      IF( BLOCK_CYCLIC_2D*CSRC_*CTXT_*DLEN_*DTYPE_*LLD_*MB_*M_*NB_*N_*
     $    RSRC_.LT.0 )RETURN
*
      ICTXT = DESCQ( CTXT_ )
      NB = DESCQ( NB_ )
      CALL BLACS_GRIDINFO( ICTXT, NPROW, NPCOL, MYROW, MYCOL )
      CALL INFOG2L( ID, ID, DESCQ, NPROW, NPCOL, MYROW, MYCOL, IIQ, JJQ,
     $              IQROW, IQCOL )
      N2 = N - N1

      
      IF (COMPZ == 'F') GOTO 50
*
*     Z = Q'*V,  Q = DirectSum(Q1, Q2)
*

*
*     Form z1 which consist of the last two rows of Q1
*
      DO K = 1, HBW
        CALL INFOG2L( IQ-1+(ID+N1-1-HBW+K), JQ-1+ID, DESCQ, NPROW, 
     $        NPCOL, MYROW, MYCOL, IIZ1, JJZ1, IZ1ROW, IZ1COL )
        NQ1 = NUMROC( N1, NB, MYCOL, IZ1COL, NPCOL )
        IF( ( MYROW.EQ.IZ1ROW ) .AND. ( NQ1.NE.0 ) ) THEN
!           CALL DCOPY( NQ1, Q( IIZ1, JJZ1 ), LDQ, WORK, 1 )
           CALL DDCOPY( NQ1, Qh( IIZ1, JJZ1 ), Ql( IIZ1, JJZ1 ), LDQ,
     $                  WORKh, WORKl, 1 )
           DO J = 1, NQ1
!               WORK(J) = V(K) * WORK(J)
!<<<           WORK(J) = V(K) * WORK(J)
               t_ch = Vh(K) * WORKh(J)
               t_u1 = 134217729.0 * Vh(K)
               t_p1 = t_u1
     +                  - (t_u1 - Vh(K))
               t_p2 = Vh(K) - t_p1
               t_u1 = 134217729.0 * WORKh(J)
               t_r1 = t_u1
     +                  - (t_u1 - WORKh(J))
               t_r2 = WORKh(J) - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (Vh(K)*WORKl(J)
     +                  +  Vl(K)*WORKh(J))
               t_s1 = t_ch + t_cl
               WORKl(J) = t_cl - (t_s1 - t_ch)
               WORKh(J) = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           WORK(J) = V(K) * WORK(J)
           END DO

           IF( MYROW.NE.IQROW .OR. MYCOL.NE.IQCOL ) THEN
!     $        CALL DGESD2D( ICTXT, NQ1, 1, WORK, NQ1, IQROW, IQCOL )
#if defined COMM_MPI
            CALL MakeMpiInfo('A',ICTXT,IQROW,IQCOL,DEST,COMM,TAG)
            CALL MPI_Isend_dd(WORKh,WORKl,NQ1,
     $           MPI_DOUBLE_PRECISION,DEST,1,COMM,ireq,ierr)
            CALL MPI_Wait_dd(ireq,status,ierr)
#elif defined COMM_BLACS2
            DO l = 1, NQ1
               WORK(l)     = WORKh(l)
               WORK(l+NQ1) = WORKl(l)
            END DO
            NBUF2 = NQ1*2
            CALL DGESD2D( ICTXT, NBUF2, 1, WORK, NBUF2, IQROW, IQCOL )
#else
              CALL DGESD2D(
     $               ICTXT, NQ1, 1, WORKh, NQ1, IQROW, IQCOL )
              CALL DGESD2D(
     $               ICTXT, NQ1, 1, WORKl, NQ1, IQROW, IQCOL )
#endif
           END IF
        END IF
*
*     Proc (IQROW, IQCOL) receive the parts of z1
*
        IF( MYROW.EQ.IQROW .AND. MYCOL.EQ.IQCOL ) THEN
           COL = IZ1COL
           DO 20 I = 0, NPCOL - 1
              NQ1 = NUMROC( N1, NB, COL, IZ1COL, NPCOL )
              IF( NQ1.GT.0 ) THEN
                 IF( IZ1ROW.NE.IQROW .OR. COL.NE.IQCOL ) THEN
                    IBUF = N1 + 1
!                    CALL DGERV2D( ICTXT, NQ1, 1, WORK( IBUF ), NQ1,
!     $                        IZ1ROW, COL )
#if defined COMM_MPI
                  CALL MakeMpiInfo('A',ICTXT,IZ1ROW,COL,DEST,COMM,TAG)
                  DBUFF(1:NQ1)       = WORKh(IBUF:IBUF+NQ1-1)
                  DBUFF(NQ1+1:2*NQ1) = WORKl(IBUF:IBUF+NQ1-1)
                  CALL MPI_Irecv_dd(DBUFF,NQ1,
     $                 MPI_DOUBLE_PRECISION,DEST,1,COMM,ireq,ierr)
                  CALL MPI_WaitIrecv_dd(WORKh(IBUF),WORKl(IBUF),
     $                 DBUFF,NQ1,ireq,status,ierr)
#elif defined COMM_BLACS2
                  NBUF2 = NQ1*2
!                  CALL DGERV2D( ICTXT, NBUF2, 1, WORK( IBUF ), NBUF2,
!     $                          IZ1ROW, COL )
!                  Do l = IBUF,IBUF+NQ1-1
!                     WORKh(l) = WORK(l)
!                     WORKl(l) = WORK(l+NQ1)
!                  END Do
                  CALL DGERV2D( ICTXT, NBUF2, 1, WORK, NBUF2,
     $                          IZ1ROW, COL )
                  Do l = 1,NQ1
                     WORKh(l+IBUF-1) = WORK(l)
                     WORKl(l+IBUF-1) = WORK(l+NQ1)
                  END Do
#else
                  CALL DGERV2D( ICTXT, NQ1, 1, WORKh( IBUF ), NQ1,
     $                      IZ1ROW, COL )
                  CALL DGERV2D( ICTXT, NQ1, 1, WORKl( IBUF ), NQ1,
     $                      IZ1ROW, COL )
#endif
                 ELSE
                    IBUF = 1
                 END IF
                 IZ1 = 0
                 IZ = I*NB + 1
                 NBLOC = ( NQ1-1 ) / NB + 1
                 DO 10 J = 1, NBLOC
                    ZSIZ = MIN( NB, NQ1-IZ1 )
!                    CALL DCOPY( ZSIZ, WORK( IBUF+IZ1 ), 1, 
!     $                          TEMP( IZ ), 1 )
                    CALL DDCOPY( ZSIZ,
     $                          WORKh( IBUF+IZ1 ), WORKl( IBUF+IZ1 ), 1,
     $                          TEMPh( IZ ), TEMPl( IZ ), 1 )
                    IZ1 = IZ1 + NB
                    IZ = IZ + NB*NPCOL
10               CONTINUE
              END IF
              COL = MOD( COL+1, NPCOL )
20         CONTINUE
*
*          ADD THE NEW RECEIVED VECTOR TO Z
*
           IF (K .EQ. 1) THEN
!                CALL DCOPY(N1, TEMP, 1, Z, 1)
                CALL DDCOPY(N1, TEMPh, TEMPl, 1, Zh, Zl, 1)
            ELSE
!                CALL DAXPY(N1, 1.0D+0, TEMP, 1, Z, 1)
                CALL DDAXPY(
     $               N1, 1.0D+0, 0.0D+0, TEMPh, TEMPl, 1, Zh, Zl, 1)
            ENDIF
        END IF
      END DO
*
*     Form z2 which consist of the first 2 rows of Q2
*

      DO K = 1, HBW
        CALL INFOG2L( IQ-1+( ID+N1 ) + K - 1, JQ-1+( ID+N1 ), DESCQ, 
     $    NPROW, NPCOL, MYROW, MYCOL, IIZ2, JJZ2, IZ2ROW, IZ2COL)
        NQ2 = NUMROC( N2, NB, MYCOL, IZ2COL, NPCOL )
        IF( ( MYROW.EQ.IZ2ROW ) .AND. ( NQ2.NE.0 ) ) THEN
!           CALL DCOPY( NQ2, Q( IIZ2, JJZ2 ), LDQ, WORK, 1 )
           CALL DDCOPY( NQ2, Qh( IIZ2, JJZ2 ), Ql( IIZ2, JJZ2), LDQ,
     $                  WORKh, WORKl, 1 )
           DO J = 1, NQ2
!               WORK(J) = V(K+HBW) * WORK(J)
!<<<           WORK(J) = V(K+HBW) * WORK(J)
               t_ch = Vh(K+HBW) * WORKh(J)
               t_u1 = 134217729.0 * Vh(K+HBW)
               t_p1 = t_u1
     +                  - (t_u1 - Vh(K+HBW))
               t_p2 = Vh(K+HBW) - t_p1
               t_u1 = 134217729.0 * WORKh(J)
               t_r1 = t_u1
     +                  - (t_u1 - WORKh(J))
               t_r2 = WORKh(J) - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (Vh(K+HBW)*WORKl(J)
     +                  +  Vl(K+HBW)*WORKh(J))
               t_s1 = t_ch + t_cl
               WORKl(J) = t_cl - (t_s1 - t_ch)
               WORKh(J) = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           WORK(J) = V(K+HBW) * WORK(J)
           END DO
           IF( MYROW.NE.IQROW .OR. MYCOL.NE.IQCOL ) THEN
!     $        CALL DGESD2D( ICTXT, NQ2, 1, WORK, NQ2, IQROW, IQCOL )
#if defined COMM_MPI
            CALL MakeMpiInfo('A',ICTXT,IQROW,IQCOL,DEST,COMM,TAG)
            CALL MPI_Isend_dd(WORKh,WORKl,NQ2,
     $           MPI_DOUBLE_PRECISION,DEST,1,COMM,ireq,ierr)
            CALL MPI_Wait_dd(ireq,status,ierr)
#elif defined COMM_BLACS2
            DO l = 1,NQ2
               WORK(l)     = WORKh(l)
               WORK(l+NQ2) = WORKl(l)
            END DO
            NBUF2 = NQ2*2
            CALL DGESD2D( ICTXT, NBUF2, 1, WORK, NBUF2, IQROW, IQCOL )
#else
            CALL DGESD2D( ICTXT, NQ2, 1, WORKh, NQ2, IQROW, IQCOL )
            CALL DGESD2D( ICTXT, NQ2, 1, WORKl, NQ2, IQROW, IQCOL )
#endif
           END IF
        END IF
*
*     Proc (IQROW, IQCOL) receive the parts of z2
*
        IF( MYROW.EQ.IQROW .AND. MYCOL.EQ.IQCOL ) THEN
           COL = IZ2COL
           DO 40 I = 0, NPCOL - 1
              NQ2 = NUMROC( N2, NB, COL, IZ2COL, NPCOL )
              IF( NQ2.GT.0 ) THEN
                 IF( IQROW.NE.IZ2ROW .OR. IQCOL.NE.COL ) THEN
                    IBUF = 1 + N2
!                    CALL DGERV2D( ICTXT, NQ2, 1, WORK( IBUF ), NQ2,
!     $                            IZ2ROW, COL )
#if defined COMM_MPI
                  CALL MakeMpiInfo('A',ICTXT,IZ2ROW,COL,DEST,COMM,TAG)
                  DBUFF(1:NQ2)       = WORKh(IBUF:IBUF+NQ2-1)
                  DBUFF(1+NQ2:2*NQ2) = WORKl(IBUF:IBUF+NQ2-1)
                  CALL MPI_Irecv_dd(DBUFF,NQ2,
     $                 MPI_DOUBLE_PRECISION,DEST,1,COMM,ireq,ierr)
                  CALL MPI_WaitIrecv_dd(WORKh(IBUF),WORKl(IBUF),
     $                 DBUFF,NQ2,ireq,status,ierr)
#elif defined COMM_BLACS2
                  NBUF2 = NQ2*2
                  CALL DGERV2D( ICTXT, NBUF2, 1, WORK, NBUF2,
     $                          IZ2ROW, COL )
                  DO l = 1, NQ2
                     J = l+IBUF-1
                     WORKh(J) = WORK(l)
                     WORKl(J) = WORK(l+NQ2)
                  END DO
#else
                    CALL DGERV2D( ICTXT, NQ2, 1, WORKh( IBUF ), NQ2,
     $                             IZ2ROW, COL )
                    CALL DGERV2D( ICTXT, NQ2, 1, WORKl( IBUF ), NQ2,
     $                             IZ2ROW, COL )
#endif
                 ELSE
                    IBUF = 1
                 END IF
                 IZ2 = 0
                 IZ = NB*I + N1 + 1
                 NBLOC = ( NQ2-1 ) / NB + 1
                 DO 30 J = 1, NBLOC
                    ZSIZ = MIN( NB, NQ2-IZ2 )
!                    CALL DCOPY( ZSIZ, WORK( IBUF+IZ2 ), 1, 
!     $                          TEMP( IZ ), 1 )
                    CALL DDCOPY( ZSIZ,
     $                          WORKh( IBUF+IZ2 ), WORKl( IBUF+IZ2 ), 1,
     $                          TEMPh( IZ ), TEMPl( IZ ), 1 )
                    IZ2 = IZ2 + NB
                    IZ = IZ + NB*NPCOL
   30            CONTINUE
              END IF
              COL = MOD( COL+1, NPCOL )
   40      CONTINUE
*
*          ADD THE NEW RECEIVED VECTOR TO Z
*
           IF (K .EQ. 1) THEN
!                CALL DAXPY(N2, 0.0D+0, Z(N1+1), 1, TEMP(N1+1), 1)
!                CALL DCOPY(N2, TEMP(N1+1), 1, Z(N1+1), 1)
                CALL DDAXPY(N2, 0.0D+0, 0.0D+0, Zh(N1+1), Zl(N1+1), 1,
     &                      TEMPh(N1+1), TEMPl(N1+1), 1)
                CALL DDCOPY(N2, TEMPh(N1+1), TEMPl(N1+1), 1,
     &                      Zh(N1+1), Zl(N1+1), 1)
            ELSE
!                CALL DAXPY(N2, 1.0D+0, TEMP(N1+1), 1, Z(N1+1), 1)
                CALL DDAXPY(N2, 1.0D+0, 0.0D+0,
     &                      TEMPh(N1+1), TEMPl(N1+1), 1,
     &                      Zh(N1+1), Zl(N1+1), 1)
            ENDIF

        END IF
      END DO

      GOTO 100

50    CONTINUE

*
*     Q'*V, Q is a dense matrix
*     Need to sum up the 4 rows: IQ-1+(ID+N1-2)  ... IQ-1+(ID+N1+1)
*     that usually not on the same node
*

      DO K = 1, HBW*HBW

          CALL INFOG2L(IQ-1+(ID+N1-1-HBW+K), JQ-1+ID, DESCQ, NPROW,
     $           NPCOL, MYROW, MYCOL, IIZ2, JJZ2, IZ2ROW, IZ2COL )

          NQ1 = NUMROC( N, NB, MYCOL, IZ2COL, NPCOL )

          IF( ( MYROW.EQ.IZ2ROW ) .AND. ( NQ1.NE.0 ) ) THEN
!             CALL DCOPY( NQ1, Q( IIZ2, JJZ2 ), LDQ, WORK, 1 )
             CALL DDCOPY( NQ1, Qh( IIZ2, JJZ2 ), Ql( IIZ2, JJZ2 ), LDQ,
     $                    WORKh, WORKl, 1 )
             DO J = 1, NQ1
!                 WORK (J) = V(K) * WORK (J)
!<<<           WORK(J) = V(K) * WORK(J)
               t_ch = Vh(K) * WORKh(J)
               t_u1 = 134217729.0 * Vh(K)
               t_p1 = t_u1
     +                  - (t_u1 - Vh(K))
               t_p2 = Vh(K) - t_p1
               t_u1 = 134217729.0 * WORKh(J)
               t_r1 = t_u1
     +                  - (t_u1 - WORKh(J))
               t_r2 = WORKh(J) - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (Vh(K)*WORKl(J)
     +                  +  Vl(K)*WORKh(J))
               t_s1 = t_ch + t_cl
               WORKl(J) = t_cl - (t_s1 - t_ch)
               WORKh(J) = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           WORK(J) = V(K) * WORK(J)
             END DO
        

             IF( MYROW.NE.IQROW .OR. MYCOL.NE.IQCOL ) THEN
!     $          CALL DGESD2D( ICTXT, NQ1, 1, WORK, NQ1, IQROW, IQCOL )
#if defined COMM_MPI
            CALL MakeMpiInfo('A',ICTXT,IQROW,IQCOL,DEST,COMM,TAG)
            CALL MPI_Isend_dd(WORKh,WORKl,NQ1,
     $           MPI_DOUBLE_PRECISION,DEST,1,COMM,ireq,ierr)
            CALL MPI_Wait_dd(ireq,status,ierr)
#elif defined COMM_BLACS2
            DO l = 1, NQ1
               WORK(l)     = WORKh(l)
               WORK(l+NQ1) = WORKl(l)
            END DO
            NBUF2 = NQ1*2
            CALL DGESD2D( ICTXT, NBUF2, 1, WORK, NBUF2, IQROW, IQCOL )
#else
                CALL DGESD2D( ICTXT, NQ1, 1,
     $                         WORKh, NQ1, IQROW, IQCOL )
                CALL DGESD2D( ICTXT, NQ1, 1,
     $                         WORKl, NQ1, IQROW, IQCOL )
#endif
             END IF
          END IF

*
*     Proc (IQROW, IQCOL) receive the parts of z1
*
          IF( MYROW.EQ.IQROW .AND. MYCOL.EQ.IQCOL ) THEN

             COL = IZ2COL
             DO 70 I = 0, NPCOL - 1
                NQ1 = NUMROC( N, NB, COL, IZ2COL, NPCOL )
                IF( NQ1.GT.0 ) THEN
                   IF( IZ2ROW.NE.IQROW .OR. COL.NE.IQCOL ) THEN
                      IBUF = N1 + 1
!                      CALL DGERV2D( ICTXT, NQ1, 1, WORK( IBUF ), NQ1,
!     $                          IZ2ROW, COL )
#if defined COMM_MPI
                  CALL MakeMpiInfo('A',ICTXT,IZ2ROW,COL,DEST,COMM,TAG)
                  DBUFF(1:NQ1)       = WORKh(IBUF:IBUF+NQ1-1)
                  DBUFF(1+NQ1:2*NQ1) = WORKl(IBUF:IBUF+NQ1-1)
                  CALL MPI_Irecv_dd(DBUFF,NQ1,
     $                 MPI_DOUBLE_PRECISION,DEST,1,COMM,ireq,ierr)
                  CALL MPI_WaitIrecv_dd(WORKh(IBUF),WORKl(IBUF),
     $                 DBUFF,NQ1,ireq,status,ierr)
#elif defined COMM_BLACS2
                  NBUF2 = NQ1*2
                  CALL DGERV2D( ICTXT, NBUF2, 1, WORK, NBUF2,
     $                          IZ2ROW, COL )
                  Do l = 1, NQ1
                     J = l+IBUF-1
                     WORKh(J) = WORK(l)
                     WORKl(J) = WORK(l+NQ1)
                  END DO
#else
                  CALL DGERV2D( ICTXT, NQ1, 1, WORKh( IBUF ), NQ1,
     $                      IZ2ROW, COL )
                  CALL DGERV2D( ICTXT, NQ1, 1, WORKl( IBUF ), NQ1,
     $                      IZ2ROW, COL )
#endif
                   ELSE
                      IBUF = 1
                   END IF
                   IZ1 = 0
                   IZ = I*NB + 1
                   NBLOC = ( NQ1-1 ) / NB + 1
                   DO 60 J = 1, NBLOC
                      ZSIZ = MIN( NB, NQ1-IZ1 )
!                      CALL DCOPY( ZSIZ, WORK( IBUF+IZ1 ), 1, 
!     $                            TEMP( IZ ), 1 )
                      CALL DDCOPY( ZSIZ,
     $                        WORKh( IBUF+IZ1 ), WORKl( IBUF+IZ1 ), 1, 
     $                        TEMPh( IZ ), TEMPl( IZ ), 1 )
                      IZ1 = IZ1 + NB
                      IZ = IZ + NB*NPCOL
   60              CONTINUE
                END IF
                COL = MOD( COL+1, NPCOL )
   70        CONTINUE


*
*             ADD THE NEW RECEIVED VECTOR TO Z
*

              IF (K .EQ. 1) THEN
!!                 CALL DAXPY(N, 0.0D+0, Z, 1, TEMP, 1)
!                  CALL DCOPY(N, TEMP, 1, Z, 1)
                  CALL DDCOPY(N, TEMPh, TEMPl, 1, Zh, Zl, 1)

              ELSE
!                  CALL DAXPY(N, 1.0D+0, TEMP, 1, Z, 1)
                  CALL DDAXPY(N, 1.0D+0, 0.0D+0, TEMPh, TEMPl, 1,
     $                        Zh, Zl, 1)
              ENDIF

          END IF

      END DO


100   CONTINUE
*
*     proc(IQROW,IQCOL) broadcast Z=(Z1,Z2)
*
      IF( MYROW.EQ.IQROW .AND. MYCOL.EQ.IQCOL ) THEN
!         CALL DGEBS2D( ICTXT, 'All', ' ', N, 1, Z, N )
#if defined COMM_MPI
         CALL MakeMpiInfo('S',ICTXT,0,0,DEST,COMM,TAG)
         CALL MPI_Bcast_dd(Zh,Zl,N,
     $        MPI_DOUBLE_PRECISION,DEST,COMM,ierr)
#elif defined COMM_BLACS2
         DO l = 1,N
            Z(l)   = Zh(l)
            Z(l+N) = Zl(l)
         END DO
         NBUF2 = N*2
         CALL DGEBS2D( ICTXT, 'All', ' ', NBUF2, 1, Z, NBUF2 )
#else
         CALL DGEBS2D( ICTXT, 'All', ' ', N, 1, Zh, N )
         CALL DGEBS2D( ICTXT, 'All', ' ', N, 1, Zl, N )
#endif
      ELSE
!         CALL DGEBR2D( ICTXT, 'All', ' ', N, 1, Z, N, IQROW, IQCOL )
#if defined COMM_MPI
         CALL MakeMpiInfo('B',ICTXT,IQROW,IQCOL,DEST,COMM,TAG)
         CALL MPI_Bcast_dd(Zh,Zl,N,
     $        MPI_DOUBLE_PRECISION,DEST,COMM,ierr)
#elif defined COMM_BLACS2
         NBUF2 = N*2
         CALL DGEBR2D( ICTXT, 'All', ' ', NBUF2, 1, Z, NBUF2,
     $                 IQROW, IQCOL )
         DO l = 1,N
            Zh(l) = Z(l)
            Zl(l) = Z(l+N)
         END DO
#else
         CALL DGEBR2D( ICTXT, 'All', ' ', N, 1, Zh, N, IQROW, IQCOL )
         CALL DGEBR2D( ICTXT, 'All', ' ', N, 1, Zl, N, IQROW, IQCOL )
#endif
      END IF


      RETURN
*

*     End of DDEIGEN_PDDLAEDZ
*
      END
