!      subroutine eigen_prd_2update_local(
!     &              w, nm,
!     &              ux, uy, vx, vy, nv,
!     &              i_base, i)
      subroutine ddeigen_prd_2update_local(
     &              wh, wl, nm,
     &              uxh, uxl, uyh, uyl, vxh, vxl, vyh, vyl, nv,
     &              i_base, i)
!----
!      use communication_sx, only : get_loop_start
!     &                           , get_loop_end
!     &                           , translate_l2g
      use ddcommunication_sx, only : get_loop_start
     &                             , get_loop_end
     &                             , translate_l2g
!----
      implicit none
!----
      integer, intent(in)    ::  nm, nv
!      real(8), intent(inout) ::  w(1:nm,*)
!      real(8), intent(in)    ::  ux(1:nv,*),uy(1:nv,*)
!      real(8), intent(in)    ::  vx(1:nv,*),vy(1:nv,*)
      real(8), intent(inout) ::  wh(1:nm,*), wl(1:nm,*)
      real(8), intent(in)    ::  uxh(1:nv,*),uyh(1:nv,*)
      real(8), intent(in)    ::  uxl(1:nv,*),uyl(1:nv,*)
      real(8), intent(in)    ::  vxh(1:nv,*),vyh(1:nv,*)
      real(8), intent(in)    ::  vxl(1:nv,*),vyl(1:nv,*)
      integer, intent(in)    ::  i_base, i
!----
      integer                ::  k_1
      integer                ::  j, l
!----
      integer                ::  i_1, i_2, i_3, i_4
      integer                ::  j_1, j_2, j_3
      integer                ::  l_1
      integer                ::  jj_1, jj_2, jj_3
      integer                ::  kk_1, kk_2, kk_3
      integer                ::  lx
!----
      include 'trd.h'
      include 'cstab.h'
!----
!      real(8)                :: u_x0, v_x0
!      real(8)                :: u_x1, v_x1
!      real(8)                :: uy0_0, vy0_0
!      real(8)                :: uy1_0, vy1_0
!      real(8)                :: uy0_1, vy0_1
!      real(8)                :: uy1_1, vy1_1
!      real(8)                :: uy0_2, vy0_2
!      real(8)                :: uy1_2, vy1_2
!      real(8)                :: uy0_3, vy0_3
!      real(8)                :: uy1_3, vy1_3
!      real(8)                :: uy0_4, vy0_4
!      real(8)                :: uy1_4, vy1_4
!      real(8)                :: uy0_5, vy0_5
!      real(8)                :: uy1_5, vy1_5
!      real(8)                :: w0
!      real(8)                :: w1
!      real(8)                :: w2
!      real(8)                :: w3
!      real(8)                :: w4
!      real(8)                :: w5
      real(8)                :: u_x0h, u_x0l, v_x0h, v_x0l 
      real(8)                :: u_x1h, u_x1l, v_x1h, v_x1l 
      real(8)                :: uy0_0h, uy0_0l, vy0_0h, vy0_0l 
      real(8)                :: uy1_0h, uy1_0l, vy1_0h, vy1_0l 
      real(8)                :: uy0_1h, uy0_1l, vy0_1h, vy0_1l 
      real(8)                :: uy1_1h, uy1_1l, vy1_1h, vy1_1l 
      real(8)                :: uy0_2h, uy0_2l, vy0_2h, vy0_2l 
      real(8)                :: uy1_2h, uy1_2l, vy1_2h, vy1_2l 
      real(8)                :: uy0_3h, uy0_3l, vy0_3h, vy0_3l 
      real(8)                :: uy1_3h, uy1_3l, vy1_3h, vy1_3l 
      real(8)                :: uy0_4h, uy0_4l, vy0_4h, vy0_4l 
      real(8)                :: uy1_4h, uy1_4l, vy1_4h, vy1_4l 
      real(8)                :: uy0_5h, uy0_5l, vy0_5h, vy0_5l 
      real(8)                :: uy1_5h, uy1_5l, vy1_5h, vy1_5l 
      real(8)                :: w0h, w0l 
      real(8)                :: w1h, w1l 
      real(8)                :: w2h, w2l 
      real(8)                :: w3h, w3l 
      real(8)                :: w4h, w4l 
      real(8)                :: w5h, w5l 

      double precision tmp1h, tmp1l
      double precision tmp2h, tmp2l
!     tmp vars
      double precision t_ch, t_cl
      double precision t_p1, t_p2
      double precision t_q1, t_q2
      double precision t_r1, t_r2
      double precision t_s1, t_s2
      double precision t_t1, t_t2
      double precision t_u1, t_u2
      double precision t_x1, t_x2
      double precision t_y1, t_y2
      double precision t_z1, t_z2
      double precision t_x, t_ax
      double precision t_t1h, t_t1l
      double precision t_t2h, t_t2l

      integer, parameter     :: vlen  = 336

      k_1 = i - i_base
      if ( k_1 <= 1 ) return
!----
      lx  = l1_lsize*l1_way/16

      i_2 = get_loop_start(i_base+1, size_of_row,my_row)
      i_3 = get_loop_end  (i-mband,  size_of_row,my_row)
      i_4 = mod(i_3-i_2+1,6)+i_2
      if ( i_2 > i_3 ) return
!----
      l = i - mband
      jj_2 = get_loop_start(1, size_of_col,my_col)
      jj_3 = get_loop_end  (l, size_of_col,my_col)

      do jj_1=jj_2,jj_3,lx
         j_2 = jj_1; j_3 = min(jj_1+lx-1,jj_3)
         do i_1=i_2,i_4-1                         ! 0
            j   = translate_l2g(i_1, size_of_row,my_row)
            l_1 = j-i_base
!            uy0_0 = uy(i_1+0,k_1-0)
!            vy0_0 = vy(i_1+0,k_1-0)
!            uy1_0 = uy(i_1+0,k_1-1)
!            vy1_0 = vy(i_1+0,k_1-1)
            uy0_0h = uyh(i_1+0,k_1-0)
            uy0_0l = uyl(i_1+0,k_1-0)
            vy0_0h = vyh(i_1+0,k_1-0)
            vy0_0l = vyl(i_1+0,k_1-0)
            uy1_0h = uyh(i_1+0,k_1-1)
            uy1_0l = uyl(i_1+0,k_1-1)
            vy1_0h = vyh(i_1+0,k_1-1)
            vy1_0l = vyl(i_1+0,k_1-1)



!dir$ ivdep
!dir$ vector always
            do j_1=j_2,j_3
!               u_x0 = ux(j_1,k_1-0)
!               v_x0 = vx(j_1,k_1-0)
!               u_x1 = ux(j_1,k_1-1)
!               v_x1 = vx(j_1,k_1-1)
               u_x0h = uxh(j_1,k_1-0)
               u_x0l = uxl(j_1,k_1-0)
               v_x0h = vxh(j_1,k_1-0)
               v_x0l = vxl(j_1,k_1-0)
               u_x1h = uxh(j_1,k_1-1)
               u_x1l = uxl(j_1,k_1-1)
               v_x1h = vxh(j_1,k_1-1)
               v_x1l = vxl(j_1,k_1-1)

!               w0 = w(j_1,l_1+0*size_of_row)
!               w0 = w0
!     &               - (u_x0 * vy0_0)
!     &               - (v_x0 * uy0_0)
!               w0 = w0
!     &               - (u_x1 * vy1_0)
!     &               - (v_x1 * uy1_0)
!               w(j_1,l_1+0*size_of_row) = w0
               w0h = wh(j_1,l_1+0*size_of_row)
               w0l = wl(j_1,l_1+0*size_of_row)
!<<<           tmp1 = u_x0 * vy0_0
               t_ch = u_x0h * vy0_0h
               t_u1 = 134217729.0 * u_x0h
               t_p1 = t_u1
     +                  - (t_u1 - u_x0h)
               t_p2 = u_x0h - t_p1
               t_u1 = 134217729.0 * vy0_0h
               t_r1 = t_u1
     +                  - (t_u1 - vy0_0h)
               t_r2 = vy0_0h - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (u_x0h*vy0_0l
     +                  +  u_x0l*vy0_0h)
               t_s1 = t_ch + t_cl
               tmp1l = t_cl - (t_s1 - t_ch)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp1 = u_x0 * vy0_0
!<<<           tmp2 = v_x0 * uy0_0
               t_ch = v_x0h * uy0_0h
               t_u1 = 134217729.0 * v_x0h
               t_p1 = t_u1
     +                  - (t_u1 - v_x0h)
               t_p2 = v_x0h - t_p1
               t_u1 = 134217729.0 * uy0_0h
               t_r1 = t_u1
     +                  - (t_u1 - uy0_0h)
               t_r2 = uy0_0h - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (v_x0h*uy0_0l
     +                  +  v_x0l*uy0_0h)
               t_s1 = t_ch + t_cl
               tmp2l = t_cl - (t_s1 - t_ch)
               tmp2h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp2 = v_x0 * uy0_0
!<<<           w0 = w0 - tmp1
               t_p1 = w0h - tmp1h
               t_p2 = t_p1 - w0h
               t_ch = t_p1
               t_cl = (w0h - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + w0l - tmp1l
               t_s1 = t_ch + t_cl
               w0l = t_cl - (t_s1 - t_ch)
               w0h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           w0 = w0 - tmp1
!<<<           w0 = w0 - tmp2
               t_p1 = w0h - tmp2h
               t_p2 = t_p1 - w0h
               t_ch = t_p1
               t_cl = (w0h - (t_p1 - t_p2))
     +                  - (tmp2h + t_p2)
               t_cl = t_cl + w0l - tmp2l
               t_s1 = t_ch + t_cl
               w0l = t_cl - (t_s1 - t_ch)
               w0h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           w0 = w0 - tmp2
!<<<           tmp1 = u_x1 * vy1_0
               t_ch = u_x1h * vy1_0h
               t_u1 = 134217729.0 * u_x1h
               t_p1 = t_u1
     +                  - (t_u1 - u_x1h)
               t_p2 = u_x1h - t_p1
               t_u1 = 134217729.0 * vy1_0h
               t_r1 = t_u1
     +                  - (t_u1 - vy1_0h)
               t_r2 = vy1_0h - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (u_x1h*vy1_0l
     +                  +  u_x1l*vy1_0h)
               t_s1 = t_ch + t_cl
               tmp1l = t_cl - (t_s1 - t_ch)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp1 = u_x1 * vy1_0
!<<<           tmp2 = v_x1 * uy1_0
               t_ch = v_x1h * uy1_0h
               t_u1 = 134217729.0 * v_x1h
               t_p1 = t_u1
     +                  - (t_u1 - v_x1h)
               t_p2 = v_x1h - t_p1
               t_u1 = 134217729.0 * uy1_0h
               t_r1 = t_u1
     +                  - (t_u1 - uy1_0h)
               t_r2 = uy1_0h - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (v_x1h*uy1_0l
     +                  +  v_x1l*uy1_0h)
               t_s1 = t_ch + t_cl
               tmp2l = t_cl - (t_s1 - t_ch)
               tmp2h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp2 = v_x1 * uy1_0
!<<<           w0 = w0 - tmp1
               t_p1 = w0h - tmp1h
               t_p2 = t_p1 - w0h
               t_ch = t_p1
               t_cl = (w0h - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + w0l - tmp1l
               t_s1 = t_ch + t_cl
               w0l = t_cl - (t_s1 - t_ch)
               w0h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           w0 = w0 - tmp1
!<<<           w0 = w0 - tmp2
               t_p1 = w0h - tmp2h
               t_p2 = t_p1 - w0h
               t_ch = t_p1
               t_cl = (w0h - (t_p1 - t_p2))
     +                  - (tmp2h + t_p2)
               t_cl = t_cl + w0l - tmp2l
               t_s1 = t_ch + t_cl
               w0l = t_cl - (t_s1 - t_ch)
               w0h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           w0 = w0 - tmp2
               wh(j_1,l_1+0*size_of_row) = w0h
               wl(j_1,l_1+0*size_of_row) = w0l

            end do! j_1


         end do! l_1
         do i_1=i_4,i_3,6                     ! 5
            j   = translate_l2g(i_1, size_of_row,my_row)
            l_1 = j-i_base
!            uy0_0 = uy(i_1+0,k_1-0)
!            vy0_0 = vy(i_1+0,k_1-0)
!            uy1_0 = uy(i_1+0,k_1-1)
!            vy1_0 = vy(i_1+0,k_1-1)
!            uy0_1 = uy(i_1+1,k_1-0)
!            vy0_1 = vy(i_1+1,k_1-0)
!            uy1_1 = uy(i_1+1,k_1-1)
!            vy1_1 = vy(i_1+1,k_1-1)
!            uy0_2 = uy(i_1+2,k_1-0)
!            vy0_2 = vy(i_1+2,k_1-0)
!            uy1_2 = uy(i_1+2,k_1-1)
!            vy1_2 = vy(i_1+2,k_1-1)
!            uy0_3 = uy(i_1+3,k_1-0)
!            vy0_3 = vy(i_1+3,k_1-0)
!            uy1_3 = uy(i_1+3,k_1-1)
!            vy1_3 = vy(i_1+3,k_1-1)
!            uy0_4 = uy(i_1+4,k_1-0)
!            vy0_4 = vy(i_1+4,k_1-0)
!            uy1_4 = uy(i_1+4,k_1-1)
!            vy1_4 = vy(i_1+4,k_1-1)
!            uy0_5 = uy(i_1+5,k_1-0)
!            vy0_5 = vy(i_1+5,k_1-0)
!            uy1_5 = uy(i_1+5,k_1-1)
!            vy1_5 = vy(i_1+5,k_1-1)
            uy0_0h = uyh(i_1+0,k_1-0)
            uy0_0l = uyl(i_1+0,k_1-0)
            vy0_0h = vyh(i_1+0,k_1-0)
            vy0_0l = vyl(i_1+0,k_1-0)
            uy1_0h = uyh(i_1+0,k_1-1)
            uy1_0l = uyl(i_1+0,k_1-1)
            vy1_0h = vyh(i_1+0,k_1-1)
            vy1_0l = vyl(i_1+0,k_1-1)
            uy0_1h = uyh(i_1+1,k_1-0)
            uy0_1l = uyl(i_1+1,k_1-0)
            vy0_1h = vyh(i_1+1,k_1-0)
            vy0_1l = vyl(i_1+1,k_1-0)
            uy1_1h = uyh(i_1+1,k_1-1)
            uy1_1l = uyl(i_1+1,k_1-1)
            vy1_1h = vyh(i_1+1,k_1-1)
            vy1_1l = vyl(i_1+1,k_1-1)
            uy0_2h = uyh(i_1+2,k_1-0)
            uy0_2l = uyl(i_1+2,k_1-0)
            vy0_2h = vyh(i_1+2,k_1-0)
            vy0_2l = vyl(i_1+2,k_1-0)
            uy1_2h = uyh(i_1+2,k_1-1)
            uy1_2l = uyl(i_1+2,k_1-1)
            vy1_2h = vyh(i_1+2,k_1-1)
            vy1_2l = vyl(i_1+2,k_1-1)
            uy0_3h = uyh(i_1+3,k_1-0)
            uy0_3l = uyl(i_1+3,k_1-0)
            vy0_3h = vyh(i_1+3,k_1-0)
            vy0_3l = vyl(i_1+3,k_1-0)
            uy1_3h = uyh(i_1+3,k_1-1)
            uy1_3l = uyl(i_1+3,k_1-1)
            vy1_3h = vyh(i_1+3,k_1-1)
            vy1_3l = vyl(i_1+3,k_1-1)
            uy0_4h = uyh(i_1+4,k_1-0)
            uy0_4l = uyl(i_1+4,k_1-0)
            vy0_4h = vyh(i_1+4,k_1-0)
            vy0_4l = vyl(i_1+4,k_1-0)
            uy1_4h = uyh(i_1+4,k_1-1)
            uy1_4l = uyl(i_1+4,k_1-1)
            vy1_4h = vyh(i_1+4,k_1-1)
            vy1_4l = vyl(i_1+4,k_1-1)
            uy0_5h = uyh(i_1+5,k_1-0)
            uy0_5l = uyl(i_1+5,k_1-0)
            vy0_5h = vyh(i_1+5,k_1-0)
            vy0_5l = vyl(i_1+5,k_1-0)
            uy1_5h = uyh(i_1+5,k_1-1)
            uy1_5l = uyl(i_1+5,k_1-1)
            vy1_5h = vyh(i_1+5,k_1-1)
            vy1_5l = vyl(i_1+5,k_1-1)


            do kk_1=j_2,j_3,vlen
               kk_2=kk_1; kk_3=min(kk_1+vlen-1,j_3)


!dir$ ivdep
!dir$ vector always
               do j_1=kk_2,kk_3
!                  u_x0 = ux(j_1,k_1-0)
!                  v_x0 = vx(j_1,k_1-0)
!                  u_x1 = ux(j_1,k_1-1)
!                  v_x1 = vx(j_1,k_1-1)
                  u_x0h = uxh(j_1,k_1-0)
                  u_x0l = uxl(j_1,k_1-0)
                  v_x0h = vxh(j_1,k_1-0)
                  v_x0l = vxl(j_1,k_1-0)
                  u_x1h = uxh(j_1,k_1-1)
                  u_x1l = uxl(j_1,k_1-1)
                  v_x1h = vxh(j_1,k_1-1)
                  v_x1l = vxl(j_1,k_1-1)

!                  w0 = w(j_1,l_1+0*size_of_row)
!                  w1 = w(j_1,l_1+1*size_of_row)
                  w0h = wh(j_1,l_1+0*size_of_row)
                  w0l = wl(j_1,l_1+0*size_of_row)
                  w1h = wh(j_1,l_1+1*size_of_row)
                  w1l = wl(j_1,l_1+1*size_of_row)
!                  w0 = w0
!     &               - (u_x0 * vy0_0)
!     &               - (v_x0 * uy0_0)
!                  w1 = w1
!     &               - (u_x0 * vy0_1)
!     &               - (v_x0 * uy0_1)
!                  w0 = w0
!     &               - (u_x1 * vy1_0)
!     &               - (v_x1 * uy1_0)
!                  w1 = w1
!     &               - (u_x1 * vy1_1)
!     &               - (v_x1 * uy1_1)
!<<<              tmp1 = u_x0 * vy0_0
                  t_ch = u_x0h * vy0_0h
                  t_u1 = 134217729.0 * u_x0h
                  t_p1 = t_u1
     +                     - (t_u1 - u_x0h)
                  t_p2 = u_x0h - t_p1
                  t_u1 = 134217729.0 * vy0_0h
                  t_r1 = t_u1
     +                     - (t_u1 - vy0_0h)
                  t_r2 = vy0_0h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (u_x0h*vy0_0l
     +                     +  u_x0l*vy0_0h)
                  t_s1 = t_ch + t_cl
                  tmp1l = t_cl - (t_s1 - t_ch)
                  tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp1 = u_x0 * vy0_0
!<<<              tmp2 = v_x0 * uy0_0
                  t_ch = v_x0h * uy0_0h
                  t_u1 = 134217729.0 * v_x0h
                  t_p1 = t_u1
     +                     - (t_u1 - v_x0h)
                  t_p2 = v_x0h - t_p1
                  t_u1 = 134217729.0 * uy0_0h
                  t_r1 = t_u1
     +                     - (t_u1 - uy0_0h)
                  t_r2 = uy0_0h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (v_x0h*uy0_0l
     +                     +  v_x0l*uy0_0h)
                  t_s1 = t_ch + t_cl
                  tmp2l = t_cl - (t_s1 - t_ch)
                  tmp2h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp2 = v_x0 * uy0_0
!<<<              w0 = w0 - tmp1
                  t_p1 = w0h - tmp1h
                  t_p2 = t_p1 - w0h
                  t_ch = t_p1
                  t_cl = (w0h - (t_p1 - t_p2))
     +                     - (tmp1h + t_p2)
                  t_cl = t_cl + w0l - tmp1l
                  t_s1 = t_ch + t_cl
                  w0l = t_cl - (t_s1 - t_ch)
                  w0h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>              w0 = w0 - tmp1
!<<<              w0 = w0 - tmp2
                  t_p1 = w0h - tmp2h
                  t_p2 = t_p1 - w0h
                  t_ch = t_p1
                  t_cl = (w0h - (t_p1 - t_p2))
     +                     - (tmp2h + t_p2)
                  t_cl = t_cl + w0l - tmp2l
                  t_s1 = t_ch + t_cl
                  w0l = t_cl - (t_s1 - t_ch)
                  w0h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>              w0 = w0 - tmp2
!<<<              tmp1 = u_x0 * vy0_1
                  t_ch = u_x0h * vy0_1h
                  t_u1 = 134217729.0 * u_x0h
                  t_p1 = t_u1
     +                     - (t_u1 - u_x0h)
                  t_p2 = u_x0h - t_p1
                  t_u1 = 134217729.0 * vy0_1h
                  t_r1 = t_u1
     +                     - (t_u1 - vy0_1h)
                  t_r2 = vy0_1h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (u_x0h*vy0_1l
     +                     +  u_x0l*vy0_1h)
                  t_s1 = t_ch + t_cl
                  tmp1l = t_cl - (t_s1 - t_ch)
                  tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp1 = u_x0 * vy0_1
!<<<              tmp2 = v_x0 * uy0_1
                  t_ch = v_x0h * uy0_1h
                  t_u1 = 134217729.0 * v_x0h
                  t_p1 = t_u1
     +                     - (t_u1 - v_x0h)
                  t_p2 = v_x0h - t_p1
                  t_u1 = 134217729.0 * uy0_1h
                  t_r1 = t_u1
     +                     - (t_u1 - uy0_1h)
                  t_r2 = uy0_1h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (v_x0h*uy0_1l
     +                     +  v_x0l*uy0_1h)
                  t_s1 = t_ch + t_cl
                  tmp2l = t_cl - (t_s1 - t_ch)
                  tmp2h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp2 = v_x0 * uy0_1
!<<<              w1 = w1 - tmp1
                  t_p1 = w1h - tmp1h
                  t_p2 = t_p1 - w1h
                  t_ch = t_p1
                  t_cl = (w1h - (t_p1 - t_p2))
     +                     - (tmp1h + t_p2)
                  t_cl = t_cl + w1l - tmp1l
                  t_s1 = t_ch + t_cl
                  w1l = t_cl - (t_s1 - t_ch)
                  w1h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>              w1 = w1 - tmp1
!<<<              w1 = w1 - tmp2
                  t_p1 = w1h - tmp2h
                  t_p2 = t_p1 - w1h
                  t_ch = t_p1
                  t_cl = (w1h - (t_p1 - t_p2))
     +                     - (tmp2h + t_p2)
                  t_cl = t_cl + w1l - tmp2l
                  t_s1 = t_ch + t_cl
                  w1l = t_cl - (t_s1 - t_ch)
                  w1h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>              w1 = w1 - tmp2
!<<<              tmp1 = u_x1 * vy1_0
                  t_ch = u_x1h * vy1_0h
                  t_u1 = 134217729.0 * u_x1h
                  t_p1 = t_u1
     +                     - (t_u1 - u_x1h)
                  t_p2 = u_x1h - t_p1
                  t_u1 = 134217729.0 * vy1_0h
                  t_r1 = t_u1
     +                     - (t_u1 - vy1_0h)
                  t_r2 = vy1_0h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (u_x1h*vy1_0l
     +                     +  u_x1l*vy1_0h)
                  t_s1 = t_ch + t_cl
                  tmp1l = t_cl - (t_s1 - t_ch)
                  tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp1 = u_x1 * vy1_0
!<<<              tmp2 = v_x1 * uy1_0
                  t_ch = v_x1h * uy1_0h
                  t_u1 = 134217729.0 * v_x1h
                  t_p1 = t_u1
     +                     - (t_u1 - v_x1h)
                  t_p2 = v_x1h - t_p1
                  t_u1 = 134217729.0 * uy1_0h
                  t_r1 = t_u1
     +                     - (t_u1 - uy1_0h)
                  t_r2 = uy1_0h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (v_x1h*uy1_0l
     +                     +  v_x1l*uy1_0h)
                  t_s1 = t_ch + t_cl
                  tmp2l = t_cl - (t_s1 - t_ch)
                  tmp2h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp2 = v_x1 * uy1_0
!<<<              w0 = w0 - tmp1
                  t_p1 = w0h - tmp1h
                  t_p2 = t_p1 - w0h
                  t_ch = t_p1
                  t_cl = (w0h - (t_p1 - t_p2))
     +                     - (tmp1h + t_p2)
                  t_cl = t_cl + w0l - tmp1l
                  t_s1 = t_ch + t_cl
                  w0l = t_cl - (t_s1 - t_ch)
                  w0h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>              w0 = w0 - tmp1
!<<<              w0 = w0 - tmp2
                  t_p1 = w0h - tmp2h
                  t_p2 = t_p1 - w0h
                  t_ch = t_p1
                  t_cl = (w0h - (t_p1 - t_p2))
     +                     - (tmp2h + t_p2)
                  t_cl = t_cl + w0l - tmp2l
                  t_s1 = t_ch + t_cl
                  w0l = t_cl - (t_s1 - t_ch)
                  w0h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>              w0 = w0 - tmp2
!<<<              tmp1 = u_x1 * vy1_1
                  t_ch = u_x1h * vy1_1h
                  t_u1 = 134217729.0 * u_x1h
                  t_p1 = t_u1
     +                     - (t_u1 - u_x1h)
                  t_p2 = u_x1h - t_p1
                  t_u1 = 134217729.0 * vy1_1h
                  t_r1 = t_u1
     +                     - (t_u1 - vy1_1h)
                  t_r2 = vy1_1h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (u_x1h*vy1_1l
     +                     +  u_x1l*vy1_1h)
                  t_s1 = t_ch + t_cl
                  tmp1l = t_cl - (t_s1 - t_ch)
                  tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp1 = u_x1 * vy1_1
!<<<              tmp2 = v_x1 * uy1_1
                  t_ch = v_x1h * uy1_1h
                  t_u1 = 134217729.0 * v_x1h
                  t_p1 = t_u1
     +                     - (t_u1 - v_x1h)
                  t_p2 = v_x1h - t_p1
                  t_u1 = 134217729.0 * uy1_1h
                  t_r1 = t_u1
     +                     - (t_u1 - uy1_1h)
                  t_r2 = uy1_1h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (v_x1h*uy1_1l
     +                     +  v_x1l*uy1_1h)
                  t_s1 = t_ch + t_cl
                  tmp2l = t_cl - (t_s1 - t_ch)
                  tmp2h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp2 = v_x1 * uy1_1
!<<<              w1 = w1 - tmp1
                  t_p1 = w1h - tmp1h
                  t_p2 = t_p1 - w1h
                  t_ch = t_p1
                  t_cl = (w1h - (t_p1 - t_p2))
     +                     - (tmp1h + t_p2)
                  t_cl = t_cl + w1l - tmp1l
                  t_s1 = t_ch + t_cl
                  w1l = t_cl - (t_s1 - t_ch)
                  w1h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>              w1 = w1 - tmp1
!<<<              w1 = w1 - tmp2
                  t_p1 = w1h - tmp2h
                  t_p2 = t_p1 - w1h
                  t_ch = t_p1
                  t_cl = (w1h - (t_p1 - t_p2))
     +                     - (tmp2h + t_p2)
                  t_cl = t_cl + w1l - tmp2l
                  t_s1 = t_ch + t_cl
                  w1l = t_cl - (t_s1 - t_ch)
                  w1h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>              w1 = w1 - tmp2
                  wh(j_1,l_1+0*size_of_row) = w0h
                  wl(j_1,l_1+0*size_of_row) = w0l
                  wh(j_1,l_1+1*size_of_row) = w1h
                  wl(j_1,l_1+1*size_of_row) = w1l
               end do! j_1

!dir$ ivdep
!dir$ vector always
               do j_1=kk_2,kk_3
!                  u_x0 = ux(j_1,k_1-0)
!                  v_x0 = vx(j_1,k_1-0)
!                  u_x1 = ux(j_1,k_1-1)
!                  v_x1 = vx(j_1,k_1-1)
                  u_x0h = uxh(j_1,k_1-0)
                  u_x0l = uxl(j_1,k_1-0)
                  v_x0h = vxh(j_1,k_1-0)
                  v_x0l = vxl(j_1,k_1-0)
                  u_x1h = uxh(j_1,k_1-1)
                  u_x1l = uxl(j_1,k_1-1)
                  v_x1h = vxh(j_1,k_1-1)
                  v_x1l = vxl(j_1,k_1-1)

!                  w2 = w(j_1,l_1+2*size_of_row)
!                  w3 = w(j_1,l_1+3*size_of_row)
                  w2h = wh(j_1,l_1+2*size_of_row)
                  w2l = wl(j_1,l_1+2*size_of_row)
                  w3h = wh(j_1,l_1+3*size_of_row)
                  w3l = wl(j_1,l_1+3*size_of_row)
!                  w2 = w2
!     &               - (u_x0 * vy0_2)
!     &               - (v_x0 * uy0_2)
!                  w3 = w3
!     &               - (u_x0 * vy0_3)
!     &               - (v_x0 * uy0_3)
!                  w2 = w2
!     &               - (u_x1 * vy1_2)
!     &               - (v_x1 * uy1_2)
!                  w3 = w3
!     &               - (u_x1 * vy1_3)
!     &               - (v_x1 * uy1_3)
!<<<              tmp1 = u_x0 * vy0_2
                  t_ch = u_x0h * vy0_2h
                  t_u1 = 134217729.0 * u_x0h
                  t_p1 = t_u1
     +                     - (t_u1 - u_x0h)
                  t_p2 = u_x0h - t_p1
                  t_u1 = 134217729.0 * vy0_2h
                  t_r1 = t_u1
     +                     - (t_u1 - vy0_2h)
                  t_r2 = vy0_2h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (u_x0h*vy0_2l
     +                     +  u_x0l*vy0_2h)
                  t_s1 = t_ch + t_cl
                  tmp1l = t_cl - (t_s1 - t_ch)
                  tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp1 = u_x0 * vy0_2
!<<<              tmp2 = v_x0 * uy0_2
                  t_ch = v_x0h * uy0_2h
                  t_u1 = 134217729.0 * v_x0h
                  t_p1 = t_u1
     +                     - (t_u1 - v_x0h)
                  t_p2 = v_x0h - t_p1
                  t_u1 = 134217729.0 * uy0_2h
                  t_r1 = t_u1
     +                     - (t_u1 - uy0_2h)
                  t_r2 = uy0_2h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (v_x0h*uy0_2l
     +                     +  v_x0l*uy0_2h)
                  t_s1 = t_ch + t_cl
                  tmp2l = t_cl - (t_s1 - t_ch)
                  tmp2h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp2 = v_x0 * uy0_2
!<<<              w2 = w2 - tmp1
                  t_p1 = w2h - tmp1h
                  t_p2 = t_p1 - w2h
                  t_ch = t_p1
                  t_cl = (w2h - (t_p1 - t_p2))
     +                     - (tmp1h + t_p2)
                  t_cl = t_cl + w2l - tmp1l
                  t_s1 = t_ch + t_cl
                  w2l = t_cl - (t_s1 - t_ch)
                  w2h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>              w2 = w2 - tmp1
!<<<              w2 = w2 - tmp2
                  t_p1 = w2h - tmp2h
                  t_p2 = t_p1 - w2h
                  t_ch = t_p1
                  t_cl = (w2h - (t_p1 - t_p2))
     +                     - (tmp2h + t_p2)
                  t_cl = t_cl + w2l - tmp2l
                  t_s1 = t_ch + t_cl
                  w2l = t_cl - (t_s1 - t_ch)
                  w2h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>              w2 = w2 - tmp2
!<<<              tmp1 = u_x0 * vy0_3
                  t_ch = u_x0h * vy0_3h
                  t_u1 = 134217729.0 * u_x0h
                  t_p1 = t_u1
     +                     - (t_u1 - u_x0h)
                  t_p2 = u_x0h - t_p1
                  t_u1 = 134217729.0 * vy0_3h
                  t_r1 = t_u1
     +                     - (t_u1 - vy0_3h)
                  t_r2 = vy0_3h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (u_x0h*vy0_3l
     +                     +  u_x0l*vy0_3h)
                  t_s1 = t_ch + t_cl
                  tmp1l = t_cl - (t_s1 - t_ch)
                  tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp1 = u_x0 * vy0_3
!<<<              tmp2 = v_x0 * uy0_3
                  t_ch = v_x0h * uy0_3h
                  t_u1 = 134217729.0 * v_x0h
                  t_p1 = t_u1
     +                     - (t_u1 - v_x0h)
                  t_p2 = v_x0h - t_p1
                  t_u1 = 134217729.0 * uy0_3h
                  t_r1 = t_u1
     +                     - (t_u1 - uy0_3h)
                  t_r2 = uy0_3h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (v_x0h*uy0_3l
     +                     +  v_x0l*uy0_3h)
                  t_s1 = t_ch + t_cl
                  tmp2l = t_cl - (t_s1 - t_ch)
                  tmp2h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp2 = v_x0 * uy0_3
!<<<              w3 = w3 - tmp1
                  t_p1 = w3h - tmp1h
                  t_p2 = t_p1 - w3h
                  t_ch = t_p1
                  t_cl = (w3h - (t_p1 - t_p2))
     +                     - (tmp1h + t_p2)
                  t_cl = t_cl + w3l - tmp1l
                  t_s1 = t_ch + t_cl
                  w3l = t_cl - (t_s1 - t_ch)
                  w3h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>              w3 = w3 - tmp1
!<<<              w3 = w3 - tmp2
                  t_p1 = w3h - tmp2h
                  t_p2 = t_p1 - w3h
                  t_ch = t_p1
                  t_cl = (w3h - (t_p1 - t_p2))
     +                     - (tmp2h + t_p2)
                  t_cl = t_cl + w3l - tmp2l
                  t_s1 = t_ch + t_cl
                  w3l = t_cl - (t_s1 - t_ch)
                  w3h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>              w3 = w3 - tmp2
!<<<              tmp1 = u_x1 * vy1_2
                  t_ch = u_x1h * vy1_2h
                  t_u1 = 134217729.0 * u_x1h
                  t_p1 = t_u1
     +                     - (t_u1 - u_x1h)
                  t_p2 = u_x1h - t_p1
                  t_u1 = 134217729.0 * vy1_2h
                  t_r1 = t_u1
     +                     - (t_u1 - vy1_2h)
                  t_r2 = vy1_2h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (u_x1h*vy1_2l
     +                     +  u_x1l*vy1_2h)
                  t_s1 = t_ch + t_cl
                  tmp1l = t_cl - (t_s1 - t_ch)
                  tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp1 = u_x1 * vy1_2
!<<<              tmp2 = v_x1 * uy1_2
                  t_ch = v_x1h * uy1_2h
                  t_u1 = 134217729.0 * v_x1h
                  t_p1 = t_u1
     +                     - (t_u1 - v_x1h)
                  t_p2 = v_x1h - t_p1
                  t_u1 = 134217729.0 * uy1_2h
                  t_r1 = t_u1
     +                     - (t_u1 - uy1_2h)
                  t_r2 = uy1_2h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (v_x1h*uy1_2l
     +                     +  v_x1l*uy1_2h)
                  t_s1 = t_ch + t_cl
                  tmp2l = t_cl - (t_s1 - t_ch)
                  tmp2h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp2 = v_x1 * uy1_2
!<<<              w2 = w2 - tmp1
                  t_p1 = w2h - tmp1h
                  t_p2 = t_p1 - w2h
                  t_ch = t_p1
                  t_cl = (w2h - (t_p1 - t_p2))
     +                     - (tmp1h + t_p2)
                  t_cl = t_cl + w2l - tmp1l
                  t_s1 = t_ch + t_cl
                  w2l = t_cl - (t_s1 - t_ch)
                  w2h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>              w2 = w2 - tmp1
!<<<              w2 = w2 - tmp2
                  t_p1 = w2h - tmp2h
                  t_p2 = t_p1 - w2h
                  t_ch = t_p1
                  t_cl = (w2h - (t_p1 - t_p2))
     +                     - (tmp2h + t_p2)
                  t_cl = t_cl + w2l - tmp2l
                  t_s1 = t_ch + t_cl
                  w2l = t_cl - (t_s1 - t_ch)
                  w2h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>              w2 = w2 - tmp2
!<<<              tmp1 = u_x1 * vy1_3
                  t_ch = u_x1h * vy1_3h
                  t_u1 = 134217729.0 * u_x1h
                  t_p1 = t_u1
     +                     - (t_u1 - u_x1h)
                  t_p2 = u_x1h - t_p1
                  t_u1 = 134217729.0 * vy1_3h
                  t_r1 = t_u1
     +                     - (t_u1 - vy1_3h)
                  t_r2 = vy1_3h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (u_x1h*vy1_3l
     +                     +  u_x1l*vy1_3h)
                  t_s1 = t_ch + t_cl
                  tmp1l = t_cl - (t_s1 - t_ch)
                  tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp1 = u_x1 * vy1_3
!<<<              tmp2 = v_x1 * uy1_3
                  t_ch = v_x1h * uy1_3h
                  t_u1 = 134217729.0 * v_x1h
                  t_p1 = t_u1
     +                     - (t_u1 - v_x1h)
                  t_p2 = v_x1h - t_p1
                  t_u1 = 134217729.0 * uy1_3h
                  t_r1 = t_u1
     +                     - (t_u1 - uy1_3h)
                  t_r2 = uy1_3h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (v_x1h*uy1_3l
     +                     +  v_x1l*uy1_3h)
                  t_s1 = t_ch + t_cl
                  tmp2l = t_cl - (t_s1 - t_ch)
                  tmp2h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp2 = v_x1 * uy1_3
!<<<              w3 = w3 - tmp1
                  t_p1 = w3h - tmp1h
                  t_p2 = t_p1 - w3h
                  t_ch = t_p1
                  t_cl = (w3h - (t_p1 - t_p2))
     +                     - (tmp1h + t_p2)
                  t_cl = t_cl + w3l - tmp1l
                  t_s1 = t_ch + t_cl
                  w3l = t_cl - (t_s1 - t_ch)
                  w3h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>              w3 = w3 - tmp1
!<<<              w3 = w3 - tmp2
                  t_p1 = w3h - tmp2h
                  t_p2 = t_p1 - w3h
                  t_ch = t_p1
                  t_cl = (w3h - (t_p1 - t_p2))
     +                     - (tmp2h + t_p2)
                  t_cl = t_cl + w3l - tmp2l
                  t_s1 = t_ch + t_cl
                  w3l = t_cl - (t_s1 - t_ch)
                  w3h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>              w3 = w3 - tmp2
!                  w(j_1,l_1+2*size_of_row) = w2
!                  w(j_1,l_1+3*size_of_row) = w3
                  wh(j_1,l_1+2*size_of_row) = w2h
                  wl(j_1,l_1+2*size_of_row) = w2l
                  wh(j_1,l_1+3*size_of_row) = w3h
                  wl(j_1,l_1+3*size_of_row) = w3l


!                  w4 = w(j_1,l_1+4*size_of_row)
!                  w5 = w(j_1,l_1+5*size_of_row)
                  w4h = wh(j_1,l_1+4*size_of_row)
                  w4l = wl(j_1,l_1+4*size_of_row)
                  w5h = wh(j_1,l_1+5*size_of_row)
                  w5l = wl(j_1,l_1+5*size_of_row)
!                  w4 = w4
!     &               - (u_x0 * vy0_4)
!     &               - (v_x0 * uy0_4)
!                  w5 = w5
!     &               - (u_x0 * vy0_5)
!     &               - (v_x0 * uy0_5)
!                  w4 = w4
!     &               - (u_x1 * vy1_4)
!     &               - (v_x1 * uy1_4)
!                  w5 = w5
!     &               - (u_x1 * vy1_5)
!     &               - (v_x1 * uy1_5)
!<<<              tmp1 = u_x0 * vy0_4
                  t_ch = u_x0h * vy0_4h
                  t_u1 = 134217729.0 * u_x0h
                  t_p1 = t_u1
     +                     - (t_u1 - u_x0h)
                  t_p2 = u_x0h - t_p1
                  t_u1 = 134217729.0 * vy0_4h
                  t_r1 = t_u1
     +                     - (t_u1 - vy0_4h)
                  t_r2 = vy0_4h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (u_x0h*vy0_4l
     +                     +  u_x0l*vy0_4h)
                  t_s1 = t_ch + t_cl
                  tmp1l = t_cl - (t_s1 - t_ch)
                  tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp1 = u_x0 * vy0_4
!<<<              tmp2 = v_x0 * uy0_4
                  t_ch = v_x0h * uy0_4h
                  t_u1 = 134217729.0 * v_x0h
                  t_p1 = t_u1
     +                     - (t_u1 - v_x0h)
                  t_p2 = v_x0h - t_p1
                  t_u1 = 134217729.0 * uy0_4h
                  t_r1 = t_u1
     +                     - (t_u1 - uy0_4h)
                  t_r2 = uy0_4h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (v_x0h*uy0_4l
     +                     +  v_x0l*uy0_4h)
                  t_s1 = t_ch + t_cl
                  tmp2l = t_cl - (t_s1 - t_ch)
                  tmp2h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp2 = v_x0 * uy0_4
!<<<              w4 = w4 - tmp1
                  t_p1 = w4h - tmp1h
                  t_p2 = t_p1 - w4h
                  t_ch = t_p1
                  t_cl = (w4h - (t_p1 - t_p2))
     +                     - (tmp1h + t_p2)
                  t_cl = t_cl + w4l - tmp1l
                  t_s1 = t_ch + t_cl
                  w4l = t_cl - (t_s1 - t_ch)
                  w4h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>              w4 = w4 - tmp1
!<<<              w4 = w4 - tmp2
                  t_p1 = w4h - tmp2h
                  t_p2 = t_p1 - w4h
                  t_ch = t_p1
                  t_cl = (w4h - (t_p1 - t_p2))
     +                     - (tmp2h + t_p2)
                  t_cl = t_cl + w4l - tmp2l
                  t_s1 = t_ch + t_cl
                  w4l = t_cl - (t_s1 - t_ch)
                  w4h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>              w4 = w4 - tmp2
!<<<              tmp1 = u_x0 * vy0_5
                  t_ch = u_x0h * vy0_5h
                  t_u1 = 134217729.0 * u_x0h
                  t_p1 = t_u1
     +                     - (t_u1 - u_x0h)
                  t_p2 = u_x0h - t_p1
                  t_u1 = 134217729.0 * vy0_5h
                  t_r1 = t_u1
     +                     - (t_u1 - vy0_5h)
                  t_r2 = vy0_5h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (u_x0h*vy0_5l
     +                     +  u_x0l*vy0_5h)
                  t_s1 = t_ch + t_cl
                  tmp1l = t_cl - (t_s1 - t_ch)
                  tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp1 = u_x0 * vy0_5
!<<<              tmp2 = v_x0 * uy0_5
                  t_ch = v_x0h * uy0_5h
                  t_u1 = 134217729.0 * v_x0h
                  t_p1 = t_u1
     +                     - (t_u1 - v_x0h)
                  t_p2 = v_x0h - t_p1
                  t_u1 = 134217729.0 * uy0_5h
                  t_r1 = t_u1
     +                     - (t_u1 - uy0_5h)
                  t_r2 = uy0_5h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (v_x0h*uy0_5l
     +                     +  v_x0l*uy0_5h)
                  t_s1 = t_ch + t_cl
                  tmp2l = t_cl - (t_s1 - t_ch)
                  tmp2h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp2 = v_x0 * uy0_5
!<<<              w5 = w5 - tmp1
                  t_p1 = w5h - tmp1h
                  t_p2 = t_p1 - w5h
                  t_ch = t_p1
                  t_cl = (w5h - (t_p1 - t_p2))
     +                     - (tmp1h + t_p2)
                  t_cl = t_cl + w5l - tmp1l
                  t_s1 = t_ch + t_cl
                  w5l = t_cl - (t_s1 - t_ch)
                  w5h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>              w5 = w5 - tmp1
!<<<              w5 = w5 - tmp2
                  t_p1 = w5h - tmp2h
                  t_p2 = t_p1 - w5h
                  t_ch = t_p1
                  t_cl = (w5h - (t_p1 - t_p2))
     +                     - (tmp2h + t_p2)
                  t_cl = t_cl + w5l - tmp2l
                  t_s1 = t_ch + t_cl
                  w5l = t_cl - (t_s1 - t_ch)
                  w5h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>              w5 = w5 - tmp2
!<<<              tmp1 = u_x1 * vy1_4
                  t_ch = u_x1h * vy1_4h
                  t_u1 = 134217729.0 * u_x1h
                  t_p1 = t_u1
     +                     - (t_u1 - u_x1h)
                  t_p2 = u_x1h - t_p1
                  t_u1 = 134217729.0 * vy1_4h
                  t_r1 = t_u1
     +                     - (t_u1 - vy1_4h)
                  t_r2 = vy1_4h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (u_x1h*vy1_4l
     +                     +  u_x1l*vy1_4h)
                  t_s1 = t_ch + t_cl
                  tmp1l = t_cl - (t_s1 - t_ch)
                  tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp1 = u_x1 * vy1_4
!<<<              tmp2 = v_x1 * uy1_4
                  t_ch = v_x1h * uy1_4h
                  t_u1 = 134217729.0 * v_x1h
                  t_p1 = t_u1
     +                     - (t_u1 - v_x1h)
                  t_p2 = v_x1h - t_p1
                  t_u1 = 134217729.0 * uy1_4h
                  t_r1 = t_u1
     +                     - (t_u1 - uy1_4h)
                  t_r2 = uy1_4h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (v_x1h*uy1_4l
     +                     +  v_x1l*uy1_4h)
                  t_s1 = t_ch + t_cl
                  tmp2l = t_cl - (t_s1 - t_ch)
                  tmp2h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp2 = v_x1 * uy1_4
!<<<              w4 = w4 - tmp1
                  t_p1 = w4h - tmp1h
                  t_p2 = t_p1 - w4h
                  t_ch = t_p1
                  t_cl = (w4h - (t_p1 - t_p2))
     +                     - (tmp1h + t_p2)
                  t_cl = t_cl + w4l - tmp1l
                  t_s1 = t_ch + t_cl
                  w4l = t_cl - (t_s1 - t_ch)
                  w4h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>              w4 = w4 - tmp1
!<<<              w4 = w4 - tmp2
                  t_p1 = w4h - tmp2h
                  t_p2 = t_p1 - w4h
                  t_ch = t_p1
                  t_cl = (w4h - (t_p1 - t_p2))
     +                     - (tmp2h + t_p2)
                  t_cl = t_cl + w4l - tmp2l
                  t_s1 = t_ch + t_cl
                  w4l = t_cl - (t_s1 - t_ch)
                  w4h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>              w4 = w4 - tmp2
!<<<              tmp1 = u_x1 * vy1_5
                  t_ch = u_x1h * vy1_5h
                  t_u1 = 134217729.0 * u_x1h
                  t_p1 = t_u1
     +                     - (t_u1 - u_x1h)
                  t_p2 = u_x1h - t_p1
                  t_u1 = 134217729.0 * vy1_5h
                  t_r1 = t_u1
     +                     - (t_u1 - vy1_5h)
                  t_r2 = vy1_5h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (u_x1h*vy1_5l
     +                     +  u_x1l*vy1_5h)
                  t_s1 = t_ch + t_cl
                  tmp1l = t_cl - (t_s1 - t_ch)
                  tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp1 = u_x1 * vy1_5
!<<<              tmp2 = v_x1 * uy1_5
                  t_ch = v_x1h * uy1_5h
                  t_u1 = 134217729.0 * v_x1h
                  t_p1 = t_u1
     +                     - (t_u1 - v_x1h)
                  t_p2 = v_x1h - t_p1
                  t_u1 = 134217729.0 * uy1_5h
                  t_r1 = t_u1
     +                     - (t_u1 - uy1_5h)
                  t_r2 = uy1_5h - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (v_x1h*uy1_5l
     +                     +  v_x1l*uy1_5h)
                  t_s1 = t_ch + t_cl
                  tmp2l = t_cl - (t_s1 - t_ch)
                  tmp2h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp2 = v_x1 * uy1_5
!<<<              w5 = w5 - tmp1
                  t_p1 = w5h - tmp1h
                  t_p2 = t_p1 - w5h
                  t_ch = t_p1
                  t_cl = (w5h - (t_p1 - t_p2))
     +                     - (tmp1h + t_p2)
                  t_cl = t_cl + w5l - tmp1l
                  t_s1 = t_ch + t_cl
                  w5l = t_cl - (t_s1 - t_ch)
                  w5h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>              w5 = w5 - tmp1
!<<<              w5 = w5 - tmp2
                  t_p1 = w5h - tmp2h
                  t_p2 = t_p1 - w5h
                  t_ch = t_p1
                  t_cl = (w5h - (t_p1 - t_p2))
     +                     - (tmp2h + t_p2)
                  t_cl = t_cl + w5l - tmp2l
                  t_s1 = t_ch + t_cl
                  w5l = t_cl - (t_s1 - t_ch)
                  w5h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>              w5 = w5 - tmp2
!                  w(j_1,l_1+4*size_of_row) = w4
!                  w(j_1,l_1+5*size_of_row) = w5
                  wh(j_1,l_1+4*size_of_row) = w4h
                  wl(j_1,l_1+4*size_of_row) = w4l
                  wh(j_1,l_1+5*size_of_row) = w5h
                  wl(j_1,l_1+5*size_of_row) = w5l
               end do! j_1

            end do! kk_1

         end do! l_1
      end do! jj_1
!----
      return
!      end subroutine ! eigen_prd_2update_local
      end subroutine ! ddeigen_prd_2update_local

