!      subroutine eigen_prd_2update_v(
!     &              ux, vx, nv,
!     &              u_t, v_t,
!     &              i, i_base, m0)
      subroutine ddeigen_prd_2update_v(
     &              uxh, uxl, vxh, vxl, nv,
     &              u_th, u_tl, v_th, v_tl,
     &              i, i_base, m0)
!----
!      use communication_sx, only : reduce_dbl
!     &                           , translate_g2l
!     &                           , get_loop_end
      use ddcommunication_sx, only : ddreduce_dbl
     &                             , translate_g2l
     &                             , get_loop_end
!----
      implicit none
!
      integer, intent(in)    ::  nv, i, i_base, m0
!      real(8), intent(inout) ::  ux(1:nv,*)
!      real(8), intent(inout) ::  vx(1:nv,*)
!      real(8), intent(inout) ::  u_t(4,*)
!      real(8), intent(inout) ::  v_t(*)
      real(8), intent(inout) ::  uxh(1:nv,*), uxl(1:nv,*)
      real(8), intent(inout) ::  vxh(1:nv,*), vxl(1:nv,*)
      real(8), intent(inout) ::  u_th(4,*), u_tl(4,*)
      real(8), intent(inout) ::  v_th(*), v_tl(*)
!----
      integer                ::  j, l, n, ll
      integer                ::  k_1, k_2
!----
      integer                ::  j_1, j_2, j_3
      integer                ::  l_1, l_2, l_4
      integer                ::  jj_1, jj_2, jj_3
      integer                ::  lx
!----
      include 'trd.h'
      include 'param.h'
      include 'cstab.h'
!----
!      real(8)                ::  w0, w1
!      real(8)                ::  u0_0, v0_0
!      real(8)                ::  u1_0, v1_0
!      real(8)                ::  u0_1, v0_1
!      real(8)                ::  u1_1, v1_1
!      real(8)                ::  ux0, vx0
!      real(8)                ::  ux1, vx1
      real(8)                ::  w0h, w0l, w1h, w1l
      real(8)                ::  u0_0h, u0_0l, v0_0h, v0_0l 
      real(8)                ::  u1_0h, u1_0l, v1_0h, v1_0l 
      real(8)                ::  u0_1h, u0_1l, v0_1h, v0_1l 
      real(8)                ::  u1_1h, u1_1l, v1_1h, v1_1l 
      real(8)                ::  ux0h, ux0l, vx0h, vx0l 
      real(8)                ::  ux1h, ux1l, vx1h, vx1l
      double precision tmp1h, tmp1l
      double precision tmp2h, tmp2l
!     tmp vars
      double precision t_ch, t_cl
      double precision t_p1, t_p2
      double precision t_q1, t_q2
      double precision t_r1, t_r2
      double precision t_s1, t_s2
      double precision t_t1, t_t2
      double precision t_u1, t_u2
      double precision t_x1, t_x2
      double precision t_y1, t_y2
      double precision t_z1, t_z2
      double precision t_x, t_ax
      double precision t_t1h, t_t1l
      double precision t_t2h, t_t2l


      k_1 = i - i_base
      k_2 = m0

      if ( k_2 <= k_1 ) return

      l = i - mband
      n  = translate_g2l(l, size_of_col,my_col)

! for attention to unexpected overflow or nan
      j_3 = get_loop_end(l, size_of_col,my_col)
      if ( j_3 < n ) then
!         vx(j_3+1:n,k_1-0) = zero ! in case
!         vx(j_3+1:n,k_1-1) = zero ! in case
!     
         vxh(j_3+1:n,k_1-0) = zeroh
         vxl(j_3+1:n,k_1-0) = zerol
!     
         vxh(j_3+1:n,k_1-1) = zeroh
         vxl(j_3+1:n,k_1-1) = zerol
      end if
!----
! v=v-(uv+vu)u
!----
      l_2 = k_2-k_1
      do j=1,l_2*(2*mband)
!         u_t(j,1) = zero
         u_th(j,1) = zeroh
         u_tl(j,1) = zerol
      end do

      l_4 = mod(k_2-k_1,2)+k_1+1
      lx  = l1_lsize*l1_way/16

      ll = (n-1)/size_of_row+1
      ll = ((ll-1)/2+1)*2

      jj_2 = 1+ll*(my_row-1)
      jj_3 = min(n,ll*my_row)
      do jj_1=jj_2,jj_3,lx
         j_2 = jj_1; j_3 = min(jj_1+lx-1,jj_3)

         do l_1=k_1+1,l_4-1                        ! 0

            j = l_1-k_1
!            u0_0 = u_t(1,j+0)
!            v0_0 = u_t(2,j+0)
!            u1_0 = u_t(3,j+0)
!            v1_0 = u_t(4,j+0)
            u0_0h = u_th(1,j+0)
            u0_0l = u_tl(1,j+0)
            v0_0h = u_th(2,j+0)
            v0_0l = u_tl(2,j+0)
            u1_0h = u_th(3,j+0)
            u1_0l = u_tl(3,j+0)
            v1_0h = u_th(4,j+0)
            v1_0l = u_tl(4,j+0)
!dir$ ivdep
!dir$ vector always
            do j_1=j_2,j_3
!               w0 = ux(j_1,k_1-0)
!               w1 = ux(j_1,k_1-1)
               w0h = uxh(j_1,k_1-0)
               w0l = uxl(j_1,k_1-0)
               w1h = uxh(j_1,k_1-1)
               w1l = uxl(j_1,k_1-1)
!               u0_0 = u0_0 + vx(j_1,l_1+0) * w0
!               v0_0 = v0_0 + ux(j_1,l_1+0) * w0
!               u1_0 = u1_0 + vx(j_1,l_1+0) * w1
!               v1_0 = v1_0 + ux(j_1,l_1+0) * w1
!<<<           tmp1 = vx(j_1,l_1+0) * w0
               t_ch = vxh(j_1,l_1+0) * w0h
               t_u1 = 134217729.0 * vxh(j_1,l_1+0)
               t_p1 = t_u1
     +                  - (t_u1 - vxh(j_1,l_1+0))
               t_p2 = vxh(j_1,l_1+0) - t_p1
               t_u1 = 134217729.0 * w0h
               t_r1 = t_u1
     +                  - (t_u1 - w0h)
               t_r2 = w0h - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (vxh(j_1,l_1+0)*w0l
     +                  +  vxl(j_1,l_1+0)*w0h)
               t_s1 = t_ch + t_cl
               tmp1l = t_cl - (t_s1 - t_ch)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp1 = vx(j_1,l_1+0) * w0
!<<<           u0_0 = u0_0 + tmp1
               t_p1 = u0_0h + tmp1h
               t_p2 = t_p1 - u0_0h
               t_q1 = t_p1
               t_q2 = (u0_0h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + u0_0l + tmp1l
               u0_0h = t_q1 + t_q2
               u0_0l = t_q2 - (u0_0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           u0_0 = u0_0 + tmp1
!<<<           tmp1 = ux(j_1,l_1+0) * w0
               t_ch = uxh(j_1,l_1+0) * w0h
               t_u1 = 134217729.0 * uxh(j_1,l_1+0)
               t_p1 = t_u1
     +                  - (t_u1 - uxh(j_1,l_1+0))
               t_p2 = uxh(j_1,l_1+0) - t_p1
               t_u1 = 134217729.0 * w0h
               t_r1 = t_u1
     +                  - (t_u1 - w0h)
               t_r2 = w0h - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (uxh(j_1,l_1+0)*w0l
     +                  +  uxl(j_1,l_1+0)*w0h)
               t_s1 = t_ch + t_cl
               tmp1l = t_cl - (t_s1 - t_ch)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp1 = ux(j_1,l_1+0) * w0
!<<<           v0_0 = v0_0 + tmp1
               t_p1 = v0_0h + tmp1h
               t_p2 = t_p1 - v0_0h
               t_q1 = t_p1
               t_q2 = (v0_0h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + v0_0l + tmp1l
               v0_0h = t_q1 + t_q2
               v0_0l = t_q2 - (v0_0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           v0_0 = v0_0 + tmp1
!<<<           tmp1 = vx(j_1,l_1+0) * w1
               t_ch = vxh(j_1,l_1+0) * w1h
               t_u1 = 134217729.0 * vxh(j_1,l_1+0)
               t_p1 = t_u1
     +                  - (t_u1 - vxh(j_1,l_1+0))
               t_p2 = vxh(j_1,l_1+0) - t_p1
               t_u1 = 134217729.0 * w1h
               t_r1 = t_u1
     +                  - (t_u1 - w1h)
               t_r2 = w1h - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (vxh(j_1,l_1+0)*w1l
     +                  +  vxl(j_1,l_1+0)*w1h)
               t_s1 = t_ch + t_cl
               tmp1l = t_cl - (t_s1 - t_ch)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp1 = vx(j_1,l_1+0) * w1
!<<<           u1_0 = u1_0 + tmp1
               t_p1 = u1_0h + tmp1h
               t_p2 = t_p1 - u1_0h
               t_q1 = t_p1
               t_q2 = (u1_0h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + u1_0l + tmp1l
               u1_0h = t_q1 + t_q2
               u1_0l = t_q2 - (u1_0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           u1_0 = u1_0 + tmp1
!<<<           tmp1 = ux(j_1,l_1+0) * w1
               t_ch = uxh(j_1,l_1+0) * w1h
               t_u1 = 134217729.0 * uxh(j_1,l_1+0)
               t_p1 = t_u1
     +                  - (t_u1 - uxh(j_1,l_1+0))
               t_p2 = uxh(j_1,l_1+0) - t_p1
               t_u1 = 134217729.0 * w1h
               t_r1 = t_u1
     +                  - (t_u1 - w1h)
               t_r2 = w1h - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (uxh(j_1,l_1+0)*w1l
     +                  +  uxl(j_1,l_1+0)*w1h)
               t_s1 = t_ch + t_cl
               tmp1l = t_cl - (t_s1 - t_ch)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp1 = ux(j_1,l_1+0) * w1
!<<<           v1_0 = v1_0 + tmp1
               t_p1 = v1_0h + tmp1h
               t_p2 = t_p1 - v1_0h
               t_q1 = t_p1
               t_q2 = (v1_0h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + v1_0l + tmp1l
               v1_0h = t_q1 + t_q2
               v1_0l = t_q2 - (v1_0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           v1_0 = v1_0 + tmp1
            end do! j_1
!            u_t(1,j+0) = u0_0
!            u_t(2,j+0) = v0_0
!            u_t(3,j+0) = u1_0
!            u_t(4,j+0) = v1_0
            u_th(1,j+0) = u0_0h
            u_tl(1,j+0) = u0_0l
            u_th(2,j+0) = v0_0h
            u_tl(2,j+0) = v0_0l
            u_th(3,j+0) = u1_0h
            u_tl(3,j+0) = u1_0l
            u_th(4,j+0) = v1_0h
            u_tl(4,j+0) = v1_0l
         end do! l_1
         do l_1=l_4,k_2,2                      ! 1

            j = l_1-k_1
!            u0_0 = u_t(1,j+0)
!            v0_0 = u_t(2,j+0)
!            u1_0 = u_t(3,j+0)
!            v1_0 = u_t(4,j+0)
!            u0_1 = u_t(1,j+1)
!            v0_1 = u_t(2,j+1)
!            u1_1 = u_t(3,j+1)
!            v1_1 = u_t(4,j+1)
            u0_0h = u_th(1,j+0)
            u0_0l = u_tl(1,j+0)
            v0_0h = u_th(2,j+0)
            v0_0l = u_tl(2,j+0)
            u1_0h = u_th(3,j+0)
            u1_0l = u_tl(3,j+0)
            v1_0h = u_th(4,j+0)
            v1_0l = u_tl(4,j+0)
            u0_1h = u_th(1,j+1)
            u0_1l = u_tl(1,j+1)
            v0_1h = u_th(2,j+1)
            v0_1l = u_tl(2,j+1)
            u1_1h = u_th(3,j+1)
            u1_1l = u_tl(3,j+1)
            v1_1h = u_th(4,j+1)
            v1_1l = u_tl(4,j+1)
!dir$ ivdep
!dir$ vector always
            do j_1=j_2,j_3
!               w0 = ux(j_1,k_1-0)
!               w1 = ux(j_1,k_1-1)
               w0h = uxh(j_1,k_1-0)
               w0l = uxl(j_1,k_1-0)
               w1h = uxh(j_1,k_1-1)
               w1l = uxl(j_1,k_1-1)
!               u0_0 = u0_0 + vx(j_1,l_1+0) * w0
!               v0_0 = v0_0 + ux(j_1,l_1+0) * w0
!               u1_0 = u1_0 + vx(j_1,l_1+0) * w1
!               v1_0 = v1_0 + ux(j_1,l_1+0) * w1
!               u0_1 = u0_1 + vx(j_1,l_1+1) * w0
!               v0_1 = v0_1 + ux(j_1,l_1+1) * w0
!               u1_1 = u1_1 + vx(j_1,l_1+1) * w1
!               v1_1 = v1_1 + ux(j_1,l_1+1) * w1
!<<<           tmp1 = vx(j_1,l_1+0) * w0
               t_ch = vxh(j_1,l_1+0) * w0h
               t_u1 = 134217729.0 * vxh(j_1,l_1+0)
               t_p1 = t_u1
     +                  - (t_u1 - vxh(j_1,l_1+0))
               t_p2 = vxh(j_1,l_1+0) - t_p1
               t_u1 = 134217729.0 * w0h
               t_r1 = t_u1
     +                  - (t_u1 - w0h)
               t_r2 = w0h - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (vxh(j_1,l_1+0)*w0l
     +                  +  vxl(j_1,l_1+0)*w0h)
               t_s1 = t_ch + t_cl
               tmp1l = t_cl - (t_s1 - t_ch)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp1 = vx(j_1,l_1+0) * w0
!<<<           u0_0 = u0_0 + tmp1
               t_p1 = u0_0h + tmp1h
               t_p2 = t_p1 - u0_0h
               t_q1 = t_p1
               t_q2 = (u0_0h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + u0_0l + tmp1l
               u0_0h = t_q1 + t_q2
               u0_0l = t_q2 - (u0_0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           u0_0 = u0_0 + tmp1
!<<<           tmp1 = ux(j_1,l_1+0) * w0
               t_ch = uxh(j_1,l_1+0) * w0h
               t_u1 = 134217729.0 * uxh(j_1,l_1+0)
               t_p1 = t_u1
     +                  - (t_u1 - uxh(j_1,l_1+0))
               t_p2 = uxh(j_1,l_1+0) - t_p1
               t_u1 = 134217729.0 * w0h
               t_r1 = t_u1
     +                  - (t_u1 - w0h)
               t_r2 = w0h - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (uxh(j_1,l_1+0)*w0l
     +                  +  uxl(j_1,l_1+0)*w0h)
               t_s1 = t_ch + t_cl
               tmp1l = t_cl - (t_s1 - t_ch)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp1 = ux(j_1,l_1+0) * w0
!<<<           v0_0 = v0_0 + tmp1
               t_p1 = v0_0h + tmp1h
               t_p2 = t_p1 - v0_0h
               t_q1 = t_p1
               t_q2 = (v0_0h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + v0_0l + tmp1l
               v0_0h = t_q1 + t_q2
               v0_0l = t_q2 - (v0_0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           v0_0 = v0_0 + tmp1
!<<<           tmp1 = vx(j_1,l_1+0) * w1
               t_ch = vxh(j_1,l_1+0) * w1h
               t_u1 = 134217729.0 * vxh(j_1,l_1+0)
               t_p1 = t_u1
     +                  - (t_u1 - vxh(j_1,l_1+0))
               t_p2 = vxh(j_1,l_1+0) - t_p1
               t_u1 = 134217729.0 * w1h
               t_r1 = t_u1
     +                  - (t_u1 - w1h)
               t_r2 = w1h - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (vxh(j_1,l_1+0)*w1l
     +                  +  vxl(j_1,l_1+0)*w1h)
               t_s1 = t_ch + t_cl
               tmp1l = t_cl - (t_s1 - t_ch)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp1 = vx(j_1,l_1+0) * w1
!<<<           u1_0 = u1_0 + tmp1
               t_p1 = u1_0h + tmp1h
               t_p2 = t_p1 - u1_0h
               t_q1 = t_p1
               t_q2 = (u1_0h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + u1_0l + tmp1l
               u1_0h = t_q1 + t_q2
               u1_0l = t_q2 - (u1_0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           u1_0 = u1_0 + tmp1
!<<<           tmp1 = ux(j_1,l_1+0) * w1
               t_ch = uxh(j_1,l_1+0) * w1h
               t_u1 = 134217729.0 * uxh(j_1,l_1+0)
               t_p1 = t_u1
     +                  - (t_u1 - uxh(j_1,l_1+0))
               t_p2 = uxh(j_1,l_1+0) - t_p1
               t_u1 = 134217729.0 * w1h
               t_r1 = t_u1
     +                  - (t_u1 - w1h)
               t_r2 = w1h - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (uxh(j_1,l_1+0)*w1l
     +                  +  uxl(j_1,l_1+0)*w1h)
               t_s1 = t_ch + t_cl
               tmp1l = t_cl - (t_s1 - t_ch)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp1 = ux(j_1,l_1+0) * w1
!<<<           v1_0 = v1_0 + tmp1
               t_p1 = v1_0h + tmp1h
               t_p2 = t_p1 - v1_0h
               t_q1 = t_p1
               t_q2 = (v1_0h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + v1_0l + tmp1l
               v1_0h = t_q1 + t_q2
               v1_0l = t_q2 - (v1_0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           v1_0 = v1_0 + tmp1
!<<<           tmp1 = vx(j_1,l_1+1) * w0
               t_ch = vxh(j_1,l_1+1) * w0h
               t_u1 = 134217729.0 * vxh(j_1,l_1+1)
               t_p1 = t_u1
     +                  - (t_u1 - vxh(j_1,l_1+1))
               t_p2 = vxh(j_1,l_1+1) - t_p1
               t_u1 = 134217729.0 * w0h
               t_r1 = t_u1
     +                  - (t_u1 - w0h)
               t_r2 = w0h - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (vxh(j_1,l_1+1)*w0l
     +                  +  vxl(j_1,l_1+1)*w0h)
               t_s1 = t_ch + t_cl
               tmp1l = t_cl - (t_s1 - t_ch)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp1 = vx(j_1,l_1+1) * w0
!<<<           u0_1 = u0_1 + tmp1
               t_p1 = u0_1h + tmp1h
               t_p2 = t_p1 - u0_1h
               t_q1 = t_p1
               t_q2 = (u0_1h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + u0_1l + tmp1l
               u0_1h = t_q1 + t_q2
               u0_1l = t_q2 - (u0_1h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           u0_1 = u0_1 + tmp1
!<<<           tmp1 = ux(j_1,l_1+1) * w0
               t_ch = uxh(j_1,l_1+1) * w0h
               t_u1 = 134217729.0 * uxh(j_1,l_1+1)
               t_p1 = t_u1
     +                  - (t_u1 - uxh(j_1,l_1+1))
               t_p2 = uxh(j_1,l_1+1) - t_p1
               t_u1 = 134217729.0 * w0h
               t_r1 = t_u1
     +                  - (t_u1 - w0h)
               t_r2 = w0h - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (uxh(j_1,l_1+1)*w0l
     +                  +  uxl(j_1,l_1+1)*w0h)
               t_s1 = t_ch + t_cl
               tmp1l = t_cl - (t_s1 - t_ch)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp1 = ux(j_1,l_1+1) * w0
!<<<           v0_1 = v0_1 + tmp1
               t_p1 = v0_1h + tmp1h
               t_p2 = t_p1 - v0_1h
               t_q1 = t_p1
               t_q2 = (v0_1h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + v0_1l + tmp1l
               v0_1h = t_q1 + t_q2
               v0_1l = t_q2 - (v0_1h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           v0_1 = v0_1 + tmp1
!<<<           tmp1 = vx(j_1,l_1+1) * w1
               t_ch = vxh(j_1,l_1+1) * w1h
               t_u1 = 134217729.0 * vxh(j_1,l_1+1)
               t_p1 = t_u1
     +                  - (t_u1 - vxh(j_1,l_1+1))
               t_p2 = vxh(j_1,l_1+1) - t_p1
               t_u1 = 134217729.0 * w1h
               t_r1 = t_u1
     +                  - (t_u1 - w1h)
               t_r2 = w1h - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (vxh(j_1,l_1+1)*w1l
     +                  +  vxl(j_1,l_1+1)*w1h)
               t_s1 = t_ch + t_cl
               tmp1l = t_cl - (t_s1 - t_ch)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp1 = vx(j_1,l_1+1) * w1
!<<<           u1_1 = u1_1 + tmp1
               t_p1 = u1_1h + tmp1h
               t_p2 = t_p1 - u1_1h
               t_q1 = t_p1
               t_q2 = (u1_1h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + u1_1l + tmp1l
               u1_1h = t_q1 + t_q2
               u1_1l = t_q2 - (u1_1h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           u1_1 = u1_1 + tmp1
!<<<           tmp1 = ux(j_1,l_1+1) * w1
               t_ch = uxh(j_1,l_1+1) * w1h
               t_u1 = 134217729.0 * uxh(j_1,l_1+1)
               t_p1 = t_u1
     +                  - (t_u1 - uxh(j_1,l_1+1))
               t_p2 = uxh(j_1,l_1+1) - t_p1
               t_u1 = 134217729.0 * w1h
               t_r1 = t_u1
     +                  - (t_u1 - w1h)
               t_r2 = w1h - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (uxh(j_1,l_1+1)*w1l
     +                  +  uxl(j_1,l_1+1)*w1h)
               t_s1 = t_ch + t_cl
               tmp1l = t_cl - (t_s1 - t_ch)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp1 = ux(j_1,l_1+1) * w1
!<<<           v1_1 = v1_1 + tmp1
               t_p1 = v1_1h + tmp1h
               t_p2 = t_p1 - v1_1h
               t_q1 = t_p1
               t_q2 = (v1_1h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + v1_1l + tmp1l
               v1_1h = t_q1 + t_q2
               v1_1l = t_q2 - (v1_1h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           v1_1 = v1_1 + tmp1
            end do! j_1
!            u_t(1,j+0) = u0_0
!            u_t(2,j+0) = v0_0
!            u_t(3,j+0) = u1_0
!            u_t(4,j+0) = v1_0
!            u_t(1,j+1) = u0_1
!            u_t(2,j+1) = v0_1
!            u_t(3,j+1) = u1_1
!            u_t(4,j+1) = v1_1
            u_th(1,j+0) = u0_0h
            u_tl(1,j+0) = u0_0l
            u_th(2,j+0) = v0_0h
            u_tl(2,j+0) = v0_0l
            u_th(3,j+0) = u1_0h
            u_tl(3,j+0) = u1_0l
            u_th(4,j+0) = v1_0h
            u_tl(4,j+0) = v1_0l
            u_th(1,j+1) = u0_1h
            u_tl(1,j+1) = u0_1l
            u_th(2,j+1) = v0_1h
            u_tl(2,j+1) = v0_1l
            u_th(3,j+1) = u1_1h
            u_tl(3,j+1) = u1_1l
            u_th(4,j+1) = v1_1h
            u_tl(4,j+1) = v1_1l
         end do! l_1

      end do! jj_1

!      call reduce_dbl(u_t, v_t, (k_2-k_1)*(2*mband), 1, mpi_comm_row)
!      call reduce_dbl(u_t, v_t, (k_2-k_1)*(2*mband), 1, mpi_comm_col)
      call ddreduce_dbl(
     &     u_th, u_tl, v_th, v_tl, (k_2-k_1)*(2*mband), 1, mpi_comm_row)
      call ddreduce_dbl(
     &     u_th, u_tl, v_th, v_tl, (k_2-k_1)*(2*mband), 1, mpi_comm_col)

      if ( n > 100000 ) then
         jj_2 = 1+ll*(my_row-1)
         jj_3 = min(n,ll*my_row)
      else
         jj_2 = 1
         jj_3 = n
      end if
      do jj_1=jj_2,jj_3,lx
         j_2 = jj_1; j_3 = min(jj_1+lx-1,jj_3)

         do l_1=k_1+1,l_4-1                        ! 0

            j = l_1-k_1

!            u0_0 = u_t(1,j+0)
!            v0_0 = u_t(2,j+0)
!            u1_0 = u_t(3,j+0)
!            v1_0 = u_t(4,j+0)
            u0_0h = u_th(1,j+0)
            u0_0l = u_tl(1,j+0)
            v0_0h = u_th(2,j+0)
            v0_0l = u_tl(2,j+0)
            u1_0h = u_th(3,j+0)
            u1_0l = u_tl(3,j+0)
            v1_0h = u_th(4,j+0)
            v1_0l = u_tl(4,j+0)
!dir$ ivdep
!dir$ vector always
            do j_1=j_2,j_3
!               w0 = vx(j_1,k_1-0)
!               w1 = vx(j_1,k_1-1)
!               ux0 = ux(j_1,l_1+0)
!               vx0 = vx(j_1,l_1+0)
               w0h = vxh(j_1,k_1-0)
               w0l = vxl(j_1,k_1-0)
               w1h = vxh(j_1,k_1-1)
               w1l = vxl(j_1,k_1-1)
               ux0h = uxh(j_1,l_1+0)
               ux0l = uxl(j_1,l_1+0)
               vx0h = vxh(j_1,l_1+0)
               vx0l = vxl(j_1,l_1+0)
!               w0 = w0
!     &            - ux0 * u0_0
!     &            - vx0 * v0_0
!               w1 = w1
!     &            - ux0 * u1_0
!     &            - vx0 * v1_0
!<<<           tmp1 = ux0 * u0_0
               t_ch = ux0h * u0_0h
               t_u1 = 134217729.0 * ux0h
               t_p1 = t_u1
     +                  - (t_u1 - ux0h)
               t_p2 = ux0h - t_p1
               t_u1 = 134217729.0 * u0_0h
               t_r1 = t_u1
     +                  - (t_u1 - u0_0h)
               t_r2 = u0_0h - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (ux0h*u0_0l
     +                  +  ux0l*u0_0h)
               t_s1 = t_ch + t_cl
               tmp1l = t_cl - (t_s1 - t_ch)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp1 = ux0 * u0_0
!<<<           tmp2 = vx0 * v0_0
               t_ch = vx0h * v0_0h
               t_u1 = 134217729.0 * vx0h
               t_p1 = t_u1
     +                  - (t_u1 - vx0h)
               t_p2 = vx0h - t_p1
               t_u1 = 134217729.0 * v0_0h
               t_r1 = t_u1
     +                  - (t_u1 - v0_0h)
               t_r2 = v0_0h - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (vx0h*v0_0l
     +                  +  vx0l*v0_0h)
               t_s1 = t_ch + t_cl
               tmp2l = t_cl - (t_s1 - t_ch)
               tmp2h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp2 = vx0 * v0_0
!<<<           w0 = w0 - tmp1
               t_p1 = w0h - tmp1h
               t_p2 = t_p1 - w0h
               t_ch = t_p1
               t_cl = (w0h - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + w0l - tmp1l
               t_s1 = t_ch + t_cl
               w0l = t_cl - (t_s1 - t_ch)
               w0h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           w0 = w0 - tmp1
!<<<           w0 = w0 - tmp2
               t_p1 = w0h - tmp2h
               t_p2 = t_p1 - w0h
               t_ch = t_p1
               t_cl = (w0h - (t_p1 - t_p2))
     +                  - (tmp2h + t_p2)
               t_cl = t_cl + w0l - tmp2l
               t_s1 = t_ch + t_cl
               w0l = t_cl - (t_s1 - t_ch)
               w0h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           w0 = w0 - tmp2
!<<<           tmp1 = ux0 * u1_0
               t_ch = ux0h * u1_0h
               t_u1 = 134217729.0 * ux0h
               t_p1 = t_u1
     +                  - (t_u1 - ux0h)
               t_p2 = ux0h - t_p1
               t_u1 = 134217729.0 * u1_0h
               t_r1 = t_u1
     +                  - (t_u1 - u1_0h)
               t_r2 = u1_0h - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (ux0h*u1_0l
     +                  +  ux0l*u1_0h)
               t_s1 = t_ch + t_cl
               tmp1l = t_cl - (t_s1 - t_ch)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp1 = ux0 * u1_0
!<<<           tmp2 = vx0 * v1_0
               t_ch = vx0h * v1_0h
               t_u1 = 134217729.0 * vx0h
               t_p1 = t_u1
     +                  - (t_u1 - vx0h)
               t_p2 = vx0h - t_p1
               t_u1 = 134217729.0 * v1_0h
               t_r1 = t_u1
     +                  - (t_u1 - v1_0h)
               t_r2 = v1_0h - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (vx0h*v1_0l
     +                  +  vx0l*v1_0h)
               t_s1 = t_ch + t_cl
               tmp2l = t_cl - (t_s1 - t_ch)
               tmp2h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp2 = vx0 * v1_0
!<<<           w1 = w1 - tmp1
               t_p1 = w1h - tmp1h
               t_p2 = t_p1 - w1h
               t_ch = t_p1
               t_cl = (w1h - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + w1l - tmp1l
               t_s1 = t_ch + t_cl
               w1l = t_cl - (t_s1 - t_ch)
               w1h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           w1 = w1 - tmp1
!<<<           w1 = w1 - tmp2
               t_p1 = w1h - tmp2h
               t_p2 = t_p1 - w1h
               t_ch = t_p1
               t_cl = (w1h - (t_p1 - t_p2))
     +                  - (tmp2h + t_p2)
               t_cl = t_cl + w1l - tmp2l
               t_s1 = t_ch + t_cl
               w1l = t_cl - (t_s1 - t_ch)
               w1h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           w1 = w1 - tmp2

!               vx(j_1,k_1-0) = w0
!               vx(j_1,k_1-1) = w1
               vxh(j_1,k_1-0) = w0h
               vxl(j_1,k_1-0) = w0l
               vxh(j_1,k_1-1) = w1h
               vxl(j_1,k_1-1) = w1l
            end do! j_1
         end do! l_1
         do l_1=l_4,k_2,2                      ! 1

            j = l_1-k_1

!            u0_0 = u_t(1,j+0)
!            v0_0 = u_t(2,j+0)
!            u1_0 = u_t(3,j+0)
!            v1_0 = u_t(4,j+0)
!            u0_1 = u_t(1,j+1)
!            v0_1 = u_t(2,j+1)
!            u1_1 = u_t(3,j+1)
!            v1_1 = u_t(4,j+1)
            u0_0h = u_th(1,j+0)
            u0_0l = u_tl(1,j+0)
            v0_0h = u_th(2,j+0)
            v0_0l = u_tl(2,j+0)
            u1_0h = u_th(3,j+0)
            u1_0l = u_tl(3,j+0)
            v1_0h = u_th(4,j+0)
            v1_0l = u_tl(4,j+0)
            u0_1h = u_th(1,j+1)
            u0_1l = u_tl(1,j+1)
            v0_1h = u_th(2,j+1)
            v0_1l = u_tl(2,j+1)
            u1_1h = u_th(3,j+1)
            u1_1l = u_tl(3,j+1)
            v1_1h = u_th(4,j+1)
            v1_1l = u_tl(4,j+1)
!dir$ ivdep
!dir$ vector always
            do j_1=j_2,j_3
!               w0 = vx(j_1,k_1-0)
!               w1 = vx(j_1,k_1-1)
!               ux0 = ux(j_1,l_1+0)
!               vx0 = vx(j_1,l_1+0)
               w0h = vxh(j_1,k_1-0)
               w0l = vxl(j_1,k_1-0)
               w1h = vxh(j_1,k_1-1)
               w1l = vxl(j_1,k_1-1)
               ux0h = uxh(j_1,l_1+0)
               ux0l = uxl(j_1,l_1+0)
               vx0h = vxh(j_1,l_1+0)
               vx0l = vxl(j_1,l_1+0)
!               w0 = w0
!     &            - ux0 * u0_0
!     &            - vx0 * v0_0
!               w1 = w1
!     &            - ux0 * u1_0
!     &            - vx0 * v1_0
!<<<           tmp1 = ux0 * u0_0
               t_ch = ux0h * u0_0h
               t_u1 = 134217729.0 * ux0h
               t_p1 = t_u1
     +                  - (t_u1 - ux0h)
               t_p2 = ux0h - t_p1
               t_u1 = 134217729.0 * u0_0h
               t_r1 = t_u1
     +                  - (t_u1 - u0_0h)
               t_r2 = u0_0h - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (ux0h*u0_0l
     +                  +  ux0l*u0_0h)
               t_s1 = t_ch + t_cl
               tmp1l = t_cl - (t_s1 - t_ch)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp1 = ux0 * u0_0
!<<<           tmp2 = vx0 * v0_0
               t_ch = vx0h * v0_0h
               t_u1 = 134217729.0 * vx0h
               t_p1 = t_u1
     +                  - (t_u1 - vx0h)
               t_p2 = vx0h - t_p1
               t_u1 = 134217729.0 * v0_0h
               t_r1 = t_u1
     +                  - (t_u1 - v0_0h)
               t_r2 = v0_0h - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (vx0h*v0_0l
     +                  +  vx0l*v0_0h)
               t_s1 = t_ch + t_cl
               tmp2l = t_cl - (t_s1 - t_ch)
               tmp2h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp2 = vx0 * v0_0
!<<<           w0 = w0 - tmp1
               t_p1 = w0h - tmp1h
               t_p2 = t_p1 - w0h
               t_ch = t_p1
               t_cl = (w0h - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + w0l - tmp1l
               t_s1 = t_ch + t_cl
               w0l = t_cl - (t_s1 - t_ch)
               w0h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           w0 = w0 - tmp1
!<<<           w0 = w0 - tmp2
               t_p1 = w0h - tmp2h
               t_p2 = t_p1 - w0h
               t_ch = t_p1
               t_cl = (w0h - (t_p1 - t_p2))
     +                  - (tmp2h + t_p2)
               t_cl = t_cl + w0l - tmp2l
               t_s1 = t_ch + t_cl
               w0l = t_cl - (t_s1 - t_ch)
               w0h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           w0 = w0 - tmp2
!<<<           tmp1 = ux0 * u1_0
               t_ch = ux0h * u1_0h
               t_u1 = 134217729.0 * ux0h
               t_p1 = t_u1
     +                  - (t_u1 - ux0h)
               t_p2 = ux0h - t_p1
               t_u1 = 134217729.0 * u1_0h
               t_r1 = t_u1
     +                  - (t_u1 - u1_0h)
               t_r2 = u1_0h - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (ux0h*u1_0l
     +                  +  ux0l*u1_0h)
               t_s1 = t_ch + t_cl
               tmp1l = t_cl - (t_s1 - t_ch)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp1 = ux0 * u1_0
!<<<           tmp2 = vx0 * v1_0
               t_ch = vx0h * v1_0h
               t_u1 = 134217729.0 * vx0h
               t_p1 = t_u1
     +                  - (t_u1 - vx0h)
               t_p2 = vx0h - t_p1
               t_u1 = 134217729.0 * v1_0h
               t_r1 = t_u1
     +                  - (t_u1 - v1_0h)
               t_r2 = v1_0h - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (vx0h*v1_0l
     +                  +  vx0l*v1_0h)
               t_s1 = t_ch + t_cl
               tmp2l = t_cl - (t_s1 - t_ch)
               tmp2h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp2 = vx0 * v1_0
!<<<           w1 = w1 - tmp1
               t_p1 = w1h - tmp1h
               t_p2 = t_p1 - w1h
               t_ch = t_p1
               t_cl = (w1h - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + w1l - tmp1l
               t_s1 = t_ch + t_cl
               w1l = t_cl - (t_s1 - t_ch)
               w1h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           w1 = w1 - tmp1
!<<<           w1 = w1 - tmp2
               t_p1 = w1h - tmp2h
               t_p2 = t_p1 - w1h
               t_ch = t_p1
               t_cl = (w1h - (t_p1 - t_p2))
     +                  - (tmp2h + t_p2)
               t_cl = t_cl + w1l - tmp2l
               t_s1 = t_ch + t_cl
               w1l = t_cl - (t_s1 - t_ch)
               w1h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           w1 = w1 - tmp2
!               ux1 = ux(j_1,l_1+1)
!               vx1 = vx(j_1,l_1+1)
               ux1h = uxh(j_1,l_1+1)
               ux1l = uxl(j_1,l_1+1)
               vx1h = vxh(j_1,l_1+1)
               vx1l = vxl(j_1,l_1+1)
!               w0 = w0
!     &            - ux1 * u0_1
!     &            - vx1 * v0_1
!               w1 = w1
!     &            - ux1 * u1_1
!     &            - vx1 * v1_1
!<<<           tmp1 = ux1 * u0_1
               t_ch = ux1h * u0_1h
               t_u1 = 134217729.0 * ux1h
               t_p1 = t_u1
     +                  - (t_u1 - ux1h)
               t_p2 = ux1h - t_p1
               t_u1 = 134217729.0 * u0_1h
               t_r1 = t_u1
     +                  - (t_u1 - u0_1h)
               t_r2 = u0_1h - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (ux1h*u0_1l
     +                  +  ux1l*u0_1h)
               t_s1 = t_ch + t_cl
               tmp1l = t_cl - (t_s1 - t_ch)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp1 = ux1 * u0_1
!<<<           tmp2 = vx1 * v0_1
               t_ch = vx1h * v0_1h
               t_u1 = 134217729.0 * vx1h
               t_p1 = t_u1
     +                  - (t_u1 - vx1h)
               t_p2 = vx1h - t_p1
               t_u1 = 134217729.0 * v0_1h
               t_r1 = t_u1
     +                  - (t_u1 - v0_1h)
               t_r2 = v0_1h - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (vx1h*v0_1l
     +                  +  vx1l*v0_1h)
               t_s1 = t_ch + t_cl
               tmp2l = t_cl - (t_s1 - t_ch)
               tmp2h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp2 = vx1 * v0_1
!<<<           w0 = w0 - tmp1
               t_p1 = w0h - tmp1h
               t_p2 = t_p1 - w0h
               t_ch = t_p1
               t_cl = (w0h - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + w0l - tmp1l
               t_s1 = t_ch + t_cl
               w0l = t_cl - (t_s1 - t_ch)
               w0h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           w0 = w0 - tmp1
!<<<           w0 = w0 - tmp2
               t_p1 = w0h - tmp2h
               t_p2 = t_p1 - w0h
               t_ch = t_p1
               t_cl = (w0h - (t_p1 - t_p2))
     +                  - (tmp2h + t_p2)
               t_cl = t_cl + w0l - tmp2l
               t_s1 = t_ch + t_cl
               w0l = t_cl - (t_s1 - t_ch)
               w0h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           w0 = w0 - tmp2
!<<<           tmp1 = ux1 * u1_1
               t_ch = ux1h * u1_1h
               t_u1 = 134217729.0 * ux1h
               t_p1 = t_u1
     +                  - (t_u1 - ux1h)
               t_p2 = ux1h - t_p1
               t_u1 = 134217729.0 * u1_1h
               t_r1 = t_u1
     +                  - (t_u1 - u1_1h)
               t_r2 = u1_1h - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (ux1h*u1_1l
     +                  +  ux1l*u1_1h)
               t_s1 = t_ch + t_cl
               tmp1l = t_cl - (t_s1 - t_ch)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp1 = ux1 * u1_1
!<<<           tmp2 = vx1 * v1_1
               t_ch = vx1h * v1_1h
               t_u1 = 134217729.0 * vx1h
               t_p1 = t_u1
     +                  - (t_u1 - vx1h)
               t_p2 = vx1h - t_p1
               t_u1 = 134217729.0 * v1_1h
               t_r1 = t_u1
     +                  - (t_u1 - v1_1h)
               t_r2 = v1_1h - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (vx1h*v1_1l
     +                  +  vx1l*v1_1h)
               t_s1 = t_ch + t_cl
               tmp2l = t_cl - (t_s1 - t_ch)
               tmp2h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp2 = vx1 * v1_1
!<<<           w1 = w1 - tmp1
               t_p1 = w1h - tmp1h
               t_p2 = t_p1 - w1h
               t_ch = t_p1
               t_cl = (w1h - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + w1l - tmp1l
               t_s1 = t_ch + t_cl
               w1l = t_cl - (t_s1 - t_ch)
               w1h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           w1 = w1 - tmp1
!<<<           w1 = w1 - tmp2
               t_p1 = w1h - tmp2h
               t_p2 = t_p1 - w1h
               t_ch = t_p1
               t_cl = (w1h - (t_p1 - t_p2))
     +                  - (tmp2h + t_p2)
               t_cl = t_cl + w1l - tmp2l
               t_s1 = t_ch + t_cl
               w1l = t_cl - (t_s1 - t_ch)
               w1h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           w1 = w1 - tmp2
!               vx(j_1,k_1-0) = w0
!               vx(j_1,k_1-1) = w1
               vxh(j_1,k_1-0) = w0h
               vxl(j_1,k_1-0) = w0l
               vxh(j_1,k_1-1) = w1h
               vxl(j_1,k_1-1) = w1l
            end do! j_1
         end do! l_1

      end do! jj_1

      if ( n > 100000 ) then
         do j_1=1,jj_2-1
!            vx(j_1,k_1-0) = zero
!            vx(j_1,k_1-1) = zero
            vxh(j_1,k_1-0) = zeroh
            vxl(j_1,k_1-0) = zerol
            vxh(j_1,k_1-1) = zeroh
            vxl(j_1,k_1-1) = zerol
         end do! j_1
         do j_1=jj_3+1,n
!            vx(j_1,k_1-0) = zero
!            vx(j_1,k_1-1) = zero
            vxh(j_1,k_1-0) = zeroh
            vxl(j_1,k_1-0) = zerol
            vxh(j_1,k_1-1) = zeroh
            vxl(j_1,k_1-1) = zerol
         end do! j_1

         do j_1=1,n
!            v_t(j_1)   = vx(1,k_1-0)
!            v_t(j_1+n) = vx(1,k_1-1)
            v_th(j_1) = vxh(1,k_1-0)
            v_tl(j_1) = vxl(1,k_1-0)
            v_th(j_1+n) = vxh(1,k_1-1)
            v_tl(j_1+n) = vxl(1,k_1-1)
         end do! j_1
!         call reduce_dbl(v_t, u_t, mband*n, 1, mpi_comm_row)
         call ddreduce_dbl(
     &             v_th, v_tl, u_th, u_tl, mband*n, 1, mpi_comm_row)
         do j_1=1,n
!            vx(1,k_1-0) = v_t(j_1)
!            vx(1,k_1-1) = v_t(j_1+n)
            vxh(1,k_1-0) = v_th(j_1)
            vxl(1,k_1-0) = v_tl(j_1)
            vxh(1,k_1-1) = v_th(j_1+n)
            vxl(1,k_1-1) = v_tl(j_1+n)
         end do! j_1
      end if

!  for attention to unexpected overflow or nan
      j_3 = get_loop_end(l, size_of_col,my_col)
      if ( j_3 < n ) then
!         vx(j_3+1:n,k_1-0) = zero ! in case
!         vx(j_3+1:n,k_1-1) = zero ! in case
         vxh(j_3+1:n,k_1-0) = zeroh
         vxl(j_3+1:n,k_1-0) = zerol
         vxh(j_3+1:n,k_1-1) = zeroh
         vxl(j_3+1:n,k_1-1) = zerol
      end if


      return
      end subroutine ! ddeigen_prd_2update_v

