!      subroutine eigen_prd_u(
!     &              a, nm,
!     &              u_x, u_y, nv,
!     &              u_t, v_t, i, c, e, ne)
      subroutine ddeigen_prd_u(
     &              ah, al,nm,
     &              u_xh, u_xl, u_yh, u_yl, nv,
     &              u_th, u_tl, v_th, v_tl, i, ch, cl, eh, el, ne)
!----
!      use communication_sx, only : bcast_dbl
!     &                           , reduce_dbl   
!     &                           , datacast_dbl
!     &                           , datacast_dbl2
!     &                           , translate_g2l
!     &                           , get_loop_start
!     &                           , get_loop_end
!     &                           , get_loop_node
      use ddcommunication_sx, only : ddbcast_dbl
     &                             , ddreduce_dbl   
     &                             , dddatacast_dbl
     &                             , dddatacast_dbl2
     &                             , translate_g2l
     &                             , get_loop_start
     &                             , get_loop_end
     &                             , get_loop_node
!----
      implicit none

      integer, intent(in)    :: nm, nv, ne, i
!      real(8), intent(inout) :: a(1:nm,*)
!      real(8), intent(out)   :: u_x(1:nv,*), u_y(1:nv,*)
!      real(8), intent(out)   :: u_t(*), v_t(*)
      real(8), intent(inout) :: ah(1:nm,*), al(1:nm,*)
      real(8), intent(out)   :: u_xh(1:nv,*), u_yh(1:nv,*)
      real(8), intent(out)   :: u_xl(1:nv,*), u_yl(1:nv,*)
      real(8), intent(out)   :: u_th(*), v_th(*)
      real(8), intent(out)   :: u_tl(*), v_tl(*)

      include 'trd.h'

!      real(8), intent(out)   :: c(mband,mband), e(1:ne,*)
      real(8), intent(out)   :: ch(mband,mband), eh(1:ne,*)
      real(8), intent(out)   :: cl(mband,mband), el(1:ne,*)

!      real(8)                :: g_n(mband), a_n
!      real(8)                :: t, tt(2*mband**2), ss(2*mband**2)
!      real(8)                :: alpha(mband), beta(mband), scale(mband)
      real(8)                :: g_nh(mband), a_nh
      real(8)                :: g_nl(mband), a_nl
      real(8)                :: th, tth(2*mband**2), ssh(2*mband**2)
      real(8)                :: tl, ttl(2*mband**2), ssl(2*mband**2)
      real(8)                :: alphah(mband),betah(mband),scaleh(mband)
      real(8)                :: alphal(mband),betal(mband),scalel(mband)

!      real(8), parameter     :: zero = 0.0d+00, one = 1.0d+00
      real(8), parameter     :: zeroh = 0.0d+00, oneh = 1.0d+00
      real(8), parameter     :: zerol = 0.0d+00, onel = 0.0d+00

      integer                :: owner_node_col, col_local
      integer                :: owner_node_row
      integer                :: i_1
      integer                :: j_1, j_2, j_3
      integer                :: k_1
      integer                :: l, ll

!      real(8) :: t11, t12, t22, tol
!      real(8) :: a1, a2
!      real(8) :: al(mband,mband), ax(mband, mband)
!      real(8), parameter :: eps = 2d-16
      real(8) :: t11h, t12h, t22h, tolh
      real(8) :: t11l, t12l, t22l, toll
      real(8) :: a1h, a1l, a2h, a2l
      real(8) :: alh(mband,mband), axh(mband, mband)
      real(8) :: all(mband,mband), axl(mband, mband)
      real(8), parameter :: epsh = 2d-16
      real(8), parameter :: epsl = 0d0
      double precision tmp1h, tmp1l
!     tmp vars
      double precision t_ch, t_cl
      double precision t_p1, t_p2
      double precision t_q1, t_q2
      double precision t_r1, t_r2
      double precision t_s1, t_s2
      double precision t_t1, t_t2
      double precision t_u1, t_u2
      double precision t_x1, t_x2
      double precision t_y1, t_y2
      double precision t_z1, t_z2
      double precision t_x, t_ax
      double precision t_t1h, t_t1l
      double precision t_t2h, t_t2l
      double precision sixteenh, sixteenl
      double precision twoh, twol
      sixteenh = 16.d0
      sixteenl = 0.0d+0
      twoh = 2.d0
      twol = 0.0d+0

      l  = i-mband
      ll = l-mband

!      alpha(1:mband) = one
!      beta (1:mband) = one
!      g_n  (1:mband) = zero
!      scale(1:mband) = zero
      alphah(1:mband) = oneh
      alphal(1:mband) = onel
      betah(1:mband) = oneh
      betal(1:mband) = onel
      g_nh(1:mband) = zeroh
      g_nl(1:mband) = zerol
      scaleh(1:mband) = zeroh
      scalel(1:mband) = zerol

!      c(1:mband, 1:mband)  = zero
      ch(1:mband,1:mband) = zeroh
      cl(1:mband,1:mband) = zerol


      do i_1=mband,1,-1
         if ( ll + i_1 >= 1  ) then

            owner_node_row = get_loop_node(l+i_1, size_of_row, my_row)
            col_local       = translate_g2l(i-1,   size_of_col, my_col)
!            call bcast_dbl(a(1,i_1), col_local, owner_node_row,
!     &                     mpi_comm_row)
            call ddbcast_dbl(
     &                 ah(1,i_1), al(1,i_1), col_local, owner_node_row,
     &                 mpi_comm_row)

         end if
      end do


!      al(1:mband, 1:mband) = zero
      alh(1:mband,1:mband) = zeroh
      all(1:mband,1:mband) = zerol

      do i_1=mband,1,-1
         if ( ll + i_1 >= 1  ) then

            owner_node_col = get_loop_node(ll+i_1, size_of_col, my_col)
            col_local      = translate_g2l(ll+i_1, size_of_col, my_col)

            do j_1=mband,1,-1
               if ( my_col == owner_node_col ) then
!                  al(i_1,j_1) = a(col_local, j_1)
                  alh(i_1,j_1) = ah(col_local,j_1)
                  all(i_1,j_1) = al(col_local,j_1)
               endif
            end do

         end if
      end do

      j_2 = get_loop_start(1, size_of_col, my_col)
      j_3 = get_loop_end  (l, size_of_col, my_col)

!      t11 = zero; t12 = zero; t22 = zero
      t11h = zeroh; t12h = zeroh; t22h = zeroh
      t11l = zerol; t12l = zerol; t22l = zerol
      do j_1=j_2,j_3
!         a2  =a(j_1, 2)
!         a1  =a(j_1, 1)
         a2h = ah(j_1,2)
         a2l = al(j_1,2)
         a1h = ah(j_1,1)
         a1l = al(j_1,1)
!         t22 = t22 + a2 * a2
!<<<     tmp1 = a2 * a2
         t_ch = a2h * a2h
         t_u1 = 134217729.0 * a2h
         t_p1 = t_u1
     +            - (t_u1 - a2h)
         t_p2 = a2h - t_p1
         t_u1 = 134217729.0 * a2h
         t_r1 = t_u1
     +            - (t_u1 - a2h)
         t_r2 = a2h - t_r1
         t_cl = ((t_p1*t_r1
     +            - t_ch)
     +           + t_p1 * t_r2
     +           + t_p2 * t_r1)
     +           + t_p2 * t_r2
         t_cl = t_cl
     +            + (a2h*a2l
     +            +  a2l*a2h)
         t_s1 = t_ch + t_cl
         tmp1l = t_cl - (t_s1 - t_ch)
         tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>     tmp1 = a2 * a2
!<<<     t22 = t22 + tmp1
         t_p1 = t22h + tmp1h
         t_p2 = t_p1 - t22h
         t_q1 = t_p1
         t_q2 = (t22h - (t_p1 - t_p2))
     +            + (tmp1h - t_p2)
         t_q2 = t_q2 + t22l + tmp1l
         t22h = t_q1 + t_q2
         t22l = t_q2 - (t22h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>     t22 = t22 + tmp1
!         t12 = t12 + a1 * a2
!<<<     tmp1 = a1 * a2
         t_ch = a1h * a2h
         t_u1 = 134217729.0 * a1h
         t_p1 = t_u1
     +            - (t_u1 - a1h)
         t_p2 = a1h - t_p1
         t_u1 = 134217729.0 * a2h
         t_r1 = t_u1
     +            - (t_u1 - a2h)
         t_r2 = a2h - t_r1
         t_cl = ((t_p1*t_r1
     +            - t_ch)
     +           + t_p1 * t_r2
     +           + t_p2 * t_r1)
     +           + t_p2 * t_r2
         t_cl = t_cl
     +            + (a1h*a2l
     +            +  a1l*a2h)
         t_s1 = t_ch + t_cl
         tmp1l = t_cl - (t_s1 - t_ch)
         tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>     tmp1 = a1 * a2
!<<<     t12 = t12 + tmp1
         t_p1 = t12h + tmp1h
         t_p2 = t_p1 - t12h
         t_q1 = t_p1
         t_q2 = (t12h - (t_p1 - t_p2))
     +            + (tmp1h - t_p2)
         t_q2 = t_q2 + t12l + tmp1l
         t12h = t_q1 + t_q2
         t12l = t_q2 - (t12h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>     t12 = t12 + tmp1
!         t11 = t11 + a1 * a1
!<<<     tmp1 = a1 * a1
         t_ch = a1h * a1h
         t_u1 = 134217729.0 * a1h
         t_p1 = t_u1
     +            - (t_u1 - a1h)
         t_p2 = a1h - t_p1
         t_u1 = 134217729.0 * a1h
         t_r1 = t_u1
     +            - (t_u1 - a1h)
         t_r2 = a1h - t_r1
         t_cl = ((t_p1*t_r1
     +            - t_ch)
     +           + t_p1 * t_r2
     +           + t_p2 * t_r1)
     +           + t_p2 * t_r2
         t_cl = t_cl
     +            + (a1h*a1l
     +            +  a1l*a1h)
         t_s1 = t_ch + t_cl
         tmp1l = t_cl - (t_s1 - t_ch)
         tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>     tmp1 = a1 * a1
!<<<     t11 = t11 + tmp1
         t_p1 = t11h + tmp1h
         t_p2 = t_p1 - t11h
         t_q1 = t_p1
         t_q2 = (t11h - (t_p1 - t_p2))
     +            + (tmp1h - t_p2)
         t_q2 = t_q2 + t11l + tmp1l
         t11h = t_q1 + t_q2
         t11l = t_q2 - (t11h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>     t11 = t11 + tmp1
      end do

!      tt(1) =  t22
!      tt(2) =  t12
!      tt(3) =  t11
!      tt(4) =  al(2,2)
!      tt(5) =  al(1,2)
!      tt(6) =  al(2,1)
!      tt(7) =  al(1,1)
         tth(1) = t22h
         ttl(1) = t22l
         tth(2) = t12h
         ttl(2) = t12l
         tth(3) = t11h
         ttl(3) = t11l
         tth(4) = alh(2,2)
         ttl(4) = all(2,2)
         tth(5) = alh(1,2)
         ttl(5) = all(1,2)
         tth(6) = alh(2,1)
         ttl(6) = all(2,1)
         tth(7) = alh(1,1)
         ttl(7) = all(1,1)
!      call reduce_dbl(tt, ss, 7, 1, mpi_comm_col)
      call ddreduce_dbl(tth, ttl, ssh, ssl, 7, 1, mpi_comm_col)
!      ax(2,2) = tt(1)
!      ax(1,2) = tt(2)
!      ax(2,1) = ax(1,2)
!      ax(1,1) = tt(3)
!      al(2,2) = tt(4)
!      al(1,2) = tt(5)
!      al(2,1) = tt(6)
!      al(1,1) = tt(7)
         axh(2,2) = tth(1)
         axl(2,2) = ttl(1)
         axh(1,2) = tth(2)
         axl(1,2) = ttl(2)
         axh(2,1) = axh(1,2)
         axl(2,1) = axl(1,2)
         axh(1,1) = tth(3)
         axl(1,1) = ttl(3)
         alh(2,2) = tth(4)
         all(2,2) = ttl(4)
         alh(1,2) = tth(5)
         all(1,2) = ttl(5)
         alh(2,1) = tth(6)
         all(2,1) = ttl(6)
         alh(1,1) = tth(7)
         all(1,1) = ttl(7)

      do i_1=mband,1,-1
         if ( ll + i_1 >= 1  ) then

            j_2 = get_loop_start(1,      size_of_col, my_col)
            j_3 = get_loop_end  (ll+i_1, size_of_col, my_col)

            owner_node_col = get_loop_node(ll+i_1, size_of_col, my_col)
            col_local      = translate_g2l(ll+i_1, size_of_col, my_col)

            if ( i_1 == 2 ) then

!               alpha(i_1) = ax(i_1, i_1)
!               a_n        = al(i_1, i_1)
               alphah(i_1) = axh(i_1,i_1)
               alphal(i_1) = axl(i_1,i_1)
               a_nh = alh(i_1,i_1)
               a_nl = all(i_1,i_1)

               do j_1=j_2,j_3
!                  u_x(j_1, i_1) = a(j_1, i_1)
                  u_xh(j_1,i_1) = ah(j_1,i_1)
                  u_xl(j_1,i_1) = al(j_1,i_1)
               end do
            else
!               tol = 16 * ax(1, 1) * eps
!<<<           tmp1 = sixteen * ax(1,1)
               t_ch = sixteenh * axh(1,1)
               t_u1 = 134217729.0 * sixteenh
               t_p1 = t_u1
     +                  - (t_u1 - sixteenh)
               t_p2 = sixteenh - t_p1
               t_u1 = 134217729.0 * axh(1,1)
               t_r1 = t_u1
     +                  - (t_u1 - axh(1,1))
               t_r2 = axh(1,1) - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (sixteenh*axl(1,1)
     +                  +  sixteenl*axh(1,1))
               t_s1 = t_ch + t_cl
               tmp1l = t_cl - (t_s1 - t_ch)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp1 = sixteen * ax(1,1)
!<<<           tol = tmp1 * eps
               t_ch = tmp1h * epsh
               t_u1 = 134217729.0 * tmp1h
               t_p1 = t_u1
     +                  - (t_u1 - tmp1h)
               t_p2 = tmp1h - t_p1
               t_u1 = 134217729.0 * epsh
               t_r1 = t_u1
     +                  - (t_u1 - epsh)
               t_r2 = epsh - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (tmp1h*epsl
     +                  +  tmp1l*epsh)
               t_s1 = t_ch + t_cl
               toll = t_cl - (t_s1 - t_ch)
               tolh = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tol = tmp1 * eps
!               ax(1, 1) = max(zero, ax(1, 1) - al(2, 1)**2)
!<<<           tmp1 = al(2,1) * al(2,1)
               t_ch = alh(2,1) * alh(2,1)
               t_u1 = 134217729.0 * alh(2,1)
               t_p1 = t_u1
     +                  - (t_u1 - alh(2,1))
               t_p2 = alh(2,1) - t_p1
               t_u1 = 134217729.0 * alh(2,1)
               t_r1 = t_u1
     +                  - (t_u1 - alh(2,1))
               t_r2 = alh(2,1) - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (alh(2,1)*all(2,1)
     +                  +  all(2,1)*alh(2,1))
               t_s1 = t_ch + t_cl
               tmp1l = t_cl - (t_s1 - t_ch)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp1 = al(2,1) * al(2,1)
!<<<           tmp1 = ax(1,1) - tmp1
               t_p1 = axh(1,1) - tmp1h
               t_p2 = t_p1 - axh(1,1)
               t_ch = t_p1
               t_cl = (axh(1,1) - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + axl(1,1) - tmp1l
               t_s1 = t_ch + t_cl
               tmp1l = t_cl - (t_s1 - t_ch)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           tmp1 = ax(1,1) - tmp1
               if (
!                   (zero .gt. tmp1)
     +             ((zeroh .gt. tmp1h) .or.
     +              ((zeroh .eq. tmp1h) .and.
     +               (zerol .gt. tmp1l)))
     &         ) then
                  axh(1,1) = zeroh
                  axl(1,1) = zerol
               else
                  axh(1,1) = tmp1h
                  axl(1,1) = tmp1l
               endif
!               ax(1, 2) =           ax(1, 2) - al(2, 1)*al(2, 2)
!<<<           tmp1 = al(2,1) * al(2,2)
               t_ch = alh(2,1) * alh(2,2)
               t_u1 = 134217729.0 * alh(2,1)
               t_p1 = t_u1
     +                  - (t_u1 - alh(2,1))
               t_p2 = alh(2,1) - t_p1
               t_u1 = 134217729.0 * alh(2,2)
               t_r1 = t_u1
     +                  - (t_u1 - alh(2,2))
               t_r2 = alh(2,2) - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (alh(2,1)*all(2,2)
     +                  +  all(2,1)*alh(2,2))
               t_s1 = t_ch + t_cl
               tmp1l = t_cl - (t_s1 - t_ch)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp1 = al(2,1) * al(2,2)
!<<<           ax(1,2) = ax(1,2) - tmp1
               t_p1 = axh(1,2) - tmp1h
               t_p2 = t_p1 - axh(1,2)
               t_ch = t_p1
               t_cl = (axh(1,2) - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + axl(1,2) - tmp1l
               t_s1 = t_ch + t_cl
               axl(1,2) = t_cl - (t_s1 - t_ch)
               axh(1,2) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           ax(1,2) = ax(1,2) - tmp1

!               alpha(i_1) = ax(i_1, i_1)
!               a_n        = al(i_1, i_1)
               alphah(i_1) = axh(i_1,i_1)
               alphal(i_1) = axl(i_1,i_1)
               a_nh = alh(i_1,i_1)
               a_nl = all(i_1,i_1)

! singularity found, so re-calculate norm and inner products
!               if ( alpha(i_1) < tol ) then
               if ( 
!                   (alpha(i_1) .lt. tol)
     +             ((alphah(i_1) .lt. tolh) .or.
     +              ((alphah(i_1) .eq. tolh) .and.
     +               (alphal(i_1) .lt. toll)))
     &         ) then
                  do j_1=j_2,j_3
!                     u_x(j_1, 1) = a(j_1, 1)
                     u_xh(j_1,1) = ah(j_1,1)
                     u_xl(j_1,1) = al(j_1,1)
                  end do
                  do k_1=1,mband
!                     t = zero
                     th = zeroh
                     tl = zerol
                     do j_1=j_2,j_3
!                        t = t + u_x(j_1, i_1)*u_x(j_1, k_1)
!<<<                    tmp1 = u_x(j_1,i_1) * u_x(j_1,k_1)
                        t_ch = u_xh(j_1,i_1) * u_xh(j_1,k_1)
                        t_u1 = 134217729.0 * u_xh(j_1,i_1)
                        t_p1 = t_u1
     +                           - (t_u1 - u_xh(j_1,i_1))
                        t_p2 = u_xh(j_1,i_1) - t_p1
                        t_u1 = 134217729.0 * u_xh(j_1,k_1)
                        t_r1 = t_u1
     +                           - (t_u1 - u_xh(j_1,k_1))
                        t_r2 = u_xh(j_1,k_1) - t_r1
                        t_cl = ((t_p1*t_r1
     +                           - t_ch)
     +                          + t_p1 * t_r2
     +                          + t_p2 * t_r1)
     +                          + t_p2 * t_r2
                        t_cl = t_cl
     +                           + (u_xh(j_1,i_1)*u_xl(j_1,k_1)
     +                           +  u_xl(j_1,i_1)*u_xh(j_1,k_1))
                        t_s1 = t_ch + t_cl
                        tmp1l = t_cl - (t_s1 - t_ch)
                        tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>                    tmp1 = u_x(j_1,i_1) * u_x(j_1,k_1)
!<<<                    t = t + tmp1
                        t_p1 = th + tmp1h
                        t_p2 = t_p1 - th
                        t_q1 = t_p1
                        t_q2 = (th - (t_p1 - t_p2))
     +                           + (tmp1h - t_p2)
                        t_q2 = t_q2 + tl + tmp1l
                        th = t_q1 + t_q2
                        tl = t_q2 - (th - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>                    t = t + tmp1
                     enddo
!                     tt(1+k_1)=t
                     tth(1+k_1) = th
                     ttl(1+k_1) = tl
                  end do
                  if ( my_col == owner_node_col ) then
!                     a_n = a(col_local, i_1)
                     a_nh = ah(col_local,i_1)
                     a_nl = al(col_local,i_1)
                  else
!                     a_n = zero
                     a_nh = zeroh
                     a_nl = zerol
                  end if
!                  tt(1) =  a_n
                  tth(1) = a_nh
                  ttl(1) = a_nl
!                  call reduce_dbl(tt, ss, 1+mband, 1, mpi_comm_col)
                  call ddreduce_dbl(
     &                    tth, ttl, ssh, ssl, 1+mband, 1, mpi_comm_col)
!                  a_n        = tt(1)
                  a_nh = tth(1)
                  a_nl = ttl(1)
                  do k_1=1,mband
!                     ax(i_1,k_1) = tt(1+k_1)
                     axh(i_1,k_1) = tth(1+k_1)
                     axl(i_1,k_1) = ttl(1+k_1)
                  end do
                  do k_1=1,mband
                     if ( k_1 /= i_1 ) then
!                        ax(k_1,i_1) = ax(i_1,k_1)
                        axh(k_1,i_1) = axh(i_1,k_1)
                        axl(k_1,i_1) = axl(i_1,k_1)
                     end if
                  end do
!                  alpha(i_1) = ax(i_1,i_1)
                  alphah(i_1) = axh(i_1,i_1)
                  alphal(i_1) = axl(i_1,i_1)
               else
                  do j_1=j_2,j_3
!                     u_x(j_1, i_1) = a(j_1, i_1)
                     u_xh(j_1,i_1) = ah(j_1,i_1)
                     u_xl(j_1,i_1) = al(j_1,i_1)
                  end do
               end if

            endif

!            if ( alpha(i_1) > zero ) then
            if ( 
!                (alpha(i_1) .gt. zero)
     +          ((alphah(i_1) .gt. zeroh) .or.
     +           ((alphah(i_1) .eq. zeroh) .and.
     +            (alphal(i_1) .gt. zerol)))
     &      ) then

!               scale(i_1) = sqrt(alpha(i_1))
!<<<           scale(i_1) = sqrt(alpha(i_1))
               if (alphah(i_1).eq.0.0D+0.and.alphal(i_1).eq.0.0D+0) then
                 scaleh(i_1) = 0.0d+0
                 scalel(i_1) = 0.0d+0
               else
               if (alphah(i_1).lt.0.0d+0.or.
     +            (alphah(i_1).eq.0.0d+0.and.alphal(i_1).lt.0.0d+0))then
                 write(6,'(a)')
     +              'SQRT CALLED WITH NEGATIVE ARGUMENT'
                 scaleh(i_1) = 0.0d+0
                 scalel(i_1) = 0.0d+0
                 return
               endif
               t_x = 1.0D+0/sqrt(alphah(i_1))
               t_ax = alphah(i_1) * t_x
!                  call dd_mul(t_y1,t_y2,t_x,
!                              0.0,0.5,0.0)
                   t_y1 = t_x * 0.5d+0
                   t_u1 = 134217729.0 * t_x
                   t_p1 = t_u1
     +                      - (t_u1 - t_x)
                   t_p2 = t_x - t_p1
                   t_u1 = 134217729.0 * 0.5d+0
                   t_r1 = t_u1
     +                      - (t_u1 - 0.5d+0)
                   t_r2 = 0.5d+0 - t_r1
                   t_y2 = ((t_p1*t_r1
     +                      - t_y1)
     +                      + t_p1*t_r2
     +                      + t_p2 * t_r1)
     +                      + t_p2 * t_r2
                   t_s1 = t_y1 + t_y2
                   t_y2 = t_y2
     +                      - (t_s1 - t_y1)
                   t_y1 = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!                  call dd_mul(t_z1,t_z2,t_ax,
!                              0.0,t_ax,0.0)
                   t_z1 = t_ax * t_ax
                   t_u1 = 134217729.0 * t_ax
                   t_p1 = t_u1
     +                      - (t_u1 - t_ax)
                   t_p2 = t_ax - t_p1
                   t_u1 = 134217729.0 * t_ax
                   t_r1 = t_u1
     +                      - (t_u1 - t_ax)
                   t_r2 = t_ax - t_r1
                   t_z2 = ((t_p1 * t_r1
     +                      - t_z1)
     +                      + t_p1 * t_r2
     +                      + t_p2 * t_r1)
     +                      + t_p2*t_r2
                   t_s1 = t_z1 + t_z2
                   t_z2 = t_z2
     +                      - (t_s1 - t_z1)
                   t_z1 = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!                  call dd_sub(t_t2h,t_t2l,
!                           alphah(i_1),alphal(i_1),t_z1,t_z2)
                   t_p1 = alphah(i_1) - t_z1
                   t_p2 = t_p1 - alphah(i_1)
                   t_t2l = (alphah(i_1)
     +                      -(t_p1 - t_p2))
     +                      -(t_z1 + t_p2)
                   t_t2h = t_p1
                   t_t2l = t_t2l
     +                      + alphal(i_1) - t_z2
                   t_s1 = t_t2h + t_t2l
                   t_t2l = t_t2l
     +                      - (t_s1 - t_t2h)
                   t_t2h = t_s1
#ifdef FPCOUNTER
#include "fsub.h"
#endif
!                  call dd_mul(t_t1h,t_t1l,
!                              t_t2h,t_t2l,
!                              t_y1,t_y2)
                   t_t1h = t_t2h * t_y1
                   t_u1 = 134217729.0 * t_t2h
                   t_p1 = t_u1
     +                      - (t_u1 - t_t2h)
                   t_p2 = t_t2h - t_p1
                   t_u1 = 134217729.0 * t_y1
                   t_r1 = t_u1
     +                      - (t_u1 - t_y1)
                   t_r2 = t_y1 - t_r1
                   t_t1l = ((t_p1*t_r1
     +                      - t_t1h)
     +                      + t_p1*t_r2
     +                      + t_p2*t_r1)
     +                      + t_p2*t_r2
                   t_t1l = t_t1l
     +                      + (t_t2h * t_y2
     +                      +  t_t2l * t_y1)
                   t_s1 = t_t1h + t_t1l
                   t_t1l = t_t1l - (t_s1
     +                       - t_t1h)
                   t_t1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!                  call dd_selfadd(t_t1h,t_t1l,
!                              t_ax,0.0)
                   t_p1 = t_t1h + t_ax
                   t_p2 = t_p1 - t_t1h
                   t_q2 = (t_t1h
     +                      - (t_p1 - t_p2))
     +                      + (t_ax - t_p2)
                   t_q1 = t_p1
                   t_q2 = t_q2 + t_t1l
                   t_t1h = t_q1 + t_q2
                   t_t1l = t_q2
     +                       - (t_t1h - t_q1)
                   scaleh(i_1) = t_t1h
                   scalel(i_1) = t_t1l
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
               endif
!>>>           scale(i_1) = sqrt(alpha(i_1))

!----
! scaling for evading numerical instability
!----
!               t = one / scale(i_1)
!<<<           t = one / scale(i_1)
               t_q1 = oneh / scaleh(i_1)
               t_ch = scaleh(i_1) * t_q1
               t_u1 = 134217729.0 * scaleh(i_1)
               t_p1 = t_u1
     +                  - (t_u1 - scaleh(i_1))
               t_p2 = scaleh(i_1) - t_p1
               t_u1 = 134217729.0 * t_q1
               t_r1 = t_u1
     +                  - (t_u1 - t_q1)
               t_r2 = t_q1 - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                  + t_p1*t_r2
     +                  + t_p2*t_r1)
     +                  + t_p2*t_r2
               t_cl = t_cl
     +                  + (scalel(i_1) * t_q1)
               t_s1 = t_ch + t_cl
               t_cl = t_cl
     +                  - (t_s1 - t_ch)
               t_ch = t_s1
               t_s1 = oneh - t_ch
               t_r1 = t_s1 - oneh
               t_s2 = (oneh
     +                  - (t_s1 - t_r1))
     +                  - (t_ch + t_r1)
               t_s2 = t_s2 - t_cl
               t_s2 = t_s2 + onel
               t_q2 = (t_s1 + t_s2)
     +                  / scaleh(i_1)
               th = t_q1 + t_q2
               tl = t_q2
     +               - (th - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>           t = one / scale(i_1)
               do j_1=j_2,j_3
!                  u_x(j_1, i_1) = u_x(j_1, i_1) * t
!<<<              u_x(j_1,i_1) = u_x(j_1,i_1) * t
                  t_ch = u_xh(j_1,i_1) * th
                  t_u1 = 134217729.0 * u_xh(j_1,i_1)
                  t_p1 = t_u1
     +                     - (t_u1 - u_xh(j_1,i_1))
                  t_p2 = u_xh(j_1,i_1) - t_p1
                  t_u1 = 134217729.0 * th
                  t_r1 = t_u1
     +                     - (t_u1 - th)
                  t_r2 = th - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (u_xh(j_1,i_1)*tl
     +                     +  u_xl(j_1,i_1)*th)
                  t_s1 = t_ch + t_cl
                  u_xl(j_1,i_1) = t_cl - (t_s1 - t_ch)
                  u_xh(j_1,i_1) = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              u_x(j_1,i_1) = u_x(j_1,i_1) * t
               end do
               do k_1 = 1, mband
!                  al (k_1, i_1) = al (k_1, i_1) * t
!                  ax (k_1, i_1) = ax (k_1, i_1) * t
!                  ax (i_1, k_1) = ax (i_1, k_1) * t
!<<<              al(k_1,i_1) = al(k_1,i_1) * t
                  t_ch = alh(k_1,i_1) * th
                  t_u1 = 134217729.0 * alh(k_1,i_1)
                  t_p1 = t_u1
     +                     - (t_u1 - alh(k_1,i_1))
                  t_p2 = alh(k_1,i_1) - t_p1
                  t_u1 = 134217729.0 * th
                  t_r1 = t_u1
     +                     - (t_u1 - th)
                  t_r2 = th - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (alh(k_1,i_1)*tl
     +                     +  all(k_1,i_1)*th)
                  t_s1 = t_ch + t_cl
                  all(k_1,i_1) = t_cl - (t_s1 - t_ch)
                  alh(k_1,i_1) = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              al(k_1,i_1) = al(k_1,i_1) * t
!<<<              ax(k_1,i_1) = ax(k_1,i_1) * t
                  t_ch = axh(k_1,i_1) * th
                  t_u1 = 134217729.0 * axh(k_1,i_1)
                  t_p1 = t_u1
     +                     - (t_u1 - axh(k_1,i_1))
                  t_p2 = axh(k_1,i_1) - t_p1
                  t_u1 = 134217729.0 * th
                  t_r1 = t_u1
     +                     - (t_u1 - th)
                  t_r2 = th - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (axh(k_1,i_1)*tl
     +                     +  axl(k_1,i_1)*th)
                  t_s1 = t_ch + t_cl
                  axl(k_1,i_1) = t_cl - (t_s1 - t_ch)
                  axh(k_1,i_1) = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              ax(k_1,i_1) = ax(k_1,i_1) * t
!<<<              ax(i_1,k_1) = ax(i_1,k_1) * t
                  t_ch = axh(i_1,k_1) * th
                  t_u1 = 134217729.0 * axh(i_1,k_1)
                  t_p1 = t_u1
     +                     - (t_u1 - axh(i_1,k_1))
                  t_p2 = axh(i_1,k_1) - t_p1
                  t_u1 = 134217729.0 * th
                  t_r1 = t_u1
     +                     - (t_u1 - th)
                  t_r2 = th - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (axh(i_1,k_1)*tl
     +                     +  axl(i_1,k_1)*th)
                  t_s1 = t_ch + t_cl
                  axl(i_1,k_1) = t_cl - (t_s1 - t_ch)
                  axh(i_1,k_1) = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              ax(i_1,k_1) = ax(i_1,k_1) * t
               end do

!               a_n          =  a_n * t
!<<<           a_n = a_n * t
               t_ch = a_nh * th
               t_u1 = 134217729.0 * a_nh
               t_p1 = t_u1
     +                  - (t_u1 - a_nh)
               t_p2 = a_nh - t_p1
               t_u1 = 134217729.0 * th
               t_r1 = t_u1
     +                  - (t_u1 - th)
               t_r2 = th - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (a_nh*tl
     +                  +  a_nl*th)
               t_s1 = t_ch + t_cl
               a_nl = t_cl - (t_s1 - t_ch)
               a_nh = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           a_n = a_n * t
!               g_n(i_1)     = -sign(one, a_n)
!<<<           tmp1 = abs(one)
               if (oneh .lt. 0.0d+0) then
                 tmp1h = -oneh
                 tmp1l = -onel
               elseif (
     +           (oneh .eq. 0.0d+0).and.
     +           (onel .lt. 0.0d+0)) then
                 tmp1h = oneh
                 tmp1l = -onel
               else
                 tmp1h = oneh
                 tmp1l = onel
               endif
!>>>           tmp1 = abs(one)
                if (
!                   (a_n .ge. 0.0)
     +             ((a_nh .gt. 0.0d+0) .or.
     +              ((a_nh .eq. 0.0d+0) .and.
     +               (a_nl .ge. 0.0d+0)))
     &          ) then
!<<<              g_n(i_1) = -tmp1
                  g_nh(i_1) = -tmp1h
                  g_nl(i_1) = -tmp1l
!>>>              g_n(i_1) = -tmp1
                else
                  g_nh(i_1) = tmp1h
                  g_nl(i_1) = tmp1l
                endif
!               beta(i_1)    =  one - a_n * g_n(i_1)
!<<<           tmp1 = a_n * g_n(i_1)
               t_ch = a_nh * g_nh(i_1)
               t_u1 = 134217729.0 * a_nh
               t_p1 = t_u1
     +                  - (t_u1 - a_nh)
               t_p2 = a_nh - t_p1
               t_u1 = 134217729.0 * g_nh(i_1)
               t_r1 = t_u1
     +                  - (t_u1 - g_nh(i_1))
               t_r2 = g_nh(i_1) - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (a_nh*g_nl(i_1)
     +                  +  a_nl*g_nh(i_1))
               t_s1 = t_ch + t_cl
               tmp1l = t_cl - (t_s1 - t_ch)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           tmp1 = a_n * g_n(i_1)
!<<<           beta(i_1) = one - tmp1
               t_p1 = oneh - tmp1h
               t_p2 = t_p1 - oneh
               t_ch = t_p1
               t_cl = (oneh - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + onel - tmp1l
               t_s1 = t_ch + t_cl
               betal(i_1) = t_cl - (t_s1 - t_ch)
               betah(i_1) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           beta(i_1) = one - tmp1
!               al(i_1, i_1) =  a_n - g_n(i_1)
!<<<           al(i_1,i_1) = a_n - g_n(i_1)
               t_p1 = a_nh - g_nh(i_1)
               t_p2 = t_p1 - a_nh
               t_ch = t_p1
               t_cl = (a_nh - (t_p1 - t_p2))
     +                  - (g_nh(i_1) + t_p2)
               t_cl = t_cl + a_nl - g_nl(i_1)
               t_s1 = t_ch + t_cl
               all(i_1,i_1) = t_cl - (t_s1 - t_ch)
               alh(i_1,i_1) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           al(i_1,i_1) = a_n - g_n(i_1)

               if ( my_col == owner_node_col ) then
!                  u_x(col_local, i_1) =  al(i_1, i_1)
                  u_xh(col_local,i_1) = alh(i_1,i_1)
                  u_xl(col_local,i_1) = all(i_1,i_1)
               end if

               do k_1=1,i_1-1
!                  ax(k_1, i_1) = ax(k_1, i_1) - g_n(i_1) * al(i_1, k_1)
!                  ax(i_1, k_1) = ax(k_1, i_1)
!<<<              tmp1 = g_n(i_1) * al(i_1,k_1)
                  t_ch = g_nh(i_1) * alh(i_1,k_1)
                  t_u1 = 134217729.0 * g_nh(i_1)
                  t_p1 = t_u1
     +                     - (t_u1 - g_nh(i_1))
                  t_p2 = g_nh(i_1) - t_p1
                  t_u1 = 134217729.0 * alh(i_1,k_1)
                  t_r1 = t_u1
     +                     - (t_u1 - alh(i_1,k_1))
                  t_r2 = alh(i_1,k_1) - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (g_nh(i_1)*all(i_1,k_1)
     +                     +  g_nl(i_1)*alh(i_1,k_1))
                  t_s1 = t_ch + t_cl
                  tmp1l = t_cl - (t_s1 - t_ch)
                  tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp1 = g_n(i_1) * al(i_1,k_1)
!<<<              ax(k_1,i_1) = ax(k_1,i_1) - tmp1
                  t_p1 = axh(k_1,i_1) - tmp1h
                  t_p2 = t_p1 - axh(k_1,i_1)
                  t_ch = t_p1
                  t_cl = (axh(k_1,i_1) - (t_p1 - t_p2))
     +                     - (tmp1h + t_p2)
                  t_cl = t_cl + axl(k_1,i_1) - tmp1l
                  t_s1 = t_ch + t_cl
                  axl(k_1,i_1) = t_cl - (t_s1 - t_ch)
                  axh(k_1,i_1) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>              ax(k_1,i_1) = ax(k_1,i_1) - tmp1
                  axh(i_1,k_1) = axh(k_1,i_1)
                  axl(i_1,k_1) = axl(k_1,i_1)
               end do
!               ax(i_1, i_1) = 2 * beta(i_1)
!<<<           ax(i_1,i_1) = two * beta(i_1)
               t_ch = twoh * betah(i_1)
               t_u1 = 134217729.0 * twoh
               t_p1 = t_u1
     +                  - (t_u1 - twoh)
               t_p2 = twoh - t_p1
               t_u1 = 134217729.0 * betah(i_1)
               t_r1 = t_u1
     +                  - (t_u1 - betah(i_1))
               t_r2 = betah(i_1) - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (twoh*betal(i_1)
     +                  +  twol*betah(i_1))
               t_s1 = t_ch + t_cl
               axl(i_1,i_1) = t_cl - (t_s1 - t_ch)
               axh(i_1,i_1) = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           ax(i_1,i_1) = two * beta(i_1)
               do k_1=i_1+1, mband
!                  ax(i_1, k_1) = ax(i_1, k_1) - g_n(i_1) * al(i_1, k_1)
!                  ax(k_1, i_1) = ax(i_1, k_1)
!<<<              tmp1 = g_n(i_1) * al(i_1,k_1)
                  t_ch = g_nh(i_1) * alh(i_1,k_1)
                  t_u1 = 134217729.0 * g_nh(i_1)
                  t_p1 = t_u1
     +                     - (t_u1 - g_nh(i_1))
                  t_p2 = g_nh(i_1) - t_p1
                  t_u1 = 134217729.0 * alh(i_1,k_1)
                  t_r1 = t_u1
     +                     - (t_u1 - alh(i_1,k_1))
                  t_r2 = alh(i_1,k_1) - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (g_nh(i_1)*all(i_1,k_1)
     +                     +  g_nl(i_1)*alh(i_1,k_1))
                  t_s1 = t_ch + t_cl
                  tmp1l = t_cl - (t_s1 - t_ch)
                  tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              tmp1 = g_n(i_1) * al(i_1,k_1)
!<<<              ax(i_1,k_1) = ax(i_1,k_1) - tmp1
                  t_p1 = axh(i_1,k_1) - tmp1h
                  t_p2 = t_p1 - axh(i_1,k_1)
                  t_ch = t_p1
                  t_cl = (axh(i_1,k_1) - (t_p1 - t_p2))
     +                     - (tmp1h + t_p2)
                  t_cl = t_cl + axl(i_1,k_1) - tmp1l
                  t_s1 = t_ch + t_cl
                  axl(i_1,k_1) = t_cl - (t_s1 - t_ch)
                  axh(i_1,k_1) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>              ax(i_1,k_1) = ax(i_1,k_1) - tmp1
                  axh(k_1,i_1) = axh(i_1,k_1)
                  axl(k_1,i_1) = axl(i_1,k_1)
               end do

               do k_1=1,i_1-1
!                  t            = ax(k_1, i_1) / beta(i_1)
!<<<              t = ax(k_1,i_1) / beta(i_1)
                  t_q1 = axh(k_1,i_1) / betah(i_1)
                  t_ch = betah(i_1) * t_q1
                  t_u1 = 134217729.0 * betah(i_1)
                  t_p1 = t_u1
     +                     - (t_u1 - betah(i_1))
                  t_p2 = betah(i_1) - t_p1
                  t_u1 = 134217729.0 * t_q1
                  t_r1 = t_u1
     +                     - (t_u1 - t_q1)
                  t_r2 = t_q1 - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                     + t_p1*t_r2
     +                     + t_p2*t_r1)
     +                     + t_p2*t_r2
                  t_cl = t_cl
     +                     + (betal(i_1) * t_q1)
                  t_s1 = t_ch + t_cl
                  t_cl = t_cl
     +                     - (t_s1 - t_ch)
                  t_ch = t_s1
                  t_s1 = axh(k_1,i_1) - t_ch
                  t_r1 = t_s1 - axh(k_1,i_1)
                  t_s2 = (axh(k_1,i_1)
     +                     - (t_s1 - t_r1))
     +                     - (t_ch + t_r1)
                  t_s2 = t_s2 - t_cl
                  t_s2 = t_s2 + axl(k_1,i_1)
                  t_q2 = (t_s1 + t_s2)
     +                     / betah(i_1)
                  th = t_q1 + t_q2
                  tl = t_q2
     +                  - (th - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>              t = ax(k_1,i_1) / beta(i_1)
                  j_2 = get_loop_start(1,      size_of_col, my_col)
                  j_3 = get_loop_end  (ll+i_1, size_of_col, my_col)
                  do j_1=j_2,j_3
!                     a (j_1, k_1) = a (j_1, k_1) - t * u_x(j_1, i_1)
!<<<                 tmp1 = t * u_x(j_1,i_1)
                     t_ch = th * u_xh(j_1,i_1)
                     t_u1 = 134217729.0 * th
                     t_p1 = t_u1
     +                        - (t_u1 - th)
                     t_p2 = th - t_p1
                     t_u1 = 134217729.0 * u_xh(j_1,i_1)
                     t_r1 = t_u1
     +                        - (t_u1 - u_xh(j_1,i_1))
                     t_r2 = u_xh(j_1,i_1) - t_r1
                     t_cl = ((t_p1*t_r1
     +                        - t_ch)
     +                       + t_p1 * t_r2
     +                       + t_p2 * t_r1)
     +                       + t_p2 * t_r2
                     t_cl = t_cl
     +                        + (th*u_xl(j_1,i_1)
     +                        +  tl*u_xh(j_1,i_1))
                     t_s1 = t_ch + t_cl
                     tmp1l = t_cl - (t_s1 - t_ch)
                     tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>                 tmp1 = t * u_x(j_1,i_1)
!<<<                 a(j_1,k_1) = a(j_1,k_1) - tmp1
                     t_p1 = ah(j_1,k_1) - tmp1h
                     t_p2 = t_p1 - ah(j_1,k_1)
                     t_ch = t_p1
                     t_cl = (ah(j_1,k_1) - (t_p1 - t_p2))
     +                        - (tmp1h + t_p2)
                     t_cl = t_cl + al(j_1,k_1) - tmp1l
                     t_s1 = t_ch + t_cl
                     al(j_1,k_1) = t_cl - (t_s1 - t_ch)
                     ah(j_1,k_1) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>                 a(j_1,k_1) = a(j_1,k_1) - tmp1
                  end do! j_1
                  do j_1=1,i_1
!                     al(j_1, k_1) = al(j_1, k_1) - t * al (j_1, i_1)
!<<<                 tmp1 = t * al(j_1,i_1)
                     t_ch = th * alh(j_1,i_1)
                     t_u1 = 134217729.0 * th
                     t_p1 = t_u1
     +                        - (t_u1 - th)
                     t_p2 = th - t_p1
                     t_u1 = 134217729.0 * alh(j_1,i_1)
                     t_r1 = t_u1
     +                        - (t_u1 - alh(j_1,i_1))
                     t_r2 = alh(j_1,i_1) - t_r1
                     t_cl = ((t_p1*t_r1
     +                        - t_ch)
     +                       + t_p1 * t_r2
     +                       + t_p2 * t_r1)
     +                       + t_p2 * t_r2
                     t_cl = t_cl
     +                        + (th*all(j_1,i_1)
     +                        +  tl*alh(j_1,i_1))
                     t_s1 = t_ch + t_cl
                     tmp1l = t_cl - (t_s1 - t_ch)
                     tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>                 tmp1 = t * al(j_1,i_1)
!<<<                 al(j_1,k_1) = al(j_1,k_1) - tmp1
                     t_p1 = alh(j_1,k_1) - tmp1h
                     t_p2 = t_p1 - alh(j_1,k_1)
                     t_ch = t_p1
                     t_cl = (alh(j_1,k_1) - (t_p1 - t_p2))
     +                        - (tmp1h + t_p2)
                     t_cl = t_cl + all(j_1,k_1) - tmp1l
                     t_s1 = t_ch + t_cl
                     all(j_1,k_1) = t_cl - (t_s1 - t_ch)
                     alh(j_1,k_1) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>                 al(j_1,k_1) = al(j_1,k_1) - tmp1
                  end do
!                  ax(k_1, i_1) = - ax(k_1, i_1)
!                  ax(i_1, k_1) =   ax(k_1, i_1)
!<<<                 ax(k_1,i_1) = -ax(k_1,i_1)
                     axh(k_1,i_1) = -axh(k_1,i_1)
                     axl(k_1,i_1) = -axl(k_1,i_1)
!>>>                 ax(k_1,i_1) = -ax(k_1,i_1)
                     axh(i_1,k_1) = axh(k_1,i_1)
                     axl(i_1,k_1) = axl(k_1,i_1)
               end do

            end if

         end if
      end do
!----
      do i_1=1,mband
         if ( ll + i_1 >= 1  ) then
!----
! scaling back
!----
!            if ( alpha(i_1) > zero ) then
            if (
!               alpha(i_1) > zero
!                (alpha(i_1) .gt. zero)
     +          ((alphah(i_1) .gt. zeroh) .or.
     +           ((alphah(i_1) .eq. zeroh) .and.
     +            (alphal(i_1) .gt. zerol)))
     &      ) then
!               g_n(i_1)   = g_n(i_1)  * scale(i_1)
!               beta(i_1)  = beta(i_1) * alpha(i_1)
!<<<           g_n(i_1) = g_n(i_1) * scale(i_1)
               t_ch = g_nh(i_1) * scaleh(i_1)
               t_u1 = 134217729.0 * g_nh(i_1)
               t_p1 = t_u1
     +                  - (t_u1 - g_nh(i_1))
               t_p2 = g_nh(i_1) - t_p1
               t_u1 = 134217729.0 * scaleh(i_1)
               t_r1 = t_u1
     +                  - (t_u1 - scaleh(i_1))
               t_r2 = scaleh(i_1) - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (g_nh(i_1)*scalel(i_1)
     +                  +  g_nl(i_1)*scaleh(i_1))
               t_s1 = t_ch + t_cl
               g_nl(i_1) = t_cl - (t_s1 - t_ch)
               g_nh(i_1) = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           g_n(i_1) = g_n(i_1) * scale(i_1)
!<<<           beta(i_1) = beta(i_1) * alpha(i_1)
               t_ch = betah(i_1) * alphah(i_1)
               t_u1 = 134217729.0 * betah(i_1)
               t_p1 = t_u1
     +                  - (t_u1 - betah(i_1))
               t_p2 = betah(i_1) - t_p1
               t_u1 = 134217729.0 * alphah(i_1)
               t_r1 = t_u1
     +                  - (t_u1 - alphah(i_1))
               t_r2 = alphah(i_1) - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (betah(i_1)*alphal(i_1)
     +                  +  betal(i_1)*alphah(i_1))
               t_s1 = t_ch + t_cl
               betal(i_1) = t_cl - (t_s1 - t_ch)
               betah(i_1) = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           beta(i_1) = beta(i_1) * alpha(i_1)
            else
!               g_n(i_1)   = zero
!               beta(i_1)  = one
               g_nh(i_1) = zeroh
               g_nl(i_1) = zerol
               betah(i_1) = oneh
               betal(i_1) = onel
            endif
            j_2 = get_loop_start(1,      size_of_col, my_col)
            j_3 = get_loop_end  (ll+i_1, size_of_col, my_col)
!            t = scale(i_1)
            th = scaleh(i_1)
            tl = scalel(i_1)
            do j_1=j_2,j_3
!               u_x(j_1, i_1) = u_x(j_1, i_1) * t
!<<<           u_x(j_1,i_1) = u_x(j_1,i_1) * t
               t_ch = u_xh(j_1,i_1) * th
               t_u1 = 134217729.0 * u_xh(j_1,i_1)
               t_p1 = t_u1
     +                  - (t_u1 - u_xh(j_1,i_1))
               t_p2 = u_xh(j_1,i_1) - t_p1
               t_u1 = 134217729.0 * th
               t_r1 = t_u1
     +                  - (t_u1 - th)
               t_r2 = th - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (u_xh(j_1,i_1)*tl
     +                  +  u_xl(j_1,i_1)*th)
               t_s1 = t_ch + t_cl
               u_xl(j_1,i_1) = t_cl - (t_s1 - t_ch)
               u_xh(j_1,i_1) = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           u_x(j_1,i_1) = u_x(j_1,i_1) * t
            end do
         end if
      end do
!----
      owner_node_row = get_loop_node(i, size_of_row, my_row)
      if ( owner_node_row == my_row ) then
         if ( i > 2 ) then
            owner_node_col = get_loop_node(i-2, size_of_col, my_col)
            if ( owner_node_col == my_col ) then
               col_local = translate_g2l(i-2, size_of_col, my_col)
!               e(i-1, 1) = a(col_local, 1)
               eh(i-1,1) = ah(col_local,1)
               el(i-1,1) = al(col_local,1)
            end if
         end if
         if ( i > 1 ) then
            owner_node_col = get_loop_node(i-1, size_of_col, my_col)
            if ( owner_node_col == my_col ) then
               col_local = translate_g2l(i-1, size_of_col, my_col)
!               e(i, 1) = a(col_local, 2)
               eh(i,1) = ah(col_local,2)
               el(i,1) = al(col_local,2)
            end if
         end if
         owner_node_col = get_loop_node(i,   size_of_col, my_col)
         if ( owner_node_col == my_col ) then
!            e(i-1, 2) = g_n(1)
!            e(i  , 2) = g_n(2)
            eh(i-1,2) = g_nh(1)
            el(i-1,2) = g_nl(1)
            eh(i,2) = g_nh(2)
            el(i,2) = g_nl(2)
         end if
      end if

      do i_1=1,mband
         if ( ll + i_1 >= 1  ) then
            j_2 = get_loop_start(ll+i_1+1, size_of_col, my_col)
            j_3 = get_loop_end  (i-1,      size_of_col, my_col)
!            u_x(j_2:j_3,i_1) = zero
            u_xh(j_2:j_3,i_1) = zeroh
            u_xl(j_2:j_3,i_1) = zerol

            j_3 = get_loop_end  (ll+i_1+mband-1, size_of_col, my_col)
!            a(1:j_3,i_1) = u_x(1:j_3,i_1)
            ah(1:j_3,i_1) = u_xh(1:j_3,i_1)
            al(1:j_3,i_1) = u_xl(1:j_3,i_1)
         end if
      end do
      col_local = translate_g2l(i-1, size_of_col, my_col)
      if ( mod(mband,2)==1 ) then; i_1 = 1
!         call datacast_dbl(u_y(1, i_1),u_x(1, i_1),u_t,v_t,col_local)
         call dddatacast_dbl(
     &               u_yh(1,i_1), u_yl(1,i_1), u_xh(1,i_1), u_xl(1,i_1),
     &               u_th, u_tl, v_th, v_tl, col_local)
      end if
      do i_1=mod(mband,2)+1,mband,2
!         call datacast_dbl2(u_y(1, i_1),u_y(1, i_1+1),
!     &                      u_x(1, i_1),u_x(1, i_1+1),u_t,v_t,col_local)
         call dddatacast_dbl2(
     &            u_yh(1,i_1),u_yl(1,i_1),u_yh(1,i_1+1),u_yl(1,i_1+1),
     &            u_xh(1,i_1),u_xl(1,i_1),u_xh(1,i_1+1),u_xl(1,i_1+1),
     &            u_th,u_tl,v_th,v_tl,col_local)
      end do

!      c(1:mband, 1:mband) = zero
      ch(1:mband,1:mband) = zeroh
      cl(1:mband,1:mband) = zerol
      do i_1=1,mband
!         c(i_1, i_1) = one / beta(i_1)
!<<<     c(i_1,i_1) = one / beta(i_1)
         t_q1 = oneh / betah(i_1)
         t_ch = betah(i_1) * t_q1
         t_u1 = 134217729.0 * betah(i_1)
         t_p1 = t_u1
     +            - (t_u1 - betah(i_1))
         t_p2 = betah(i_1) - t_p1
         t_u1 = 134217729.0 * t_q1
         t_r1 = t_u1
     +            - (t_u1 - t_q1)
         t_r2 = t_q1 - t_r1
         t_cl = ((t_p1*t_r1
     +            - t_ch)
     +            + t_p1*t_r2
     +            + t_p2*t_r1)
     +            + t_p2*t_r2
         t_cl = t_cl
     +            + (betal(i_1) * t_q1)
         t_s1 = t_ch + t_cl
         t_cl = t_cl
     +            - (t_s1 - t_ch)
         t_ch = t_s1
         t_s1 = oneh - t_ch
         t_r1 = t_s1 - oneh
         t_s2 = (oneh
     +            - (t_s1 - t_r1))
     +            - (t_ch + t_r1)
         t_s2 = t_s2 - t_cl
         t_s2 = t_s2 + onel
         t_q2 = (t_s1 + t_s2)
     +            / betah(i_1)
         ch(i_1,i_1) = t_q1 + t_q2
         cl(i_1,i_1) = t_q2
     +         - (ch(i_1,i_1) - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>     c(i_1,i_1) = one / beta(i_1)
      end do
      do i_1=1,mband
         do j_1=1,i_1-1
!            c(j_1,i_1) = ax(j_1,i_1)*scale(j_1)*scale(i_1)
!<<<        tmp1 = scale(j_1) * scale(i_1)
            t_ch = scaleh(j_1) * scaleh(i_1)
            t_u1 = 134217729.0 * scaleh(j_1)
            t_p1 = t_u1
     +               - (t_u1 - scaleh(j_1))
            t_p2 = scaleh(j_1) - t_p1
            t_u1 = 134217729.0 * scaleh(i_1)
            t_r1 = t_u1
     +               - (t_u1 - scaleh(i_1))
            t_r2 = scaleh(i_1) - t_r1
            t_cl = ((t_p1*t_r1
     +               - t_ch)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            t_cl = t_cl
     +               + (scaleh(j_1)*scalel(i_1)
     +               +  scalel(j_1)*scaleh(i_1))
            t_s1 = t_ch + t_cl
            tmp1l = t_cl - (t_s1 - t_ch)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>        tmp1 = scale(j_1) * scale(i_1)
!<<<        c(j_1,i_1) = ax(j_1,i_1) * tmp1
            t_ch = axh(j_1,i_1) * tmp1h
            t_u1 = 134217729.0 * axh(j_1,i_1)
            t_p1 = t_u1
     +               - (t_u1 - axh(j_1,i_1))
            t_p2 = axh(j_1,i_1) - t_p1
            t_u1 = 134217729.0 * tmp1h
            t_r1 = t_u1
     +               - (t_u1 - tmp1h)
            t_r2 = tmp1h - t_r1
            t_cl = ((t_p1*t_r1
     +               - t_ch)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            t_cl = t_cl
     +               + (axh(j_1,i_1)*tmp1l
     +               +  axl(j_1,i_1)*tmp1h)
            t_s1 = t_ch + t_cl
            cl(j_1,i_1) = t_cl - (t_s1 - t_ch)
            ch(j_1,i_1) = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>        c(j_1,i_1) = ax(j_1,i_1) * tmp1
         end do
      end do

      return
!      end subroutine eigen_prd_u
      end subroutine ddeigen_prd_u

