!      subroutine eigen_prd_v(u_x, v_x, v_y, nv, u_t, v_t, c, i)
      subroutine ddeigen_prd_v(
     &     u_xh,u_xl,v_xh,v_xl,v_yh,v_yl,nv,u_th,u_tl,v_th,v_tl,ch,cl,i)
!----
!      use communication_sx, only : reduce_dbl
!     &                           , datacast_dbl
!     &                           , translate_g2l
!     &                           , get_loop_start
!     &                           , get_loop_end
!     &                           , get_loop_node
      use ddcommunication_sx, only : ddreduce_dbl
     &                             , dddatacast_dbl
     &                             , translate_g2l
     &                             , get_loop_start
     &                             , get_loop_end
     &                             , get_loop_node
!----
      implicit none

      integer, intent(in)    :: nv, i
!      real(8), intent(in)    :: u_x(1:nv,*)
!      real(8), intent(inout) :: v_x(1:nv,*), v_y(1:nv,*)
!      real(8), intent(out)   :: u_t(*), v_t(*)
!      real(8), intent(inout) :: c(2,2)
      real(8), intent(in)    :: u_xh(1:nv,*), u_xl(1:nv,*)
      real(8), intent(inout) :: v_xh(1:nv,*), v_yh(1:nv,*)
      real(8), intent(inout) :: v_xl(1:nv,*), v_yl(1:nv,*)
      real(8), intent(out)   :: u_th(*), v_th(*)
      real(8), intent(out)   :: u_tl(*), v_tl(*)
      real(8), intent(inout) :: ch(2,2), cl(2,2)

!      real(8)                ::  tt(4), ss(4)
!      real(8)                ::  s11,s12,s21,s22
!      real(8)                ::  c11,c12,c21,c22
!      real(8)                ::  u12
!      real(8)                ::  sx(2,2), tx(2,2)
!      real(8)                ::  u1, u2
!      real(8)                ::  v1, v2
      real(8)                ::  tth(4), ttl(4), ssh(4), ssl(4)
      real(8)                ::  s11h,s12h,s21h,s22h
      real(8)                ::  s11l,s12l,s21l,s22l
      real(8)                ::  c11h,c12h,c21h,c22h
      real(8)                ::  c11l,c12l,c21l,c22l
      real(8)                ::  u12h, u12l
      real(8)                ::  sxh(2,2), txh(2,2)
      real(8)                ::  sxl(2,2), txl(2,2)
      real(8)                ::  u1h, u1l, u2h, u2l
      real(8)                ::  v1h, v1l, v2h, v2l


      integer                ::  col_local, owner_node_col
      integer                ::  row_local, owner_node_row
      integer                ::  j_1, j_2, j_3
      integer                ::  l
      integer                ::  n, ll, jj_2, jj_3

!---- integer, parameter     ::  vtol = 512
      integer, parameter     ::  vtol = 51200

      double precision tmp1h, tmp1l
      double precision tmp2h, tmp2l
      double precision t_twoh, t_twol
!     tmp vars
      double precision t_ch, t_cl
      double precision t_p1, t_p2
      double precision t_q1, t_q2
      double precision t_r1, t_r2
      double precision t_s1, t_s2
      double precision t_t1, t_t2
      double precision t_u1, t_u2
      double precision t_x1, t_x2
      double precision t_y1, t_y2
      double precision t_z1, t_z2
      double precision t_x, t_ax
      double precision t_t1h, t_t1l
      double precision t_t2h, t_t2l

      include 'trd.h'
      include 'param.h'

      t_twoh = 2.0d0
      t_twol = 0.0d+0


      l = i-2

      owner_node_col = get_loop_node (l, size_of_col,my_col)
      owner_node_row = get_loop_node (i, size_of_row,my_row)

      col_local       = translate_g2l(l, size_of_col,my_col)
      row_local       = translate_g2l(i, size_of_row,my_row)

      j_2         = get_loop_start(1, size_of_col,my_col)
      j_3         = get_loop_end  (l, size_of_col,my_col)

      n = j_3-j_2+1
      ll = (n-1)/size_of_row+1
      ll = ((ll-1)/2+1)*2

      if ( n > vtol ) then
         jj_2 = j_2+(1+ll*(my_row-1))-1
         jj_3 = j_2+(min(n,ll*my_row))-1
      else
         jj_2 = j_2
         jj_3 = j_3
      end if

! s:=v^tu=u^tau
!      s11 = zero
!      s12 = zero
!      s22 = zero
!      u12 = zero
      s11h = zeroh
      s11l = zerol
      s12h = zeroh
      s12l = zerol
      s22h = zeroh
      s22l = zerol
      u12h = zeroh
      u12l = zerol
!dir$ unroll(2)
!dir$ ivdep
!dir$ vector always
      do j_1=jj_2,jj_3
!         v1 = v_x(j_1,1)
!         v2 = v_x(j_1,2)
!         u1 = u_x(j_1,1)
!         u2 = u_x(j_1,2)
         v1h = v_xh(j_1,1)
         v1l = v_xl(j_1,1)
         v2h = v_xh(j_1,2)
         v2l = v_xl(j_1,2)
         u1h = u_xh(j_1,1)
         u1l = u_xl(j_1,1)
         u2h = u_xh(j_1,2)
         u2l = u_xl(j_1,2)
!         s11  = s11 + v1 * u1
!         s12  = s12 + v1 * u2
!         s22  = s22 + v2 * u2
!<<<     tmp1 = v1 * u1
         t_ch = v1h * u1h
         t_u1 = 134217729.0 * v1h
         t_p1 = t_u1
     +            - (t_u1 - v1h)
         t_p2 = v1h - t_p1
         t_u1 = 134217729.0 * u1h
         t_r1 = t_u1
     +            - (t_u1 - u1h)
         t_r2 = u1h - t_r1
         t_cl = ((t_p1*t_r1
     +            - t_ch)
     +           + t_p1 * t_r2
     +           + t_p2 * t_r1)
     +           + t_p2 * t_r2
         t_cl = t_cl
     +            + (v1h*u1l
     +            +  v1l*u1h)
         t_s1 = t_ch + t_cl
         tmp1l = t_cl - (t_s1 - t_ch)
         tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>     tmp1 = v1 * u1
!<<<     s11 = s11 + tmp1
         t_p1 = s11h + tmp1h
         t_p2 = t_p1 - s11h
         t_q1 = t_p1
         t_q2 = (s11h - (t_p1 - t_p2))
     +            + (tmp1h - t_p2)
         t_q2 = t_q2 + s11l + tmp1l
         s11h = t_q1 + t_q2
         s11l = t_q2 - (s11h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>     s11 = s11 + tmp1
!<<<     tmp1 = v1 * u2
         t_ch = v1h * u2h
         t_u1 = 134217729.0 * v1h
         t_p1 = t_u1
     +            - (t_u1 - v1h)
         t_p2 = v1h - t_p1
         t_u1 = 134217729.0 * u2h
         t_r1 = t_u1
     +            - (t_u1 - u2h)
         t_r2 = u2h - t_r1
         t_cl = ((t_p1*t_r1
     +            - t_ch)
     +           + t_p1 * t_r2
     +           + t_p2 * t_r1)
     +           + t_p2 * t_r2
         t_cl = t_cl
     +            + (v1h*u2l
     +            +  v1l*u2h)
         t_s1 = t_ch + t_cl
         tmp1l = t_cl - (t_s1 - t_ch)
         tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>     tmp1 = v1 * u2
!<<<     s12 = s12 + tmp1
         t_p1 = s12h + tmp1h
         t_p2 = t_p1 - s12h
         t_q1 = t_p1
         t_q2 = (s12h - (t_p1 - t_p2))
     +            + (tmp1h - t_p2)
         t_q2 = t_q2 + s12l + tmp1l
         s12h = t_q1 + t_q2
         s12l = t_q2 - (s12h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>     s12 = s12 + tmp1
!<<<     tmp1 = v2 * u2
         t_ch = v2h * u2h
         t_u1 = 134217729.0 * v2h
         t_p1 = t_u1
     +            - (t_u1 - v2h)
         t_p2 = v2h - t_p1
         t_u1 = 134217729.0 * u2h
         t_r1 = t_u1
     +            - (t_u1 - u2h)
         t_r2 = u2h - t_r1
         t_cl = ((t_p1*t_r1
     +            - t_ch)
     +           + t_p1 * t_r2
     +           + t_p2 * t_r1)
     +           + t_p2 * t_r2
         t_cl = t_cl
     +            + (v2h*u2l
     +            +  v2l*u2h)
         t_s1 = t_ch + t_cl
         tmp1l = t_cl - (t_s1 - t_ch)
         tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>     tmp1 = v2 * u2
!<<<     s22 = s22 + tmp1
         t_p1 = s22h + tmp1h
         t_p2 = t_p1 - s22h
         t_q1 = t_p1
         t_q2 = (s22h - (t_p1 - t_p2))
     +            + (tmp1h - t_p2)
         t_q2 = t_q2 + s22l + tmp1l
         s22h = t_q1 + t_q2
         s22l = t_q2 - (s22h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>     s22 = s22 + tmp1
!----    u12  = u12 + u1 * u2
      end do! j_1
!      ss(1) = s11
!      ss(2) = s12
!      ss(3) = s22
      ssh(1) = s11h
      ssl(1) = s11l
      ssh(2) = s12h
      ssl(2) = s12l
      ssh(3) = s22h
      ssl(3) = s22l
!---- ss(4) = u12


      if ( n > vtol ) then
!         call reduce_dbl(ss(1), tt(1), 4, 1, mpi_comm_row)
         call ddreduce_dbl(
     &          ssh(1), ssl(1), tth(1), ttl(1), 4, 1, mpi_comm_row)
      end if
!      call reduce_dbl(ss(1), tt(1), 4, 1, mpi_comm_col)
      call ddreduce_dbl(
     &       ssh(1), ssl(1), tth(1), ttl(1), 4, 1, mpi_comm_col)

!---- u12 = ss(4)
!      u12 = c(1,2)
!      c(2,1) = -c(2,2)*(c(1,1)*u12)
      u12h = ch(1,2)
      u12l = cl(1,2)
!<<<  tmp1 = c(1,1) * u12
      t_ch = ch(1,1) * u12h
      t_u1 = 134217729.0 * ch(1,1)
      t_p1 = t_u1
     +         - (t_u1 - ch(1,1))
      t_p2 = ch(1,1) - t_p1
      t_u1 = 134217729.0 * u12h
      t_r1 = t_u1
     +         - (t_u1 - u12h)
      t_r2 = u12h - t_r1
      t_cl = ((t_p1*t_r1
     +         - t_ch)
     +        + t_p1 * t_r2
     +        + t_p2 * t_r1)
     +        + t_p2 * t_r2
      t_cl = t_cl
     +         + (ch(1,1)*u12l
     +         +  cl(1,1)*u12h)
      t_s1 = t_ch + t_cl
      tmp1l = t_cl - (t_s1 - t_ch)
      tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>  tmp1 = c(1,1) * u12
!<<<  c(2,1) = c(2,2) * tmp1
      t_ch = ch(2,2) * tmp1h
      t_u1 = 134217729.0 * ch(2,2)
      t_p1 = t_u1
     +         - (t_u1 - ch(2,2))
      t_p2 = ch(2,2) - t_p1
      t_u1 = 134217729.0 * tmp1h
      t_r1 = t_u1
     +         - (t_u1 - tmp1h)
      t_r2 = tmp1h - t_r1
      t_cl = ((t_p1*t_r1
     +         - t_ch)
     +        + t_p1 * t_r2
     +        + t_p2 * t_r1)
     +        + t_p2 * t_r2
      t_cl = t_cl
     +         + (ch(2,2)*tmp1l
     +         +  cl(2,2)*tmp1h)
      t_s1 = t_ch + t_cl
      cl(2,1) = t_cl - (t_s1 - t_ch)
      ch(2,1) = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>  c(2,1) = c(2,2) * tmp1
!<<<  c(2,1) = -c(2,1)
      ch(2,1) = -ch(2,1)
      cl(2,1) = -cl(2,1)
!>>>  c(2,1) = -c(2,1)

!---- print*,"v2'=",v_x(1:l,2)

! sx:=s
!      sx(1,1) = ss(1)
!      sx(2,1) = ss(2)
!      sx(1,2) = ss(2)
!      sx(2,2) = ss(3)
      sxh(1,1) = ssh(1)
      sxl(1,1) = ssl(1)
      sxh(2,1) = ssh(2)
      sxl(2,1) = ssl(2)
      sxh(1,2) = ssh(2)
      sxl(1,2) = ssl(2)
      sxh(2,2) = ssh(3)
      sxl(2,2) = ssl(3)

! tx:=sx*c
!      tx(1,1) = sx(1,1)*c(1,1) + sx(1,2)*c(2,1)
!      tx(2,1) = sx(2,1)*c(1,1) + sx(2,2)*c(2,1)
!      tx(1,2) =                  sx(1,2)*c(2,2)
!      tx(2,2) =                  sx(2,2)*c(2,2)
!<<<  tmp1 = sx(1,1) * c(1,1)
      t_ch = sxh(1,1) * ch(1,1)
      t_u1 = 134217729.0 * sxh(1,1)
      t_p1 = t_u1
     +         - (t_u1 - sxh(1,1))
      t_p2 = sxh(1,1) - t_p1
      t_u1 = 134217729.0 * ch(1,1)
      t_r1 = t_u1
     +         - (t_u1 - ch(1,1))
      t_r2 = ch(1,1) - t_r1
      t_cl = ((t_p1*t_r1
     +         - t_ch)
     +        + t_p1 * t_r2
     +        + t_p2 * t_r1)
     +        + t_p2 * t_r2
      t_cl = t_cl
     +         + (sxh(1,1)*cl(1,1)
     +         +  sxl(1,1)*ch(1,1))
      t_s1 = t_ch + t_cl
      tmp1l = t_cl - (t_s1 - t_ch)
      tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>  tmp1 = sx(1,1) * c(1,1)
!<<<  tmp2 = sx(1,2) * c(2,1)
      t_ch = sxh(1,2) * ch(2,1)
      t_u1 = 134217729.0 * sxh(1,2)
      t_p1 = t_u1
     +         - (t_u1 - sxh(1,2))
      t_p2 = sxh(1,2) - t_p1
      t_u1 = 134217729.0 * ch(2,1)
      t_r1 = t_u1
     +         - (t_u1 - ch(2,1))
      t_r2 = ch(2,1) - t_r1
      t_cl = ((t_p1*t_r1
     +         - t_ch)
     +        + t_p1 * t_r2
     +        + t_p2 * t_r1)
     +        + t_p2 * t_r2
      t_cl = t_cl
     +         + (sxh(1,2)*cl(2,1)
     +         +  sxl(1,2)*ch(2,1))
      t_s1 = t_ch + t_cl
      tmp2l = t_cl - (t_s1 - t_ch)
      tmp2h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>  tmp2 = sx(1,2) * c(2,1)
!<<<  tx(1,1) = tmp1 + tmp2
      t_p1 = tmp1h + tmp2h
      t_p2 = t_p1 - tmp1h
      t_q1 = t_p1
      t_q2 = (tmp1h - (t_p1 - t_p2))
     +         + (tmp2h - t_p2)
      t_q2 = t_q2 + tmp1l + tmp2l
      txh(1,1) = t_q1 + t_q2
      txl(1,1) = t_q2 - (txh(1,1) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>  tx(1,1) = tmp1 + tmp2
!<<<  tmp1 = sx(2,1) * c(1,1)
      t_ch = sxh(2,1) * ch(1,1)
      t_u1 = 134217729.0 * sxh(2,1)
      t_p1 = t_u1
     +         - (t_u1 - sxh(2,1))
      t_p2 = sxh(2,1) - t_p1
      t_u1 = 134217729.0 * ch(1,1)
      t_r1 = t_u1
     +         - (t_u1 - ch(1,1))
      t_r2 = ch(1,1) - t_r1
      t_cl = ((t_p1*t_r1
     +         - t_ch)
     +        + t_p1 * t_r2
     +        + t_p2 * t_r1)
     +        + t_p2 * t_r2
      t_cl = t_cl
     +         + (sxh(2,1)*cl(1,1)
     +         +  sxl(2,1)*ch(1,1))
      t_s1 = t_ch + t_cl
      tmp1l = t_cl - (t_s1 - t_ch)
      tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>  tmp1 = sx(2,1) * c(1,1)
!<<<  tmp2 = sx(2,2) * c(2,1)
      t_ch = sxh(2,2) * ch(2,1)
      t_u1 = 134217729.0 * sxh(2,2)
      t_p1 = t_u1
     +         - (t_u1 - sxh(2,2))
      t_p2 = sxh(2,2) - t_p1
      t_u1 = 134217729.0 * ch(2,1)
      t_r1 = t_u1
     +         - (t_u1 - ch(2,1))
      t_r2 = ch(2,1) - t_r1
      t_cl = ((t_p1*t_r1
     +         - t_ch)
     +        + t_p1 * t_r2
     +        + t_p2 * t_r1)
     +        + t_p2 * t_r2
      t_cl = t_cl
     +         + (sxh(2,2)*cl(2,1)
     +         +  sxl(2,2)*ch(2,1))
      t_s1 = t_ch + t_cl
      tmp2l = t_cl - (t_s1 - t_ch)
      tmp2h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>  tmp2 = sx(2,2) * c(2,1)
!<<<  tx(2,1) = tmp1 + tmp2
      t_p1 = tmp1h + tmp2h
      t_p2 = t_p1 - tmp1h
      t_q1 = t_p1
      t_q2 = (tmp1h - (t_p1 - t_p2))
     +         + (tmp2h - t_p2)
      t_q2 = t_q2 + tmp1l + tmp2l
      txh(2,1) = t_q1 + t_q2
      txl(2,1) = t_q2 - (txh(2,1) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>  tx(2,1) = tmp1 + tmp2
!<<<  tx(1,2) = sx(1,2) * c(2,2)
      t_ch = sxh(1,2) * ch(2,2)
      t_u1 = 134217729.0 * sxh(1,2)
      t_p1 = t_u1
     +         - (t_u1 - sxh(1,2))
      t_p2 = sxh(1,2) - t_p1
      t_u1 = 134217729.0 * ch(2,2)
      t_r1 = t_u1
     +         - (t_u1 - ch(2,2))
      t_r2 = ch(2,2) - t_r1
      t_cl = ((t_p1*t_r1
     +         - t_ch)
     +        + t_p1 * t_r2
     +        + t_p2 * t_r1)
     +        + t_p2 * t_r2
      t_cl = t_cl
     +         + (sxh(1,2)*cl(2,2)
     +         +  sxl(1,2)*ch(2,2))
      t_s1 = t_ch + t_cl
      txl(1,2) = t_cl - (t_s1 - t_ch)
      txh(1,2) = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>  tx(1,2) = sx(1,2) * c(2,2)
!<<<  tx(2,2) = sx(2,2) * c(2,2)
      t_ch = sxh(2,2) * ch(2,2)
      t_u1 = 134217729.0 * sxh(2,2)
      t_p1 = t_u1
     +         - (t_u1 - sxh(2,2))
      t_p2 = sxh(2,2) - t_p1
      t_u1 = 134217729.0 * ch(2,2)
      t_r1 = t_u1
     +         - (t_u1 - ch(2,2))
      t_r2 = ch(2,2) - t_r1
      t_cl = ((t_p1*t_r1
     +         - t_ch)
     +        + t_p1 * t_r2
     +        + t_p2 * t_r1)
     +        + t_p2 * t_r2
      t_cl = t_cl
     +         + (sxh(2,2)*cl(2,2)
     +         +  sxl(2,2)*ch(2,2))
      t_s1 = t_ch + t_cl
      txl(2,2) = t_cl - (t_s1 - t_ch)
      txh(2,2) = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>  tx(2,2) = sx(2,2) * c(2,2)
            
! sx:=c^t*tx
!      sx(1,1) = c(1,1)*tx(1,1) + c(2,1)*tx(2,1)
!      sx(2,1) =                  c(2,2)*tx(2,1)
!      sx(1,2) = c(1,1)*tx(1,2) + c(2,1)*tx(2,2)
!      sx(2,2) =                  c(2,2)*tx(2,2)
!<<<  tmp1 = c(1,1) * tx(1,1)
      t_ch = ch(1,1) * txh(1,1)
      t_u1 = 134217729.0 * ch(1,1)
      t_p1 = t_u1
     +         - (t_u1 - ch(1,1))
      t_p2 = ch(1,1) - t_p1
      t_u1 = 134217729.0 * txh(1,1)
      t_r1 = t_u1
     +         - (t_u1 - txh(1,1))
      t_r2 = txh(1,1) - t_r1
      t_cl = ((t_p1*t_r1
     +         - t_ch)
     +        + t_p1 * t_r2
     +        + t_p2 * t_r1)
     +        + t_p2 * t_r2
      t_cl = t_cl
     +         + (ch(1,1)*txl(1,1)
     +         +  cl(1,1)*txh(1,1))
      t_s1 = t_ch + t_cl
      tmp1l = t_cl - (t_s1 - t_ch)
      tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>  tmp1 = c(1,1) * tx(1,1)
!<<<  tmp2 = c(2,1) * tx(2,1)
      t_ch = ch(2,1) * txh(2,1)
      t_u1 = 134217729.0 * ch(2,1)
      t_p1 = t_u1
     +         - (t_u1 - ch(2,1))
      t_p2 = ch(2,1) - t_p1
      t_u1 = 134217729.0 * txh(2,1)
      t_r1 = t_u1
     +         - (t_u1 - txh(2,1))
      t_r2 = txh(2,1) - t_r1
      t_cl = ((t_p1*t_r1
     +         - t_ch)
     +        + t_p1 * t_r2
     +        + t_p2 * t_r1)
     +        + t_p2 * t_r2
      t_cl = t_cl
     +         + (ch(2,1)*txl(2,1)
     +         +  cl(2,1)*txh(2,1))
      t_s1 = t_ch + t_cl
      tmp2l = t_cl - (t_s1 - t_ch)
      tmp2h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>  tmp2 = c(2,1) * tx(2,1)
!<<<  sx(1,1) = tmp1 + tmp2
      t_p1 = tmp1h + tmp2h
      t_p2 = t_p1 - tmp1h
      t_q1 = t_p1
      t_q2 = (tmp1h - (t_p1 - t_p2))
     +         + (tmp2h - t_p2)
      t_q2 = t_q2 + tmp1l + tmp2l
      sxh(1,1) = t_q1 + t_q2
      sxl(1,1) = t_q2 - (sxh(1,1) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>  sx(1,1) = tmp1 + tmp2
!<<<  sx(2,1) = c(2,2) * tx(2,1)
      t_ch = ch(2,2) * txh(2,1)
      t_u1 = 134217729.0 * ch(2,2)
      t_p1 = t_u1
     +         - (t_u1 - ch(2,2))
      t_p2 = ch(2,2) - t_p1
      t_u1 = 134217729.0 * txh(2,1)
      t_r1 = t_u1
     +         - (t_u1 - txh(2,1))
      t_r2 = txh(2,1) - t_r1
      t_cl = ((t_p1*t_r1
     +         - t_ch)
     +        + t_p1 * t_r2
     +        + t_p2 * t_r1)
     +        + t_p2 * t_r2
      t_cl = t_cl
     +         + (ch(2,2)*txl(2,1)
     +         +  cl(2,2)*txh(2,1))
      t_s1 = t_ch + t_cl
      sxl(2,1) = t_cl - (t_s1 - t_ch)
      sxh(2,1) = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>  sx(2,1) = c(2,2) * tx(2,1)
!<<<  tmp1 = c(1,1) * tx(1,2)
      t_ch = ch(1,1) * txh(1,2)
      t_u1 = 134217729.0 * ch(1,1)
      t_p1 = t_u1
     +         - (t_u1 - ch(1,1))
      t_p2 = ch(1,1) - t_p1
      t_u1 = 134217729.0 * txh(1,2)
      t_r1 = t_u1
     +         - (t_u1 - txh(1,2))
      t_r2 = txh(1,2) - t_r1
      t_cl = ((t_p1*t_r1
     +         - t_ch)
     +        + t_p1 * t_r2
     +        + t_p2 * t_r1)
     +        + t_p2 * t_r2
      t_cl = t_cl
     +         + (ch(1,1)*txl(1,2)
     +         +  cl(1,1)*txh(1,2))
      t_s1 = t_ch + t_cl
      tmp1l = t_cl - (t_s1 - t_ch)
      tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>  tmp1 = c(1,1) * tx(1,2)
!<<<  tmp2 = c(2,1) * tx(2,2)
      t_ch = ch(2,1) * txh(2,2)
      t_u1 = 134217729.0 * ch(2,1)
      t_p1 = t_u1
     +         - (t_u1 - ch(2,1))
      t_p2 = ch(2,1) - t_p1
      t_u1 = 134217729.0 * txh(2,2)
      t_r1 = t_u1
     +         - (t_u1 - txh(2,2))
      t_r2 = txh(2,2) - t_r1
      t_cl = ((t_p1*t_r1
     +         - t_ch)
     +        + t_p1 * t_r2
     +        + t_p2 * t_r1)
     +        + t_p2 * t_r2
      t_cl = t_cl
     +         + (ch(2,1)*txl(2,2)
     +         +  cl(2,1)*txh(2,2))
      t_s1 = t_ch + t_cl
      tmp2l = t_cl - (t_s1 - t_ch)
      tmp2h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>  tmp2 = c(2,1) * tx(2,2)
!<<<  sx(1,2) = tmp1 + tmp2
      t_p1 = tmp1h + tmp2h
      t_p2 = t_p1 - tmp1h
      t_q1 = t_p1
      t_q2 = (tmp1h - (t_p1 - t_p2))
     +         + (tmp2h - t_p2)
      t_q2 = t_q2 + tmp1l + tmp2l
      sxh(1,2) = t_q1 + t_q2
      sxl(1,2) = t_q2 - (sxh(1,2) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>  sx(1,2) = tmp1 + tmp2
!<<<  sx(2,2) = c(2,2) * tx(2,2)
      t_ch = ch(2,2) * txh(2,2)
      t_u1 = 134217729.0 * ch(2,2)
      t_p1 = t_u1
     +         - (t_u1 - ch(2,2))
      t_p2 = ch(2,2) - t_p1
      t_u1 = 134217729.0 * txh(2,2)
      t_r1 = t_u1
     +         - (t_u1 - txh(2,2))
      t_r2 = txh(2,2) - t_r1
      t_cl = ((t_p1*t_r1
     +         - t_ch)
     +        + t_p1 * t_r2
     +        + t_p2 * t_r1)
     +        + t_p2 * t_r2
      t_cl = t_cl
     +         + (ch(2,2)*txl(2,2)
     +         +  cl(2,2)*txh(2,2))
      t_s1 = t_ch + t_cl
      sxl(2,2) = t_cl - (t_s1 - t_ch)
      sxh(2,2) = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>  sx(2,2) = c(2,2) * tx(2,2)

!      tx(1,1) = sx(1,1)
!      tx(2,2) = sx(2,2)
!      tx(2,1) = sx(1,2)+sx(2,1)
!      tx(1,2) = zero
      txh(1,1) = sxh(1,1)
      txl(1,1) = sxl(1,1)
      txh(2,2) = sxh(2,2)
      txl(2,2) = sxl(2,2)
!<<<  tx(2,1) = sx(1,2) + sx(2,1)
      t_p1 = sxh(1,2) + sxh(2,1)
      t_p2 = t_p1 - sxh(1,2)
      t_q1 = t_p1
      t_q2 = (sxh(1,2) - (t_p1 - t_p2))
     +         + (sxh(2,1) - t_p2)
      t_q2 = t_q2 + sxl(1,2) + sxl(2,1)
      txh(2,1) = t_q1 + t_q2
      txl(2,1) = t_q2 - (txh(2,1) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>  tx(2,1) = sx(1,2) + sx(2,1)
      txh(1,2) = zeroh
      txl(1,2) = zerol

!      s11 = -tx(1,1)/2
!      s21 = -tx(2,1)/2
!      s12 = -tx(1,2)/2
!      s22 = -tx(2,2)/2
!<<<  s11 = tx(1,1) / t_two
      t_q1 = txh(1,1) / t_twoh
      t_ch = t_twoh * t_q1
      t_u1 = 134217729.0 * t_twoh
      t_p1 = t_u1
     +         - (t_u1 - t_twoh)
      t_p2 = t_twoh - t_p1
      t_u1 = 134217729.0 * t_q1
      t_r1 = t_u1
     +         - (t_u1 - t_q1)
      t_r2 = t_q1 - t_r1
      t_cl = ((t_p1*t_r1
     +         - t_ch)
     +         + t_p1*t_r2
     +         + t_p2*t_r1)
     +         + t_p2*t_r2
      t_cl = t_cl
     +         + (t_twol * t_q1)
      t_s1 = t_ch + t_cl
      t_cl = t_cl
     +         - (t_s1 - t_ch)
      t_ch = t_s1
      t_s1 = txh(1,1) - t_ch
      t_r1 = t_s1 - txh(1,1)
      t_s2 = (txh(1,1)
     +         - (t_s1 - t_r1))
     +         - (t_ch + t_r1)
      t_s2 = t_s2 - t_cl
      t_s2 = t_s2 + txl(1,1)
      t_q2 = (t_s1 + t_s2)
     +         / t_twoh
      s11h = t_q1 + t_q2
      s11l = t_q2
     +      - (s11h - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>  s11 = tx(1,1) / t_two
!<<<  s21 = tx(2,1) / t_two
      t_q1 = txh(2,1) / t_twoh
      t_ch = t_twoh * t_q1
      t_u1 = 134217729.0 * t_twoh
      t_p1 = t_u1
     +         - (t_u1 - t_twoh)
      t_p2 = t_twoh - t_p1
      t_u1 = 134217729.0 * t_q1
      t_r1 = t_u1
     +         - (t_u1 - t_q1)
      t_r2 = t_q1 - t_r1
      t_cl = ((t_p1*t_r1
     +         - t_ch)
     +         + t_p1*t_r2
     +         + t_p2*t_r1)
     +         + t_p2*t_r2
      t_cl = t_cl
     +         + (t_twol * t_q1)
      t_s1 = t_ch + t_cl
      t_cl = t_cl
     +         - (t_s1 - t_ch)
      t_ch = t_s1
      t_s1 = txh(2,1) - t_ch
      t_r1 = t_s1 - txh(2,1)
      t_s2 = (txh(2,1)
     +         - (t_s1 - t_r1))
     +         - (t_ch + t_r1)
      t_s2 = t_s2 - t_cl
      t_s2 = t_s2 + txl(2,1)
      t_q2 = (t_s1 + t_s2)
     +         / t_twoh
      s21h = t_q1 + t_q2
      s21l = t_q2
     +      - (s21h - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>  s21 = tx(2,1) / t_two
!<<<  s12 = tx(1,2) / t_two
      t_q1 = txh(1,2) / t_twoh
      t_ch = t_twoh * t_q1
      t_u1 = 134217729.0 * t_twoh
      t_p1 = t_u1
     +         - (t_u1 - t_twoh)
      t_p2 = t_twoh - t_p1
      t_u1 = 134217729.0 * t_q1
      t_r1 = t_u1
     +         - (t_u1 - t_q1)
      t_r2 = t_q1 - t_r1
      t_cl = ((t_p1*t_r1
     +         - t_ch)
     +         + t_p1*t_r2
     +         + t_p2*t_r1)
     +         + t_p2*t_r2
      t_cl = t_cl
     +         + (t_twol * t_q1)
      t_s1 = t_ch + t_cl
      t_cl = t_cl
     +         - (t_s1 - t_ch)
      t_ch = t_s1
      t_s1 = txh(1,2) - t_ch
      t_r1 = t_s1 - txh(1,2)
      t_s2 = (txh(1,2)
     +         - (t_s1 - t_r1))
     +         - (t_ch + t_r1)
      t_s2 = t_s2 - t_cl
      t_s2 = t_s2 + txl(1,2)
      t_q2 = (t_s1 + t_s2)
     +         / t_twoh
      s12h = t_q1 + t_q2
      s12l = t_q2
     +      - (s12h - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>  s12 = tx(1,2) / t_two
!<<<  s22 = tx(2,2) / t_two
      t_q1 = txh(2,2) / t_twoh
      t_ch = t_twoh * t_q1
      t_u1 = 134217729.0 * t_twoh
      t_p1 = t_u1
     +         - (t_u1 - t_twoh)
      t_p2 = t_twoh - t_p1
      t_u1 = 134217729.0 * t_q1
      t_r1 = t_u1
     +         - (t_u1 - t_q1)
      t_r2 = t_q1 - t_r1
      t_cl = ((t_p1*t_r1
     +         - t_ch)
     +         + t_p1*t_r2
     +         + t_p2*t_r1)
     +         + t_p2*t_r2
      t_cl = t_cl
     +         + (t_twol * t_q1)
      t_s1 = t_ch + t_cl
      t_cl = t_cl
     +         - (t_s1 - t_ch)
      t_ch = t_s1
      t_s1 = txh(2,2) - t_ch
      t_r1 = t_s1 - txh(2,2)
      t_s2 = (txh(2,2)
     +         - (t_s1 - t_r1))
     +         - (t_ch + t_r1)
      t_s2 = t_s2 - t_cl
      t_s2 = t_s2 + txl(2,2)
      t_q2 = (t_s1 + t_s2)
     +         / t_twoh
      s22h = t_q1 + t_q2
      s22l = t_q2
     +      - (s22h - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>  s22 = tx(2,2) / t_two
!<<<  s11 = -s11
      s11h = -s11h
      s11l = -s11l
!>>>  s11 = -s11
!<<<  s21 = -s21
      s21h = -s21h
      s21l = -s21l
!>>>  s21 = -s21
!<<<  s12 = -s12
      s12h = -s12h
      s12l = -s12l
!>>>  s12 = -s12
!<<<  s22 = -s22
      s22h = -s22h
      s22l = -s22l
!>>>  s22 = -s22

!      c11 = c(1,1)
!      c21 = c(2,1)
!      c12 = zero
!      c22 = c(2,2)
      c11h = ch(1,1)
      c11l = cl(1,1)
      c21h = ch(2,1)
      c21l = cl(2,1)
      c12h = zeroh
      c12l = zerol
      c22h = ch(2,2)
      c22l = cl(2,2)

!---- print*,"s=[",s11,s12
!---- print*,"  [",s21,s22

! v:=vc^t
!dir$ unroll(2)
!dir$ ivdep
!dir$ vector always
      do j_1=jj_2,jj_3
!         v1 = v_x(j_1,1)
!         v2 = v_x(j_1,2)
!         v1         =      v1 * c(1,1) + v2 * c(2,1)
!         v2         =                    v2 * c(2,2)
         v1h = v_xh(j_1,1)
         v1l = v_xl(j_1,1)
         v2h = v_xh(j_1,2)
         v2l = v_xl(j_1,2)
!<<<     tmp1 = v1 * c(1,1)
         t_ch = v1h * ch(1,1)
         t_u1 = 134217729.0 * v1h
         t_p1 = t_u1
     +            - (t_u1 - v1h)
         t_p2 = v1h - t_p1
         t_u1 = 134217729.0 * ch(1,1)
         t_r1 = t_u1
     +            - (t_u1 - ch(1,1))
         t_r2 = ch(1,1) - t_r1
         t_cl = ((t_p1*t_r1
     +            - t_ch)
     +           + t_p1 * t_r2
     +           + t_p2 * t_r1)
     +           + t_p2 * t_r2
         t_cl = t_cl
     +            + (v1h*cl(1,1)
     +            +  v1l*ch(1,1))
         t_s1 = t_ch + t_cl
         tmp1l = t_cl - (t_s1 - t_ch)
         tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>     tmp1 = v1 * c(1,1)
!<<<     tmp2 = v2 * c(2,1)
         t_ch = v2h * ch(2,1)
         t_u1 = 134217729.0 * v2h
         t_p1 = t_u1
     +            - (t_u1 - v2h)
         t_p2 = v2h - t_p1
         t_u1 = 134217729.0 * ch(2,1)
         t_r1 = t_u1
     +            - (t_u1 - ch(2,1))
         t_r2 = ch(2,1) - t_r1
         t_cl = ((t_p1*t_r1
     +            - t_ch)
     +           + t_p1 * t_r2
     +           + t_p2 * t_r1)
     +           + t_p2 * t_r2
         t_cl = t_cl
     +            + (v2h*cl(2,1)
     +            +  v2l*ch(2,1))
         t_s1 = t_ch + t_cl
         tmp2l = t_cl - (t_s1 - t_ch)
         tmp2h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>     tmp2 = v2 * c(2,1)
!<<<     v1 = tmp1 + tmp2
         t_p1 = tmp1h + tmp2h
         t_p2 = t_p1 - tmp1h
         t_q1 = t_p1
         t_q2 = (tmp1h - (t_p1 - t_p2))
     +            + (tmp2h - t_p2)
         t_q2 = t_q2 + tmp1l + tmp2l
         v1h = t_q1 + t_q2
         v1l = t_q2 - (v1h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>     v1 = tmp1 + tmp2
!<<<     v2 = v2 * c(2,2)
         t_ch = v2h * ch(2,2)
         t_u1 = 134217729.0 * v2h
         t_p1 = t_u1
     +            - (t_u1 - v2h)
         t_p2 = v2h - t_p1
         t_u1 = 134217729.0 * ch(2,2)
         t_r1 = t_u1
     +            - (t_u1 - ch(2,2))
         t_r2 = ch(2,2) - t_r1
         t_cl = ((t_p1*t_r1
     +            - t_ch)
     +           + t_p1 * t_r2
     +           + t_p2 * t_r1)
     +           + t_p2 * t_r2
         t_cl = t_cl
     +            + (v2h*cl(2,2)
     +            +  v2l*ch(2,2))
         t_s1 = t_ch + t_cl
         v2l = t_cl - (t_s1 - t_ch)
         v2h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>     v2 = v2 * c(2,2)
!---- end do! j_1
!
!---- print*,"v2''=",v_x(1:l,2)
!
! v:=v-us
!---- do j_1=jj_2,jj_3
!         u1 = u_x(j_1,1)
!         u2 = u_x(j_1,2)
!         v_x(j_1,1) = v1 + s11 * u1 + s21 * u2
!         v_x(j_1,2) = v2            + s22 * u2
         u1h = u_xh(j_1,1)
         u1l = u_xl(j_1,1)
         u2h = u_xh(j_1,2)
         u2l = u_xl(j_1,2)
!<<<     tmp1 = s11 * u1
         t_ch = s11h * u1h
         t_u1 = 134217729.0 * s11h
         t_p1 = t_u1
     +            - (t_u1 - s11h)
         t_p2 = s11h - t_p1
         t_u1 = 134217729.0 * u1h
         t_r1 = t_u1
     +            - (t_u1 - u1h)
         t_r2 = u1h - t_r1
         t_cl = ((t_p1*t_r1
     +            - t_ch)
     +           + t_p1 * t_r2
     +           + t_p2 * t_r1)
     +           + t_p2 * t_r2
         t_cl = t_cl
     +            + (s11h*u1l
     +            +  s11l*u1h)
         t_s1 = t_ch + t_cl
         tmp1l = t_cl - (t_s1 - t_ch)
         tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>     tmp1 = s11 * u1
!<<<     tmp2 = s21 * u2
         t_ch = s21h * u2h
         t_u1 = 134217729.0 * s21h
         t_p1 = t_u1
     +            - (t_u1 - s21h)
         t_p2 = s21h - t_p1
         t_u1 = 134217729.0 * u2h
         t_r1 = t_u1
     +            - (t_u1 - u2h)
         t_r2 = u2h - t_r1
         t_cl = ((t_p1*t_r1
     +            - t_ch)
     +           + t_p1 * t_r2
     +           + t_p2 * t_r1)
     +           + t_p2 * t_r2
         t_cl = t_cl
     +            + (s21h*u2l
     +            +  s21l*u2h)
         t_s1 = t_ch + t_cl
         tmp2l = t_cl - (t_s1 - t_ch)
         tmp2h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>     tmp2 = s21 * u2
!<<<     v_x(j_1,1) = v1 + tmp1
         t_p1 = v1h + tmp1h
         t_p2 = t_p1 - v1h
         t_q1 = t_p1
         t_q2 = (v1h - (t_p1 - t_p2))
     +            + (tmp1h - t_p2)
         t_q2 = t_q2 + v1l + tmp1l
         v_xh(j_1,1) = t_q1 + t_q2
         v_xl(j_1,1) = t_q2 - (v_xh(j_1,1) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>     v_x(j_1,1) = v1 + tmp1
!<<<     v_x(j_1,1) = v_x(j_1,1) + tmp2
         t_p1 = v_xh(j_1,1) + tmp2h
         t_p2 = t_p1 - v_xh(j_1,1)
         t_q1 = t_p1
         t_q2 = (v_xh(j_1,1) - (t_p1 - t_p2))
     +            + (tmp2h - t_p2)
         t_q2 = t_q2 + v_xl(j_1,1) + tmp2l
         v_xh(j_1,1) = t_q1 + t_q2
         v_xl(j_1,1) = t_q2 - (v_xh(j_1,1) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>     v_x(j_1,1) = v_x(j_1,1) + tmp2
!<<<     tmp1 = s22 * u2
         t_ch = s22h * u2h
         t_u1 = 134217729.0 * s22h
         t_p1 = t_u1
     +            - (t_u1 - s22h)
         t_p2 = s22h - t_p1
         t_u1 = 134217729.0 * u2h
         t_r1 = t_u1
     +            - (t_u1 - u2h)
         t_r2 = u2h - t_r1
         t_cl = ((t_p1*t_r1
     +            - t_ch)
     +           + t_p1 * t_r2
     +           + t_p2 * t_r1)
     +           + t_p2 * t_r2
         t_cl = t_cl
     +            + (s22h*u2l
     +            +  s22l*u2h)
         t_s1 = t_ch + t_cl
         tmp1l = t_cl - (t_s1 - t_ch)
         tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>     tmp1 = s22 * u2
!<<<     v_x(j_1,2) = v2 + tmp1
         t_p1 = v2h + tmp1h
         t_p2 = t_p1 - v2h
         t_q1 = t_p1
         t_q2 = (v2h - (t_p1 - t_p2))
     +            + (tmp1h - t_p2)
         t_q2 = t_q2 + v2l + tmp1l
         v_xh(j_1,2) = t_q1 + t_q2
         v_xl(j_1,2) = t_q2 - (v_xh(j_1,2) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>     v_x(j_1,2) = v2 + tmp1
      end do! j_1

!---- print*,"u2'''=",u_x(1:l,2)
!---- print*,"u1'''=",u_x(1:l,1)
!---- print*,"v2'''=",v_x(1:l,2)
!---- print*,"v1'''=",v_x(1:l,1)

      if ( n > vtol ) then
         do j_1=j_2,jj_2-1
!            v_x(j_1,1)=zero
!            v_x(j_1,2)=zero
            v_xh(j_1,1) = zeroh
            v_xl(j_1,1) = zerol
            v_xh(j_1,2) = zeroh
            v_xl(j_1,2) = zerol
         end do! j_1
         do j_1=jj_3+1,j_3
!            v_x(j_1,1)=zero
!            v_x(j_1,2)=zero
            v_xh(j_1,1) = zeroh
            v_xl(j_1,1) = zerol
            v_xh(j_1,2) = zeroh
            v_xl(j_1,2) = zerol
         end do! j_1

         if ( size_of_row > 1 ) then
            do j_1=j_2,j_3
!               v_t(j_1)  =v_x(j_1,1)
!               v_t(j_1+n)=v_x(j_1,2)
               v_th(j_1) = v_xh(j_1,1)
               v_tl(j_1) = v_xl(j_1,1)
               v_th(j_1+n) = v_xh(j_1,2)
               v_tl(j_1+n) = v_xl(j_1,2)
            end do
            !call reduce_dbl(v_t(1), u_t(1), 2*n, 1, mpi_comm_row)
            call ddreduce_dbl(
     &         v_th(1), v_tl(1), u_th(1), u_tl(1), 2*n, 1, mpi_comm_row)
            do j_1=j_2,j_3
!               v_x(j_1,1) = v_t(j_1)
!               v_x(j_1,2) = v_t(j_1+n)
               v_xh(j_1,1) = v_th(j_1)
               v_xl(j_1,1) = v_tl(j_1)
               v_xh(j_1,2) = v_th(j_1+n)
               v_xl(j_1,2) = v_tl(j_1+n)
            end do
         end if
      end if

!      call datacast_dbl(v_y(1,1), v_x(1,1), u_t(1), v_t(1), col_local)
!      call datacast_dbl(v_y(1,2), v_x(1,2), u_t(1), v_t(1), col_local)
      call dddatacast_dbl(
     &       v_yh(1,1), v_yl(1,1), v_xh(1,1), v_xl(1,1),
     &       u_th(1), u_tl(1), v_th(1), v_tl(1), col_local)
      call dddatacast_dbl(
     &       v_yh(1,2), v_yl(1,2), v_xh(1,2), v_xl(1,2),
     &       u_th(1), u_tl(1), v_th(1), v_tl(1), col_local)

! for attention to unexpected overflow or nan
      j_3 = get_loop_end      (l, size_of_col, my_col)
      n   = translate_g2l(l, size_of_col, my_col)
      if ( j_3 < n ) then
!         v_x(j_3+1:n,1) = zero ! in case
!         v_x(j_3+1:n,2) = zero ! in case
         v_xh(j_3+1:n,1) = zeroh
         v_xl(j_3+1:n,1) = zerol
         v_xh(j_3+1:n,2) = zeroh
         v_xl(j_3+1:n,2) = zerol
      end if

      j_3 = get_loop_end      (l, size_of_row, my_row)
      n   = translate_g2l(l, size_of_row, my_row)
      if ( j_3 < n ) then
!         v_y(j_3+1:n,1) = zero ! in case
!         v_y(j_3+1:n,2) = zero ! in case
         v_yh(j_3+1:n,1) = zeroh
         v_yl(j_3+1:n,1) = zerol
         v_yh(j_3+1:n,2) = zeroh
         v_yl(j_3+1:n,2) = zerol
      end if


      return
!      end subroutine eigen_prd_v
      end subroutine ddeigen_prd_v

