!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!  n   : dimension of matrix
!  a   : matrix
!  nma : size of array "a"
!  w   : array for eigen value
!  z   : array for eigen vector
!  d   : array to store a main diagonal element
!  e   : array to store a sub diagonal element
!  nme : size of array "e"
!  m0  : coefficient of blocking
!  ifl : switch flag ( 0:eigen-value and eigen-vector )
!                    ( 1:eigen-value only )
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!      subroutine eigen_sx(
      subroutine ddeigen_sx(
     &           n,ah,al,nma,wh,wl,zh,zl,dh,dl,eh,el,nme,m0,ifl)
      implicit none

!      real(8) :: a(*),z(*),d(*),e(*),w(*)
      double precision ah(*), al(*)
      double precision zh(*), zl(*)
      double precision dh(*), dl(*)
      double precision eh(*), el(*)
      double precision wh(*), wl(*)
!      real(8),allocatable :: work(:)
      real(8),allocatable :: workh(:), workl(:)
      real(8) :: hs0, hs1
      integer :: n, nma, nme, m0, ifl
      integer :: m_forward, m_backward, istat
!
      include 'mpif.h'
      include 'trd.h'
!
      hs0=MPI_Wtime()

      m_forward = m0
!      call eigen_prd(n, a(1), nma, d(1), e(1), nme, m_forward)
      call ddeigen_prd(n, ah(1), al(1), nma, dh(1), dl(1), eh(1), el(1),
     &                 nme, m_forward)

!      allocate(work(2*nme), stat=istat)
      allocate(workh(2*nme), workl(2*nme), stat=istat)
      if(istat.ne.0) then
         print*,"Memory exhausted in eigen_sx routine"
         call flush(6)
         stop
      endif

!      work(0*nme+1:0*nme+n-1) = e(0*nme+2:0*nme+n)
!      work(0*nme+n) = 0
!      work(1*nme+1:1*nme+n-2) = e(1*nme+3:1*nme+n)
!      work(1*nme+n-1) = 0
!      work(1*nme+n) = 0
!      w(1:n)=d(1:n)
      workh(0*nme+1:0*nme+n-1) = eh(0*nme+2:0*nme+n)
      workl(0*nme+1:0*nme+n-1) = el(0*nme+2:0*nme+n)
      workh(0*nme+n) = 0.0d+0
      workl(0*nme+n) = 0.0d+0
      workh(1*nme+1:1*nme+n-2) = eh(1*nme+3:1*nme+n)
      workl(1*nme+1:1*nme+n-2) = el(1*nme+3:1*nme+n)
      workh(1*nme+n-1) = 0.0d+0
      workl(1*nme+n-1) = 0.0d+0
      workh(1*nme+n) = 0.0d+0
      workl(1*nme+n) = 0.0d+0
      wh(1:n) = dh(1:n)
      wl(1:n) = dl(1:n)

!      call eigen_dcx(n, w(1), work(1), nme, z(1), nma)
      call ddeigen_dcx(n, wh(1), wl(1), workh(1), workl(1), nme, 
     &                 zh(1), zl(1), nma)
!      deallocate(work)
      deallocate(workh, workl)

      if(ifl==0) then
         m_backward = 128
!         call eigen_pbk(n, a(1), nma, z(1), nma, e(1+nme), m_backward)
         call ddeigen_pbk(n, ah(1), al(1), nma, zh(1), zl(1), nma,
     &                    eh(1+nme), el(1+nme), m_backward)
      endif

#ifdef TIMER
      hs1=MPI_Wtime()
      if(myrank==1) then
         print*," "
         print*,"Total Execution Time of eigen_sx =",hs1-hs0,"(sec)"
      endif
      call flush(6)
#endif
*
      return
      end

