!      SUBROUTINE PDLAED2X( ICTXT, K, N, N1, NB, D, DROW, DCOL, Q, LDQ,
!     $                    RHO, Z, W, DLAMDA, Q2, LDQ2, QBUF, CTOT, PSM,
!     $                    NPCOL, INDX, INDXC, INDXP, INDCOL, COLTYP, NN,
!     $                    NN1, NN2, IB1, IB2 )
      SUBROUTINE PDDLAED2X( ICTXT, K, N, N1, NB, Dh, Dl, DROW, DCOL,
     $                    Qh, Ql, LDQ, RHOh, RHOl, Zh, Zl, Wh, Wl,
     $                    DLAMDAh, DLAMDAl, Q2h, Q2l, LDQ2,
     $                    QBUFh, QBUFl, CTOT, PSM,
     $                    NPCOL, INDX, INDXC, INDXP, INDCOL, COLTYP, NN,
     $                    NN1, NN2, IB1, IB2 )
*
*  -- ScaLAPACK auxiliary routine (version 1.7) --
*     University of Tennessee, Knoxville, Oak Ridge National Laboratory,
*     and University of California, Berkeley.
*     December 31, 1998
*
*     .. Scalar Arguments ..
      INTEGER            DCOL, DROW, IB1, IB2, ICTXT, K, LDQ, LDQ2, N,
     $                   N1, NB, NN, NN1, NN2, NPCOL
!      DOUBLE PRECISION   RHO
      double precision RHOh, RHOl
*     ..
*     .. Array Arguments ..
      INTEGER            COLTYP( * ), CTOT( 0: NPCOL-1, 4 ),
     $                   INDCOL( N ), INDX( * ), INDXC( * ), INDXP( * ),
     $                   PSM( 0: NPCOL-1, 4 )
!      DOUBLE PRECISION   D( * ), DLAMDA( * ), Q( LDQ, * ),
!     $                   Q2( LDQ2, * ), QBUF( * ), W( * ), Z( * )
      double precision Dh(*), Dl(*)
      double precision DLAMDAh(*), DLAMDAl(*)
      double precision Qh(LDQ,*), Ql(LDQ,*)
      double precision Q2h(LDQ2,*), Q2l(LDQ2,*)
      double precision QBUFh(*), QBUFl(*)
      double precision Wh(*), Wl(*)
      double precision Zh(*), Zl(*)
*     ..
*
*  Purpose
*  =======
*
*  PDLAED2X sorts the two sets of eigenvalues together into a single
*  sorted set.  Then it tries to deflate the size of the problem.
*  There are two ways in which deflation can occur:  when two or more
*  eigenvalues are close together or if there is a tiny entry in the
*  Z vector.  For each such occurrence the order of the related secular
*  equation problem is reduced by one.
*
*  Arguments
*  =========
*
*  ICTXT  (global input) INTEGER
*         The BLACS context handle, indicating the global context of
*         the operation on the matrix. The context itself is global.
*
*  K      (output) INTEGER
*         The number of non-deflated eigenvalues, and the order of the
*         related secular equation. 0 <= K <=N.
*
*  N      (input) INTEGER
*         The dimension of the symmetric tridiagonal matrix.  N >= 0.
*
*  N1     (input) INTEGER
*         The location of the last eigenvalue in the leading sub-matrix.
*         min(1,N) < N1 < N.
*
*  NB      (global input) INTEGER
*          The blocking factor used to distribute the columns of the
*          matrix. NB >= 1.
*
*  D      (input/output) DOUBLE PRECISION array, dimension (N)
*         On entry, D contains the eigenvalues of the two submatrices to
*         be combined.
*         On exit, D contains the trailing (N-K) updated eigenvalues
*         (those which were deflated) sorted into increasing order.
*
*  DROW   (global input) INTEGER
*          The process row over which the first row of the matrix D is
*          distributed. 0 <= DROW < NPROW.
*
*  DCOL   (global input) INTEGER
*          The process column over which the first column of the
*          matrix D is distributed. 0 <= DCOL < NPCOL.
*
*  Q      (input/output) DOUBLE PRECISION array, dimension (LDQ, N)
*         On entry, Q contains the eigenvectors of two submatrices in
*         the two square blocks with corners at (1,1), (N1,N1)
*         and (N1+1, N1+1), (N,N).
*         On exit, Q contains the trailing (N-K) updated eigenvectors
*         (those which were deflated) in its last N-K columns.
*
*  LDQ    (input) INTEGER
*         The leading dimension of the array Q.  LDQ >= max(1,NQ).
*
*  RHO    (global input/output) DOUBLE PRECISION
*         On entry, the off-diagonal element associated with the rank-1
*         cut which originally split the two submatrices which are now
*         being recombined.
*         On exit, RHO has been modified to the value required by
*         PDLAED3.
*
*  Z      (global input) DOUBLE PRECISION array, dimension (N)
*         On entry, Z contains the updating vector (the last
*         row of the first sub-eigenvector matrix and the first row of
*         the second sub-eigenvector matrix).
*         On exit, the contents of Z have been destroyed by the updating
*         process.
*
*  DLAMDA (global output) DOUBLE PRECISION array, dimension (N)
*         A copy of the first K eigenvalues which will be used by
*         SLAED3 to form the secular equation.
*
*  W      (global output) DOUBLE PRECISION array, dimension (N)
*         The first k values of the final deflation-altered z-vector
*         which will be passed to SLAED3.
*
*  Q2     (output) DOUBLE PRECISION array, dimension (LDQ2, NQ)
*         A copy of the first K eigenvectors which will be used by
*
*  LDQ2    (input) INTEGER
*         The leading dimension of the array Q2.
*
*  QBUF   (workspace) DOUBLE PRECISION array, dimension 3*N
*
*  CTOT   (workspace) INTEGER array, dimension( NPCOL, 4)
*
*  PSM    (workspace) INTEGER array, dimension( NPCOL, 4)
*
*  NPCOL   (global input) INTEGER
*          The total number of columns over which the distributed
*           submatrix is distributed.
*
*  INDX   (workspace) INTEGER array, dimension (N)
*         The permutation used to sort the contents of DLAMDA into
*         ascending order.
*
*  INDXC  (output) INTEGER array, dimension (N)
*         The permutation used to arrange the columns of the deflated
*         Q matrix into three groups:  the first group contains non-zero
*         elements only at and above N1, the second contains
*         non-zero elements only below N1, and the third is dense.
*
*  INDXP  (workspace) INTEGER array, dimension (N)
*         The permutation used to place deflated values of D at the end
*         of the array.  INDXP(1:K) points to the nondeflated D-values
*         and INDXP(K+1:N) points to the deflated eigenvalues.
*
*  INDCOL (workspace) INTEGER array, dimension (N)
*
*  COLTYP (workspace/output) INTEGER array, dimension (N)
*         During execution, a label which will indicate which of the
*         following types a column in the Q2 matrix is:
*         1 : non-zero in the upper half only;
*         2 : dense;
*         3 : non-zero in the lower half only;
*         4 : deflated.
*
*  NN     (global output) INTEGER, the order of matrix U, (PDLAED1).
*  NN1    (global output) INTEGER, the order of matrix Q1, (PDLAED1).
*  NN2    (global output) INTEGER, the order of matrix Q2, (PDLAED1).
*  IB1    (global output) INTEGER, pointeur on Q1, (PDLAED1).
*  IB2    (global output) INTEGER, pointeur on Q2, (PDLAED1).
*
*  =====================================================================
*
*     .. Parameters ..
!      DOUBLE PRECISION   MONE, ZERO, ONE, TWO, EIGHT
!      PARAMETER          ( MONE = -1.0D0, ZERO = 0.0D0, ONE = 1.0D0,
!     $                   TWO = 2.0D0, EIGHT = 8.0D0 )
*     ..
*     .. Local Scalars ..
      INTEGER            COL, CT, I, IAM, IE1, IE2, IMAX, INFO, J, JJQ2,
     $                   JJS, JMAX, JS, K2, MYCOL, MYROW, N1P1, N2, NJ,
     $                   NJCOL, NJJ, NP, NPROCS, NPROW, PJ, PJCOL, PJJ
!      DOUBLE PRECISION   C, EPS, S, T, TAU, TOL
      double precision Ch, Cl
      double precision EPSh, EPSl
      double precision Sh, Sl
      double precision Th, Tl
      double precision TAUh, TAUl
      double precision TOLh, TOLl
#ifdef COMM_BLACS2_
      DOUBLE PRECISION Q(2*N), QBUF(6*N)
      INTEGER NBUF2
#endif
*     ..
*     .. External Functions ..
      INTEGER            IDAMAX, INDXG2L, INDXL2G, NUMROC
!      DOUBLE PRECISION   DLAPY2, PDLAMCH
      EXTERNAL           IDAMAX, INDXG2L, INDXL2G, NUMROC, PDLAMCH,
     $                   DLAPY2
*     ..
*     .. External Subroutines ..
!      EXTERNAL           BLACS_GRIDINFO, BLACS_PINFO, DCOPY, DGERV2D,
!     $                   DGESD2D, DLAPST, DROT, DSCAL, INFOG1L
      EXTERNAL           BLACS_GRIDINFO, BLACS_PINFO, DDCOPY, DDGERV2D,
     $                   DDGESD2D, DDLAPST, DDROT, DDSCAL, INFOG1L,
     $                   DDLAPY2, PDDLAMCH
#ifdef COMM_MPI
      EXTERNAL           MakeMpiInfo
#endif
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, MIN, MOD, SQRT
*     ..
*     .. External Functions ..
*     ..
*     .. Local Arrays ..
      INTEGER            PTT( 4 )
*     ..
*     .. Executable Statements ..
      double precision SQR2h, SQR2l
      double precision tmp1h, tmp1l
      double precision tmp2h, tmp2l
!     tmp vars
      double precision t_ch, t_cl
      double precision t_p1, t_p2
      double precision t_q1, t_q2
      double precision t_r1, t_r2
      double precision t_s1, t_s2
      double precision t_t1, t_t2
      double precision t_u1, t_u2
      double precision t_x1, t_x2
      double precision t_y1, t_y2
      double precision t_z1, t_z2
      double precision t_x, t_ax
      double precision t_t1h, t_t1l
      double precision t_t2h, t_t2l
      double precision MONEh, MONEl
      double precision ZEROh, ZEROl
      double precision ONEh, ONEl
      double precision TWOh, TWOl
      double precision EIGHTh, EIGHTl

      include 'mpif.h'

      double precision QBUFF(2*N)
      INTEGER REQ(8192), REQ_PTR, MYRANK, IERR, ST(8192)
      REQ_PTR=0

      ZEROh = 0.0d+0
      ZEROl = 0.0d+0
      ONEh = 1.0d+0
      ONEl = 0.0d+0
!<<<  MONE = -ONE
      MONEh = -ONEh
      MONEl = -ONEl
!>>>  MONE = -ONE
      TWOh = 2.0D0
      TWOl = 0.0d+0
      EIGHTh = 8.0D0
      EIGHTl = 0.0d+0

*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
      CALL BLACS_PINFO( IAM, NPROCS )
      CALL BLACS_GRIDINFO( ICTXT, NPROW, NPCOL, MYROW, MYCOL )
      NP = NUMROC( N, NB, MYROW, DROW, NPROW )
*
      N2 = N - N1
      N1P1 = N1 + 1
*
!      IF( RHO.LT.ZERO ) THEN
      IF( 
!          (RHO .lt. ZERO)
     +    ((RHOh .lt. ZEROh) .or.
     +     ((RHOh .eq. ZEROh) .and.
     +      (RHOl .lt. ZEROl)))
     $) THEN
!         CALL DSCAL( N2, MONE, Z( N1P1 ), 1 )
         CALL DDSCAL( N2, MONEh, MONEl, Zh( N1P1 ), Zl( N1P1 ), 1 )
      END IF
*
*     Normalize z so that norm(z) = 1.  Since z is the concatenation of
*     two normalized vectors, norm2(z) = sqrt(2).
*
!      T = ONE / SQRT( TWO )
!<<<  SQR2 = sqrt(TWO)
      if (TWOh.eq.0.0D+0.and.TWOl.eq.0.0D+0) then
        SQR2h = 0.0d+0
        SQR2l = 0.0d+0
      else
      if (TWOh.lt.0.0d+0.or.
     +   (TWOh.eq.0.0d+0.and.TWOl.lt.0.0d+0)) then
        write(6,'(a)')
     +     'SQRT CALLED WITH NEGATIVE ARGUMENT'
        SQR2h = 0.0d+0
        SQR2l = 0.0d+0
        return
      endif
      t_x = 1.0D+0/sqrt(TWOh)
      t_ax = TWOh * t_x
!         call dd_mul(t_y1,t_y2,t_x,
!                     0.0,0.5,0.0)
          t_y1 = t_x * 0.5d+0
          t_u1 = 134217729.0 * t_x
          t_p1 = t_u1
     +             - (t_u1 - t_x)
          t_p2 = t_x - t_p1
          t_u1 = 134217729.0 * 0.5d+0
          t_r1 = t_u1
     +             - (t_u1 - 0.5d+0)
          t_r2 = 0.5d+0 - t_r1
          t_y2 = ((t_p1*t_r1
     +             - t_y1)
     +             + t_p1*t_r2
     +             + t_p2 * t_r1)
     +             + t_p2 * t_r2
          t_s1 = t_y1 + t_y2
          t_y2 = t_y2
     +             - (t_s1 - t_y1)
          t_y1 = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!         call dd_mul(t_z1,t_z2,t_ax,
!                     0.0,t_ax,0.0)
          t_z1 = t_ax * t_ax
          t_u1 = 134217729.0 * t_ax
          t_p1 = t_u1
     +             - (t_u1 - t_ax)
          t_p2 = t_ax - t_p1
          t_u1 = 134217729.0 * t_ax
          t_r1 = t_u1
     +             - (t_u1 - t_ax)
          t_r2 = t_ax - t_r1
          t_z2 = ((t_p1 * t_r1
     +             - t_z1)
     +             + t_p1 * t_r2
     +             + t_p2 * t_r1)
     +             + t_p2*t_r2
          t_s1 = t_z1 + t_z2
          t_z2 = t_z2
     +             - (t_s1 - t_z1)
          t_z1 = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!         call dd_sub(t_t2h,t_t2l,
!                           TWOh,TWOl,t_z1,t_z2)
          t_p1 = TWOh - t_z1
          t_p2 = t_p1 - TWOh
          t_t2l = (TWOh
     +             -(t_p1 - t_p2))
     +             -(t_z1 + t_p2)
          t_t2h = t_p1
          t_t2l = t_t2l
     +             + TWOl - t_z2
          t_s1 = t_t2h + t_t2l
          t_t2l = t_t2l
     +             - (t_s1 - t_t2h)
          t_t2h = t_s1
#ifdef FPCOUNTER
#include "fsub.h"
#endif
!         call dd_mul(t_t1h,t_t1l,
!                     t_t2h,t_t2l,
!                     t_y1,t_y2)
          t_t1h = t_t2h * t_y1
          t_u1 = 134217729.0 * t_t2h
          t_p1 = t_u1
     +             - (t_u1 - t_t2h)
          t_p2 = t_t2h - t_p1
          t_u1 = 134217729.0 * t_y1
          t_r1 = t_u1
     +             - (t_u1 - t_y1)
          t_r2 = t_y1 - t_r1
          t_t1l = ((t_p1*t_r1
     +             - t_t1h)
     +             + t_p1*t_r2
     +             + t_p2*t_r1)
     +             + t_p2*t_r2
          t_t1l = t_t1l
     +             + (t_t2h * t_y2
     +             +  t_t2l * t_y1)
          t_s1 = t_t1h + t_t1l
          t_t1l = t_t1l - (t_s1
     +              - t_t1h)
          t_t1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!         call dd_selfadd(t_t1h,t_t1l,
!                     t_ax,0.0)
          t_p1 = t_t1h + t_ax
          t_p2 = t_p1 - t_t1h
          t_q2 = (t_t1h
     +             - (t_p1 - t_p2))
     +             + (t_ax - t_p2)
          t_q1 = t_p1
          t_q2 = t_q2 + t_t1l
          t_t1h = t_q1 + t_q2
          t_t1l = t_q2
     +              - (t_t1h - t_q1)
          SQR2h = t_t1h
          SQR2l = t_t1l
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
      endif
!>>>  SQR2 = sqrt(TWO)
!<<<  T = ONE / SQR2
      t_q1 = ONEh / SQR2h
      t_ch = SQR2h * t_q1
      t_u1 = 134217729.0 * SQR2h
      t_p1 = t_u1
     +         - (t_u1 - SQR2h)
      t_p2 = SQR2h - t_p1
      t_u1 = 134217729.0 * t_q1
      t_r1 = t_u1
     +         - (t_u1 - t_q1)
      t_r2 = t_q1 - t_r1
      t_cl = ((t_p1*t_r1
     +         - t_ch)
     +         + t_p1*t_r2
     +         + t_p2*t_r1)
     +         + t_p2*t_r2
      t_cl = t_cl
     +         + (SQR2l * t_q1)
      t_s1 = t_ch + t_cl
      t_cl = t_cl
     +         - (t_s1 - t_ch)
      t_ch = t_s1
      t_s1 = ONEh - t_ch
      t_r1 = t_s1 - ONEh
      t_s2 = (ONEh
     +         - (t_s1 - t_r1))
     +         - (t_ch + t_r1)
      t_s2 = t_s2 - t_cl
      t_s2 = t_s2 + ONEl
      t_q2 = (t_s1 + t_s2)
     +         / SQR2h
      Th = t_q1 + t_q2
      Tl = t_q2
     +      - (Th - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>  T = ONE / SQR2
!      CALL DSCAL( N, T, Z, 1 )
      CALL DDSCAL( N, Th, Tl, Zh, Zl, 1 )
*
*     RHO = ABS( norm(z)**2 * RHO )
*
!      RHO = ABS( TWO*RHO )
!<<<  tmp1 = TWO * RHO
      t_ch = TWOh * RHOh
      t_u1 = 134217729.0 * TWOh
      t_p1 = t_u1
     +         - (t_u1 - TWOh)
      t_p2 = TWOh - t_p1
      t_u1 = 134217729.0 * RHOh
      t_r1 = t_u1
     +         - (t_u1 - RHOh)
      t_r2 = RHOh - t_r1
      t_cl = ((t_p1*t_r1
     +         - t_ch)
     +        + t_p1 * t_r2
     +        + t_p2 * t_r1)
     +        + t_p2 * t_r2
      t_cl = t_cl
     +         + (TWOh*RHOl
     +         +  TWOl*RHOh)
      t_s1 = t_ch + t_cl
      tmp1l = t_cl - (t_s1 - t_ch)
      tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>  tmp1 = TWO * RHO
!<<<  RHO = abs(tmp1)
      if (tmp1h .lt. 0.0d+0) then
        RHOh = -tmp1h
        RHOl = -tmp1l
      elseif (
     +  (tmp1h .eq. 0.0d+0).and.
     +  (tmp1l .lt. 0.0d+0)) then
        RHOh = tmp1h
        RHOl = -tmp1l
      else
        RHOh = tmp1h
        RHOl = tmp1l
      endif
!>>>  RHO = abs(tmp1)
*
*     Calculate the allowable deflation tolerance
*
      IMAX = IDAMAX( N, Z, 1 )
      JMAX = IDAMAX( N, D, 1 )
!      EPS = PDLAMCH( ICTXT, 'Epsilon' )
      CALL PDDLAMCH( ICTXT, 'Epsilon' , EPSh, EPSl )
!      TOL = EIGHT*EPS*MAX( ABS( D( JMAX ) ), ABS( Z( IMAX ) ) )
!<<<  tmp1 = abs(D(JMAX))
      if (Dh(JMAX) .lt. 0.0d+0) then
        tmp1h = -Dh(JMAX)
        tmp1l = -Dl(JMAX)
      elseif (
     +  (Dh(JMAX) .eq. 0.0d+0).and.
     +  (Dl(JMAX) .lt. 0.0d+0)) then
        tmp1h = Dh(JMAX)
        tmp1l = -Dl(JMAX)
      else
        tmp1h = Dh(JMAX)
        tmp1l = Dl(JMAX)
      endif
!>>>  tmp1 = abs(D(JMAX))
!<<<  tmp2 = abs(Z(IMAX))
      if (Zh(IMAX) .lt. 0.0d+0) then
        tmp2h = -Zh(IMAX)
        tmp2l = -Zl(IMAX)
      elseif (
     +  (Zh(IMAX) .eq. 0.0d+0).and.
     +  (Zl(IMAX) .lt. 0.0d+0)) then
        tmp2h = Zh(IMAX)
        tmp2l = -Zl(IMAX)
      else
        tmp2h = Zh(IMAX)
        tmp2l = Zl(IMAX)
      endif
!>>>  tmp2 = abs(Z(IMAX))
      if (
!          (tmp1 .lt. tmp2)
     +    ((tmp1h .lt. tmp2h) .or.
     +     ((tmp1h .eq. tmp2h) .and.
     +      (tmp1l .lt. tmp2l)))
     &) then
         tmp1h = tmp2h
         tmp1l = tmp2l
      endif
!<<<  tmp2 = EIGHT * EPS
      t_ch = EIGHTh * EPSh
      t_u1 = 134217729.0 * EIGHTh
      t_p1 = t_u1
     +         - (t_u1 - EIGHTh)
      t_p2 = EIGHTh - t_p1
      t_u1 = 134217729.0 * EPSh
      t_r1 = t_u1
     +         - (t_u1 - EPSh)
      t_r2 = EPSh - t_r1
      t_cl = ((t_p1*t_r1
     +         - t_ch)
     +        + t_p1 * t_r2
     +        + t_p2 * t_r1)
     +        + t_p2 * t_r2
      t_cl = t_cl
     +         + (EIGHTh*EPSl
     +         +  EIGHTl*EPSh)
      t_s1 = t_ch + t_cl
      tmp2l = t_cl - (t_s1 - t_ch)
      tmp2h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>  tmp2 = EIGHT * EPS
!<<<  TOL = tmp2 * tmp1
      t_ch = tmp2h * tmp1h
      t_u1 = 134217729.0 * tmp2h
      t_p1 = t_u1
     +         - (t_u1 - tmp2h)
      t_p2 = tmp2h - t_p1
      t_u1 = 134217729.0 * tmp1h
      t_r1 = t_u1
     +         - (t_u1 - tmp1h)
      t_r2 = tmp1h - t_r1
      t_cl = ((t_p1*t_r1
     +         - t_ch)
     +        + t_p1 * t_r2
     +        + t_p2 * t_r1)
     +        + t_p2 * t_r2
      t_cl = t_cl
     +         + (tmp2h*tmp1l
     +         +  tmp2l*tmp1h)
      t_s1 = t_ch + t_cl
      TOLl = t_cl - (t_s1 - t_ch)
      TOLh = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>  TOL = tmp2 * tmp1
*
*     If the rank-1 modifier is small enough, no more needs to be done
*     except to reorganize Q so that its columns correspond with the
*     elements in D.
*
!      IF( RHO*ABS( Z( IMAX ) ).LE.TOL ) THEN
!<<<  tmp1 = abs(Z(IMAX))
      if (Zh(IMAX) .lt. 0.0d+0) then
        tmp1h = -Zh(IMAX)
        tmp1l = -Zl(IMAX)
      elseif (
     +  (Zh(IMAX) .eq. 0.0d+0).and.
     +  (Zl(IMAX) .lt. 0.0d+0)) then
        tmp1h = Zh(IMAX)
        tmp1l = -Zl(IMAX)
      else
        tmp1h = Zh(IMAX)
        tmp1l = Zl(IMAX)
      endif
!>>>  tmp1 = abs(Z(IMAX))
!<<<  tmp1 = RHO * tmp1
      t_ch = RHOh * tmp1h
      t_u1 = 134217729.0 * RHOh
      t_p1 = t_u1
     +         - (t_u1 - RHOh)
      t_p2 = RHOh - t_p1
      t_u1 = 134217729.0 * tmp1h
      t_r1 = t_u1
     +         - (t_u1 - tmp1h)
      t_r2 = tmp1h - t_r1
      t_cl = ((t_p1*t_r1
     +         - t_ch)
     +        + t_p1 * t_r2
     +        + t_p2 * t_r1)
     +        + t_p2 * t_r2
      t_cl = t_cl
     +         + (RHOh*tmp1l
     +         +  RHOl*tmp1h)
      t_s1 = t_ch + t_cl
      tmp1l = t_cl - (t_s1 - t_ch)
      tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>  tmp1 = RHO * tmp1
      IF(
!          (tmp1 .le. TOL)
     +    ((tmp1h .lt. TOLh) .or.
     +     ((tmp1h .eq. TOLh) .and.
     +      (tmp1l .le. TOLl)))
     &) THEN
         K = 0
         GO TO 220
      END IF
*
*     If there are multiple eigenvalues then the problem deflates.  Here
*     the number of equal eigenvalues are found.  As each equal
*     eigenvalue is found, an elementary reflector is computed to rotate
*     the corresponding eigensubspace so that the corresponding
*     components of Z are zero in this new basis.
*
*
!      CALL DLAPST( 'I', N, D, INDX, INFO )
      CALL DDLAPST( 'I', N, Dh, Dl, INDX, INFO )
*
      DO 10 I = 1, N1
         COLTYP( I ) = 1
   10 CONTINUE
      DO 20 I = N1P1, N
         COLTYP( I ) = 3
   20 CONTINUE
      COL = DCOL
      DO 40 I = 1, N, NB
         DO 30 J = 0, NB - 1
            IF( I+J.LE.N )
     $         INDCOL( I+J ) = COL
   30    CONTINUE
         COL = MOD( COL+1, NPCOL )
   40 CONTINUE
*
      K = 0
      K2 = N + 1
      DO 50 J = 1, N
         NJ = INDX( J )
!         IF( RHO*ABS( Z( NJ ) ).LE.TOL ) THEN
!<<<     tmp1 = abs(Z(NJ))
         if (Zh(NJ) .lt. 0.0d+0) then
           tmp1h = -Zh(NJ)
           tmp1l = -Zl(NJ)
         elseif (
     +     (Zh(NJ) .eq. 0.0d+0).and.
     +     (Zl(NJ) .lt. 0.0d+0)) then
           tmp1h = Zh(NJ)
           tmp1l = -Zl(NJ)
         else
           tmp1h = Zh(NJ)
           tmp1l = Zl(NJ)
         endif
!>>>     tmp1 = abs(Z(NJ))
!<<<     tmp1 = RHO * tmp1
         t_ch = RHOh * tmp1h
         t_u1 = 134217729.0 * RHOh
         t_p1 = t_u1
     +            - (t_u1 - RHOh)
         t_p2 = RHOh - t_p1
         t_u1 = 134217729.0 * tmp1h
         t_r1 = t_u1
     +            - (t_u1 - tmp1h)
         t_r2 = tmp1h - t_r1
         t_cl = ((t_p1*t_r1
     +            - t_ch)
     +           + t_p1 * t_r2
     +           + t_p2 * t_r1)
     +           + t_p2 * t_r2
         t_cl = t_cl
     +            + (RHOh*tmp1l
     +            +  RHOl*tmp1h)
         t_s1 = t_ch + t_cl
         tmp1l = t_cl - (t_s1 - t_ch)
         tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>     tmp1 = RHO * tmp1
         IF(
!             (tmp1 .le. TOL)
     +       ((tmp1h .lt. TOLh) .or.
     +        ((tmp1h .eq. TOLh) .and.
     +         (tmp1l .le. TOLl)))
     $   ) THEN
*
*           Deflate due to small z component.
*
            K2 = K2 - 1
            COLTYP( NJ ) = 4
            INDXP( K2 ) = NJ
            IF( J.EQ.N )
     $         GO TO 80
         ELSE
            PJ = NJ
            GO TO 60
         END IF
   50 CONTINUE
   60 CONTINUE
      J = J + 1
      NJ = INDX( J )
      IF( J.GT.N )
     $   GO TO 80
!      IF( RHO*ABS( Z( NJ ) ).LE.TOL ) THEN
!<<<  tmp1 = abs(Z(NJ))
      if (Zh(NJ) .lt. 0.0d+0) then
        tmp1h = -Zh(NJ)
        tmp1l = -Zl(NJ)
      elseif (
     +  (Zh(NJ) .eq. 0.0d+0).and.
     +  (Zl(NJ) .lt. 0.0d+0)) then
        tmp1h = Zh(NJ)
        tmp1l = -Zl(NJ)
      else
        tmp1h = Zh(NJ)
        tmp1l = Zl(NJ)
      endif
!>>>  tmp1 = abs(Z(NJ))
!<<<  tmp1 = RHO * tmp1
      t_ch = RHOh * tmp1h
      t_u1 = 134217729.0 * RHOh
      t_p1 = t_u1
     +         - (t_u1 - RHOh)
      t_p2 = RHOh - t_p1
      t_u1 = 134217729.0 * tmp1h
      t_r1 = t_u1
     +         - (t_u1 - tmp1h)
      t_r2 = tmp1h - t_r1
      t_cl = ((t_p1*t_r1
     +         - t_ch)
     +        + t_p1 * t_r2
     +        + t_p2 * t_r1)
     +        + t_p2 * t_r2
      t_cl = t_cl
     +         + (RHOh*tmp1l
     +         +  RHOl*tmp1h)
      t_s1 = t_ch + t_cl
      tmp1l = t_cl - (t_s1 - t_ch)
      tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>  tmp1 = RHO * tmp1
      IF(
!          (tmp1 .le. TOL)
     +    ((tmp1h .lt. TOLh) .or.
     +     ((tmp1h .eq. TOLh) .and.
     +      (tmp1l .le. TOLl)))
     $) THEN
*
*        Deflate due to small z component.
*
         K2 = K2 - 1
         COLTYP( NJ ) = 4
         INDXP( K2 ) = NJ
      ELSE
*
*        Check if eigenvalues are close enough to allow deflation.
*
!         S = Z( PJ )
!         C = Z( NJ )
         Sh = Zh(PJ)
         Sl = Zl(PJ)
         Ch = Zh(NJ)
         Cl = Zl(NJ)
*
*        Find sqrt(a**2+b**2) without overflow or
*        destructive underflow.
*
!         TAU = DLAPY2( C, S )
         CALL DDLAPY2( Ch, Cl, Sh, Sl, TAUh, TAUl )
!         T = D( NJ ) - D( PJ )
!         C = C / TAU
!         S = -S / TAU
!<<<     T = D(NJ) - D(PJ)
         t_p1 = Dh(NJ) - Dh(PJ)
         t_p2 = t_p1 - Dh(NJ)
         t_ch = t_p1
         t_cl = (Dh(NJ) - (t_p1 - t_p2))
     +            - (Dh(PJ) + t_p2)
         t_cl = t_cl + Dl(NJ) - Dl(PJ)
         t_s1 = t_ch + t_cl
         Tl = t_cl - (t_s1 - t_ch)
         Th = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>     T = D(NJ) - D(PJ)
!<<<     C = C / TAU
         t_q1 = Ch / TAUh
         t_ch = TAUh * t_q1
         t_u1 = 134217729.0 * TAUh
         t_p1 = t_u1
     +            - (t_u1 - TAUh)
         t_p2 = TAUh - t_p1
         t_u1 = 134217729.0 * t_q1
         t_r1 = t_u1
     +            - (t_u1 - t_q1)
         t_r2 = t_q1 - t_r1
         t_cl = ((t_p1*t_r1
     +            - t_ch)
     +            + t_p1*t_r2
     +            + t_p2*t_r1)
     +            + t_p2*t_r2
         t_cl = t_cl
     +            + (TAUl * t_q1)
         t_s1 = t_ch + t_cl
         t_cl = t_cl
     +            - (t_s1 - t_ch)
         t_ch = t_s1
         t_s1 = Ch - t_ch
         t_r1 = t_s1 - Ch
         t_s2 = (Ch
     +            - (t_s1 - t_r1))
     +            - (t_ch + t_r1)
         t_s2 = t_s2 - t_cl
         t_s2 = t_s2 + Cl
         t_q2 = (t_s1 + t_s2)
     +            / TAUh
         Ch = t_q1 + t_q2
         Cl = t_q2
     +         - (Ch - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>     C = C / TAU
!<<<     S = S / TAU
         t_q1 = Sh / TAUh
         t_ch = TAUh * t_q1
         t_u1 = 134217729.0 * TAUh
         t_p1 = t_u1
     +            - (t_u1 - TAUh)
         t_p2 = TAUh - t_p1
         t_u1 = 134217729.0 * t_q1
         t_r1 = t_u1
     +            - (t_u1 - t_q1)
         t_r2 = t_q1 - t_r1
         t_cl = ((t_p1*t_r1
     +            - t_ch)
     +            + t_p1*t_r2
     +            + t_p2*t_r1)
     +            + t_p2*t_r2
         t_cl = t_cl
     +            + (TAUl * t_q1)
         t_s1 = t_ch + t_cl
         t_cl = t_cl
     +            - (t_s1 - t_ch)
         t_ch = t_s1
         t_s1 = Sh - t_ch
         t_r1 = t_s1 - Sh
         t_s2 = (Sh
     +            - (t_s1 - t_r1))
     +            - (t_ch + t_r1)
         t_s2 = t_s2 - t_cl
         t_s2 = t_s2 + Sl
         t_q2 = (t_s1 + t_s2)
     +            / TAUh
         Sh = t_q1 + t_q2
         Sl = t_q2
     +         - (Sh - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>     S = S / TAU
!<<<     S = -S
         Sh = -Sh
         Sl = -Sl
!>>>     S = -S
!         IF( ABS( T*C*S ).LE.TOL ) THEN
!<<<     tmp1 = T * C
         t_ch = Th * Ch
         t_u1 = 134217729.0 * Th
         t_p1 = t_u1
     +            - (t_u1 - Th)
         t_p2 = Th - t_p1
         t_u1 = 134217729.0 * Ch
         t_r1 = t_u1
     +            - (t_u1 - Ch)
         t_r2 = Ch - t_r1
         t_cl = ((t_p1*t_r1
     +            - t_ch)
     +           + t_p1 * t_r2
     +           + t_p2 * t_r1)
     +           + t_p2 * t_r2
         t_cl = t_cl
     +            + (Th*Cl
     +            +  Tl*Ch)
         t_s1 = t_ch + t_cl
         tmp1l = t_cl - (t_s1 - t_ch)
         tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>     tmp1 = T * C
!<<<     tmp1 = tmp1 * S
         t_ch = tmp1h * Sh
         t_u1 = 134217729.0 * tmp1h
         t_p1 = t_u1
     +            - (t_u1 - tmp1h)
         t_p2 = tmp1h - t_p1
         t_u1 = 134217729.0 * Sh
         t_r1 = t_u1
     +            - (t_u1 - Sh)
         t_r2 = Sh - t_r1
         t_cl = ((t_p1*t_r1
     +            - t_ch)
     +           + t_p1 * t_r2
     +           + t_p2 * t_r1)
     +           + t_p2 * t_r2
         t_cl = t_cl
     +            + (tmp1h*Sl
     +            +  tmp1l*Sh)
         t_s1 = t_ch + t_cl
         tmp1l = t_cl - (t_s1 - t_ch)
         tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>     tmp1 = tmp1 * S
!<<<     tmp1 = abs(tmp1)
         if (tmp1h .lt. 0.0d+0) then
           tmp1h = -tmp1h
           tmp1l = -tmp1l
         elseif (
     +     (tmp1h .eq. 0.0d+0).and.
     +     (tmp1l .lt. 0.0d+0)) then
           tmp1h = tmp1h
           tmp1l = -tmp1l
         else
           tmp1h = tmp1h
           tmp1l = tmp1l
         endif
!>>>     tmp1 = abs(tmp1)
         IF(
!             (tmp1 .le. TOL)
     +       ((tmp1h .lt. TOLh) .or.
     +        ((tmp1h .eq. TOLh) .and.
     +         (tmp1l .le. TOLl)))
     $   ) THEN
*
*           Deflation is possible.
*
!            Z( NJ ) = TAU
!            Z( PJ ) = ZERO
            Zh(NJ) = TAUh
            Zl(NJ) = TAUl
            Zh(PJ) = ZEROh
            Zl(PJ) = ZEROl
            IF( COLTYP( NJ ).NE.COLTYP( PJ ) )
     $         COLTYP( NJ ) = 2
            COLTYP( PJ ) = 4
            CALL INFOG1L( NJ, NB, NPCOL, MYCOL, DCOL, NJJ, NJCOL )
            CALL INFOG1L( PJ, NB, NPCOL, MYCOL, DCOL, PJJ, PJCOL )
            IF( INDCOL( PJ ).EQ.INDCOL( NJ ) .AND. MYCOL.EQ.NJCOL ) THEN
!               CALL DROT( NP, Q( 1, PJJ ), 1, Q( 1, NJJ ), 1, C, S )
               CALL DDROT( NP, Qh( 1, PJJ ), Ql( 1, PJJ ), 1,
     $                   Qh( 1, NJJ ), Ql( 1, NJJ ), 1, Ch, Cl, Sh, Sl )
            ELSE IF( MYCOL.EQ.PJCOL ) THEN
!               CALL DGESD2D( ICTXT, NP, 1, Q( 1, PJJ ), NP, MYROW,
!     $                       NJCOL )
!               CALL DGERV2D( ICTXT, NP, 1, QBUF, NP, MYROW, NJCOL )
#ifdef COMM_MPI
               CALL MPI_COMM_RANK(MPI_COMM_WORLD, MYRANK, IERR)
!!               PRINT*,"IRECV1", MYROW, MYCOL, MYRANK, MYROW+NJCOL*NPROW
!               CALL MPI_IRECV( QBUF, NP, MPI_DOUBLE_PRECISION,
!     $                         MYROW+NJCOL*NPROW,
!     $                         MYROW+NJCOL*NPROW+10000,
!     $                         MPI_COMM_WORLD,
!     $                         REQ(2), IERR)
!!               PRINT*,"IRECVq", MYROW, MYCOL, MYRANK, MYROW+NJCOL*NPROW
!!               PRINT*,"ISENDs", MYROW, MYCOL, MYRANK, MYROW+NJCOL*NPROW
!               CALL MPI_ISEND( Q(1, PJJ), NP, MPI_DOUBLE_PRECISION,
!     $                         MYROW+NJCOL*NPROW,
!     $                         MYRANK+10000,
!     $                         MPI_COMM_WORLD,
!     $                         REQ(1), IERR)
!!               PRINT*,"ISENDq", MYROW, MYCOL, MYRANK, MYROW+NJCOL*NPROW
!               CALL MPI_WAITALL(2, REQ, ST, IERR)
!!               PRINT*,"WAITALL", MYROW, MYCOL, MYRANK, MYROW+NJCOL*NPROW
               CALL MPI_ISEND_DD( Qh(1, PJJ), Ql(1, PJJ), NP,
     $                            MPI_DOUBLE_PRECISION,
     $                            MYROW+NJCOL*NPROW,
     $                            MYRANK+10000,
     $                            MPI_COMM_WORLD,
     $                            REQ(1), IERR)
               CALL MPI_WAIT_DD( REQ(1), ST, IERR )
               QBUFF(1:NP)      = QBUFh(1:NP)
               QBUFF(1+NP:2*NP) = QBUFl(1:NP)
               CALL MPI_IRECV_DD( QBUFF, NP, MPI_DOUBLE_PRECISION,
     $                            MYROW+NJCOL*NPROW,
     $                            MYROW+NJCOL*NPROW+10000,
     $                            MPI_COMM_WORLD,
     $                            REQ(2), IERR)
               CALL MPI_WAITIRECV_DD( QBUFh, QBUFl, QBUFF, NP,
     $                                REQ(1), ST, IERR )
#elif defined COMM_BLACS2_
               DO I=1, NP
                  Q(I)    = Qh(I,PJJ)
                  Q(I+NP) = Ql(I,PJJ)
               END DO
               NBUF2 = NP*2
               CALL DGESD2D( ICTXT, NBUF2, 1, Q,   NBUF2, MYROW, NJCOL )
               CALL DGERV2D( ICTXT, NBUF2, 1, QBUF, NBUF2, MYROW, NJCOL)
               DO I=1, NP
                  QBUFh(I) = QBUF(I)
                  QBUFl(I) = QBUF(I+NP)
               END DO
#else
# if 0
               CALL DGESD2D( ICTXT, NP, 1, Qh( 1, PJJ ), NP, MYROW,
     $                       NJCOL )
               CALL DGESD2D( ICTXT, NP, 1, Ql( 1, PJJ ), NP, MYROW,
     $                       NJCOL )
               CALL DGERV2D( ICTXT, NP, 1, QBUFh, NP, MYROW, NJCOL )
               CALL DGERV2D( ICTXT, NP, 1, QBUFl, NP, MYROW, NJCOL )
# else
               CALL MPI_COMM_RANK(MPI_COMM_WORLD, MYRANK, IERR)
               CALL MPI_IRECV( QBUFh, NP, MPI_DOUBLE_PRECISION,
     $                         MYROW+NJCOL*NPROW,
     $                         MYROW+NJCOL*NPROW+10000,
     $                         MPI_COMM_WORLD,
     $                         REQ(2), IERR)
               CALL MPI_ISEND( Qh(1, PJJ), NP, MPI_DOUBLE_PRECISION,
     $                         MYROW+NJCOL*NPROW,
     $                         MYRANK+10000,
     $                         MPI_COMM_WORLD,
     $                         REQ(1), IERR)
               CALL MPI_WAITALL(2, REQ, ST, IERR)
               CALL MPI_IRECV( QBUFl, NP, MPI_DOUBLE_PRECISION,
     $                         MYROW+NJCOL*NPROW,
     $                         MYROW+NJCOL*NPROW+10000,
     $                         MPI_COMM_WORLD,
     $                         REQ(2), IERR)
               CALL MPI_ISEND( Ql(1, PJJ), NP, MPI_DOUBLE_PRECISION,
     $                         MYROW+NJCOL*NPROW,
     $                         MYRANK+10000,
     $                         MPI_COMM_WORLD,
     $                         REQ(1), IERR)
               CALL MPI_WAITALL(2, REQ, ST, IERR)
# endif
#endif
!               CALL DROT( NP, Q( 1, PJJ ), 1, QBUF, 1, C, S )
               CALL DDROT( NP, Qh( 1, PJJ ), Ql( 1, PJJ ), 1,
     $                     QBUFh, QBUFl, 1, Ch, Cl, Sh, Sl )
            ELSE IF( MYCOL.EQ.NJCOL ) THEN
!               CALL DGESD2D( ICTXT, NP, 1, Q( 1, NJJ ), NP, MYROW,
!     $                       PJCOL )
!               CALL DGERV2D( ICTXT, NP, 1, QBUF, NP, MYROW, PJCOL )
#ifdef COMM_MPI
               CALL MPI_COMM_RANK(MPI_COMM_WORLD, MYRANK, IERR)
!!               PRINT*,"IRECVs", MYROW, MYCOL, MYRANK, MYROW+PJCOL*NPROW
!               CALL MPI_IRECV( QBUF, NP, MPI_DOUBLE_PRECISION,
!     $                         MYROW+PJCOL*NPROW,
!     $                         MYROW+PJCOL*NPROW+10000,
!     $                         MPI_COMM_WORLD,
!     $                         REQ(2), IERR)
!!               PRINT*,"IRECVq", MYROW, MYCOL, MYRANK, MYROW+PJCOL*NPROW
!!               PRINT*,"ISENDs", MYROW, MYCOL, MYRANK, MYROW+PJCOL*NPROW
!               CALL MPI_ISEND( Q(1, NJJ), NP, MPI_DOUBLE_PRECISION,
!     $                         MYROW+PJCOL*NPROW,
!     $                         MYRANK+10000,
!     $                         MPI_COMM_WORLD,
!     $                         REQ(1), IERR)
!!               PRINT*,"ISENDq", MYROW, MYCOL, MYRANK, MYROW+PJCOL*NPROW
!               CALL MPI_WAITALL(2, REQ, ST, IERR)
!!               PRINT*,"WAITALL", MYROW, MYCOL, MYRANK, MYROW+PJCOL*NPROW
               CALL MPI_ISEND_DD( Qh(1, NJJ), Ql(1, NJJ),NP,
     $                            MPI_DOUBLE_PRECISION,
     $                            MYROW+PJCOL*NPROW,
     $                            MYRANK+10000,
     $                            MPI_COMM_WORLD,
     $                            REQ(1), IERR)
               CALL MPI_WAIT_DD( REQ(1), ST, IERR )
               QBUFF(1:NP)      = QBUFh(1:NP)
               QBUFF(1+NP:2*NP) = QBUFl(1:NP)
               CALL MPI_IRECV_DD( QBUFF, NP, MPI_DOUBLE_PRECISION,
     $                            MYROW+PJCOL*NPROW,
     $                            MYROW+PJCOL*NPROW+10000,
     $                            MPI_COMM_WORLD,
     $                            REQ(2), IERR)
               CALL MPI_WAITIRECV_DD( QBUFh, QBUFl, QBUFF, NP,
     $                                REQ(1), ST, IERR )
#elif defined COMM_BLACS2_
               DO I=1, NP
                 Q(I)    = Qh(I, NJJ)
                 Q(I+NP) = Ql(I, NJJ)
               END DO
               NBUF2 = NP*2
               CALL DGESD2D( ICTXT, NBUF2, 1, Q,    NBUF2, MYROW, PJCOL)
               CALL DGERV2D( ICTXT, NBUF2, 1, QBUF, NBUF2, MYROW, PJCOL)
               DO I=1, NP
                  QBUFh(I) = QBUF(I)
                  QBUFl(I) = QBUF(I+NP)
               END DO
#else
# if 0
               CALL DGESD2D( ICTXT, NP, 1, Qh( 1, NJJ ), NP, MYROW,
     $                       PJCOL )
               CALL DGESD2D( ICTXT, NP, 1, Ql( 1, NJJ ), NP, MYROW,
     $                       PJCOL )
               CALL DGERV2D( ICTXT, NP, 1, QBUFh, NP, MYROW, PJCOL )
               CALL DGERV2D( ICTXT, NP, 1, QBUFl, NP, MYROW, PJCOL )
# else
               CALL MPI_COMM_RANK(MPI_COMM_WORLD, MYRANK, IERR)
               CALL MPI_IRECV( QBUFh, NP, MPI_DOUBLE_PRECISION,
     $                         MYROW+PJCOL*NPROW,
     $                         MYROW+PJCOL*NPROW+10000,
     $                         MPI_COMM_WORLD,
     $                         REQ(2), IERR)
               CALL MPI_ISEND( Qh(1, NJJ), NP, MPI_DOUBLE_PRECISION,
     $                         MYROW+PJCOL*NPROW,
     $                         MYRANK+10000,
     $                         MPI_COMM_WORLD,
     $                         REQ(1), IERR)
               CALL MPI_WAITALL(2, REQ, ST, IERR)
               CALL MPI_IRECV( QBUFl, NP, MPI_DOUBLE_PRECISION,
     $                         MYROW+PJCOL*NPROW,
     $                         MYROW+PJCOL*NPROW+10000,
     $                         MPI_COMM_WORLD,
     $                         REQ(2), IERR)
               CALL MPI_ISEND( Ql(1, NJJ), NP, MPI_DOUBLE_PRECISION,
     $                         MYROW+PJCOL*NPROW,
     $                         MYRANK+10000,
     $                         MPI_COMM_WORLD,
     $                         REQ(1), IERR)
               CALL MPI_WAITALL(2, REQ, ST, IERR)
# endif
#endif
!               CALL DROT( NP, QBUF, 1, Q( 1, NJJ ), 1, C, S )
               CALL DDROT( NP, QBUFh, QBUFl, 1,
     $                  Qh( 1, NJJ ), Ql( 1, NJJ ), 1, Ch, Cl, Sh, Sl )
            END IF
!            T = D( PJ )*C**2 + D( NJ )*S**2
!<<<        tmp1 = C * C
            t_ch = Ch * Ch
            t_u1 = 134217729.0 * Ch
            t_p1 = t_u1
     +               - (t_u1 - Ch)
            t_p2 = Ch - t_p1
            t_u1 = 134217729.0 * Ch
            t_r1 = t_u1
     +               - (t_u1 - Ch)
            t_r2 = Ch - t_r1
            t_cl = ((t_p1*t_r1
     +               - t_ch)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            t_cl = t_cl
     +               + (Ch*Cl
     +               +  Cl*Ch)
            t_s1 = t_ch + t_cl
            tmp1l = t_cl - (t_s1 - t_ch)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>        tmp1 = C * C
!<<<        T = D(PJ) * tmp1
            t_ch = Dh(PJ) * tmp1h
            t_u1 = 134217729.0 * Dh(PJ)
            t_p1 = t_u1
     +               - (t_u1 - Dh(PJ))
            t_p2 = Dh(PJ) - t_p1
            t_u1 = 134217729.0 * tmp1h
            t_r1 = t_u1
     +               - (t_u1 - tmp1h)
            t_r2 = tmp1h - t_r1
            t_cl = ((t_p1*t_r1
     +               - t_ch)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            t_cl = t_cl
     +               + (Dh(PJ)*tmp1l
     +               +  Dl(PJ)*tmp1h)
            t_s1 = t_ch + t_cl
            Tl = t_cl - (t_s1 - t_ch)
            Th = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>        T = D(PJ) * tmp1
!<<<        tmp1 = S * S
            t_ch = Sh * Sh
            t_u1 = 134217729.0 * Sh
            t_p1 = t_u1
     +               - (t_u1 - Sh)
            t_p2 = Sh - t_p1
            t_u1 = 134217729.0 * Sh
            t_r1 = t_u1
     +               - (t_u1 - Sh)
            t_r2 = Sh - t_r1
            t_cl = ((t_p1*t_r1
     +               - t_ch)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            t_cl = t_cl
     +               + (Sh*Sl
     +               +  Sl*Sh)
            t_s1 = t_ch + t_cl
            tmp1l = t_cl - (t_s1 - t_ch)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>        tmp1 = S * S
!<<<        tmp1 = D(NJ) * tmp1
            t_ch = Dh(NJ) * tmp1h
            t_u1 = 134217729.0 * Dh(NJ)
            t_p1 = t_u1
     +               - (t_u1 - Dh(NJ))
            t_p2 = Dh(NJ) - t_p1
            t_u1 = 134217729.0 * tmp1h
            t_r1 = t_u1
     +               - (t_u1 - tmp1h)
            t_r2 = tmp1h - t_r1
            t_cl = ((t_p1*t_r1
     +               - t_ch)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            t_cl = t_cl
     +               + (Dh(NJ)*tmp1l
     +               +  Dl(NJ)*tmp1h)
            t_s1 = t_ch + t_cl
            tmp1l = t_cl - (t_s1 - t_ch)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>        tmp1 = D(NJ) * tmp1
!<<<        T = T + tmp1
            t_p1 = Th + tmp1h
            t_p2 = t_p1 - Th
            t_q1 = t_p1
            t_q2 = (Th - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + Tl + tmp1l
            Th = t_q1 + t_q2
            Tl = t_q2 - (Th - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        T = T + tmp1
!            D( NJ ) = D( PJ )*S**2 + D( NJ )*C**2
!<<<        tmp1 = S * S
            t_ch = Sh * Sh
            t_u1 = 134217729.0 * Sh
            t_p1 = t_u1
     +               - (t_u1 - Sh)
            t_p2 = Sh - t_p1
            t_u1 = 134217729.0 * Sh
            t_r1 = t_u1
     +               - (t_u1 - Sh)
            t_r2 = Sh - t_r1
            t_cl = ((t_p1*t_r1
     +               - t_ch)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            t_cl = t_cl
     +               + (Sh*Sl
     +               +  Sl*Sh)
            t_s1 = t_ch + t_cl
            tmp1l = t_cl - (t_s1 - t_ch)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>        tmp1 = S * S
!<<<        tmp1 = D(PJ) * tmp1
            t_ch = Dh(PJ) * tmp1h
            t_u1 = 134217729.0 * Dh(PJ)
            t_p1 = t_u1
     +               - (t_u1 - Dh(PJ))
            t_p2 = Dh(PJ) - t_p1
            t_u1 = 134217729.0 * tmp1h
            t_r1 = t_u1
     +               - (t_u1 - tmp1h)
            t_r2 = tmp1h - t_r1
            t_cl = ((t_p1*t_r1
     +               - t_ch)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            t_cl = t_cl
     +               + (Dh(PJ)*tmp1l
     +               +  Dl(PJ)*tmp1h)
            t_s1 = t_ch + t_cl
            tmp1l = t_cl - (t_s1 - t_ch)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>        tmp1 = D(PJ) * tmp1
!<<<        tmp2 = C * C
            t_ch = Ch * Ch
            t_u1 = 134217729.0 * Ch
            t_p1 = t_u1
     +               - (t_u1 - Ch)
            t_p2 = Ch - t_p1
            t_u1 = 134217729.0 * Ch
            t_r1 = t_u1
     +               - (t_u1 - Ch)
            t_r2 = Ch - t_r1
            t_cl = ((t_p1*t_r1
     +               - t_ch)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            t_cl = t_cl
     +               + (Ch*Cl
     +               +  Cl*Ch)
            t_s1 = t_ch + t_cl
            tmp2l = t_cl - (t_s1 - t_ch)
            tmp2h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>        tmp2 = C * C
!<<<        tmp2 = D(NJ) * tmp2
            t_ch = Dh(NJ) * tmp2h
            t_u1 = 134217729.0 * Dh(NJ)
            t_p1 = t_u1
     +               - (t_u1 - Dh(NJ))
            t_p2 = Dh(NJ) - t_p1
            t_u1 = 134217729.0 * tmp2h
            t_r1 = t_u1
     +               - (t_u1 - tmp2h)
            t_r2 = tmp2h - t_r1
            t_cl = ((t_p1*t_r1
     +               - t_ch)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            t_cl = t_cl
     +               + (Dh(NJ)*tmp2l
     +               +  Dl(NJ)*tmp2h)
            t_s1 = t_ch + t_cl
            tmp2l = t_cl - (t_s1 - t_ch)
            tmp2h = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>        tmp2 = D(NJ) * tmp2
!<<<        D(NJ) = tmp1 + tmp2
            t_p1 = tmp1h + tmp2h
            t_p2 = t_p1 - tmp1h
            t_q1 = t_p1
            t_q2 = (tmp1h - (t_p1 - t_p2))
     +               + (tmp2h - t_p2)
            t_q2 = t_q2 + tmp1l + tmp2l
            Dh(NJ) = t_q1 + t_q2
            Dl(NJ) = t_q2 - (Dh(NJ) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        D(NJ) = tmp1 + tmp2
!            D( PJ ) = T
            Dh(PJ) = Th
            Dl(PJ) = Tl
            K2 = K2 - 1
            I = 1
   70       CONTINUE
            IF( K2+I.LE.N ) THEN
!               IF( D( PJ ).LT.D( INDXP( K2+I ) ) ) THEN
               IF(
!                   (D(PJ) .lt. D(INDXP(K2+I)))
     +             ((Dh(PJ) .lt. Dh(INDXP(K2+I))) .or.
     +              ((Dh(PJ) .eq. Dh(INDXP(K2+I))) .and.
     +               (Dl(PJ) .lt. Dl(INDXP(K2+I)))))
     $         ) THEN
                  INDXP( K2+I-1 ) = INDXP( K2+I )
                  INDXP( K2+I ) = PJ
                  I = I + 1
                  GO TO 70
               ELSE
                  INDXP( K2+I-1 ) = PJ
               END IF
            ELSE
               INDXP( K2+I-1 ) = PJ
            END IF
            PJ = NJ
         ELSE
            K = K + 1
!            DLAMDA( K ) = D( PJ )
!            W( K ) = Z( PJ )
                  DLAMDAh(K) = Dh(PJ)
                  DLAMDAl(K) = Dl(PJ)
                  Wh(K) = Zh(PJ)
                  Wl(K) = Zl(PJ)
            INDXP( K ) = PJ
            PJ = NJ
         END IF
      END IF
      GO TO 60
   80 CONTINUE
*
*     Record the last eigenvalue.
*
      K = K + 1
!      DLAMDA( K ) = D( PJ )
!      W( K ) = Z( PJ )
      DLAMDAh(K) = Dh(PJ)
      DLAMDAl(K) = Dl(PJ)
      Wh(K) = Zh(PJ)
      Wl(K) = Zl(PJ)
      INDXP( K ) = PJ
*
*     Count up the total number of the various types of columns, then
*     form a permutation which positions the four column types into
*     four uniform groups (although one or more of these groups may be
*     empty).
*
      DO 100 J = 1, 4
         DO 90 I = 0, NPCOL - 1
            CTOT( I, J ) = 0
   90    CONTINUE
         PTT( J ) = 0
  100 CONTINUE
      DO 110 J = 1, N
         CT = COLTYP( J )
         COL = INDCOL( J )
         CTOT( COL, CT ) = CTOT( COL, CT ) + 1
  110 CONTINUE
*
*     PSM(*) = Position in SubMatrix (of types 1 through 4)
*
      DO 120 COL = 0, NPCOL - 1
         PSM( COL, 1 ) = 1
         PSM( COL, 2 ) = 1 + CTOT( COL, 1 )
         PSM( COL, 3 ) = PSM( COL, 2 ) + CTOT( COL, 2 )
         PSM( COL, 4 ) = PSM( COL, 3 ) + CTOT( COL, 3 )
  120 CONTINUE
      PTT( 1 ) = 1
      DO 140 I = 2, 4
         CT = 0
         DO 130 J = 0, NPCOL - 1
            CT = CT + CTOT( J, I-1 )
  130    CONTINUE
         PTT( I ) = PTT( I-1 ) + CT
  140 CONTINUE
*
*     Fill out the INDXC array so that the permutation which it induces
*     will place all type-1 columns first, all type-2 columns next,
*     then all type-3's, and finally all type-4's.
*
      DO 150 J = 1, N
         JS = INDXP( J )
         COL = INDCOL( JS )
         CT = COLTYP( JS )
         I = INDXL2G( PSM( COL, CT ), NB, COL, DCOL, NPCOL )
         INDX( J ) = I
         INDXC( PTT( CT ) ) = I
         PSM( COL, CT ) = PSM( COL, CT ) + 1
         PTT( CT ) = PTT( CT ) + 1
  150 CONTINUE
*
*
      DO 160 J = 1, N
         JS = INDXP( J )
         JJS = INDXG2L( JS, NB, J, J, NPCOL )
         COL = INDCOL( JS )
         IF( COL.EQ.MYCOL ) THEN
            I = INDX( J )
            JJQ2 = INDXG2L( I, NB, J, J, NPCOL )
!            CALL DCOPY( NP, Q( 1, JJS ), 1, Q2( 1, JJQ2 ), 1 )
            CALL DDCOPY( NP, Qh( 1, JJS ), Ql( 1, JJS ), 1,
     $                   Q2h( 1, JJQ2 ), Q2l( 1, JJQ2 ), 1 )
         END IF
  160 CONTINUE
*
*
*     The deflated eigenvalues and their corresponding vectors go back
*     into the last N - K slots of D and Q respectively.
*
!      CALL DCOPY( N, D, 1, Z, 1 )
      CALL DDCOPY( N, Dh, Dl, 1, Zh, Zl, 1 )
      DO 170 J = K + 1, N
         JS = INDXP( J )
         I = INDX( J )
!         D( I ) = Z( JS )
         Dh(I) = Zh(JS)
         Dl(I) = Zl(JS)
  170 CONTINUE
*
      PTT( 1 ) = 1
      DO 190 I = 2, 4
         CT = 0
         DO 180 J = 0, NPCOL - 1
            CT = CT + CTOT( J, I-1 )
  180    CONTINUE
         PTT( I ) = PTT( I-1 ) + CT
  190 CONTINUE
*
*
      IB1 = INDXC( 1 )
      IE1 = IB1
      IB2 = INDXC( PTT( 2 ) )
      IE2 = IB2
      DO 200 I = 2, PTT( 3 ) - 1
         IB1 = MIN( IB1, INDXC( I ) )
         IE1 = MAX( IE1, INDXC( I ) )
  200 CONTINUE
      DO 210 I = PTT( 2 ), PTT( 4 ) - 1
         IB2 = MIN( IB2, INDXC( I ) )
         IE2 = MAX( IE2, INDXC( I ) )
  210 CONTINUE
      NN1 = IE1 - IB1 + 1
      NN2 = IE2 - IB2 + 1
      NN = MAX( IE1, IE2 ) - MIN( IB1, IB2 ) + 1
  220 CONTINUE
      RETURN
*
*     End of PDDLAED2X
*
      END
