!      SUBROUTINE PDLAED3X( ICTXT, K, N, NB, D, DROW, DCOL, RHO, DLAMDA,
!     $                    W, Z, U, LDU, BUF, INDX, INDCOL, INDROW,
!     $                    INDXR, INDXC, CTOT, NPCOL, INFO )
      SUBROUTINE PDDLAED3X( ICTXT, K, N, NB, Dh, Dl, DROW, DCOL,
     $                      RHOh, RHOl, DLAMDAh, DLAMDAl, Wh, Wl,
     $                      Zh, Zl, Uh, Ul, LDU, BUFh, BUFl,
     $                      INDX, INDCOL, INDROW,
     $                      INDXR, INDXC, CTOT, NPCOL, INFO )
      USE OMP_LIB
*
*  -- ScaLAPACK auxiliary routine (version 1.7) --
*     University of Tennessee, Knoxville, Oak Ridge National Laboratory,
*     and University of California, Berkeley.
*     December 31, 1998
*
*     .. Scalar Arguments ..
      INTEGER            DCOL, DROW, ICTXT, INFO, K, LDU, N, NB, NPCOL
!      DOUBLE PRECISION   RHO
      double precision RHOh, RHOl
*     ..
*     .. Array Arguments ..
      INTEGER            CTOT( 0: NPCOL-1, 4 ), INDCOL( * ),
     $                   INDROW( * ), INDX( * ), INDXC( * ), INDXR( * )
!      DOUBLE PRECISION   BUF( 1:2*K ), D( * ), DLAMDA( * ), U( LDU, * ),
!!      DOUBLE PRECISION   BUF( * ), D( * ), DLAMDA( * ), U( LDU, * ),
!     $                   W( * ), Z(1:K)
!!     $                   W( * ), Z( * )
      double precision BUFh(1:2*K), BUFl(1:2*K)
      double precision Dh(*), Dl(*)
      double precision DLAMDAh(*), DLAMDAl(*)
      double precision Uh(LDU,*), Ul(LDU,*)
      double precision Wh(*), Wl(*)
      double precision Zh(1:K), Zl(1:K)
*     ..
*
*  Purpose
*  =======
*
*  PDLAED3X finds the roots of the secular equation, as defined by the
*  values in D, W, and RHO, between 1 and K.  It makes the
*  appropriate calls to SLAED4
*
*  This code makes very mild assumptions about floating point
*  arithmetic. It will work on machines with a guard digit in
*  add/subtract, or on those binary machines without guard digits
*  which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or Cray-2.
*  It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
*
*  Arguments
*  =========
*
*  ICTXT  (global input) INTEGER
*         The BLACS context handle, indicating the global context of
*         the operation on the matrix. The context itself is global.
*
*  K      (output) INTEGER
*         The number of non-deflated eigenvalues, and the order of the
*         related secular equation. 0 <= K <=N.
*
*  N      (input) INTEGER
*         The dimension of the symmetric tridiagonal matrix.  N >= 0.
*
*  NB      (global input) INTEGER
*          The blocking factor used to distribute the columns of the
*          matrix. NB >= 1.
*
*  D      (input/output) DOUBLE PRECISION array, dimension (N)
*         On entry, D contains the eigenvalues of the two submatrices to
*         be combined.
*         On exit, D contains the trailing (N-K) updated eigenvalues
*         (those which were deflated) sorted into increasing order.
*
*  DROW   (global input) INTEGER
*          The process row over which the first row of the matrix D is
*          distributed. 0 <= DROW < NPROW.
*
*  DCOL   (global input) INTEGER
*          The process column over which the first column of the
*          matrix D is distributed. 0 <= DCOL < NPCOL.
*
*  Q      (input/output) DOUBLE PRECISION array, dimension (LDQ, N)
*         On entry, Q contains the eigenvectors of two submatrices in
*         the two square blocks with corners at (1,1), (N1,N1)
*         and (N1+1, N1+1), (N,N).
*         On exit, Q contains the trailing (N-K) updated eigenvectors
*         (those which were deflated) in its last N-K columns.
*
*  LDQ    (input) INTEGER
*         The leading dimension of the array Q.  LDQ >= max(1,NQ).
*
*  RHO    (global input/output) DOUBLE PRECISION
*         On entry, the off-diagonal element associated with the rank-1
*         cut which originally split the two submatrices which are now
*         being recombined.
*         On exit, RHO has been modified to the value required by
*         PDLAED3X.
*
*  DLAMDA (global output) DOUBLE PRECISION array, dimension (N)
*         A copy of the first K eigenvalues which will be used by
*         SLAED3 to form the secular equation.
*
*  W      (global output) DOUBLE PRECISION array, dimension (N)
*         The first k values of the final deflation-altered z-vector
*         which will be passed to SLAED3.
*
*  Z      (global input) DOUBLE PRECISION array, dimension (N)
*         On entry, Z contains the updating vector (the last
*         row of the first sub-eigenvector matrix and the first row of
*         the second sub-eigenvector matrix).
*         On exit, the contents of Z have been destroyed by the updating
*         process.
*
*  U     (global output) DOUBLE PRECISION array
*         global dimension (N, N), local dimension (LDU, NQ).
*         Q  contains the orthonormal eigenvectors of the symmetric
*         tridiagonal matrix.
*
*  LDU    (input) INTEGER
*         The leading dimension of the array U.
*
*  QBUF   (workspace) DOUBLE PRECISION array, dimension 3*N
*
*
*  INDX   (workspace) INTEGER array, dimension (N)
*         The permutation used to sort the contents of DLAMDA into
*         ascending order.
*
*  INDCOL (workspace) INTEGER array, dimension (N)
*
*
*  INDROW (workspace) INTEGER array, dimension (N)
*
*
*  INDXR (workspace) INTEGER array, dimension (N)
*
*
*  INDXC (workspace) INTEGER array, dimension (N)
*
*  CTOT   (workspace) INTEGER array, dimension( NPCOL, 4)
*
*  NPCOL   (global input) INTEGER
*          The total number of columns over which the distributed
*           submatrix is distributed.
*
*  INFO   (output) INTEGER
*          = 0:  successful exit.
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*          > 0:  The algorithm failed to compute the ith eigenvalue.
*
*  =====================================================================
*
*     .. Parameters ..
!      DOUBLE PRECISION   ONE
!      PARAMETER          ( ONE = 1.0D+0 )
      double precision ONEh, ONEl
*     ..
*     .. Local Scalars ..
      INTEGER            COL, GI, I, IINFO, IIU, IPD, IU, J, JJU, JU,
     $                   KK, KL, KLC, KLR, MYCOL, MYKL, MYKLR, MYROW,
     $                   NPROW, PDC, PDR, ROW
      integer NBUF
!      DOUBLE PRECISION   AUX, TEMP
      double precision AUXh, AUXl
      double precision TEMPh, TEMPl
!      REAL(8) :: SZ(1:K), SBUF(1:K)
!      REAL(8), POINTER :: SZ(:), SBUF(:)
      REAL(8), POINTER :: SZh(:), SZl(:), SBUFh(:), SBUFl(:)
      INTEGER :: SINFO
*     ..
*     .. External Functions ..
      INTEGER            INDXG2L
!      DOUBLE PRECISION   DLAMC3, DNRM2
!      EXTERNAL           INDXG2L, DLAMC3, DNRM2
      EXTERNAL           INDXG2L
*     ..
*     .. External Subroutines ..
!      EXTERNAL           BLACS_GRIDINFO, DCOPY, DGEBR2D, DGEBS2D,
!     $                   DGERV2D, DGESD2D, DLAED4
      EXTERNAL           BLACS_GRIDINFO, DDCOPY, DDGEBR2D, DDGEBS2D,
     $                   DDGERV2D, DDGESD2D, DDLAED4, DDLAMC3, DDNRM2
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MOD, SIGN, SQRT
*     ..
*     .. Executable Statements ..
#ifdef COMM_MPI
      include 'mpif.h'
      integer ireq(2), ierr, dest, tag, comm, myrank
      integer istat(MPI_STATUS_SIZE)
      double precision buff(4*N)
#endif
#ifdef COMM_BLACS2
      integer NBUF2
      double precision buf(6*N)
#endif
      double precision tmp1h, tmp1l
!     tmp vars
      double precision t_ch, t_cl
      double precision t_p1, t_p2
      double precision t_q1, t_q2
      double precision t_r1, t_r2
      double precision t_s1, t_s2
      double precision t_t1, t_t2
      double precision t_u1, t_u2
      double precision t_x1, t_x2
      double precision t_y1, t_y2
      double precision t_z1, t_z2
      double precision t_x, t_ax
      double precision t_t1h, t_t1l
      double precision t_t2h, t_t2l
      ONEh = 1.0d+0
      ONEl = 0.0d+0
*
*     Test the input parameters.
*
      INFO = 0
*
*     Quick return if possible
* 

      IF( K.EQ.0 )
     $   RETURN
*
      CALL BLACS_GRIDINFO( ICTXT, NPROW, NPCOL, MYROW, MYCOL )
*
      ROW = DROW
      COL = DCOL
      DO 20 I = 1, N, NB
         DO 10 J = 0, NB - 1
            IF( I+J.LE.N ) THEN
               INDROW( I+J ) = ROW
               INDCOL( I+J ) = COL
            END IF
   10    CONTINUE
         ROW = MOD( ROW+1, NPROW )
         COL = MOD( COL+1, NPCOL )
   20 CONTINUE
*
      MYKL = CTOT( MYCOL, 1 ) + CTOT( MYCOL, 2 ) + CTOT( MYCOL, 3 )
      KLR = MYKL / NPROW
      IF( MYROW.EQ.DROW ) THEN
         MYKLR = KLR + MOD( MYKL, NPROW )
      ELSE
         MYKLR = KLR
      END IF
      PDC = 1
      COL = DCOL
   30 CONTINUE
      IF( MYCOL.NE.COL ) THEN
         PDC = PDC + CTOT( COL, 1 ) + CTOT( COL, 2 ) + CTOT( COL, 3 )
         COL = MOD( COL+1, NPCOL )
         GO TO 30
      END IF
      PDR = PDC
      KL = KLR + MOD( MYKL, NPROW )
      ROW = DROW
   40 CONTINUE
      IF( MYROW.NE.ROW ) THEN
         PDR = PDR + KL
         KL = KLR
         ROW = MOD( ROW+1, NPROW )
         GO TO 40
      END IF
*
      DO 50 I = 1, K
!         DLAMDA( I ) = DLAMC3( DLAMDA( I ), DLAMDA( I ) ) - DLAMDA( I )
!         Z( I ) = ONE
         CALL DDLAMC3(DLAMDAh(I), DLAMDAl(I), DLAMDAh(I), DLAMDAl(I),
     $                tmp1h, tmp1l)
!<<<     DLAMDA(I) = tmp1 - DLAMDA(I)
         t_p1 = tmp1h - DLAMDAh(I)
         t_p2 = t_p1 - tmp1h
         t_ch = t_p1
         t_cl = (tmp1h - (t_p1 - t_p2))
     +            - (DLAMDAh(I) + t_p2)
         t_cl = t_cl + tmp1l - DLAMDAl(I)
         t_s1 = t_ch + t_cl
         DLAMDAl(I) = t_cl - (t_s1 - t_ch)
         DLAMDAh(I) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>     DLAMDA(I) = tmp1 - DLAMDA(I)
         Zh(I) = ONEh
         Zl(I) = ONEl
   50 CONTINUE
      IF( MYKLR.GT.0 ) THEN
!-         KK = PDR
!!$OMP PARALLEL PRIVATE(I,J,KK,IINFO,SZ,SBUF,SINFO,AUX)
!$OMP PARALLEL PRIVATE(I,J,KK,IINFO,SZh,SZl,SBUFh,SBUFl,SINFO,AUXh,AUXl)
!$omp+ private(tmp1h,tmp1l,info)
!     tmp vars -> private
!$omp+ private(t_ch, t_cl)
!$omp+ private(t_p1, t_p2)
!$omp+ private(t_q1, t_q2)
!$omp+ private(t_r1, t_r2)
!$omp+ private(t_s1, t_s2)
!$omp+ private(t_t1, t_t2)
!$omp+ private(t_u1, t_u2)
!$omp+ private(t_x1, t_x2)
!$omp+ private(t_y1, t_y2)
!$omp+ private(t_z1, t_z2)
!$omp+ private(t_x, t_ax)
!$omp+ private(t_t1h, t_t1l)
!$omp+ private(t_t2h, t_t2l)

!         ALLOCATE(SZ(1:K), SBUF(1:K))
         ALLOCATE(SZh(1:K), SZl(1:K), SBUFh(1:K), SBUFl(1:K))

!         SZ( 1:K ) = ONE
         SZh(1:K) = ONEh
         SZl(1:K) = ONEl

!$OMP DO
         DO 80 I = 1, MYKLR
            KK = PDR + I - 1
!            CALL DLAED4( K, KK, DLAMDA, W, SBUF, RHO, AUX, IINFO )
            CALL DDLAED4( K, KK, DLAMDAh, DLAMDAl, Wh, Wl, SBUFh, SBUFl,
     &                    RHOh, RHOl, AUXh, AUXl, IINFO )
!            BUF(K+I) = AUX
            BUFh(K+I) = AUXh
            BUFl(K+I) = AUXl
            IF( IINFO.NE.0 ) THEN
               SINFO = KK
            END IF
*
*     ..Compute part of z
*
            DO 60 J = 1, KK - 1
!               SZ( J ) = SZ( J )*( SBUF( J ) /
!     $                  ( DLAMDA( J )-DLAMDA( KK ) ) )
!<<<           tmp1 = DLAMDA(J) - DLAMDA(KK)
               t_p1 = DLAMDAh(J) - DLAMDAh(KK)
               t_p2 = t_p1 - DLAMDAh(J)
               t_ch = t_p1
               t_cl = (DLAMDAh(J) - (t_p1 - t_p2))
     +                  - (DLAMDAh(KK) + t_p2)
               t_cl = t_cl + DLAMDAl(J) - DLAMDAl(KK)
               t_s1 = t_ch + t_cl
               tmp1l = t_cl - (t_s1 - t_ch)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           tmp1 = DLAMDA(J) - DLAMDA(KK)
!<<<           tmp1 = SBUF(J) / tmp1
               t_q1 = SBUFh(J) / tmp1h
               t_ch = tmp1h * t_q1
               t_u1 = 134217729.0 * tmp1h
               t_p1 = t_u1
     +                  - (t_u1 - tmp1h)
               t_p2 = tmp1h - t_p1
               t_u1 = 134217729.0 * t_q1
               t_r1 = t_u1
     +                  - (t_u1 - t_q1)
               t_r2 = t_q1 - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                  + t_p1*t_r2
     +                  + t_p2*t_r1)
     +                  + t_p2*t_r2
               t_cl = t_cl
     +                  + (tmp1l * t_q1)
               t_s1 = t_ch + t_cl
               t_cl = t_cl
     +                  - (t_s1 - t_ch)
               t_ch = t_s1
               t_s1 = SBUFh(J) - t_ch
               t_r1 = t_s1 - SBUFh(J)
               t_s2 = (SBUFh(J)
     +                  - (t_s1 - t_r1))
     +                  - (t_ch + t_r1)
               t_s2 = t_s2 - t_cl
               t_s2 = t_s2 + SBUFl(J)
               t_q2 = (t_s1 + t_s2)
     +                  / tmp1h
               tmp1h = t_q1 + t_q2
               tmp1l = t_q2
     +               - (tmp1h - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>           tmp1 = SBUF(J) / tmp1
!<<<           SZ(J) = SZ(J) * tmp1
               t_ch = SZh(J) * tmp1h
               t_u1 = 134217729.0 * SZh(J)
               t_p1 = t_u1
     +                  - (t_u1 - SZh(J))
               t_p2 = SZh(J) - t_p1
               t_u1 = 134217729.0 * tmp1h
               t_r1 = t_u1
     +                  - (t_u1 - tmp1h)
               t_r2 = tmp1h - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (SZh(J)*tmp1l
     +                  +  SZl(J)*tmp1h)
               t_s1 = t_ch + t_cl
               SZl(J) = t_cl - (t_s1 - t_ch)
               SZh(J) = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           SZ(J) = SZ(J) * tmp1
   60       CONTINUE
!            SZ( KK ) = SZ( KK )*SBUF( KK )
!<<<        SZ(KK) = SZ(KK) * SBUF(KK)
            t_ch = SZh(KK) * SBUFh(KK)
            t_u1 = 134217729.0 * SZh(KK)
            t_p1 = t_u1
     +               - (t_u1 - SZh(KK))
            t_p2 = SZh(KK) - t_p1
            t_u1 = 134217729.0 * SBUFh(KK)
            t_r1 = t_u1
     +               - (t_u1 - SBUFh(KK))
            t_r2 = SBUFh(KK) - t_r1
            t_cl = ((t_p1*t_r1
     +               - t_ch)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            t_cl = t_cl
     +               + (SZh(KK)*SBUFl(KK)
     +               +  SZl(KK)*SBUFh(KK))
            t_s1 = t_ch + t_cl
            SZl(KK) = t_cl - (t_s1 - t_ch)
            SZh(KK) = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>        SZ(KK) = SZ(KK) * SBUF(KK)
            DO 70 J = KK + 1, K
!               SZ( J ) = SZ( J )*( SBUF( J ) /
!     $                  ( DLAMDA( J )-DLAMDA( KK ) ) )
!<<<           tmp1 = DLAMDA(J) - DLAMDA(KK)
               t_p1 = DLAMDAh(J) - DLAMDAh(KK)
               t_p2 = t_p1 - DLAMDAh(J)
               t_ch = t_p1
               t_cl = (DLAMDAh(J) - (t_p1 - t_p2))
     +                  - (DLAMDAh(KK) + t_p2)
               t_cl = t_cl + DLAMDAl(J) - DLAMDAl(KK)
               t_s1 = t_ch + t_cl
               tmp1l = t_cl - (t_s1 - t_ch)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           tmp1 = DLAMDA(J) - DLAMDA(KK)
!<<<           tmp1 = SBUF(J) / tmp1
               t_q1 = SBUFh(J) / tmp1h
               t_ch = tmp1h * t_q1
               t_u1 = 134217729.0 * tmp1h
               t_p1 = t_u1
     +                  - (t_u1 - tmp1h)
               t_p2 = tmp1h - t_p1
               t_u1 = 134217729.0 * t_q1
               t_r1 = t_u1
     +                  - (t_u1 - t_q1)
               t_r2 = t_q1 - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                  + t_p1*t_r2
     +                  + t_p2*t_r1)
     +                  + t_p2*t_r2
               t_cl = t_cl
     +                  + (tmp1l * t_q1)
               t_s1 = t_ch + t_cl
               t_cl = t_cl
     +                  - (t_s1 - t_ch)
               t_ch = t_s1
               t_s1 = SBUFh(J) - t_ch
               t_r1 = t_s1 - SBUFh(J)
               t_s2 = (SBUFh(J)
     +                  - (t_s1 - t_r1))
     +                  - (t_ch + t_r1)
               t_s2 = t_s2 - t_cl
               t_s2 = t_s2 + SBUFl(J)
               t_q2 = (t_s1 + t_s2)
     +                  / tmp1h
               tmp1h = t_q1 + t_q2
               tmp1l = t_q2
     +               - (tmp1h - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>           tmp1 = SBUF(J) / tmp1
!<<<           SZ(J) = SZ(J) * tmp1
               t_ch = SZh(J) * tmp1h
               t_u1 = 134217729.0 * SZh(J)
               t_p1 = t_u1
     +                  - (t_u1 - SZh(J))
               t_p2 = SZh(J) - t_p1
               t_u1 = 134217729.0 * tmp1h
               t_r1 = t_u1
     +                  - (t_u1 - tmp1h)
               t_r2 = tmp1h - t_r1
               t_cl = ((t_p1*t_r1
     +                  - t_ch)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               t_cl = t_cl
     +                  + (SZh(J)*tmp1l
     +                  +  SZl(J)*tmp1h)
               t_s1 = t_ch + t_cl
               SZl(J) = t_cl - (t_s1 - t_ch)
               SZh(J) = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>           SZ(J) = SZ(J) * tmp1
   70       CONTINUE
!            KK = KK + 1
   80    CONTINUE
!$OMP ENDDO

!$OMP MASTER
!         Z(1:K) = SZ(1:K)
         Zh(1:K) = SZh(1:K)
         Zl(1:K) = SZl(1:K)
         INFO = SINFO
!$OMP END MASTER

         DO I=1,OMP_GET_NUM_THREADS()-1
!$OMP BARRIER
            IF ( OMP_GET_THREAD_NUM() == I ) THEN
               DO J=1,K
!                  Z(J) = Z(J) * SZ(J)
!<<<     Z(J) = Z(J) * SZ(J)
         t_ch = Zh(J) * SZh(J)
         t_u1 = 134217729.0 * Zh(J)
         t_p1 = t_u1
     +            - (t_u1 - Zh(J))
         t_p2 = Zh(J) - t_p1
         t_u1 = 134217729.0 * SZh(J)
         t_r1 = t_u1
     +            - (t_u1 - SZh(J))
         t_r2 = SZh(J) - t_r1
         t_cl = ((t_p1*t_r1
     +            - t_ch)
     +           + t_p1 * t_r2
     +           + t_p2 * t_r1)
     +           + t_p2 * t_r2
         t_cl = t_cl
     +            + (Zh(J)*SZl(J)
     +            +  Zl(J)*SZh(J))
         t_s1 = t_ch + t_cl
         Zl(J) = t_cl - (t_s1 - t_ch)
         Zh(J) = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>     Z(J) = Z(J) * SZ(J)
               ENDDO
               INFO = MAX(INFO,SINFO)
            END IF
         END DO

!         DEALLOCATE(SZ,SBUF)
         DEALLOCATE(SZh,SZl,SBUFh,SBUFl)

!$OMP END PARALLEL
*
         IF( MYROW.NE.DROW ) THEN
!            CALL DCOPY( K, Z, 1, BUF, 1 )
            CALL DDCOPY( K, Zh, Zl, 1, BUFh, BUFl, 1 )
!            CALL DGESD2D( ICTXT, K+MYKLR, 1, BUF, K+MYKLR, DROW, MYCOL )
#ifdef COMM_MPI
            CALL MakeMpiInfo('A',ICTXT,DROW,MYCOL,DEST,COMM,TAG)
            CALL MPI_ISEND_DD(BUFh,BUFl,K+MYKLR,
     $                      MPI_DOUBLE_PRECISION,DEST,1,COMM,IREQ,IERR)
            CALL MPI_WAIT_DD(IREQ,ISTAT,IERR)
#elif defined COMM_BLACS2
            J = K+MYKLR
            DO L=1,J
              BUF(L)   = BUFh(L)
              BUF(L+J) = BUFl(L)
            END DO
            NBUF2 = J*2
!            CALL DGESD2D( ICTXT, J*2, 1, BUF, J*2, DROW, MYCOL )
            CALL DGESD2D( ICTXT, NBUF2, 1, BUF, NBUF2, DROW, MYCOL )
#else
            NBUF = K+MYKLR
!            CALL DGESD2D( ICTXT, K+MYKLR, 1, BUFh, K+MYKLR, 
!     $                    DROW, MYCOL )
!            CALL DGESD2D( ICTXT, K+MYKLR, 1, BUFl, K+MYKLR,
!     $                    DROW, MYCOL )
            CALL DGESD2D( ICTXT, NBUF, 1, BUFh, NBUF, 
     $                    DROW, MYCOL )
            CALL DGESD2D( ICTXT, NBUF, 1, BUFl, NBUF,
     $                    DROW, MYCOL )
#endif
         ELSE
            IPD = 2*K + 1
!            CALL DCOPY( MYKLR, BUF( K+1 ), 1, BUF( IPD ), 1 )
            CALL DDCOPY( MYKLR, BUFh( K+1 ), BUFl( K+1 ), 1, 
     $                   BUFh( IPD ), BUFl( IPD ), 1 )
            IF( KLR.GT.0 ) THEN
               IPD = MYKLR + IPD
               ROW = MOD( DROW+1, NPROW )
               DO 100 I = 1, NPROW - 1
!                  CALL DGERV2D( ICTXT, K+KLR, 1, BUF, K+KLR, ROW,
!     $                          MYCOL )
#ifdef COMM_MPI
                  CALL MakeMpiInfo('A',ICTXT,ROW,MYCOL,DEST,COMM,TAG)
                  BUFF(1:K+KLR) = BUFh(1:K+KLR)
                  BUFF(1+K+KLR:2*(K+KLR)) = BUFl(1:K+KLR)
                  CALL MPI_IRECV_DD(BUFF,K+KLR,
     $                       MPI_DOUBLE_PRECISION,DEST,1,COMM,IREQ,IERR)
                  CALL MPI_WAITIRECV_DD(BUFh,BUFl,BUFF,K+KLR,
     $                                  IREQ,ISTAT,IERR)
#elif defined COMM_BLACS2
                  J = K+KLR
                  NBUF2 = J*2
!                  CALL DGERV2D( ICTXT, J*2, 1, BUF, J*2, ROW,
!     $                          MYCOL )
                  CALL DGERV2D( ICTXT, NBUF2, 1, BUF, NBUF2, ROW,
     $                          MYCOL )
                  DO L=1,J
                     BUFh(L) = BUF(L)
                     BUFl(L) = BUF(L+J)
                  END DO
#else
!                  CALL DGERV2D( ICTXT, K+KLR, 1, BUFh, K+KLR, ROW,
!     $                          MYCOL )
!                  CALL DGERV2D( ICTXT, K+KLR, 1, BUFl, K+KLR, ROW,
!     $                          MYCOL )
                  NBUF = K+KLR
                  CALL DGERV2D( ICTXT, NBUF, 1, BUFh, NBUF, ROW,
     $                          MYCOL )
                  CALL DGERV2D( ICTXT, NBUF, 1, BUFl, NBUF, ROW,
     $                          MYCOL )
#endif
!                  CALL DCOPY( KLR, BUF( K+1 ), 1, BUF( IPD ), 1 )
                  CALL DDCOPY( KLR, BUFh( K+1 ), BUFl( K+1 ), 1,
     $                         BUFh( IPD ), BUFl( IPD ), 1 )
                  DO 90 J = 1, K
!                     Z( J ) = Z( J )*BUF( J )
!<<<              Z(J) = Z(J) * BUF(J)
                  t_ch = Zh(J) * BUFh(J)
                  t_u1 = 134217729.0 * Zh(J)
                  t_p1 = t_u1
     +                     - (t_u1 - Zh(J))
                  t_p2 = Zh(J) - t_p1
                  t_u1 = 134217729.0 * BUFh(J)
                  t_r1 = t_u1
     +                     - (t_u1 - BUFh(J))
                  t_r2 = BUFh(J) - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  t_cl = t_cl
     +                     + (Zh(J)*BUFl(J)
     +                     +  Zl(J)*BUFh(J))
                  t_s1 = t_ch + t_cl
                  Zl(J) = t_cl - (t_s1 - t_ch)
                  Zh(J) = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>              Z(J) = Z(J) * BUF(J)
   90             CONTINUE
                  IPD = IPD + KLR
                  ROW = MOD( ROW+1, NPROW )
  100          CONTINUE
            END IF
         END IF
      END IF
*
      IF( MYROW.EQ.DROW ) THEN
         IF( MYCOL.NE.DCOL .AND. MYKL.NE.0 ) THEN
!            CALL DCOPY( K, Z, 1, BUF, 1 )
!            CALL DCOPY( MYKL, BUF( 2*K+1 ), 1, BUF( K+1 ), 1 )
            CALL DDCOPY( K, Zh, Zl, 1, BUFh, BUFl, 1 )
            CALL DDCOPY( MYKL, BUFh( 2*K+1 ), BUFl( 2*K+1 ), 1,
     $                   BUFh( K+1 ), BUFl( K+1 ), 1 )
!            CALL DGESD2D( ICTXT, K+MYKL, 1, BUF, K+MYKL, MYROW, DCOL )
#ifdef COMM_MPI
            CALL MakeMpiInfo('A',ICTXT,MYROW,DCOL,DEST,COMM,TAG)
            CALL MPI_ISEND_DD(BUFh,BUFl,K+MYKL,
     $                     MPI_DOUBLE_PRECISION,DEST,1,COMM,IREQ,IERR)
            CALL MPI_WAIT_DD(IREQ,ISTAT,IERR)
#elif defined COMM_BLACS2
            J = K+MYKL
            DO L=1,J
               BUF(L)   = BUFh(L)
               BUF(L+J) = BUFl(L)
            END DO
            NBUF2 = J*2
!            CALL DGESD2D( ICTXT, J*2, 1, BUF, J*2, MYROW, DCOL )
            CALL DGESD2D( ICTXT, NBUF2, 1, BUF, NBUF2, MYROW, DCOL )
#else
!            CALL DGESD2D( ICTXT, K+MYKL, 1, BUFh, K+MYKL, MYROW, DCOL )
!            CALL DGESD2D( ICTXT, K+MYKL, 1, BUFl, K+MYKL, MYROW, DCOL )
            NBUF = K+MYKL
            CALL DGESD2D( ICTXT, NBUF, 1, BUFh, NBUF, MYROW, DCOL )
            CALL DGESD2D( ICTXT, NBUF, 1, BUFl, NBUF, MYROW, DCOL )
#endif
         ELSE IF( MYCOL.EQ.DCOL ) THEN
            IPD = 2*K + 1
            COL = DCOL
            KL = MYKL
            DO 120 I = 1, NPCOL - 1
               IPD = IPD + KL
               COL = MOD( COL+1, NPCOL )
               KL = CTOT( COL, 1 ) + CTOT( COL, 2 ) + CTOT( COL, 3 )
               IF( KL.NE.0 ) THEN
!                  CALL DGERV2D( ICTXT, K+KL, 1, BUF, K+KL, MYROW, COL )
#ifdef COMM_MPI
                  CALL MakeMpiInfo('A',ICTXT,MYROW,COL,DEST,COMM,TAG)
                  BUFF(1:K+KL)          = BUFh(1:K+KL)
                  BUFF(1+K+KL:2*(K+KL)) = BUFl(1:K+KL)
                  CALL MPI_IRECV_DD(BUFF,K+KL,
     $                      MPI_DOUBLE_PRECISION,DEST,1,COMM,IREQ,IERR)
                  CALL MPI_WAITIRECV_DD(BUFh,BUFl,BUFF,K+KL,
     $                                  IREQ,ISTAT,IERR)
#elif defined COMM_BLACS2
                  J = K+KL
                  NBUF2 = J*2
!                  CALL DGERV2D( ICTXT, J*2, 1, BUF, J*2, MYROW, COL )
                  CALL DGERV2D( ICTXT, NBUF2, 1, BUF, NBUF2, MYROW, COL)
                  DO L=1,J
                     BUFh(L) = BUF(L)
                     BUFl(L) = BUF(L+J)
                  END DO
#else
!                  CALL DGERV2D( ICTXT, K+KL, 1, BUFh, K+KL, MYROW, COL )
!                  CALL DGERV2D( ICTXT, K+KL, 1, BUFl, K+KL, MYROW, COL )
                  NBUF =  K+KL
                  CALL DGERV2D( ICTXT, NBUF, 1, BUFh, NBUF, MYROW, COL )
                  CALL DGERV2D( ICTXT, NBUF, 1, BUFl, NBUF, MYROW, COL )
#endif
!                  CALL DCOPY( KL, BUF( K+1 ), 1, BUF( IPD ), 1 )
                  CALL DDCOPY( KL, BUFh( K+1 ), BUFl( K+1 ), 1,
     $                         BUFh( IPD ), BUFl( IPD ), 1 )
                  DO 110 J = 1, K
!                     Z( J ) = Z( J )*BUF( J )
!<<<                 Z(J) = Z(J) * BUF(J)
                     t_ch = Zh(J) * BUFh(J)
                     t_u1 = 134217729.0 * Zh(J)
                     t_p1 = t_u1
     +                        - (t_u1 - Zh(J))
                     t_p2 = Zh(J) - t_p1
                     t_u1 = 134217729.0 * BUFh(J)
                     t_r1 = t_u1
     +                        - (t_u1 - BUFh(J))
                     t_r2 = BUFh(J) - t_r1
                     t_cl = ((t_p1*t_r1
     +                        - t_ch)
     +                       + t_p1 * t_r2
     +                       + t_p2 * t_r1)
     +                       + t_p2 * t_r2
                     t_cl = t_cl
     +                        + (Zh(J)*BUFl(J)
     +                        +  Zl(J)*BUFh(J))
                     t_s1 = t_ch + t_cl
                     Zl(J) = t_cl - (t_s1 - t_ch)
                     Zh(J) = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>                 Z(J) = Z(J) * BUF(J)
  110             CONTINUE
               END IF
  120       CONTINUE
            DO 130 I = 1, K
!               Z( I ) = SIGN( SQRT( -Z( I ) ), W( I ) )
!<<<           Z(I) = -Z(I)
               Zh(I) = -Zh(I)
               Zl(I) = -Zl(I)
!>>>           Z(I) = -Z(I)
!<<<           tmp1 = sqrt(Z(I))
               if (Zh(I).eq.0.0D+0.and.Zl(I).eq.0.0D+0) then
                 tmp1h = 0.0d+0
                 tmp1l = 0.0d+0
               else
               if (Zh(I).lt.0.0d+0.or.
     +            (Zh(I).eq.0.0d+0.and.Zl(I).lt.0.0d+0)) then
                 write(6,'(a)')
     +              'SQRT CALLED WITH NEGATIVE ARGUMENT'
                 tmp1h = 0.0d+0
                 tmp1l = 0.0d+0
                 return
               endif
               t_x = 1.0D+0/sqrt(Zh(I))
               t_ax = Zh(I) * t_x
!                  call dd_mul(t_y1,t_y2,t_x,
!                              0.0,0.5,0.0)
                   t_y1 = t_x * 0.5d+0
                   t_u1 = 134217729.0 * t_x
                   t_p1 = t_u1
     +                      - (t_u1 - t_x)
                   t_p2 = t_x - t_p1
                   t_u1 = 134217729.0 * 0.5d+0
                   t_r1 = t_u1
     +                      - (t_u1 - 0.5d+0)
                   t_r2 = 0.5d+0 - t_r1
                   t_y2 = ((t_p1*t_r1
     +                      - t_y1)
     +                      + t_p1*t_r2
     +                      + t_p2 * t_r1)
     +                      + t_p2 * t_r2
                   t_s1 = t_y1 + t_y2
                   t_y2 = t_y2
     +                      - (t_s1 - t_y1)
                   t_y1 = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!                  call dd_mul(t_z1,t_z2,t_ax,
!                              0.0,t_ax,0.0)
                   t_z1 = t_ax * t_ax
                   t_u1 = 134217729.0 * t_ax
                   t_p1 = t_u1
     +                      - (t_u1 - t_ax)
                   t_p2 = t_ax - t_p1
                   t_u1 = 134217729.0 * t_ax
                   t_r1 = t_u1
     +                      - (t_u1 - t_ax)
                   t_r2 = t_ax - t_r1
                   t_z2 = ((t_p1 * t_r1
     +                      - t_z1)
     +                      + t_p1 * t_r2
     +                      + t_p2 * t_r1)
     +                      + t_p2*t_r2
                   t_s1 = t_z1 + t_z2
                   t_z2 = t_z2
     +                      - (t_s1 - t_z1)
                   t_z1 = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!                  call dd_sub(t_t2h,t_t2l,
!                           Zh(I),Zl(I),t_z1,t_z2)
                   t_p1 = Zh(I) - t_z1
                   t_p2 = t_p1 - Zh(I)
                   t_t2l = (Zh(I)
     +                      -(t_p1 - t_p2))
     +                      -(t_z1 + t_p2)
                   t_t2h = t_p1
                   t_t2l = t_t2l
     +                      + Zl(I) - t_z2
                   t_s1 = t_t2h + t_t2l
                   t_t2l = t_t2l
     +                      - (t_s1 - t_t2h)
                   t_t2h = t_s1
#ifdef FPCOUNTER
#include "fsub.h"
#endif
!                  call dd_mul(t_t1h,t_t1l,
!                              t_t2h,t_t2l,
!                              t_y1,t_y2)
                   t_t1h = t_t2h * t_y1
                   t_u1 = 134217729.0 * t_t2h
                   t_p1 = t_u1
     +                      - (t_u1 - t_t2h)
                   t_p2 = t_t2h - t_p1
                   t_u1 = 134217729.0 * t_y1
                   t_r1 = t_u1
     +                      - (t_u1 - t_y1)
                   t_r2 = t_y1 - t_r1
                   t_t1l = ((t_p1*t_r1
     +                      - t_t1h)
     +                      + t_p1*t_r2
     +                      + t_p2*t_r1)
     +                      + t_p2*t_r2
                   t_t1l = t_t1l
     +                      + (t_t2h * t_y2
     +                      +  t_t2l * t_y1)
                   t_s1 = t_t1h + t_t1l
                   t_t1l = t_t1l - (t_s1
     +                       - t_t1h)
                   t_t1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!                  call dd_selfadd(t_t1h,t_t1l,
!                              t_ax,0.0)
                   t_p1 = t_t1h + t_ax
                   t_p2 = t_p1 - t_t1h
                   t_q2 = (t_t1h
     +                      - (t_p1 - t_p2))
     +                      + (t_ax - t_p2)
                   t_q1 = t_p1
                   t_q2 = t_q2 + t_t1l
                   t_t1h = t_q1 + t_q2
                   t_t1l = t_q2
     +                       - (t_t1h - t_q1)
                   tmp1h = t_t1h
                   tmp1l = t_t1l
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
               endif
!>>>           tmp1 = sqrt(Z(I))
               if (
!                   (W(I) .ge. 0.0)
     +             ((Wh(I) .gt. 0.0d+0) .or.
     +              ((Wh(I) .eq. 0.0d+0) .and.
     +               (Wl(I) .ge. 0.0d+0)))
     $         ) then
                  Zh(I) = tmp1h
                  Zl(I) = tmp1l
               else
!<<<              Z(I) = -tmp1
                  Zh(I) = -tmp1h
                  Zl(I) = -tmp1l
!>>>              Z(I) = -tmp1
               endif
  130       CONTINUE
*
         END IF
      END IF
*
*     Diffusion
*
      IF( MYROW.EQ.DROW .AND. MYCOL.EQ.DCOL ) THEN
!         CALL DCOPY( K, Z, 1, BUF, 1 )
!         CALL DCOPY( K, BUF( 2*K+1 ), 1, BUF( K+1 ), 1 )
         CALL DDCOPY( K, Zh, Zl, 1, BUFh, BUFl, 1 )
         CALL DDCOPY( K, BUFh( 2*K+1 ), BUFl( 2*K+1 ), 1,
     $                BUFh( K+1 ), BUFl( K+1 ), 1 )
!         CALL DGEBS2D( ICTXT, 'All', ' ', 2*K, 1, BUF, 2*K )
#ifdef COMM_MPI
         CALL MakeMpiInfo('S',ICTXT,0,0,DEST,COMM,TAG)
         CALL MPI_BCAST_DD(BUFh,BUFl,2*K,
     $                     MPI_DOUBLE_PRECISION,DEST,COMM,IERR)
#elif defined COMM_BLACS2
         DO L=1,2*K
            BUF(L)     = BUFh(L)
            BUF(L+2*K) = BUFl(L)
         END DO
         NBUF2 = 2*2*k
!         CALL DGEBS2D( ICTXT, 'All', ' ', 2*2*K, 1, BUF, 2*2*K )
         CALL DGEBS2D( ICTXT, 'All', ' ', NBUF2, 1, BUF, NBUF2 )
#else
!         CALL DGEBS2D( ICTXT, 'All', ' ', 2*K, 1, BUFh, 2*K )
!         CALL DGEBS2D( ICTXT, 'All', ' ', 2*K, 1, BUFl, 2*K )
         NBUF = 2*K
         CALL DGEBS2D( ICTXT, 'All', ' ', NBUF, 1, BUFh, NBUF )
         CALL DGEBS2D( ICTXT, 'All', ' ', NBUF, 1, BUFl, NBUF )
#endif
      ELSE
!         CALL DGEBR2D( ICTXT, 'All', ' ', 2*K, 1, BUF, 2*K, DROW, DCOL)
#ifdef COMM_MPI
         CALL MakeMpiInfo('B',ICTXT,DROW,DCOL,DEST,COMM,TAG)
         CALL MPI_BCAST_DD(BUFh,BUFl,2*K,
     $                     MPI_DOUBLE_PRECISION,DEST,COMM,IERR)
#elif defined COMM_BLACS2
         NBUF2 = 2*2*k
!         CALL DGEBR2D( ICTXT,'All',' ',2*2*K,1,BUF,2*2*K,DROW,DCOL )
         CALL DGEBR2D( ICTXT,'All',' ',NBUF2,1,BUF,NBUF2,DROW,DCOL )
         DO L=1,2*K
            BUFh(L) = BUF(L)
            BUFl(L) = BUF(L+2*K)
         END DO
#else
!         CALL DGEBR2D( ICTXT, 'All', ' ', 2*K, 1, BUFh, 2*K, DROW, DCOL)
!         CALL DGEBR2D( ICTXT, 'All', ' ', 2*K, 1, BUFl, 2*K, DROW, DCOL)
         NBUF = 2*K
         CALL DGEBR2D( ICTXT, 'All', ' ', NBUF,1,BUFh, NBUF, DROW, DCOL)
         CALL DGEBR2D( ICTXT, 'All', ' ', NBUF,1,BUFl, NBUF, DROW, DCOL)
#endif
!         CALL DCOPY( K, BUF, 1, Z, 1 )
         CALL DDCOPY( K, BUFh, BUFl, 1, Zh, Zl, 1 )
      END IF
*
*     Copy of D at the good place
*
      KLC = 0
      KLR = 0
      DO 140 I = 1, K
         GI = INDX( I )
!         D( GI ) = BUF( K+I )
         Dh(GI) = BUFh(K+I)
         Dl(GI) = BUFl(K+I)
         COL = INDCOL( GI )
         ROW = INDROW( GI )
         IF( COL.EQ.MYCOL ) THEN
            KLC = KLC + 1
            INDXC( KLC ) = I
         END IF
         IF( ROW.EQ.MYROW ) THEN
            KLR = KLR + 1
            INDXR( KLR ) = I
         END IF
  140 CONTINUE
*
*     Compute eigenvectors of the modified rank-1 modification.
*
      IF( MYKL.NE.0 ) THEN
!!$OMP PARALLEL DO PRIVATE(I,J,KK,IU,JU,IIU,JJU,BUF,AUX,TEMP,IINFO)
!$OMP PARALLEL DO PRIVATE(I,J,KK,IU,JU,IIU,JJU)
!$omp+ PRIVATE(BUFh,BUFl,AUXh,AUXl,TEMPh,TEMPl,IINFO,info)
!     tmp vars -> private
!$omp+ private(t_ch, t_cl)
!$omp+ private(t_p1, t_p2)
!$omp+ private(t_q1, t_q2)
!$omp+ private(t_r1, t_r2)
!$omp+ private(t_s1, t_s2)
!$omp+ private(t_t1, t_t2)
!$omp+ private(t_u1, t_u2)
!$omp+ private(t_x1, t_x2)
!$omp+ private(t_y1, t_y2)
!$omp+ private(t_z1, t_z2)
!$omp+ private(t_x, t_ax)
!$omp+ private(t_t1h, t_t1l)
!$omp+ private(t_t2h, t_t2l)
!$+ REDUCTION(MAX:INFO)
         DO 180 J = 1, MYKL
            KK = INDXC( J )
            JU = INDX( KK )
            JJU = INDXG2L( JU, NB, J, J, NPCOL )
!            CALL DLAED4( K, KK, DLAMDA, W, BUF, RHO, AUX, IINFO )
            CALL DDLAED4( K, KK, DLAMDAh, DLAMDAl, Wh, Wl, BUFh, BUFl,
     $                    RHOh, RHOl, AUXh, AUXl, IINFO )
            IF( IINFO.NE.0 ) THEN
               INFO = KK
            END IF
            IF( K.EQ.1 .OR. K.EQ.2 ) THEN
               DO 150 I = 1, KLR
                  KK = INDXR( I )
                  IU = INDX( KK )
                  IIU = INDXG2L( IU, NB, J, J, NPROW )
!                  U( IIU, JJU ) = BUF( KK )
                  Uh(IIU,JJU) = BUFh(KK)
                  Ul(IIU,JJU) = BUFl(KK)
  150          CONTINUE
               GO TO 180
            END IF
*
            DO 160 I = 1, K
!               BUF( I ) = Z( I ) / BUF( I )
!<<<              BUF(I) = Z(I) / BUF(I)
                  t_q1 = Zh(I) / BUFh(I)
                  t_ch = BUFh(I) * t_q1
                  t_u1 = 134217729.0 * BUFh(I)
                  t_p1 = t_u1
     +                     - (t_u1 - BUFh(I))
                  t_p2 = BUFh(I) - t_p1
                  t_u1 = 134217729.0 * t_q1
                  t_r1 = t_u1
     +                     - (t_u1 - t_q1)
                  t_r2 = t_q1 - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                     + t_p1*t_r2
     +                     + t_p2*t_r1)
     +                     + t_p2*t_r2
                  t_cl = t_cl
     +                     + (BUFl(I) * t_q1)
                  t_s1 = t_ch + t_cl
                  t_cl = t_cl
     +                     - (t_s1 - t_ch)
                  t_ch = t_s1
                  t_s1 = Zh(I) - t_ch
                  t_r1 = t_s1 - Zh(I)
                  t_s2 = (Zh(I)
     +                     - (t_s1 - t_r1))
     +                     - (t_ch + t_r1)
                  t_s2 = t_s2 - t_cl
                  t_s2 = t_s2 + Zl(I)
                  t_q2 = (t_s1 + t_s2)
     +                     / BUFh(I)
                  BUFh(I) = t_q1 + t_q2
                  BUFl(I) = t_q2
     +                  - (BUFh(I) - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>              BUF(I) = Z(I) / BUF(I)
  160       CONTINUE
!            TEMP = DNRM2( K, BUF, 1 )
            CALL DDNRM2( K, BUFh, BUFl, 1, TEMPh, TEMPl )
            DO 170 I = 1, KLR
               KK = INDXR( I )
               IU = INDX( KK )
               IIU = INDXG2L( IU, NB, J, J, NPROW )
!               U( IIU, JJU ) = BUF( KK ) / TEMP
!<<<              U(IIU,JJU) = BUF(KK) / TEMP
                  t_q1 = BUFh(KK) / TEMPh
                  t_ch = TEMPh * t_q1
                  t_u1 = 134217729.0 * TEMPh
                  t_p1 = t_u1
     +                     - (t_u1 - TEMPh)
                  t_p2 = TEMPh - t_p1
                  t_u1 = 134217729.0 * t_q1
                  t_r1 = t_u1
     +                     - (t_u1 - t_q1)
                  t_r2 = t_q1 - t_r1
                  t_cl = ((t_p1*t_r1
     +                     - t_ch)
     +                     + t_p1*t_r2
     +                     + t_p2*t_r1)
     +                     + t_p2*t_r2
                  t_cl = t_cl
     +                     + (TEMPl * t_q1)
                  t_s1 = t_ch + t_cl
                  t_cl = t_cl
     +                     - (t_s1 - t_ch)
                  t_ch = t_s1
                  t_s1 = BUFh(KK) - t_ch
                  t_r1 = t_s1 - BUFh(KK)
                  t_s2 = (BUFh(KK)
     +                     - (t_s1 - t_r1))
     +                     - (t_ch + t_r1)
                  t_s2 = t_s2 - t_cl
                  t_s2 = t_s2 + BUFl(KK)
                  t_q2 = (t_s1 + t_s2)
     +                     / TEMPh
                  Uh(IIU,JJU) = t_q1 + t_q2
                  Ul(IIU,JJU) = t_q2
     +                  - (Uh(IIU,JJU) - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>              U(IIU,JJU) = BUF(KK) / TEMP
  170       CONTINUE
*
  180    CONTINUE
!$OMP END PARALLEL DO
      END IF
*
  190 CONTINUE
*
      RETURN
*
*     End of PDDLAED3X
*
      END
