       subroutine ddev_test_2D(n, ah, al, nma, wh, wl, zh, zl, nmz,
     &                         ret)
!----
      use ddcommunication_sx, only : dddatacast_dbl 
     &                             , eigen_init
     &                             , eigen_free
!----
       integer                :: n, nma, nmz
!       real(8)                :: a(*), w(*), z(*), ret
       real(8)                :: ah(*), wh(*), zh(*), ret
       real(8)                :: al(*), wl(*), zl(*)

       include 'mpif.h'
       include 'trd.h'

       call eigen_init(2)
       call MPI_Barrier(MPI_COMM_WORLD,ierr)
!       call ev_check_2D_body(n, a(1), nma, w(1), z(1), nmz, ret)
       call ddev_check_2D_body(n, ah(1), al(1), nma,
     &                         wh(1), wl(1), zh(1), zl(1), nmz, ret)
       call MPI_Barrier(MPI_COMM_WORLD,ierr)
       call eigen_free(0)

       return
       end
*
*
*
       subroutine ddev_check_2D_body(n, ah, al, nma,
     &                               wh, wl, zh, zl, nmz, ret)
!----
      use ddcommunication_sx, only : dddatacast_dbl 
     &                             , get_loop_start
     &                             , translate_g2l
     &                             , translate_l2g
     &                             , get_loop_node
     &                             , get_loop_end
!----
       implicit double precision(a-h,o-z),integer(i-n)

       integer                :: n, nma, nmz
!       real(8)                :: a(1:nma,*)
!       real(8)                :: w(1:n)
!       real(8)                :: z(1:nmz,*)
       real(8)                :: ah(1:nma,*), al(1:nma,*)
       real(8)                :: wh(1:n), wl(1:n)
       real(8)                :: zh(1:nmz,*), zl(1:nmz,*)
       real(8)                :: ret

!       real(8), pointer       :: b(:)
       real(8), pointer       :: bh(:), bl(:)
! mod.fns
!      real(8), pointer       :: c1(:)
!       real(8), allocatable   :: c1(:)
       real(8), allocatable   :: c1h(:), c1l(:)
! mod.fns
!       real(8), pointer       :: c2(:)
       real(8), pointer       :: c2h(:), c2l(:)
! mod.fns
!      real(8), pointer       :: d(:)
!       real(8), allocatable   :: d(:)
       real(8), allocatable   :: dh(:), dl(:)
! mod.fns
!       real(8), pointer       :: e(:)
       real(8), pointer       :: eh(:), el(:)

!       real(8)                :: m_epsilon
      double precision m_epsilonh, m_epsilonl
       real(8), external      :: machine_epsilon
!       real(8)                :: sum
      double precision sumh, suml
      double precision tmp1h, tmp1l
      double precision tmp2h, tmp2l
      double precision t_oneh, t_onel
!     tmp vars
      double precision t_ch, t_cl
      double precision t_p1, t_p2
      double precision t_q1, t_q2
      double precision t_r1, t_r2
      double precision t_s1, t_s2
      double precision t_t1, t_t2
      double precision t_u1, t_u2
      double precision t_x1, t_x2
      double precision t_y1, t_y2
      double precision t_z1, t_z2
      double precision t_x, t_ax
      double precision t_t1h, t_t1l
      double precision t_t2h, t_t2l

       include 'mpif.h'
       include 'trd.h'
*
!       m_epsilon = machine_epsilon()
       m_epsilonh = EPSILON(0.0d0)**2
       m_epsilonl = 0.0d0
      t_oneh = 1.0d+0
      t_onel = 0.0d+0
*
!       ra=0d0
!       rz=0d0
!       rr=0d0
!       r =0d0
      rah = 0.0d+0
      ral = 0.0d+0
      rzh = 0.0d+0
      rzl = 0.0d+0
      rrh = 0.0d+0
      rrl = 0.0d+0
      rh = 0.0d+0
      rl = 0.0d+0

       j_2 = get_loop_start(1, size_of_col,my_col)
       j_3 = get_loop_end  (n, size_of_col,my_col)
       j_4 = translate_g2l(n, size_of_col,my_col)
       i_2 = get_loop_start(1, size_of_row,my_row)
       i_3 = get_loop_end  (n, size_of_row,my_row)
       i_4 = translate_g2l(n, size_of_row,my_row)

       larray = n
!       allocate(b(1:larray))
       allocate(bh(1:larray), bl(1:larray))

       larray = j_4
!       allocate(c1(1:larray), c2(1:larray))
       allocate(c1h(1:larray), c2h(1:larray))
       allocate(c1l(1:larray), c2l(1:larray))

       larray = MAX(n+1,3*i_4)
!       allocate(d(1:larray), e(1:larray))
       allocate(dh(1:larray), eh(1:larray))
       allocate(dl(1:larray), el(1:larray))

!       b(1:n)=0d0
      bh(1:n) = 0.0d+0
      bl(1:n) = 0.0d+0

       i_m = MOD(i_3-i_2+1,4)+i_2
       do i=1,n,1

          jj_0 = get_loop_node(i, size_of_col,my_col)
          ii_0 = get_loop_node(i, size_of_row,my_row)
          jj_1 = translate_g2l(i, size_of_col,my_col)
          ii_1 = translate_g2l(i, size_of_row,my_row)

          if ( ii_0 == my_row ) then
             do j_1 = j_2, j_3
!                c1(j_1) = z(j_1,ii_1)
               c1h(j_1) = zh(j_1,ii_1)
               c1l(j_1) = zl(j_1,ii_1)
             end do
          end if
!          call MPI_Bcast(c1(1),j_4,MPI_DOUBLE_PRECISION,
!     &                   ii_0-1,mpi_comm_row,ierr)
          call MPI_Bcast_dd(c1h(1),c1l(1),j_4,MPI_DOUBLE_PRECISION,
     &                      ii_0-1,mpi_comm_row,ierr)

          do i_1 = i_2, i_m-1
!             t0 = 0.0D+00
!             s0 = 0.0D+00
!             u0 = 0.0D+00
!3ddb ind 6
               t0h = 0.0d+0
               t0l = 0.0d+0
               s0h = 0.0d+0
               s0l = 0.0d+0
               u0h = 0.0d+0
               u0l = 0.0d+0
             do j_1 = j_2, j_3
!                a0 = a(j_1,i_1)
!                b0 = c1(j_1)
               a0h = ah(j_1,i_1)
               a0l = al(j_1,i_1)
               b0h = c1h(j_1)
               b0l = c1l(j_1)
!                t0 = t0 + b0 * a0          ! t = Az(i)
!<<<           tmp1 = b0 * a0
               tmp1h = b0h * a0h
               t_u1 = 134217729.0 * b0h
               t_p1 = t_u1
     +                  - (t_u1 - b0h)
               t_p2 = b0h - t_p1
               t_u1 = 134217729.0 * a0h
               t_r1 = t_u1
     +                  - (t_u1 - a0h)
               t_r2 = a0h - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (b0h*a0l
     +               + b0l*a0h)
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = b0 * a0
!<<<           t0 = t0 + tmp1
               t_p1 = t0h + tmp1h
               t_p2 = t_p1 - t0h
               t_q1 = t_p1
               t_q2 = (t0h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + t0l + tmp1l
               t0h = t_q1 + t_q2
               t0l = t_q2 - (t0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           t0 = t0 + tmp1
!                s0 = s0 + b0 * z(j_1,i_1)  ! s = Zz(i)
!<<<           tmp1 = b0 * z(j_1,i_1)
               tmp1h = b0h * zh(j_1,i_1)
               t_u1 = 134217729.0 * b0h
               t_p1 = t_u1
     +                  - (t_u1 - b0h)
               t_p2 = b0h - t_p1
               t_u1 = 134217729.0 * zh(j_1,i_1)
               t_r1 = t_u1
     +                  - (t_u1 - zh(j_1,i_1))
               t_r2 = zh(j_1,i_1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (b0h*zl(j_1,i_1)
     +               + b0l*zh(j_1,i_1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = b0 * z(j_1,i_1)
!<<<           s0 = s0 + tmp1
               t_p1 = s0h + tmp1h
               t_p2 = t_p1 - s0h
               t_q1 = t_p1
               t_q2 = (s0h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + s0l + tmp1l
               s0h = t_q1 + t_q2
               s0l = t_q2 - (s0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           s0 = s0 + tmp1
!                u0 = u0 + ABS(a0)          ! u = |A|_1
!<<<           tmp1 = abs(a0)
               if (a0h .lt. 0.0d+0) then
                 tmp1h = -a0h
                 tmp1l = -a0l
               elseif (
     +           (a0h .eq. 0.0d+0).and.
     +           (a0l .lt. 0.0d+0)) then
                 tmp1h = a0h
                 tmp1l = -a0l
               else
                 tmp1h = a0h
                 tmp1l = a0l
               endif
!>>>           tmp1 = abs(a0)
!<<<           u0 = u0 + tmp1
               t_p1 = u0h + tmp1h
               t_p2 = t_p1 - u0h
               t_q1 = t_p1
               t_q2 = (u0h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + u0l + tmp1l
               u0h = t_q1 + t_q2
               u0l = t_q2 - (u0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           u0 = u0 + tmp1
             end do! k
!             d(1+(i_1-1)*3) = t0
!             d(2+(i_1-1)*3) = s0
!             d(3+(i_1-1)*3) = u0
            dh(1+(i_1-1)*3) = t0h
            dl(1+(i_1-1)*3) = t0l
            dh(2+(i_1-1)*3) = s0h
            dl(2+(i_1-1)*3) = s0l
            dh(3+(i_1-1)*3) = u0h
            dl(3+(i_1-1)*3) = u0l
          end do
          do i_1 = i_m, i_3, 4
!             t0 = 0.0D+00
!             t1 = 0.0D+00
!             t2 = 0.0D+00
!             t3 = 0.0D+00
!             s0 = 0.0D+00
!             s1 = 0.0D+00
!             s2 = 0.0D+00
!             s3 = 0.0D+00
!             u0 = 0.0D+00
!             u1 = 0.0D+00
!             u2 = 0.0D+00
!             u3 = 0.0D+00
            t0h = 0.0d+0
            t0l = 0.0d+0
            t1h = 0.0d+0
            t1l = 0.0d+0
            t2h = 0.0d+0
            t2l = 0.0d+0
            t3h = 0.0d+0
            t3l = 0.0d+0
            s0h = 0.0d+0
            s0l = 0.0d+0
            s1h = 0.0d+0
            s1l = 0.0d+0
            s2h = 0.0d+0
            s2l = 0.0d+0
            s3h = 0.0d+0
            s3l = 0.0d+0
            u0h = 0.0d+0
            u0l = 0.0d+0
            u1h = 0.0d+0
            u1l = 0.0d+0
            u2h = 0.0d+0
            u2l = 0.0d+0
            u3h = 0.0d+0
            u3l = 0.0d+0
             do j_1 = j_2, j_3
!                a0 = a(j_1,i_1+0)
!                a1 = a(j_1,i_1+1)
!                a2 = a(j_1,i_1+2)
!                a3 = a(j_1,i_1+3)
!                b0 = c1(j_1+0)
               a0h = ah(j_1,i_1+0)
               a0l = al(j_1,i_1+0)
               a1h = ah(j_1,i_1+1)
               a1l = al(j_1,i_1+1)
               a2h = ah(j_1,i_1+2)
               a2l = al(j_1,i_1+2)
               a3h = ah(j_1,i_1+3)
               a3l = al(j_1,i_1+3)
               b0h = c1h(j_1+0)
               b0l = c1l(j_1+0)
!                t0 = t0 + b0 * a0          ! t = Az(i)
!                t1 = t1 + b0 * a1          ! t = Az(i)
!                t2 = t2 + b0 * a2          ! t = Az(i)
!                t3 = t3 + b0 * a3          ! t = Az(i)
!<<<           tmp1 = b0 * a0
               tmp1h = b0h * a0h
               t_u1 = 134217729.0 * b0h
               t_p1 = t_u1
     +                  - (t_u1 - b0h)
               t_p2 = b0h - t_p1
               t_u1 = 134217729.0 * a0h
               t_r1 = t_u1
     +                  - (t_u1 - a0h)
               t_r2 = a0h - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (b0h*a0l
     +               + b0l*a0h)
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = b0 * a0
!<<<           t0 = t0 + tmp1
               t_p1 = t0h + tmp1h
               t_p2 = t_p1 - t0h
               t_q1 = t_p1
               t_q2 = (t0h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + t0l + tmp1l
               t0h = t_q1 + t_q2
               t0l = t_q2 - (t0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           t0 = t0 + tmp1
!<<<           tmp1 = b0 * a1
               tmp1h = b0h * a1h
               t_u1 = 134217729.0 * b0h
               t_p1 = t_u1
     +                  - (t_u1 - b0h)
               t_p2 = b0h - t_p1
               t_u1 = 134217729.0 * a1h
               t_r1 = t_u1
     +                  - (t_u1 - a1h)
               t_r2 = a1h - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (b0h*a1l
     +               + b0l*a1h)
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = b0 * a1
!<<<           t1 = t1 + tmp1
               t_p1 = t1h + tmp1h
               t_p2 = t_p1 - t1h
               t_q1 = t_p1
               t_q2 = (t1h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + t1l + tmp1l
               t1h = t_q1 + t_q2
               t1l = t_q2 - (t1h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           t1 = t1 + tmp1
!<<<           tmp1 = b0 * a2
               tmp1h = b0h * a2h
               t_u1 = 134217729.0 * b0h
               t_p1 = t_u1
     +                  - (t_u1 - b0h)
               t_p2 = b0h - t_p1
               t_u1 = 134217729.0 * a2h
               t_r1 = t_u1
     +                  - (t_u1 - a2h)
               t_r2 = a2h - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (b0h*a2l
     +               + b0l*a2h)
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = b0 * a2
!<<<           t2 = t2 + tmp1
               t_p1 = t2h + tmp1h
               t_p2 = t_p1 - t2h
               t_q1 = t_p1
               t_q2 = (t2h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + t2l + tmp1l
               t2h = t_q1 + t_q2
               t2l = t_q2 - (t2h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           t2 = t2 + tmp1
!<<<           tmp1 = b0 * a3
               tmp1h = b0h * a3h
               t_u1 = 134217729.0 * b0h
               t_p1 = t_u1
     +                  - (t_u1 - b0h)
               t_p2 = b0h - t_p1
               t_u1 = 134217729.0 * a3h
               t_r1 = t_u1
     +                  - (t_u1 - a3h)
               t_r2 = a3h - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (b0h*a3l
     +               + b0l*a3h)
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = b0 * a3
!<<<           t3 = t3 + tmp1
               t_p1 = t3h + tmp1h
               t_p2 = t_p1 - t3h
               t_q1 = t_p1
               t_q2 = (t3h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + t3l + tmp1l
               t3h = t_q1 + t_q2
               t3l = t_q2 - (t3h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           t3 = t3 + tmp1
!                s0 = s0 + b0 * z(j_1,i_1+0)! s = Zz(i)
!                s1 = s1 + b0 * z(j_1,i_1+1)! s = Zz(i)
!                s2 = s2 + b0 * z(j_1,i_1+2)! s = Zz(i)
!                s3 = s3 + b0 * z(j_1,i_1+3)! s = Zz(i)
!<<<           tmp1 = b0 * z(j_1,i_1+0)
               tmp1h = b0h * zh(j_1,i_1+0)
               t_u1 = 134217729.0 * b0h
               t_p1 = t_u1
     +                  - (t_u1 - b0h)
               t_p2 = b0h - t_p1
               t_u1 = 134217729.0 * zh(j_1,i_1+0)
               t_r1 = t_u1
     +                  - (t_u1 - zh(j_1,i_1+0))
               t_r2 = zh(j_1,i_1+0) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (b0h*zl(j_1,i_1+0)
     +               + b0l*zh(j_1,i_1+0))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = b0 * z(j_1,i_1+0)
!<<<           s0 = s0 + tmp1
               t_p1 = s0h + tmp1h
               t_p2 = t_p1 - s0h
               t_q1 = t_p1
               t_q2 = (s0h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + s0l + tmp1l
               s0h = t_q1 + t_q2
               s0l = t_q2 - (s0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           s0 = s0 + tmp1
!<<<           tmp1 = b0 * z(j_1,i_1+1)
               tmp1h = b0h * zh(j_1,i_1+1)
               t_u1 = 134217729.0 * b0h
               t_p1 = t_u1
     +                  - (t_u1 - b0h)
               t_p2 = b0h - t_p1
               t_u1 = 134217729.0 * zh(j_1,i_1+1)
               t_r1 = t_u1
     +                  - (t_u1 - zh(j_1,i_1+1))
               t_r2 = zh(j_1,i_1+1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (b0h*zl(j_1,i_1+1)
     +               + b0l*zh(j_1,i_1+1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = b0 * z(j_1,i_1+1)
!<<<           s1 = s1 + tmp1
               t_p1 = s1h + tmp1h
               t_p2 = t_p1 - s1h
               t_q1 = t_p1
               t_q2 = (s1h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + s1l + tmp1l
               s1h = t_q1 + t_q2
               s1l = t_q2 - (s1h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           s1 = s1 + tmp1
!<<<           tmp1 = b0 * z(j_1,i_1+2)
               tmp1h = b0h * zh(j_1,i_1+2)
               t_u1 = 134217729.0 * b0h
               t_p1 = t_u1
     +                  - (t_u1 - b0h)
               t_p2 = b0h - t_p1
               t_u1 = 134217729.0 * zh(j_1,i_1+2)
               t_r1 = t_u1
     +                  - (t_u1 - zh(j_1,i_1+2))
               t_r2 = zh(j_1,i_1+2) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (b0h*zl(j_1,i_1+2)
     +               + b0l*zh(j_1,i_1+2))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = b0 * z(j_1,i_1+2)
!<<<           s2 = s2 + tmp1
               t_p1 = s2h + tmp1h
               t_p2 = t_p1 - s2h
               t_q1 = t_p1
               t_q2 = (s2h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + s2l + tmp1l
               s2h = t_q1 + t_q2
               s2l = t_q2 - (s2h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           s2 = s2 + tmp1
!<<<           tmp1 = b0 * z(j_1,i_1+3)
               tmp1h = b0h * zh(j_1,i_1+3)
               t_u1 = 134217729.0 * b0h
               t_p1 = t_u1
     +                  - (t_u1 - b0h)
               t_p2 = b0h - t_p1
               t_u1 = 134217729.0 * zh(j_1,i_1+3)
               t_r1 = t_u1
     +                  - (t_u1 - zh(j_1,i_1+3))
               t_r2 = zh(j_1,i_1+3) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (b0h*zl(j_1,i_1+3)
     +               + b0l*zh(j_1,i_1+3))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = b0 * z(j_1,i_1+3)
!<<<           s3 = s3 + tmp1
               t_p1 = s3h + tmp1h
               t_p2 = t_p1 - s3h
               t_q1 = t_p1
               t_q2 = (s3h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + s3l + tmp1l
               s3h = t_q1 + t_q2
               s3l = t_q2 - (s3h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           s3 = s3 + tmp1
!                u0 = u0 + ABS(a0)          ! u = |A|_1
!                u1 = u1 + ABS(a1)          ! u = |A|_1
!                u2 = u2 + ABS(a2)          ! u = |A|_1
!                u3 = u3 + ABS(a3)          ! u = |A|_1
!<<<           tmp1 = abs(a0)
               if (a0h .lt. 0.0d+0) then
                 tmp1h = -a0h
                 tmp1l = -a0l
               elseif (
     +           (a0h .eq. 0.0d+0).and.
     +           (a0l .lt. 0.0d+0)) then
                 tmp1h = a0h
                 tmp1l = -a0l
               else
                 tmp1h = a0h
                 tmp1l = a0l
               endif
!>>>           tmp1 = abs(a0)
!<<<           u0 = u0 + tmp1
               t_p1 = u0h + tmp1h
               t_p2 = t_p1 - u0h
               t_q1 = t_p1
               t_q2 = (u0h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + u0l + tmp1l
               u0h = t_q1 + t_q2
               u0l = t_q2 - (u0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           u0 = u0 + tmp1
!<<<           tmp1 = abs(a1)
               if (a1h .lt. 0.0d+0) then
                 tmp1h = -a1h
                 tmp1l = -a1l
               elseif (
     +           (a1h .eq. 0.0d+0).and.
     +           (a1l .lt. 0.0d+0)) then
                 tmp1h = a1h
                 tmp1l = -a1l
               else
                 tmp1h = a1h
                 tmp1l = a1l
               endif
!>>>           tmp1 = abs(a1)
!<<<           u1 = u1 + tmp1
               t_p1 = u1h + tmp1h
               t_p2 = t_p1 - u1h
               t_q1 = t_p1
               t_q2 = (u1h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + u1l + tmp1l
               u1h = t_q1 + t_q2
               u1l = t_q2 - (u1h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           u1 = u1 + tmp1
!<<<           tmp1 = abs(a2)
               if (a2h .lt. 0.0d+0) then
                 tmp1h = -a2h
                 tmp1l = -a2l
               elseif (
     +           (a2h .eq. 0.0d+0).and.
     +           (a2l .lt. 0.0d+0)) then
                 tmp1h = a2h
                 tmp1l = -a2l
               else
                 tmp1h = a2h
                 tmp1l = a2l
               endif
!>>>           tmp1 = abs(a2)
!<<<           u2 = u2 + tmp1
               t_p1 = u2h + tmp1h
               t_p2 = t_p1 - u2h
               t_q1 = t_p1
               t_q2 = (u2h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + u2l + tmp1l
               u2h = t_q1 + t_q2
               u2l = t_q2 - (u2h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           u2 = u2 + tmp1
!<<<           tmp1 = abs(a3)
               if (a3h .lt. 0.0d+0) then
                 tmp1h = -a3h
                 tmp1l = -a3l
               elseif (
     +           (a3h .eq. 0.0d+0).and.
     +           (a3l .lt. 0.0d+0)) then
                 tmp1h = a3h
                 tmp1l = -a3l
               else
                 tmp1h = a3h
                 tmp1l = a3l
               endif
!>>>           tmp1 = abs(a3)
!<<<           u3 = u3 + tmp1
               t_p1 = u3h + tmp1h
               t_p2 = t_p1 - u3h
               t_q1 = t_p1
               t_q2 = (u3h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + u3l + tmp1l
               u3h = t_q1 + t_q2
               u3l = t_q2 - (u3h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           u3 = u3 + tmp1
             end do! k
!             d(1+(i_1-1)*3) = t0
!             d(2+(i_1-1)*3) = s0
!             d(3+(i_1-1)*3) = u0
!             d(1+(i_1  )*3) = t1
!             d(2+(i_1  )*3) = s1
!             d(3+(i_1  )*3) = u1
!             d(1+(i_1+1)*3) = t2
!             d(2+(i_1+1)*3) = s2
!             d(3+(i_1+1)*3) = u2
!             d(1+(i_1+2)*3) = t3
!             d(2+(i_1+2)*3) = s3
!             d(3+(i_1+2)*3) = u3
            dh(1+(i_1-1)*3) = t0h
            dl(1+(i_1-1)*3) = t0l
            dh(2+(i_1-1)*3) = s0h
            dl(2+(i_1-1)*3) = s0l
            dh(3+(i_1-1)*3) = u0h
            dl(3+(i_1-1)*3) = u0l
            dh(1+(i_1)*3) = t1h
            dl(1+(i_1)*3) = t1l
            dh(2+(i_1)*3) = s1h
            dl(2+(i_1)*3) = s1l
            dh(3+(i_1)*3) = u1h
            dl(3+(i_1)*3) = u1l
            dh(1+(i_1+1)*3) = t2h
            dl(1+(i_1+1)*3) = t2l
            dh(2+(i_1+1)*3) = s2h
            dl(2+(i_1+1)*3) = s2l
            dh(3+(i_1+1)*3) = u2h
            dl(3+(i_1+1)*3) = u2l
            dh(1+(i_1+2)*3) = t3h
            dl(1+(i_1+2)*3) = t3l
            dh(2+(i_1+2)*3) = s3h
            dl(2+(i_1+2)*3) = s3l
            dh(3+(i_1+2)*3) = u3h
            dl(3+(i_1+2)*3) = u3l
          end do

!          call MPI_Allreduce(d(1),e(1),3*(i_3-i_2+1),
          call MPI_Allreduce_dd(
     &                    dh(1),dl(1),eh(1),el(1),3*(i_3-i_2+1),
     &                    MPI_DOUBLE_PRECISION,
     &                    MPI_SUM,mpi_comm_col,ierr)

!          call datacast_dbl(d(1), c1(1), d(1+i_4), d(1+2*i_4), j_4)
          call dddatacast_dbl(
     &             dh(1), dl(1), c1h(1), c1l(1),
     &             dh(1+i_4), dl(1+i_4), dh(1+2*i_4), dl(1+2*i_4), j_4)

          if ( jj_0 == my_col ) then
             do i_1 = i_2, i_m-1
!                t0 = e(1+(i_1-1)*3)
!                s0 = e(2+(i_1-1)*3)
!                u0 = e(3+(i_1-1)*3)
               t0h = eh(1+(i_1-1)*3)
               t0l = el(1+(i_1-1)*3)
               s0h = eh(2+(i_1-1)*3)
               s0l = el(2+(i_1-1)*3)
               u0h = eh(3+(i_1-1)*3)
               u0l = el(3+(i_1-1)*3)
!                t0 = t0 - w(i) * d(i_1)     ! t = Az(i) - wz(i)
!<<<           tmp1 = w(i) * d(i_1)
               tmp1h = wh(i) * dh(i_1)
               t_u1 = 134217729.0 * wh(i)
               t_p1 = t_u1
     +                  - (t_u1 - wh(i))
               t_p2 = wh(i) - t_p1
               t_u1 = 134217729.0 * dh(i_1)
               t_r1 = t_u1
     +                  - (t_u1 - dh(i_1))
               t_r2 = dh(i_1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (wh(i)*dl(i_1)
     +               + wl(i)*dh(i_1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = w(i) * d(i_1)
!<<<           t0 = t0 - tmp1
               t_p1 = t0h - tmp1h
               t_p2 = t_p1 - t0h
               t_ch = t_p1
               t_cl = (t0h - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + t0l - tmp1l
               t_s1 = t_ch + t_cl
               t0l = t_cl - (t_s1 - t_ch)
               t0h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           t0 = t0 - tmp1
             if ( ii_0 == my_row .AND. i_1 ==ii_1 ) then
!                s0 = s0 - 1.0D+00           ! s = Zz(i) - 1(i)
!<<<           s0 = s0 - t_one
               t_p1 = s0h - t_oneh
               t_p2 = t_p1 - s0h
               t_ch = t_p1
               t_cl = (s0h - (t_p1 - t_p2))
     +                  - (t_oneh + t_p2)
               t_cl = t_cl + s0l - t_onel
               t_s1 = t_ch + t_cl
               s0l = t_cl - (t_s1 - t_ch)
               s0h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           s0 = s0 - t_one
             end if
!                b(i) = b(i) + ABS(t0)       ! b(i)=|Az(i)-wz(i)|_1
!<<<           tmp1 = abs(t0)
               if (t0h .lt. 0.0d+0) then
                 tmp1h = -t0h
                 tmp1l = -t0l
               elseif (
     +           (t0h .eq. 0.0d+0).and.
     +           (t0l .lt. 0.0d+0)) then
                 tmp1h = t0h
                 tmp1l = -t0l
               else
                 tmp1h = t0h
                 tmp1l = t0l
               endif
!>>>           tmp1 = abs(t0)
!<<<           b(i) = b(i) + tmp1
               t_p1 = bh(i) + tmp1h
               t_p2 = t_p1 - bh(i)
               t_q1 = t_p1
               t_q2 = (bh(i) - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + bl(i) + tmp1l
               bh(i) = t_q1 + t_q2
               bl(i) = t_q2 - (bh(i) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           b(i) = b(i) + tmp1
!                rz   = rz + s0**2           ! rz  =|ZZ-I|_F
!<<<           tmp1 = s0 * s0
               tmp1h = s0h * s0h
               t_u1 = 134217729.0 * s0h
               t_p1 = t_u1
     +                  - (t_u1 - s0h)
               t_p2 = s0h - t_p1
               t_u1 = 134217729.0 * s0h
               t_r1 = t_u1
     +                  - (t_u1 - s0h)
               t_r2 = s0h - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (s0h*s0l
     +               + s0l*s0h)
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = s0 * s0
!<<<           rz = rz + tmp1
               t_p1 = rzh + tmp1h
               t_p2 = t_p1 - rzh
               t_q1 = t_p1
               t_q2 = (rzh - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + rzl + tmp1l
               rzh = t_q1 + t_q2
               rzl = t_q2 - (rzh - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           rz = rz + tmp1
!                ra   = MAX(ra,u0)           ! ra  =|A|_1
                if (
!                (u0 .gt. ra)
     +          ((u0h .gt. rah) .or.
     +           ((u0h .eq. rah) .and.
     +            (u0l .gt. ral)))
     &          ) then
               rah = u0h
               ral = u0l
                endif
                
             end do
             do i_1 = i_m, i_3, 4
!                t0 = e(1+(i_1-1)*3)
!                s0 = e(2+(i_1-1)*3)
!                u0 = e(3+(i_1-1)*3)
!                t1 = e(1+(i_1  )*3)
!                s1 = e(2+(i_1  )*3)
!                u1 = e(3+(i_1  )*3)
!                t2 = e(1+(i_1+1)*3)
!                s2 = e(2+(i_1+1)*3)
!                u2 = e(3+(i_1+1)*3)
!                t3 = e(1+(i_1+2)*3)
!                s3 = e(2+(i_1+2)*3)
!                u3 = e(3+(i_1+2)*3)
               t0h = eh(1+(i_1-1)*3)
               t0l = el(1+(i_1-1)*3)
               s0h = eh(2+(i_1-1)*3)
               s0l = el(2+(i_1-1)*3)
               u0h = eh(3+(i_1-1)*3)
               u0l = el(3+(i_1-1)*3)
               t1h = eh(1+(i_1)*3)
               t1l = el(1+(i_1)*3)
               s1h = eh(2+(i_1)*3)
               s1l = el(2+(i_1)*3)
               u1h = eh(3+(i_1)*3)
               u1l = el(3+(i_1)*3)
               t2h = eh(1+(i_1+1)*3)
               t2l = el(1+(i_1+1)*3)
               s2h = eh(2+(i_1+1)*3)
               s2l = el(2+(i_1+1)*3)
               u2h = eh(3+(i_1+1)*3)
               u2l = el(3+(i_1+1)*3)
               t3h = eh(1+(i_1+2)*3)
               t3l = el(1+(i_1+2)*3)
               s3h = eh(2+(i_1+2)*3)
               s3l = el(2+(i_1+2)*3)
               u3h = eh(3+(i_1+2)*3)
               u3l = el(3+(i_1+2)*3)
!                t0 = t0 - w(i) * d(i_1+0)   ! t = Az(i) - wz(i)
!                t1 = t1 - w(i) * d(i_1+1)   ! t = Az(i) - wz(i)
!                t2 = t2 - w(i) * d(i_1+2)   ! t = Az(i) - wz(i)
!                t3 = t3 - w(i) * d(i_1+3)   ! t = Az(i) - wz(i)
!<<<           tmp1 = w(i) * d(i_1+0)
               tmp1h = wh(i) * dh(i_1+0)
               t_u1 = 134217729.0 * wh(i)
               t_p1 = t_u1
     +                  - (t_u1 - wh(i))
               t_p2 = wh(i) - t_p1
               t_u1 = 134217729.0 * dh(i_1+0)
               t_r1 = t_u1
     +                  - (t_u1 - dh(i_1+0))
               t_r2 = dh(i_1+0) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (wh(i)*dl(i_1+0)
     +               + wl(i)*dh(i_1+0))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = w(i) * d(i_1+0)
!<<<           t0 = t0 - tmp1
               t_p1 = t0h - tmp1h
               t_p2 = t_p1 - t0h
               t_ch = t_p1
               t_cl = (t0h - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + t0l - tmp1l
               t_s1 = t_ch + t_cl
               t0l = t_cl - (t_s1 - t_ch)
               t0h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           t0 = t0 - tmp1
!<<<           tmp1 = w(i) * d(i_1+1)
               tmp1h = wh(i) * dh(i_1+1)
               t_u1 = 134217729.0 * wh(i)
               t_p1 = t_u1
     +                  - (t_u1 - wh(i))
               t_p2 = wh(i) - t_p1
               t_u1 = 134217729.0 * dh(i_1+1)
               t_r1 = t_u1
     +                  - (t_u1 - dh(i_1+1))
               t_r2 = dh(i_1+1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (wh(i)*dl(i_1+1)
     +               + wl(i)*dh(i_1+1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = w(i) * d(i_1+1)
!<<<           t1 = t1 - tmp1
               t_p1 = t1h - tmp1h
               t_p2 = t_p1 - t1h
               t_ch = t_p1
               t_cl = (t1h - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + t1l - tmp1l
               t_s1 = t_ch + t_cl
               t1l = t_cl - (t_s1 - t_ch)
               t1h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           t1 = t1 - tmp1
!<<<           tmp1 = w(i) * d(i_1+2)
               tmp1h = wh(i) * dh(i_1+2)
               t_u1 = 134217729.0 * wh(i)
               t_p1 = t_u1
     +                  - (t_u1 - wh(i))
               t_p2 = wh(i) - t_p1
               t_u1 = 134217729.0 * dh(i_1+2)
               t_r1 = t_u1
     +                  - (t_u1 - dh(i_1+2))
               t_r2 = dh(i_1+2) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (wh(i)*dl(i_1+2)
     +               + wl(i)*dh(i_1+2))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = w(i) * d(i_1+2)
!<<<           t2 = t2 - tmp1
               t_p1 = t2h - tmp1h
               t_p2 = t_p1 - t2h
               t_ch = t_p1
               t_cl = (t2h - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + t2l - tmp1l
               t_s1 = t_ch + t_cl
               t2l = t_cl - (t_s1 - t_ch)
               t2h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           t2 = t2 - tmp1
!<<<           tmp1 = w(i) * d(i_1+3)
               tmp1h = wh(i) * dh(i_1+3)
               t_u1 = 134217729.0 * wh(i)
               t_p1 = t_u1
     +                  - (t_u1 - wh(i))
               t_p2 = wh(i) - t_p1
               t_u1 = 134217729.0 * dh(i_1+3)
               t_r1 = t_u1
     +                  - (t_u1 - dh(i_1+3))
               t_r2 = dh(i_1+3) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (wh(i)*dl(i_1+3)
     +               + wl(i)*dh(i_1+3))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = w(i) * d(i_1+3)
!<<<           t3 = t3 - tmp1
               t_p1 = t3h - tmp1h
               t_p2 = t_p1 - t3h
               t_ch = t_p1
               t_cl = (t3h - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + t3l - tmp1l
               t_s1 = t_ch + t_cl
               t3l = t_cl - (t_s1 - t_ch)
               t3h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           t3 = t3 - tmp1
             if ( ii_0 == my_row ) then
             if ( i_1+0 ==ii_1 ) then
!                s0 = s0 - 1.0D+00           ! s = Zz(i) - 1(i)
!<<<           s0 = s0 - t_one
               t_p1 = s0h - t_oneh
               t_p2 = t_p1 - s0h
               t_ch = t_p1
               t_cl = (s0h - (t_p1 - t_p2))
     +                  - (t_oneh + t_p2)
               t_cl = t_cl + s0l - t_onel
               t_s1 = t_ch + t_cl
               s0l = t_cl - (t_s1 - t_ch)
               s0h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           s0 = s0 - t_one
             else if ( i_1+1 ==ii_1 ) then
!                s1 = s1 - 1.0D+00           ! s = Zz(i) - 1(i)
!<<<           s1 = s1 - t_one
               t_p1 = s1h - t_oneh
               t_p2 = t_p1 - s1h
               t_ch = t_p1
               t_cl = (s1h - (t_p1 - t_p2))
     +                  - (t_oneh + t_p2)
               t_cl = t_cl + s1l - t_onel
               t_s1 = t_ch + t_cl
               s1l = t_cl - (t_s1 - t_ch)
               s1h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           s1 = s1 - t_one
             else if ( i_1+2 ==ii_1 ) then
!                s2 = s2 - 1.0D+00           ! s = Zz(i) - 1(i)
!<<<           s2 = s2 - t_one
               t_p1 = s2h - t_oneh
               t_p2 = t_p1 - s2h
               t_ch = t_p1
               t_cl = (s2h - (t_p1 - t_p2))
     +                  - (t_oneh + t_p2)
               t_cl = t_cl + s2l - t_onel
               t_s1 = t_ch + t_cl
               s2l = t_cl - (t_s1 - t_ch)
               s2h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           s2 = s2 - t_one
             else if ( i_1+3 ==ii_1 ) then
!                s3 = s3 - 1.0D+00           ! s = Zz(i) - 1(i)
!<<<           s3 = s3 - t_one
               t_p1 = s3h - t_oneh
               t_p2 = t_p1 - s3h
               t_ch = t_p1
               t_cl = (s3h - (t_p1 - t_p2))
     +                  - (t_oneh + t_p2)
               t_cl = t_cl + s3l - t_onel
               t_s1 = t_ch + t_cl
               s3l = t_cl - (t_s1 - t_ch)
               s3h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           s3 = s3 - t_one
             end if
             end if
!                b(i) = b(i) + ABS(t0)       ! b(i)=|Az(i)-wz(i)|_1
!                b(i) = b(i) + ABS(t1)       ! b(i)=|Az(i)-wz(i)|_1
!                b(i) = b(i) + ABS(t2)       ! b(i)=|Az(i)-wz(i)|_1
!                b(i) = b(i) + ABS(t3)       ! b(i)=|Az(i)-wz(i)|_1
!<<<           tmp1 = abs(t0)
               if (t0h .lt. 0.0d+0) then
                 tmp1h = -t0h
                 tmp1l = -t0l
               elseif (
     +           (t0h .eq. 0.0d+0).and.
     +           (t0l .lt. 0.0d+0)) then
                 tmp1h = t0h
                 tmp1l = -t0l
               else
                 tmp1h = t0h
                 tmp1l = t0l
               endif
!>>>           tmp1 = abs(t0)
!<<<           b(i) = b(i) + tmp1
               t_p1 = bh(i) + tmp1h
               t_p2 = t_p1 - bh(i)
               t_q1 = t_p1
               t_q2 = (bh(i) - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + bl(i) + tmp1l
               bh(i) = t_q1 + t_q2
               bl(i) = t_q2 - (bh(i) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           b(i) = b(i) + tmp1
!<<<           tmp1 = abs(t1)
               if (t1h .lt. 0.0d+0) then
                 tmp1h = -t1h
                 tmp1l = -t1l
               elseif (
     +           (t1h .eq. 0.0d+0).and.
     +           (t1l .lt. 0.0d+0)) then
                 tmp1h = t1h
                 tmp1l = -t1l
               else
                 tmp1h = t1h
                 tmp1l = t1l
               endif
!>>>           tmp1 = abs(t1)
!<<<           b(i) = b(i) + tmp1
               t_p1 = bh(i) + tmp1h
               t_p2 = t_p1 - bh(i)
               t_q1 = t_p1
               t_q2 = (bh(i) - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + bl(i) + tmp1l
               bh(i) = t_q1 + t_q2
               bl(i) = t_q2 - (bh(i) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           b(i) = b(i) + tmp1
!<<<           tmp1 = abs(t2)
               if (t2h .lt. 0.0d+0) then
                 tmp1h = -t2h
                 tmp1l = -t2l
               elseif (
     +           (t2h .eq. 0.0d+0).and.
     +           (t2l .lt. 0.0d+0)) then
                 tmp1h = t2h
                 tmp1l = -t2l
               else
                 tmp1h = t2h
                 tmp1l = t2l
               endif
!>>>           tmp1 = abs(t2)
!<<<           b(i) = b(i) + tmp1
               t_p1 = bh(i) + tmp1h
               t_p2 = t_p1 - bh(i)
               t_q1 = t_p1
               t_q2 = (bh(i) - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + bl(i) + tmp1l
               bh(i) = t_q1 + t_q2
               bl(i) = t_q2 - (bh(i) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           b(i) = b(i) + tmp1
!<<<           tmp1 = abs(t3)
               if (t3h .lt. 0.0d+0) then
                 tmp1h = -t3h
                 tmp1l = -t3l
               elseif (
     +           (t3h .eq. 0.0d+0).and.
     +           (t3l .lt. 0.0d+0)) then
                 tmp1h = t3h
                 tmp1l = -t3l
               else
                 tmp1h = t3h
                 tmp1l = t3l
               endif
!>>>           tmp1 = abs(t3)
!<<<           b(i) = b(i) + tmp1
               t_p1 = bh(i) + tmp1h
               t_p2 = t_p1 - bh(i)
               t_q1 = t_p1
               t_q2 = (bh(i) - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + bl(i) + tmp1l
               bh(i) = t_q1 + t_q2
               bl(i) = t_q2 - (bh(i) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           b(i) = b(i) + tmp1
!                rz   = rz + s0**2           ! rz  =|ZZ-I|_F
!                rz   = rz + s1**2           ! rz  =|ZZ-I|_F
!                rz   = rz + s2**2           ! rz  =|ZZ-I|_F
!                rz   = rz + s3**2           ! rz  =|ZZ-I|_F
!<<<           tmp1 = s0 * s0
               tmp1h = s0h * s0h
               t_u1 = 134217729.0 * s0h
               t_p1 = t_u1
     +                  - (t_u1 - s0h)
               t_p2 = s0h - t_p1
               t_u1 = 134217729.0 * s0h
               t_r1 = t_u1
     +                  - (t_u1 - s0h)
               t_r2 = s0h - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (s0h*s0l
     +               + s0l*s0h)
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = s0 * s0
!<<<           rz = rz + tmp1
               t_p1 = rzh + tmp1h
               t_p2 = t_p1 - rzh
               t_q1 = t_p1
               t_q2 = (rzh - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + rzl + tmp1l
               rzh = t_q1 + t_q2
               rzl = t_q2 - (rzh - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           rz = rz + tmp1
!<<<           tmp1 = s1 * s1
               tmp1h = s1h * s1h
               t_u1 = 134217729.0 * s1h
               t_p1 = t_u1
     +                  - (t_u1 - s1h)
               t_p2 = s1h - t_p1
               t_u1 = 134217729.0 * s1h
               t_r1 = t_u1
     +                  - (t_u1 - s1h)
               t_r2 = s1h - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (s1h*s1l
     +               + s1l*s1h)
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = s1 * s1
!<<<           rz = rz + tmp1
               t_p1 = rzh + tmp1h
               t_p2 = t_p1 - rzh
               t_q1 = t_p1
               t_q2 = (rzh - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + rzl + tmp1l
               rzh = t_q1 + t_q2
               rzl = t_q2 - (rzh - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           rz = rz + tmp1
!<<<           tmp1 = s2 * s2
               tmp1h = s2h * s2h
               t_u1 = 134217729.0 * s2h
               t_p1 = t_u1
     +                  - (t_u1 - s2h)
               t_p2 = s2h - t_p1
               t_u1 = 134217729.0 * s2h
               t_r1 = t_u1
     +                  - (t_u1 - s2h)
               t_r2 = s2h - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (s2h*s2l
     +               + s2l*s2h)
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = s2 * s2
!<<<           rz = rz + tmp1
               t_p1 = rzh + tmp1h
               t_p2 = t_p1 - rzh
               t_q1 = t_p1
               t_q2 = (rzh - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + rzl + tmp1l
               rzh = t_q1 + t_q2
               rzl = t_q2 - (rzh - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           rz = rz + tmp1
!<<<           tmp1 = s3 * s3
               tmp1h = s3h * s3h
               t_u1 = 134217729.0 * s3h
               t_p1 = t_u1
     +                  - (t_u1 - s3h)
               t_p2 = s3h - t_p1
               t_u1 = 134217729.0 * s3h
               t_r1 = t_u1
     +                  - (t_u1 - s3h)
               t_r2 = s3h - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (s3h*s3l
     +               + s3l*s3h)
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = s3 * s3
!                ra   = MAX(ra,u0)           ! ra  =|A|_1
                if (
!                (u0 .gt. ra)
     +          ((u0h .gt. rah) .or.
     +           ((u0h .eq. rah) .and.
     +            (u0l .gt. ral)))
     &          ) then
               rah = u0h
               ral = u0l
                endif
!                ra   = MAX(ra,u1)           ! ra  =|A|_1
                if (
!                (u1 .gt. ra)
     +          ((u1h .gt. rah) .or.
     +           ((u1h .eq. rah) .and.
     +            (u1l .gt. ral)))
     &          ) then
               rah = u1h
               ral = u1l
                endif
!                ra   = MAX(ra,u2)           ! ra  =|A|_1
                if (
!                (u2 .gt. ra)
     +          ((u2h .gt. rah) .or.
     +           ((u2h .eq. rah) .and.
     +            (u2l .gt. ral)))
     &          ) then
               rah = u2h
               ral = u2l
                endif
!                ra   = MAX(ra,u3)           ! ra  =|A|_1
                if (
!                (u3 .gt. ra)
     +          ((u3h .gt. rah) .or.
     +           ((u3h .eq. rah) .and.
     +            (u3l .gt. ral)))
     &          ) then
               rah = u3h
               ral = u3l
                endif
             end do
          end if

       end do

*>
!       d(1:n)=b(1:n)
!       d(n+1)=rz
      dh(1:n) = bh(1:n)
      dl(1:n) = bl(1:n)
      dh(n+1) = rzh
      dl(n+1) = rzl
!       call MPI_Allreduce(d(1),e(1),n+1,MPI_DOUBLE_PRECISION,
!     &                    MPI_SUM,MPI_COMM_WORLD,ierr)
       call MPI_Allreduce_dd(dh(1),dl(1),eh(1),el(1),n+1,
     &                       MPI_DOUBLE_PRECISION,
     &                       MPI_SUM,MPI_COMM_WORLD,ierr)
!       b(1:n)=e(1:n)
!       rz    =e(n+1)
      bh(1:n) = eh(1:n)
      bl(1:n) = el(1:n)
      rzh = eh(n+1)
      rzl = el(n+1)

!       r=ra
      rh = rah
      rl = ral
!       call MPI_Allreduce(ra,r,1,MPI_DOUBLE_PRECISION,
!     &                    MPI_MAX,MPI_COMM_WORLD,ierr)
       call MPI_Allreduce_dd(rah,ral,rh,rl,1,MPI_DOUBLE_PRECISION,
     &                       MPI_MAX,MPI_COMM_WORLD,ierr)
!       ra=r
      rah = rh
      ral = rl

!       rr=0d0
      rrh = 0.0d+0
      rrl = 0.0d+0
       do i=1,n
!          if(b(i)>rr)then
          if(
!       (b(i) .gt. rr)
     + ((bh(i) .gt. rrh) .or.
     +  ((bh(i) .eq. rrh) .and.
     +   (bl(i) .gt. rrl)))
     &    )then
!             rr=b(i); k=i
      rrh = bh(i)
      rrl = bl(i)
             k=i
          endif
       enddo! i

!       sum=0.0d0
      sumh = 0.0d+0
      suml = 0.0d+0
       do i=1,n
!          sum=sum+b(i)
!<<<  sum = sum + b(i)
      t_p1 = sumh + bh(i)
      t_p2 = t_p1 - sumh
      t_q1 = t_p1
      t_q2 = (sumh - (t_p1 - t_p2))
     +         + (bh(i) - t_p2)
      t_q2 = t_q2 + suml + bl(i)
      sumh = t_q1 + t_q2
      suml = t_q2 - (sumh - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>  sum = sum + b(i)
       end do

       if(myrank==1)then
          print*," "
          print*,"----- Check a calculation result. -----"
!          print*,"max|Ax-wx|=",rr,k
!          print*,"sum|Ax-wx|=",sum
!          print*,"|A|=",ra
!          print*,"epsilon=",m_epsilon
!          print*,"max|Ax-wx|/Ne|A|=",rr/(n*m_epsilon*ra)
!          print*,"|ZZ-I|=",SQRT(rz),rz
          print*,"max|Ax-wx|=",rrh,rrl,k
          print*,"sum|Ax-wx|=",sumh,suml
          print*,"|A|=",rah,ral
          print*,"epsilon=",m_epsilonh
          print*,"max|Ax-wx|/Ne|A|=",rrh/(n*m_epsilonh*rah)
          print*,"|ZZ-I|=",SQRT(rzh),rzh
          print*,"---------------------------------------"
       endif
*
!       deallocate(e)
!       deallocate(b)
!       deallocate(c1,c2)
!       deallocate(d)
       deallocate(eh, el)
       deallocate(bh, bl)
       deallocate(c1h, c1l, c2h, c2l)
       deallocate(dh, dl)
*
       return
       end
