!----
!      use communication_sx, only : eigen_init
!     &                           , eigen_free
!     &                           , translate_l2g
      use ddcommunication_sx, only : eigen_init
     &                             , eigen_free
     &                             , translate_l2g
!----
      implicit double precision (a-h,o-z)

!      real(8),allocatable :: a(:,:)
!      real(8),allocatable :: as(:,:)
      real(8),allocatable :: ah(:,:), al(:,:)
      real(8),allocatable :: ash(:,:), asl(:,:)
!      real(8), pointer ::
!     &           b(:),z(:),d(:),e(:),w(:)
      real(8), pointer ::
     &           bh(:),zh(:),dh(:),eh(:),wh(:),
     &           bl(:),zl(:),dl(:),el(:),wl(:)
      integer, parameter :: NDIM = 2
      logical iexist
!
      include 'mpif.h'
      include 'trd.h'
!
      call mpi_init(ierr)
      call mpi_comm_rank(mpi_comm_world,i$inod,ierr)
      call mpi_comm_size(mpi_comm_world,i$nnod,ierr)
*
      n=100
C*DebugWrite02-start*****************************************
      inquire(file='matsize.txt',exist=iexist)
      if(iexist) then
         open(999,file='matsize.txt',err=20)
         read(999,*,err=20) matsize
         n = matsize
 20      continue
         close(999)
      endif
      if(myrank==1)then
         write(*,*) 'matrix size = ',n
      endif
C*DebugWrite02-end*******************************************
      m=32
!      allocate(a(n,n))
!      allocate(as(n,n))
      allocate(ah(n,n),al(n,n))
      allocate(ash(n,n),asl(n,n))
      call eigen_init(NDIM)
      NPROW = size_of_col
      NPCOL = size_of_row
      nx = ((n-1)/NPROW+1)
      call CSTAB_get_optdim(nx, 6, 16*2, 16*4, nm)
      call eigen_free(0)

      NB  = 64+32
      nmz = ((n-1)/NPROW+1)
      nmz = ((nmz-1)/NB+1)*NB+1
      nmw = ((n-1)/NPCOL+1)
      nmw = ((nmw-1)/NB+1)*NB+1
      nme = ((n-1)/2+1)*2

      nh = (n-1)/4+1
      call CSTAB_get_optdim(nh, 4, 16*2, 16*4, nnh)
      nnh = 4 * nnh

      n1x = ((n-1)/nprocs+1)
      larray = MAX(MAX(nmz,nm,nnh)*nmw, n*n1x)
      allocate(
!     &         b(larray), z(larray),
!     &         d(nme), e(2*nme), w(nme),
     &         bh(larray), zh(larray),
     &         dh(nme), eh(2*nme), wh(nme),
     &         bl(larray), zl(larray),
     &         dl(nme), el(2*nme), wl(nme),
     &         stat=istat)
      if(istat.ne.0) then
         print*,"Memory exhausted"
         call flush(6)
         stop
      endif
*
!      call matrix_set(n,a)
      call ddmatrix_set(n,ah,al)
!      as=a
      ash=ah
      asl=al
!      call matrix_adjust_sx(n,a,b,nm)
      call ddmatrix_adjust_sx(n,ah,al,bh,bl,nm)
*-
!      call eigen_sx(n,b,nm,w,z,d,e,nme,m,0)
      call ddeigen_sx(n,bh,bl,nm,wh,wl,zh,zl,dh,dl,eh,el,nme,m,0)
*-
!      a=as
      ah=ash
      al=asl
      !call matrix_set(n,a)
!      call matrix_adjust_sx(n,a,b,nm)
!      call ev_test_2D(n, b, nm, w, z, nm, t)
      call ddmatrix_adjust_sx(n,ah,al,bh,bl,nm)
      call ddev_test_2D(n, bh, bl, nm, wh, wl, zh, zl, nm, t)
*
!      deallocate(a)
!      deallocate(z)
!      deallocate(d)
!      deallocate(e)
!      deallocate(w)
      deallocate(ah,al)
      deallocate(zh,zl)
      deallocate(dh,dl)
      deallocate(eh,el)
      deallocate(wh,wl)
*
      call MPI_Finalize(ierr)
      end

