!----
      use communication_sx, only : eigen_init
     &                           , eigen_free
     &                           , translate_l2g
!----
      implicit double precision (a-h,o-z)

      real(8),allocatable :: a(:,:)
      real(8), pointer ::
     &           b(:),z(:),d(:),e(:),w(:)
      integer, parameter :: NDIM = 2
      logical iexist
!
      include 'mpif.h'
      include 'trd.h'
C*DebugWrite01-start**************************************************C
c ....fobOCgɕKvȃ[NϐpӂĂ݂
      real(16),parameter::pi16=3.14159265358979323846264338327950288q0
      real(16)::w16,wth16,wth16_rmax,nrm16
      real(8)::w_rmax
      real(4)::ratio,ratio_rmax
      character(64)::txt,form16,form32
      real(16),allocatable :: zth16(:,:)
      real(8),allocatable :: ax(:,:),wx(:,:)
C*DebugWrite01-end****************************************************C
!
      call mpi_init(ierr)
      call mpi_comm_rank(mpi_comm_world,i$inod,ierr)
      call mpi_comm_size(mpi_comm_world,i$nnod,ierr)
*
      n=100
C*DebugWrite02-start*****************************************
c ....sTCYt@Cǂݍ
      inquire(file='matsize.txt',exist=iexist)
      if(iexist) then
         open(999,file='matsize.txt',err=20)
         read(999,*,err=20) matsize
         n = matsize
 20      continue
         close(999)
      endif
!      if(myrank==1)then
         write(*,*) 'matrix size = ',n
!      endif
C*DebugWrite02-end*******************************************
      m=32
      allocate(a(n,n))
      call eigen_init(NDIM)
      NPROW = size_of_col
      NPCOL = size_of_row
      nx = ((n-1)/NPROW+1)
      call CSTAB_get_optdim(nx, 6, 16*2, 16*4, nm)
      call eigen_free(0)

      NB  = 64+32
      nmz = ((n-1)/NPROW+1)
      nmz = ((nmz-1)/NB+1)*NB+1
      nmw = ((n-1)/NPCOL+1)
      nmw = ((nmw-1)/NB+1)*NB+1
      nme = ((n-1)/2+1)*2

      nh = (n-1)/4+1
      call CSTAB_get_optdim(nh, 4, 16*2, 16*4, nnh)
      nnh = 4 * nnh

      n1x = ((n-1)/nprocs+1)
      larray = MAX(MAX(nmz,nm,nnh)*nmw, n*n1x)
      allocate(
     &         b(larray), z(larray),
     &         d(nme), e(2*nme), w(nme),
     &         stat=istat)
      if(istat.ne.0) then
         print*,"Memory exhausted"
         call flush(6)
         stop
      endif
*
      call matrix_set(n,a)
      call matrix_adjust_sx(n,a,b,nm)
*-
      call eigen_sx(n,b,nm,w,z,d,e,nme,m,0)
      !!!!!!
      !if (myrank == 1) then
      !  open(80,file='w_fr.dat')
      !  do i=1,n
      !    write(80,'(e56.48e4)') w(i)
      !  enddo
      !  close(80)
      !  open(80,file='z_fr.dat')
      !  do j=1,n
      !    do i=1,n
      !      write(80,'(e56.48e4)') z(i+(j-1)*nm)
      !    enddo
      !  enddo
      !  close(80)
      !endif
      !!!!!!
*-
C*DebugWrite03-start**************************************************C
      if(myrank==1)then !1CPÛݏo
c ....ŗLl(vZlƗ_l)oĂ݂
      write(*,*) 'EigenValue='
      ratio_rmax=0.0
      do k=1,n
        w16=w(k)
        wth16=0.5q0/(1.0q0-cos(pi16*(2*(n-k+1)-1)/(2*n+1)))
        ratio=abs(w16-wth16)/wth16
        if(ratio.gt.ratio_rmax)then
          ratio_rmax=ratio
          w_rmax=w(k)
          wth16_rmax=wth16
          kk=k
        endif
CCC        write(*,'(a9,i6,a17)') '-------- ',k,' ----------------'
CCC        write(*,*) i,'  hi,lo=',wh(k),wl(k)
CCC        write(*,*) '  eigen:',w(k)
CCC        write(*,*) ' theory:',wth16
CCC        write(*,*) '  ratio:',ratio
      enddo
      write(*,'(a9,i6,a17)') '**** max:',kk,' ****************'
      write(*,*) '  eigen:',w_rmax
      write(*,*) ' theory:',wth16_rmax
      write(*,*) '  ratio:',ratio_rmax
C
      endif !1CPÛݏo
C
      if(nprocs==1)then !vZȂꍇ̂
c ....ŗLxNg(vZlƗ_l)oĂ݂
CCC      write(*,*) !kaigyo
CCC      write(*,*) 'EigenVector='
CCC      allocate(zth16(n,n))
CCC      if(n.lt.10)then
CCC        write(txt,'(i1)') n
CCC      elseif(n.lt.100)then
CCC        write(txt,'(i2)') n
CCC      elseif(n.lt.1000)then
CCC        write(txt,'(i3)') n
CCC      elseif(n.lt.10000)then
CCC        write(txt,'(i4)') n
CCC      elseif(n.lt.100000)then
CCC        write(txt,'(i5)') n
CCC      else
CCC        stop 'sub.main: n is too big'
CCC      endif
CCC      form16='(a8,'//trim(txt)//'(e24.16,16x))'
CCC      form32='(a8,'//trim(txt)//'e40.32)'
CCC      delta_max=0.0d0
CCC      do k=1,n
CCC        nrm16=0.0q0
CCC        do j=1,n
CCC          zth16(j,k)=cos(pi16*qext(2*(n-k+1)-1)*qext(2*j-1)/qext(4*n+2))
CCC          nrm16=nrm16+zth16(j,k)*zth16(j,k)
CCC        enddo
CCC        delta=0.0d0
CCC        jj=nm*(k-1)
CCC        do j=1,n
CCC          zth16(j,k)=sign(zth16(j,k),z(jj+j))/sqrt(nrm16)
CCC          delta=delta+abs(qext(z(jj+j))-zth16(j,k))
CCC        enddo
CCC        if(delta.gt.delta_max)then
CCC          delta_max=delta
CCC          kk=k
CCC        endif
CCC        write(*,'(a9,i6,a17)') '-------- ',k,' ----------------'
CCC        write(*,trim(form16)) '  eigen:',(z(jj+j),j=1,n)
CCC        write(*,trim(form32)) ' theory:',(zth16(j,k),j=1,n)
CCC        write(*,'(a16,e15.7)') ' |eigen-theory|:',delta
CCC      enddo
CCC      write(*,'(a9,i6,a17)') '**** max:',kk,' ****************'
CCC      jj=nm*(kk-1)
CCC      write(*,trim(form16)) '  eigen:',(z(jj+j),j=1,n)
CCC      write(*,trim(form32)) ' theory:',(zth16(j,kk),j=1,n)
CCC      write(*,'(a16,e15.7)') ' |eigen-theory|:',delta_max
C
      endif !vZȂꍇ̂
C*DebugWrite03-end****************************************************C
*-
      call matrix_set(n,a)
C*DebugWrite04-start**************************************************C
      if(nprocs==1)then !vZȂꍇ̂
c ....x]vZĂ݂
CCC      write(*,*) !kaigyo
CCC      write(*,*) 'Eigen_s Eval.'
CCC      allocate(ax(n,n),wx(n,n))
CCC      ax=0.0d0
CCC      wx=0.0d0
CCC      delta_max=0.0d0
CCC      do k=1,n
CCC        write(*,'(a9,i6,a17)') '-------- ',k,' ----------------'
CCC        jj=nm*(k-1)
CCC        delta=0.0d0
CCC        do j=1,n
CCC          do i=1,n
CCC            ax(j,k)=ax(j,k)+a(i,j)*z(jj+i)
CCC          enddo
CCC          wx(j,k)=w(k)*z(jj+j)
CCC          delta=delta+abs(ax(j,k)-wx(j,k))
CCC          if(delta.gt.delta_max)then
CCC            delta_max=delta
CCC            kk=k
CCC          endif
CCC        enddo
CCC        write(*,'(a8,2000e24.16)') '     Ax:',(ax(j,k),j=1,n)
CCC        write(*,'(a8,2000e24.16)') '     wx:',(wx(j,k),j=1,n)
CCC        write(*,'(a8,e24.16)') '|Ax-wx|:',delta
CCC      enddo
CCC      write(*,'(a9,i6,a17)') '**** max:',kk,' ****************'
CCC      write(*,'(a8,2000e24.16)') '     Ax:',(ax(j,kk),j=1,n)
CCC      write(*,'(a8,2000e24.16)') '     wx:',(wx(j,kk),j=1,n)
CCC      write(*,'(a8,e24.16)') '|Ax-wx|:',delta_max
CCC
CCC      deallocate(zth16)
CCC      deallocate(ax)
CCC      deallocate(wx)
C
      endif !vZȂꍇ̂
C*DebugWrite04-end****************************************************C
      call matrix_adjust_sx(n,a,b,nm)
      call ev_test_2D(n, b, nm, w, z, nm, t)
*
      deallocate(a)
      deallocate(z)
      deallocate(d)
      deallocate(e)
      deallocate(w)
*
      call MPI_Finalize(ierr)
      end

