C
C   Subroutines for Basic operation of Matrix calculation
C
C SUBROUTINE dd_divide(ah,al,bh,bl,ch,cl)
C SUBROUTINE dd_reciprocal(ah,al)
C SUBROUTINE dd_scal(ah,al,alphah,alphal)
C SUBROUTINE dd_multiple(ah,al,bh,bl,ddmh,ddml)
C SUBROUTINE dd_sub(ah,al,bh,bl,ddmh,ddml)
C SUBROUTINE dd_abs(ah,al,bh,bl)
C SUBROUTINE dd_sqrt(ah,al,bh,bl)

       SUBROUTINE dd_divide(ah,al,bh,bl,ch,cl)

         real(8) ::    ah    ,  al
         real(8) ::    bh    ,  bl
         real(8) ::    ch    ,  cl
         double precision  tmp1h,tmp1l

         if (bh.eq.0.0d+0 .and. bl.eq.0.0d+0) then
           ch = 0.0d+0
           cl = 0.0d+0
         else
		tmp1h = bh
		tmp1l = bl
		call dd_reciprocal(tmp1h,tmp1l)
		call dd_multiple(ah,al,tmp1h,tmp1l,ch,cl)

         end if
       END SUBROUTINE

       SUBROUTINE dd_reciprocal(ah,al)
         real(8) ::     ah    ,  al
         real(8) ::    temph ,  templ
         real(8) :: t_q1,t_ch,t_u1,t_p1,t_p2,t_r1,t_r2,t_cl,t_s1,t_s2
         real(8) :: t_q2

		temph = 1.0

		t_q1 = temph / ah
		t_ch = ah * t_q1
		t_u1 = 134217729.0 * ah
		t_p1 = t_u1- (t_u1 - ah)                              
		t_p2 = ah - t_p1
		t_u1 = 134217729.0 * t_q1
		t_r1 = t_u1 - (t_u1 - t_q1)                             
		t_r2 = t_q1 - t_r1
		t_cl = ((t_p1*t_r1 - t_ch)
     +                 + t_p1*t_r2 + t_p2*t_r1)
     +                 + t_p2*t_r2
		t_cl = t_cl + (al * t_q1)                              
		t_s1 = t_ch + t_cl
		t_cl = t_cl - (t_s1 - t_ch)                            
		t_ch = t_s1
		t_s1 = temph - t_ch
		t_r1 = t_s1 - temph
		t_s2 = (temph- (t_s1 - t_r1))- (t_ch + t_r1)                              
		t_s2 = t_s2 - t_cl
		t_s2 = t_s2 + templ
		t_q2 = (t_s1 + t_s2)/ ah                               
		temph = t_q1 + t_q2
		templ = t_q2- (temph - t_q1)
         al = templ
         ah = temph

       END SUBROUTINE

       SUBROUTINE dd_scal(ah,al,alphah,alphal)
         real(8) ::     ah    ,  al
         real(8) ::    alphah ,  alphal
         real(8) ::t_ch,t_u1,t_p1,t_p2,t_r1,t_r2,t_cl,t_s1

		t_ch = alphah * ah
		t_u1 = 134217729.0 * alphah
		t_p1 = t_u1 - (t_u1 - alphah)                         
		t_p2 = alphah - t_p1
		t_u1 = 134217729.0 * ah
		t_r1 = t_u1 - (t_u1 - ah)                              
		t_r2 = ah - t_r1
		t_cl = ((t_p1 * t_r1 - t_ch)
     +                 + t_p1 * t_r2 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
		t_cl = t_cl + (alphah * al) + (alphal * ah)
		t_s1 = t_ch + t_cl
		al = t_cl - (t_s1 - t_ch)
		ah = t_s1

       END SUBROUTINE

       SUBROUTINE dd_multiple(ah,al,bh,bl,ddmh,ddml)
         real(8) ::    ah    ,  al
         real(8) ::    bh    ,  bl
         real(8) ::    ddmh    ,  ddml
         real(8) :: t_u1,t_p1,t_p2,t_r1,t_r2,t_s1

         ddmh = bh * ah
         t_u1 = 134217729.0 * bh
         t_p1 = t_u1 - (t_u1 - bh)
         t_p2 = bh - t_p1
         t_u1 = 134217729.0 * ah
         t_r1 = t_u1- (t_u1 - ah)
         t_r2 = ah - t_r1
         ddml = ((t_p1*t_r1-ddmh)+ t_p1*t_r2+t_p2*t_r1) +t_p2*t_r2    
         ddml = ddml+ (bh*al+ bl*ah)
         t_s1 = ddmh + ddml
         ddml = ddml - (t_s1 - ddmh)
         ddmh = t_s1

       END SUBROUTINE

       SUBROUTINE dd_sub(ah,al,bh,bl,ddmh,ddml)
         real(8) ::    ah    ,  al
         real(8) ::    bh    ,  bl
         real(8) ::    ddmh    ,  ddml
         real(8) t_p1,t_p2,t_s1

         T_p1 = ah - bh
         T_p2 = T_p1 - ah
         ddml = (ah-(T_p1 - T_p2))-(bh + T_p2)
         ddmh = T_p1
         ddml = ddml + al - bl
         T_s1 = ddmh + ddml
         ddml = ddml - (T_s1 - ddmh)
         ddmh = T_s1
       END SUBROUTINE

       SUBROUTINE dd_add(ah,al,bh,bl,ch,cl)
         real(8) ::    ah    ,  al
         real(8) ::    bh    ,  bl
         real(8) ::    ch    ,  cl
         real(8) x_p1,x_p2,x_s1

         x_p1 = ah + bh
         x_p2 = x_p1 - ah
         ch = x_p1
         cl = (ah - (x_p1 - x_p2)) + (bh - x_p2)
         cl = cl + al + bl
         x_s1 = ch + cl
         cl = cl - (x_s1 - ch)
         ch = x_s1
       END SUBROUTINE

       SUBROUTINE dd_abs(ah,al,bh,bl)
         real(8) ::    ah    ,  al
         real(8) ::    bh    ,  bl
      
         if (ah .lt. 0.0d+00) then
           bh = -1.0 * ah
           bl = -1.0 * al
         else if ((ah .eq. 0.0d+0).and.(al .lt. 0.0d+0)) then
           bh =        ah
           bl = -1.0 * al
         else
           bh =        ah
           bl =        al
         endif
       END SUBROUTINE

       SUBROUTINE dd_sqrt(ah,al,bh,bl)
         real(8) ::    ah    ,  al
         real(8) ::    bh    ,  bl

         INTRINSIC SQRT
         double precision SSQh, SSQl
         double precision tmp1h, tmp1l
         double precision tmp2h, tmp2l
         double precision tmp3h, tmp3l
         double precision tmp4h, tmp4l
         double precision T_ch, T_cl
         double precision T_p1, T_p2
         double precision T_q1, T_q2
         double precision T_r1, T_r2
         double precision T_s1, T_s2
         double precision T_t1, T_t2
         double precision T_u1, T_u2
         double precision T_x1, T_x2
         double precision T_y1, T_y2
         double precision T_z1, T_z2
         double precision T_x, T_ax
         double precision T_t1h, T_t1l
         double precision T_t2h, T_t2l

	 SSQh=ah
	 SSQl=al

         if (SSQh.eq.0.0D+0.and.SSQl.eq.0.0D+0) then
           tmp1h = 0.0d+0
           tmp1l = 0.0d+0
         endif
         if (SSQh.lt.0.0d+0.or.
     +     (SSQh.eq.0.0d+0.and.SSQl.lt.0.0d+0)) then
           write(6,'(a)')
     +     'SQRT CALLED WITH NEGATIVE ARGUMENT'
           tmp1h = 0.0d+0
           tmp1l = 0.0d+0
         return
       endif

       T_x = 1.0D+0/sqrt(SSQh)
       T_ax = SSQh * T_x

          T_y1 = T_x * 0.5d+0
          T_u1 = 134217729.0 * T_x
          T_p1 = T_u1
     +             - (T_u1 - T_x)
          T_p2 = T_x - T_p1
          T_u1 = 134217729.0 * 0.5d+0
          T_r1 = T_u1
     +             - (T_u1 - 0.5d+0)
          T_r2 = 0.5d+0 - T_r1
          T_y2 = ((T_p1*T_r1
     +             - T_y1)
     +             + T_p1*T_r2
     +             + T_p2 * T_r1)
     +             + T_p2 * T_r2
          T_s1 = T_y1 + T_y2
          T_y2 = T_y2
     +             - (T_s1 - T_y1)
          T_y1 = T_s1

          T_z1 = T_ax * T_ax
          T_u1 = 134217729.0 * T_ax
          T_p1 = T_u1
     +             - (T_u1 - T_ax)
          T_p2 = T_ax - T_p1
          T_u1 = 134217729.0 * T_ax
          T_r1 = T_u1
     +             - (T_u1 - T_ax)
          T_r2 = T_ax - T_r1
          T_z2 = ((T_p1 * T_r1
     +             - T_z1)
     +             + T_p1 * T_r2
     +             + T_p2 * T_r1)
     +             + T_p2*T_r2
          T_s1 = T_z1 + T_z2
          T_z2 = T_z2
     +             - (T_s1 - T_z1)
          T_z1 = T_s1

          T_p1 = SSQh - T_z1
          T_p2 = T_p1 - SSQh
          T_t2l = (SSQh
     +             -(T_p1 - T_p2))
     +             -(T_z1 + T_p2)
          T_t2h = T_p1
          T_t2l = T_t2l
     +             + SSQl - T_z2
          T_s1 = T_t2h + T_t2l
          T_t2l = T_t2l
     +             - (T_s1 - T_t2h)
          T_t2h = T_s1

!         multiple
          T_t1h = T_t2h * T_y1
          T_u1 = 134217729.0 * T_t2h
          T_p1 = T_u1
     +             - (T_u1 - T_t2h)
          T_p2 = T_t2h - T_p1
          T_u1 = 134217729.0 * T_y1
          T_r1 = T_u1
     +             - (T_u1 - T_y1)
          T_r2 = T_y1 - T_r1
          T_t1l = ((T_p1*T_r1
     +             - T_t1h)
     +             + T_p1*T_r2
     +             + T_p2*T_r1)
     +             + T_p2*T_r2
          T_t1l = T_t1l
     +             + (T_t2h * T_y2
     +             +  T_t2l * T_y1)
          T_s1 = T_t1h + T_t1l
          T_t1l = T_t1l - (T_s1
     +              - T_t1h)
          T_t1h = T_s1

!         add
          T_p1 = T_t1h + T_ax
          T_p2 = T_p1 - T_t1h
          T_q2 = (T_t1h
     +             - (T_p1 - T_p2))
     +             + (T_ax - T_p2)
          T_q1 = T_p1
          T_q2 = T_q2 + T_t1l
          T_t1h = T_q1 + T_q2
          T_t1l = T_q2
     +              - (T_t1h - T_q1)
          tmp1h = T_t1h
          tmp1l = T_t1l

	bh=tmp1h
	bl=tmp1l

       END SUBROUTINE



