C
C      Orthogonal matrix for Double-Double precision
C
       subroutine ddmatrix_orthogonal(n, ah, al)
       implicit double precision(a-h,o-z),integer(i-n)
       real(8)   :: ah(n,n), al(n,n)
       real(16)  :: qtmp, qtmph, qtmpl

       real(8)   ::  vh1(n) ,  vl1(n)
       real(8)   ::  vh2(n) ,  vl2(n)
       real(8)   ::  sh3    ,  sl3
       real(8)   ::  alphah , alphal

C      Ramdam matrix
       do i=1,n
          do j=1,n
             if(i == j) then
               CALL RANDOM_NUMBER(qtmp)
               tmph = qtmp
               qtmph = tmph
               qtmpl = qtmp - qtmph
               tmpl = qtmpl
               ah(i,j)=qtmph
               al(i,j)=qtmpl
             else
               CALL RANDOM_NUMBER(qtmp)
               tmph = qtmp
               qtmph = tmph
               qtmpl = qtmp - qtmph
               tmpl = qtmpl
               ah(i,j)=tmph
               al(i,j)=tmpl
             end if
          enddo
       enddo

C      Orthogonal
       do i=1,n
          do j=1,n
            vh1(j)=ah(i,j)
            vl1(j)=al(i,j)
          end do
          if(i>1) then
            do k=1,i-1
               do j=1,n
                  vh2(j)=ah(i-k,j)
                  vl2(j)=al(i-k,j)
               end do

		alphah=-1.0
		alphal= 0.0

               call dddot(n,vh1,vl1,1,vh2,vl2,1,sh3,sl3)
               call dd_scal(sh3,sl3,alphah,alphal)
               call ddaxpy(n,sh3,sl3,vh2,vl2,1,vh1,vl1,1)

             end do
           endif

           call ddnrm2(n,vh1,vl1,1,sh3,sl3)
           call dd_reciprocal(sh3,sl3)
           call ddscal(n,sh3,sl3,vh1,vl1,1)

           do j=1,n
              ah(i,j)=vh1(j)
              al(i,j)=vl1(j)
           end do
         end do

       return
       end


